#include<bits/stdc++.h>
using namespace std;

#define FORi(i,a,b) for(int i=((int)a);i<((int)b);i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define INF 400001
#define MID ((l+r)/2)
typedef vector<int> vi;
struct seg{
	seg *L, *R;
	int val=0;
	int cnt=0;
	int laz=0;

	void build(vi &a, int l=0, int r=INF){
		if(l==r) cnt = a[l];
		else{
			L = new seg;
			R = new seg;
			L->build(a,l,MID);
			R->build(a,MID+1,r);
			cnt = L->cnt + R->cnt;
		}
	}

	void push(int l, int r){
		if(laz){
			L->val = L->cnt;
			L->laz = 1;
			R->val = R->cnt;
			R->laz = 1;
		}
		laz = 0;
	}

	int query(int rl, int rr, int l=0, int r=INF){
		if(rl<=l && r<=rr) return val;
		else if(l>rr || rl>r) return 0;
		else{
			push(l,r);
			return L->query(rl,rr,l,MID) + R->query(rl,rr,MID+1,r);
		}
	}

	void update(int rl, int rr, int ff=0, int l=0, int r=INF){
		if(rl<=l && r<=rr){
			//cout<<"Updated "<<l<<endl;
			if(ff) val = 1;
			else val = cnt;

			if(l!=r) laz = 1;
		}
		else if(l>rr || rl>r) return;
		else{
			push(l,r);
			L->update(rl,rr,ff, l,MID);
			R->update(rl,rr,ff,MID+1,r);
			val = L->val + R->val;

		}
	}

	void print(int l=0, int r=INF){
		if(l==r) cout<<"("<<l<<": "<<cnt<<" "<<val<<") ";
		else{
			L->print(l,MID);
			R->print(MID+1,r);
		}
	}

};

int n;
vector<vi> adj;
vector<int> kn;
vi cnt;
vi tin, tout;
int t=0;
void dfs(int s=0, int p=-1){
	tin[s] = ++t;
	cnt[s] = 1;
	FOA(v,adj[s]) if(v!=p) dfs(v,s), cnt[s]+=cnt[v];
	tout[s] = ++t;
}

int main(){
	cin>>n;
	adj.assign(n+1, vi());
	kn.resize(n+1);
	tin.resize(n+1);
	tout.resize(n+1);
	cnt.resize(n+1);
	FOR(i,n-1){
		int a, b;
		cin>>a>>b;
		adj[a].push_back(b);
		adj[b].push_back(a);
	}
	FOR(i,n) cin>>kn[i+1];
	dfs(1);
	//FORi(i,1,n) cout<<i<<" "<<tin[i]<<endl;
	//cout<<endl;
	vi ct(INF+1);
	FORi(i,1,n+1) ct[tin[i]] = 1;
	seg s;
	s.build(ct);
	FORi(i,1,n+1){
		if(kn[i]){
			//cout<<"Updating "<<tin[i]<<endl;
			s.update(tin[i], tin[i], 1);
		}
	}
	int qqq;
	cin>>qqq;
	while(qqq--){
		int qq, x, k;
		cin>>qq>>x>>k;
		if(qq==1){
			s.update(tin[x], tout[x]);
	//s.print();
	//cout<<endl;
		}
		else{
			cout<<s.query(tin[x], tout[x])<<endl;
		}
	}
}
