#include <bits/stdc++.h>
using namespace std;

vector<vector<int> > g;
vector<int> tin;
vector<int> tout;
vector<int> a;
vector<int> h;
vector<vector<int> > tour;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (int u : g[v]) {
        h[u] = h[v] + 1;
        dfs(u);
    }
    tout[v] = timer++;
    tour[h[v]].emplace_back(v);
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; ++i) {
        int p, v;
        cin >> p >> v;
        --p;
        --v;
        g[p].emplace_back(v);
    }
    a.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    tin.resize(n);
    tout.resize(n);
    h.assign(n, 0);
    tour.resize(n + 1);
    dfs(0);
    int q;
    cin >> q;
    if (q <= 10000 && n <= 10000) {
        while (q--) {
            int type;
            cin >> type;
            if (type == 1) {
                int v, k;
                cin >> v >> k;
                --v;
                for (int i = h[v]; i <= min(n, h[v] + k); ++i) {
                    for (int &u : tour[i]) {
                        if (tin[u] >= tin[v] && tout[u] <= tout[v])
                            a[u] = 1;
                    }
                }
            } else {
                int v, k;
                cin >> v >> k;
                --v;
                int sum = 0;
                for (int i = h[v]; i <= min(n, h[v] + k); ++i) {
                    for (int &u : tour[i]) {
                        if (tin[u] >= tin[v] && tout[u] <= tout[v])
                            sum += a[u];
                    }
                }
                cout << sum << '\n';
            }
        }
        return 0;
    }
    return 0;
}
