#include <bits/stdc++.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define se second
#define fi first

using namespace std;
using ll = long long;

struct S{
    int sum, sz;
    bool mod = 0;
};

int const N = 2e5 + 1;
vector <int> g[N];
int sum[N], tin[N], tout[N], _time = 0;
S t[4*N];
int mod[8*N];

void dfs(int v, int p = -1){
    tin[v] = _time++;
    for(auto u : g[v]){
        if(u == p){ continue;}
        dfs(u, v);
    }
    tout[v] = _time;
}

void build(int tl, int tr, int v, vector <int>& a){
    if(tl == tr){
        t[v].sum = a[tl];
        t[v].sz = 1;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(tl, tm, (v << 1) + 1, a);
    build(tm + 1, tr, (v << 1) + 2, a);
    t[v].sum = t[(v << 1) + 1].sum + t[(v << 1) + 2].sum;
    t[v].sz = t[(v << 1) + 1].sz + t[(v << 1) + 2].sz;
}

void push(int v){
    if(t[v].mod){
        t[v].sum = t[v].sz;
        if((v << 1) + 2 < 8*N){
            t[(v << 1) + 1].mod = 1;
            t[(v << 1) + 2].mod = 1;
        }
        t[v].mod = 0;
    }
}

void update(int l, int r, int tl, int tr, int v){
    r = min(r, tr);
    l = max(l, tl);
    push(v);
    if(l > r or tl > tr){
        return;
    }
    if(tl == l and tr == r){
        t[v].mod = 1;
        push(v);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(l, r, tl, tm, (v << 1) + 1);
    update(l, r, tm + 1, tr, (v << 1) + 2);
    t[v].sum = t[(v << 1) + 1].sum + t[(v << 1) + 2].sum;
    return;
}

int get(int l, int r, int tl, int tr, int v){
    r = min(r, tr);
    l = max(l, tl);
    push(v);
    if(l > r or tl > tr){
        return 0;
    }
    if(l == tl and r == tr){
        return t[v].sum;
    }
    int tm = (tl + tr) >> 1;
    return get(l, r, tl, tm, (v << 1) + 1) + get(l, r, tm + 1, tr, (v << 1) + 2);
}

signed main(){
    ibase;
    int n, q;
    cin >> n;
    for(int i = 0; i < n - 1; ++i){
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
    }
    vector <int> a(n);
    dfs(0);
    for(int i = 0; i < n; ++i){
        int b;
        cin >> b;
        a[tin[i]] = b;
    }
    build(0, n - 1, 0, a);
    cin >> q;
    while(q --> 0){
        int c, x, k;
        cin >> c >> x >> k;
        --x;
        //cout << "ADAd " << tin[x] << ' ' << tout[x] << endl;
        if(c == 1){
            update(tin[x], tout[x] - 1, 0, n - 1, 0);
        }
        else{
            cout << get(tin[x], tout[x] - 1, 0, n - 1, 0) << '\n';
        }
    }
/**
8
1 2
1 3
1 4
4 6
4 5
4 8
4 7
0 1 0 0 0 1 0 0
6
2 1 8
2 4 8
1 8 8
2 4 8
1 4 8
2 1 8
**/
}
