#include <bits/stdc++.h>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0);
#define se second
#define fi first

using namespace std;
using ll = long long;

struct S{
    int sum, sz;
    bool mod = 0;
};

struct S1{
    int c, x, k;
};

struct S2{
    int x, l, r, t, id;
};

int const N = 2e5 + 1;
int m = 0;
vector <int> g[N];
int sum[N], tin[N], tout[N], _time = 0, bt[N];
S t[4*N];
int tree[4*N];

void dfs(int v, int p = -1){
    if(p != -1){
        bt[v] = bt[p] + 1;
    }
    m = max(m, bt[v] + 1);
    tin[v] = _time++;
    for(auto u : g[v]){
        if(u == p){ continue;}
        dfs(u, v);
    }
    tout[v] = _time;
}

void build(int tl, int tr, int v, vector <int>& a){
    if(tl == tr){
        t[v].sum = a[tl];
        t[v].sz = 1;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(tl, tm, (v << 1) + 1, a);
    build(tm + 1, tr, (v << 1) + 2, a);
    t[v].sum = t[(v << 1) + 1].sum + t[(v << 1) + 2].sum;
    t[v].sz = t[(v << 1) + 1].sz + t[(v << 1) + 2].sz;
}

void push(int v){
    if(t[v].mod){
        t[v].sum = t[v].sz;
        if((v << 1) + 2 < 4*N){
            t[(v << 1) + 1].mod = 1;
            t[(v << 1) + 2].mod = 1;
        }
        t[v].mod = 0;
    }
}

void update(int l, int r, int tl, int tr, int v){
    r = min(r, tr);
    l = max(l, tl);
    push(v);
    if(l > r or tl > tr){
        return;
    }
    if(tl == l and tr == r){
        t[v].mod = 1;
        push(v);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(l, r, tl, tm, (v << 1) + 1);
    update(l, r, tm + 1, tr, (v << 1) + 2);
    t[v].sum = t[(v << 1) + 1].sum + t[(v << 1) + 2].sum;
    return;
}

int get(int l, int r, int tl, int tr, int v){
    r = min(r, tr);
    l = max(l, tl);
    push(v);
    if(l > r or tl > tr){
        return 0;
    }
    if(l == tl and r == tr){
        return t[v].sum;
    }
    int tm = (tl + tr) >> 1;
    return get(l, r, tl, tm, (v << 1) + 1) + get(l, r, tm + 1, tr, (v << 1) + 2);
}

bool comp(S2 a, S2 b){
    return a.x < b.x;
}

void _build(int tl, int tr, int v, vector <int>& a){
    if(tl == tr){
        tree[v] = a[tl];
        return;
    }
    int tm = (tl + tr) >> 1;
    _build(tl, tm, (v << 1) + 1, a);
    _build(tm + 1, tr, (v << 1) + 2, a);
    tree[v] = tree[(v << 1) + 1] + tree[(v << 1) + 2];
}

void _update(int tl, int tr, int v, int pos, int k){
    if(pos < tl or tr < pos or tl > tr){
        return;
    }
    if(tl == pos and tr == pos){
        tree[v] += k;
        return;
    }
    int tm = (tl + tr) >> 1;
    _update(tl, tm, (v << 1) + 1, pos, k);
    _update(tm + 1, tr, (v << 1) + 2, pos, k);
    tree[v] = tree[(v << 1) + 1] + tree[(v << 1) + 2];
    return;
}

int _get(int l, int r, int tl, int tr, int v){
    r = min(r, tr);
    l = max(l, tl);
    if(l > r or tl > tr){
        return 0;
    }
    if(l == tl and r == tr){
        return tree[v];
    }
    int tm = (tl + tr) >> 1;
    return _get(l, r, tl, tm, (v << 1) + 1) + _get(l, r, tm + 1, tr, (v << 1) + 2);
}

signed main(){
    ibase;
    int n, q;
    cin >> n;
    for(int i = 0; i < n - 1; ++i){
        int v, u;
        cin >> v >> u;
        --v; --u;
        g[v].push_back(u);
    }
    vector <int> a(n), _tin(n);
    bt[0] = 0;
    dfs(0);
    for(int i = 0; i < n; ++i){
        int b;
        cin >> b;
        a[tin[i]] = b;
        _tin[tin[i]] = i;
    }
    bool f = 1;
    cin >> q;
    vector <S1> v(q);
    for(int i = 0; i < q; ++i){
        cin >> v[i].c >> v[i].x >> v[i].k;
        if(v[i].c == 1){
            f = 0;
        }
    }
    if(!f){
        build(0, n - 1, 0, a);
        for(int i = 0; i < q; ++i){
            int c = v[i].c, x = v[i].x, k = v[i].k;
            --x;
            if(c == 1){
                update(tin[x], tout[x] - 1, 0, n - 1, 0);
            }
            else{
                cout << get(tin[x], tout[x] - 1, 0, n - 1, 0) << '\n';
            }
        }
        return 0;
    }
    vector <S2> v2;
    vector <int> ans(q, 0);
    for(int i = 0; i < q; ++i){
        int c = v[i].c, x = v[i].x, k = v[i].k;
        --x;
        //cout << x << ' ' << tin[x] - 1 << "  " << tout[x] << ' ' << bt[x] << ' ' << min(m - 1, bt[x] + k) << endl;
        if(tin[x]){
            v2.push_back({tin[x] - 1, bt[x], min(m - 1, bt[x] + k), -1, i});
        }
        v2.push_back({tout[x], bt[x], min(m - 1, bt[x] + k), 1, i});
    }
    sort(v2.begin(), v2.end(), comp);
    int j = 0;
    vector <int> gig(m, 0);
    _build(0, m - 1, 0, gig);
    for(int i = 0; i < n; ++i){
        if(a[i]){
            _update(0, m - 1, 0, bt[_tin[i]], 1);
            //cout << "B    " << i << ' ' << _tin[i] << ' ' << a[i] << ' ' << bt[_tin[i]] << endl;
        }
        while(j < v2.size() and v2[j].x == i){
            //cout << "A   " << v2[j].l << ' ' << v2[j].r << ' ' << get(v2[j].l, v2[j].r, 0, m - 1, 0) << endl;
            ans[v2[j].id] += _get(v2[j].l, v2[j].r, 0, m - 1, 0) * v2[j].t;
            ++j;
        }
    }
    while(j < v2.size()){
        //cout << "A   " << v2[j].l << ' ' << v2[j].r << ' ' << get(v2[j].l, v2[j].r, 0, m - 1, 0) << endl;
        ans[v2[j].id] += _get(v2[j].l, v2[j].r, 0, m - 1, 0) * v2[j].t;
        ++j;
    }
    for(auto w : ans){
        cout << w << '\n';
    }
/**
8
1 2
2 3
1 4
4 6
4 5
6 7
6 8
1 1 0 0 1 1 1 0
6
2 1 8
2 4 8
2 1 1
2 1 2
2 4 1
2 4 2
**/
}
