#include <bits/stdc++.h>

using namespace std;

constexpr int NMAX = 2005;
typedef pair <int, int> PII;
typedef pair <int, PII> PIII;

int N;
int S[NMAX], E[NMAX];
int moved[NMAX];

int sp[NMAX];

vector <PII> G[NMAX];
vector <int> asc;

vector <PIII> V;

void Dfs (int Node) {
    for (int i = 0; i < asc.size(); ++ i )
        V.push_back({sp[Node] - sp[asc[i]], {asc[i], Node}});
    asc.push_back(Node);

    for (auto it : G[Node]) {
        sp[it.first] = sp[Node] + it.second;

        Dfs(it.first);
    }
    asc.pop_back();
}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> N;

    for (int i = 1; i <= N; ++ i )
        cin >> S[i];
    for (int i = 1; i <= N; ++ i )
        cin >> E[i];

    for (int i = 1; i < N; ++ i ) {
        int x, cost;
        cin >> x >> cost;

        G[x].push_back({i+1, cost});
    }

    Dfs(1);
    sort(V.begin(), V.end());
}

void Solve () {
    int ans = 0;
    for (int i = V.size()-1; i >= 0; -- i ) {
        int from = V[i].second.first, to = V[i].second.second;
        int dist = V[i].first;

        if (S[from] + moved[from] == 0 || moved[to] == E[to]) continue;

        if (dist < 0) continue;

        int cnt = min(S[from] + moved[from], E[to] - moved[to]);
        ans = (1LL * ans + 1LL * dist * cnt);

        int cnt_moved = min(moved[from], E[to] - moved[to]);
        moved[from] -= cnt_moved;
        moved[to] += cnt_moved;

        cnt -= cnt_moved;
        S[from] -= cnt;
        moved[to] += cnt;
    }

    cout << ans << '\n';
}

int main () {
    Read();
    Solve();

    return 0;
}
