#include <iostream>
#include <cstdio>
#include <vector>

int p [ 500'005 ] = { 0 } ;
std::vector<int> c [ 500'005 ] ;
std::vector<int> w [ 500'005 ] ;

int s [ 500'005 ] = { 0 } ;
int e [ 500'005 ] = { 0 } ;

std::pair<int,int> push ( int root , int score = 0 ) {
	std::pair<int,int> b = { root , ( e [ root ] > 0 ) ? score : 0 };
	for ( int i = 0 ; i < c [ root ].size ( ) ; i++ ) {
		std::pair<int,int> t = push ( c [ root ][ i ] , score + w [ root ][ i ] ) ;
		if ( t.second >= b.second )
			b = t ;
	}
	return b;
}

int dfs ( int root ) {
	int ans = 0 ;
	int k = s [ root ] ;
	for ( int j = 0 ; j < k ; j++ ) {
		std::pair<int,int> r = push ( root ) ;
		if ( r.second > 0 ) {
			// printf ( "%d was moved to %d, %d\n" , root + 1 , r.first + 1 , r.second ) ;
			e [ r.first ]--;
			s [ root ]--;
			ans += r.second;
		}else{
			break;
		}
	}
	for ( int i = 0 ; i < c[ root ].size() ; i++ ) {
		ans += dfs ( c [ root ][ i ] ) ;
	}
	return ans ;
}

int main ( void ) {
	int N ;
	scanf ( " %d" , &N ) ;
	for ( int i = 0 ; i < N ; i++ ) {
		scanf ( " %d" , &s [ i ] ) ;
	}
	for ( int i = 0 ; i < N ; i++ ) {
		scanf ( " %d" , &e [ i ] ) ;
	}
	for ( int i = 1 ; i < N ; i++ ) {
		int Par , Wh ;
		scanf ( " %d %d" , &Par , &Wh ) ;
		Par--;
		c [ Par ].push_back ( i ) ;
		w [ Par ].push_back ( Wh ) ;
		p [ i ] = Par ;
	}
	printf ( "%d\n" , dfs ( 0 ) ) ;
	return 0;
}

/*
5
5 1 0 0 0
100 1 1 2 4
1 6
1 1
2 2
2 -1
*/
