//#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

int k;

unordered_map<ll, int> mapa;

int encode(int a, int b) {
    return 3001LL * b + a;
}

int grundy(int a, int b) {
    if (mapa.count(encode(a, b))) {
        return mapa[encode(a, b)];
    } 
    if (a == b && b == 0) {
        return 0;
    }
    if (a == 0) {
        return b;
    }
    if (a > 0 && b >= 100) {
        return 1000;
    }
    if (b != 0 && grundy(a, b - 1) > 100) {
        return mapa[encode(a, b)] = grundy(a, b - 1) + 1;
    }
    vector<int> arr;
    for (int i = 0; i <= a; i++) {
        for (int j = k * i; j <= b + (i != 0 ? 40 : 0); j++) {
            if (i != 0 || j != b) {
                int a1 = a - i;
                int b1 = j;
                arr.push_back(grundy(a1, b1));
            }
        } 
    }
    sort(arr.begin(), arr.end());
    arr.erase(unique(arr.begin(), arr.end()), arr.end());
    if (arr.back() == (int) arr.size() - 1) {
        return mapa[encode(a, b)] = arr.back() + 1;
    }
    for (int i = 0; ; i++) {
        if (arr[i] != i) {
            return mapa[encode(a, b)] = i;
        }
    }
    assert(false);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    int tot = 0;
    for (auto [a, b] : arr) {
        tot ^= grundy(a, b);
    }
    if (tot == 0) {
        cout << "Loss" << '\n';
    } else {
        cout << "Win\n";
    }
#ifdef LOCAL
    cout.flush();
#endif
}

void test() {
    k = 1;
    int n = 40;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 10; j++) {
            cout << setw(3) << grundy(i, j) << " ";
            cout.flush();
        }
        cout << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    test();
    return 0;
#endif
    cin >> k;
    int t = 1;
    cin >> t; // comment if no multitest
    while (t--) {
        solve();
    }
}
