#include <bits/stdc++.h>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int,int>pi;
typedef vector<pi> vpi;

#define GLHF ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define pb push_back
#define out(x) {cout << x << "\n";return;}

void solve();
int main(){
    GLHF;
    solve();
}

const int maxn=2e5+1;
vi g[maxn];
vi a;

vi sum,sz;

void dfs_sz(int src,int par){
    sz[src]=1,sum[src]=a[src];
    for(int nbr:g[src])
        if(nbr!=par)
            dfs_sz(nbr,src),sz[src]+=sz[nbr],sum[src]+=sum[nbr];
}


void dfs(int src,int k,int par){
    if(sum[src]==sz[src])
        return;
    sum[src]=sz[src];

    for(int nbr:g[src])
        if(nbr!=par)
            dfs(nbr,k,src);
}


void solve(){
    int n;
    cin >> n;

    for(int i=0; i<n-1; i++){
        int u,v;
        cin >> u>> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    sum.resize(n+1);
    sz.resize(n+1);
    a.resize(n+1);

    for(int i=1; i<=n; i++){
        int x;
        cin >> x;
        a[i]=x;
    }

    dfs_sz(1,-1);
    int q;
    cin >> q;

    while(q--){
        int op,x,k;
        cin >> op >> x >> k;

        if(op==1){
            dfs(x,k,-1);
        }
        else{
            cout << sum[x] << "\n";

        }

    }
}