#include <bits/stdc++.h>

using namespace std;
#define fast ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
#define endl '\n'
#define ff first
#define ss second
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
#define int long long

const int N = 2e5 + 7;
const int LOG = 20;

vector<int> g[N];
vector<int> down[N][LOG];
int up[N][LOG];
int cur[N][LOG];
int a[N];

void dfs(int v,int p) {
    up[v][0] = p;
    if(up[v][0]) down[up[v][0]][0].push_back(v),cur[up[v][0]][0] += a[v];
    for(int log = 1;log <= LOG - 1; ++log) {
        up[v][log] = up[up[v][log - 1]][log - 1];
        if(up[v][log]) down[up[v][log]][log].push_back(v),cur[up[v][log]][log] += a[v];
    }
    for(int u : g[v]) {
        dfs(u,v);
    }
}

int ask(int v,int k,int level) {
    //cout << v << ' ' << k << ' ' << level << endl;
    int res = 0;
    for(int log = 0;log <= LOG - 1; ++log) {
        if(level + (1 << log) <= k) {
            res += cur[v][log];
            for(int x : down[v][log]) {
                res += ask(x,k,level + (1 << log));
            }
            break;
        }
    }
    return res;
}

signed main()
{
    fast;
    int n;
    cin >> n;
    for(int i = 2;i <= n; ++i) {
        int v,u;
        cin >> v >> u;
        g[v].push_back(u);
    }
    for(int i = 1;i <= n; ++i) {
        cin >> a[i];
    }
    dfs(1,0);
    int q;
    cin >> q;
    while(q--) {
        int type;
        cin >> type;
        if(type == 2) {
            int v,k;
            cin >> v >> k;
            cout << a[v] + ask(v,k,0) << endl;
        }
    }
    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1
0 1 0 1
3
2 1 1
2 4 4
2 3 0
*/
