#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;
//using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

bool solve(int n, vector<pair<int, int>>& v) {
    int sumStones = 0, sumGal = 0;
    bool wasStone = false;
    for (auto [b, s] : v) {
        sumStones ^= b;
        sumGal ^= s;
        if (b) {
            wasStone = true;
        }
    }
    if (!wasStone) {
        return sumGal;
    }
    return sumStones ^ sumGal;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k, q;
    cin >> k >> q;
    while (q--) {
        int n;
        cin >> n;
        vector<pair<int, int>> v(n);
        for (auto& [i, j] : v) {
            cin >> i >> j;
        }
        cout << (solve(n, v) ? "Win\n" : "Loss\n");
    }
    return 0;
}
