//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>
//
using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 10;
int d[N], tin[N], tout[N];
int globalT;
vector<int> vInDist[N];
vector<bool> isInformedInDist[N];
bool alreadyKnows[N];
ordered_set tins;
vector<int> vtins;

void dfs(int i, vector<vector<int>>& g, int currD = 0) {
    tin[i] = globalT;
    ++globalT;
    if (!alreadyKnows[i]) {
        tins.insert(tin[i]);
    }
    vtins.push_back(tin[i]);
    d[i] = currD;
    vInDist[currD].push_back(tin[i]);
    isInformedInDist[currD].push_back(alreadyKnows[i]);
    for (int j : g[i]) {
        dfs(j, g, currD + 1);
    }
    tout[i] = globalT;
    ++globalT;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    //freopen("input.txt", "r", stdin);
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    long long root = (long long)(n) * ((long long)(n) - 1LL) / 2LL;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        root -= y;
        g[x].push_back(y);
    }
    for (int i = 0; i < n; ++i) {
        int tmp;
        cin >> tmp;
        alreadyKnows[i] = tmp;
    }
    globalT = 0;
    dfs(root, g);
    int q;
    cin >> q;
    while (q--) {
        int type, x , k;
        cin >> type >> x >> k;
        --x;
        if (type == 1) {
            while (true) {
                auto it = tins.lower_bound(tin[x]);
                if (it == tins.end() || *it > tout[x]) {
                    break;
                }
                tins.erase(it);
            }
        } else {
            cout << upper_bound(vtins.begin(),  vtins.end(), tout[x]) - lower_bound(vtins.begin(),  vtins.end(), tin[x]) - (tins.order_of_key(tout[x]) - tins.order_of_key(tin[x])) << '\n';
            // count know amount
        }
    }
    return 0;
}