//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>
//
using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 10;
int d[N], tin[N], tout[N];
int globalT;
vector<int> tinInDist[N];
vector<int> scoreInDist[N];
vector<int> prefScoreInDist[N];
vector<bool> isInformedInDist[N];
bool alreadyKnows[N];
ordered_set tins;
vector<int> vtins;
int scoreInSubTree[N];

void dfs(int i, vector<vector<int>>& g, int currD = 0) {
    tin[i] = globalT;
    ++globalT;
    if (!alreadyKnows[i]) {
        tins.insert(tin[i]);
    }
    scoreInSubTree[i] = alreadyKnows[i];
    vtins.push_back(tin[i]);
    d[i] = currD;
    tinInDist[currD].push_back(tin[i]);
    int ind = scoreInDist[currD].size();
    scoreInDist[currD].push_back(-1);
    prefScoreInDist[currD].push_back(-1);
    isInformedInDist[currD].push_back(alreadyKnows[i]);
    for (int j : g[i]) {
        dfs(j, g, currD + 1);
        scoreInSubTree[i] += scoreInSubTree[j];
    }
    scoreInDist[currD][ind] = scoreInSubTree[i];
    prefScoreInDist[currD][ind] = scoreInDist[currD][ind];
    if (ind > 0) {
        prefScoreInDist[currD][ind] += prefScoreInDist[currD][ind - 1];
    }
    tout[i] = globalT;
    ++globalT;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    long long root = (long long)(n) * ((long long)(n) - 1LL) / 2LL;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        root -= y;
        g[x].push_back(y);
    }
    for (int i = 0; i < n; ++i) {
        int tmp;
        cin >> tmp;
        alreadyKnows[i] = tmp;
    }
    globalT = 0;
    dfs(root, g);
    int q;
    cin >> q;
    while (q--) {
        int type, x , k;
        cin >> type >> x >> k;
        --x;
        if (type == 1) {
            continue;
        } else {
            int banDist = d[x] + k + 1;
            int delta = 0;
            if (tinInDist[banDist].empty()) {
                delta = 0;
            } else {
                int l = lower_bound(tinInDist[banDist].begin(),  tinInDist[banDist].end(), tin[x]) - tinInDist[banDist].begin();
                int r = upper_bound(tinInDist[banDist].begin(),  tinInDist[banDist].end(), tout[x]) - tinInDist[banDist].begin();
                --r;
                //cout << l << ' ' << r << '\n';
                if (r > 0) {
                    delta += prefScoreInDist[banDist][r];
                }
                if (l - 1 >= 0) {
                    delta -= prefScoreInDist[banDist][l - 1];
                }
            }

            cout << scoreInSubTree[x] - delta << '\n';
        }
    }
    return 0;
}