//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>
//
using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 10;
int d[N], tin[N], tout[N];
int globalT;
vector<int> tinInDist[N];
vector<int> soloScoreInDist[N];
bool alreadyKnows[N];
int MAXDIST = 0;

//struct segtree {
//    struct node {
//        int set, sum, len;
//    };
//
//    int n;
//    vector<node> tree;
//    const int NO_OP = -1;
//
//    void build(vector<int>& a) {
//        n = 1;
//        while (n < a.size()) {
//            n *= 2;
//        }
//        tree.assign(n * 2, {NO_OP, 0, 1});
//        for (int i = 0; i < a.size(); ++i) {
//            tree[i + n - 1] = {NO_OP, a[i], 1};
//        }
//        for (int i = n - 2; i >= 0; --i) {
//            tree[i].sum = tree[2 * i + 1].sum + tree[2 * i + 2].sum;
//            tree[i].len = tree[2 * i + 1].len + tree[2 * i + 2].len;
//        }
//    }
//
//    void propagate(int x) {
//        if (x >= n - 1 || tree[x].set == NO_OP) {
//            return;
//        }
//        tree[x * 2 + 1].set = tree[x].set;
//        tree[x * 2 + 1].sum = tree[x * 2 + 1].len * tree[x].set;
//        tree[x * 2 + 2].set = tree[x].set;
//        tree[x * 2 + 2].sum = tree[x * 2 + 2].len * tree[x].set;
//        tree[x].set = NO_OP;
//        tree[x].sum = tree[2 * x + 1].sum + tree[2 * x + 2].sum;
//    }
//
//    void modify(int l, int r, int x, int lx, int rx) {
//        propagate(x);
//        if (lx > r || rx < l) {
//            return;
//        }
//        if (l <= lx && rx <= r) {
//            tree[x].set = 1;
//            tree[x].sum = tree[x].len * tree[x].set;
//            return;
//        }
//        modify(l, r, x * 2 + 1, lx, (lx + rx) / 2);
//        modify(l, r, x * 2 + 2, (lx + rx) / 2 + 1, rx);
//    }
//
//    void modify(int l, int r) {
//        return modify(l, r, 0, 0, n - 1);
//    }
//
//    int get(int l, int r, int x, int lx, int rx) {
//        propagate(x);
//        if (lx > r || rx < l) {
//            return 0;
//        }
//        if (l <= lx && rx <= r) {
//            return tree[x].sum;
//        }
//        int a = get(l, r, x * 2 + 1, lx, (lx + rx) / 2);
//        int b = get(l, r, x * 2 + 2, (lx + rx) / 2 + 1, rx);
//        return a + b;
//    }
//
//    int get(int l, int r) {
//        if (r < l) {
//            return 0;
//        }
//        return get(l, r, 0, 0, n - 1);
//    }
//};

struct segtree {
    int n;
    vector<int> tree;

    void build(vector<int>& a) {
        n = 1;
        while (n < a.size()) {
            n *= 2;
        }
        tree.assign(n * 2, 0);
        for (int i = 0; i < a.size(); ++i) {
            tree[i + n - 1] = a[i];
        }
        for (int i = n - 2; i >= 0; --i) {
            tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
        }
    }

    void add(int i, int x) {
        i += n - 1;
        tree[i] += x;
        while (i) {
            i = (i - 1) / 2;
            tree[i] += x;
        }
    }

    int get(int l, int r, int x, int lx, int rx) {
        if (lx > r || rx < l) {
            return 0;
        }
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        int a = get(l, r, x * 2 + 1, lx, (lx + rx) / 2);
        int b = get(l, r, x * 2 + 2, (lx + rx) / 2 + 1, rx);
        return a + b;
    }

    int get(int l, int r) {
        if (r < l) {
            return 0;
        }
        return get(l, r, 0, 0, n - 1);
    }
};

struct level {
    segtree st;
    set<int> s; // zerosIndexes

    void build(vector<int>& a) {
        st.build(a);
        for (int i = 0; i < a.size(); ++i) {
            if (!a[i]) {
                s.insert(i);
            }
        }
    }

    void modify(int l, int r) {
        while (true) {
            auto it = s.lower_bound(l);
            if (it == s.end() || *it > r) {
                break;
            }
            st.add(*it, 1);
            s.erase(it);
        }
    }

    int get(int l, int r) {
        return st.get(l, r);
    }
};

void dfs(int i, vector<vector<int>>& g, int currD = 0) {
    MAXDIST = max(MAXDIST, currD);
    tin[i] = globalT;
    ++globalT;
    d[i] = currD;
    tinInDist[currD].push_back(tin[i]);
    soloScoreInDist[currD].push_back(alreadyKnows[i]);
    for (int j : g[i]) {
        dfs(j, g, currD + 1);
    }
    tout[i] = globalT;
    ++globalT;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    long long root = (long long)(n) * ((long long)(n) - 1LL) / 2LL;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        --x, --y;
        root -= y;
        g[x].push_back(y);
    }
    for (int i = 0; i < n; ++i) {
        int tmp;
        cin >> tmp;
        alreadyKnows[i] = tmp;
    }
    globalT = 0;
    dfs(root, g);
    vector<level> stInDist(MAXDIST + 1);
    for (int i = 0; !soloScoreInDist[i].empty(); ++i) {
        stInDist[i].build(soloScoreInDist[i]);
    }
    int q;
    cin >> q;
    while (q--) {
        int type, x , k;
        cin >> type >> x >> k;
        --x;
        if (type == 1) {
            for (int i = d[x]; i <= d[x] + k && i < N && !tinInDist[i].empty(); ++i) {
                int l = lower_bound(tinInDist[i].begin(),  tinInDist[i].end(), tin[x]) - tinInDist[i].begin();
                if (l < tinInDist[i].size()) {
                    int r = upper_bound(tinInDist[i].begin(),  tinInDist[i].end(), tout[x]) - tinInDist[i].begin();
                    --r;
                    stInDist[i].modify(l, r);
                }
            }
        } else {
            int res = 0;
            for (int i = d[x]; i <= d[x] + k && i < N && !tinInDist[i].empty(); ++i) {
                int l = lower_bound(tinInDist[i].begin(),  tinInDist[i].end(), tin[x]) - tinInDist[i].begin();
                if (l < tinInDist[i].size()) {
                    int r = upper_bound(tinInDist[i].begin(),  tinInDist[i].end(), tout[x]) - tinInDist[i].begin();
                    --r;
                    res += stInDist[i].get(l, r);
                }
            }
            cout << res << '\n';
        }
    }
    return 0;
}