#include <bits/stdc++.h>

using namespace std;

#define int long long

typedef long long ll;

const int N=(int)5e5+7;
const int INF=(int)1e18;
int n,val[N],pref[N],kek,s[N],t[N];
vector<int> g[N];

pair<int,int>tree[4*N];

pair<int,int> getmin(int v,int tl,int tr,int l,int r){
  if (tr<l||r<tl)return {INF,INF};
  if (l<=tl&&tr<=r)return tree[v];
  int tm=(tl+tr)/2;
  return min(getmin(2*v,tl,tm,l,r),getmin(2*v+1,tm+1,tr,l,r));
}

void build(int v,int tl,int tr){
  if (tl==tr){
    tree[v]={pref[tl],tl};
  }else{
    int tm=(tl+tr)/2;
    build(2*v,tl,tm);
    build(2*v+1,tm+1,tr);
    tree[v]=min(tree[2*v],tree[2*v+1]);
  }
}

void del(int v,int tl,int tr,int i){
  if (tr<i||i<tl)return;
  if (tl==tr){
    tree[v]={INF,i};
  }else{
    int tm=(tl+tr)/2;
    del(2*v,tl,tm,i);
    del(2*v+1,tm+1,tr,i);
    tree[v]=min(tree[2*v],tree[2*v+1]);
  }
}

const int K=1000;
int dp[K],ndp[K];

signed main() {
  ios::sync_with_stdio(0); cin.tie(0);

  //freopen ("input","r",stdin);

  for (int i=0;i<K;i++)dp[i]=ndp[i]=-INF;

  cin>>n;
  for (int i=1;i<=n;i++){
    cin>>s[i];
    assert(s[i]==1);
  }
  for (int i=1;i<=n;i++){
    cin>>t[i];
    assert(t[i]==1);
  }


  for (int i=2;i<=n;i++){
    int par;
    cin>>par;
    assert(par==i-1);
    cin>>val[i];
  }


  dp[0]=0;

  for (int i=1;i<=n;i++){
    pref[i]=pref[i-1]+val[i];
    for (int bef=0;bef<K-1;bef++){
      ndp[bef]=max(ndp[bef],dp[bef]);
      if (bef){
        ndp[bef-1]=max(ndp[bef-1],dp[bef]+pref[i]);
      }
      ndp[bef+1]=max(ndp[bef+1],dp[bef]-pref[i]);
    }
    for (int j=0;j<K;j++){
      dp[j]=ndp[j];
      ndp[j]=-INF;
    }
  }

  build(1,1,n);

  vector<pair<int,int>> ord;
  for (int i=1;i<=n;i++)ord.push_back({pref[i],i});
  sort(ord.rbegin(),ord.rend());

  int sol=0;


  for (auto &ii:ord){
    int i=ii.second;
    auto it=getmin(1,1,n,1,i);
    int j=it.second;
    assert(1<=j&&j<=i);
    if (it.first>=pref[i])continue;
    del(1,1,n,j);
    assert(it.first==pref[j]);
    sol+=pref[i]-it.first;
  }
  cout<<max(dp[0],sol)<<"\n";

  return 0;
}
