#include <bits/stdc++.h>

using namespace std;

const int N=(int)2e5+7;
const int K=444;
int n,lft[N],rgh[N],top,dep[N],bucket[N],first[N],last[N],all[N],thebest[N],maxdep;
int iss[N];
vector<int> g[N];
vector<int> ord[N];
vector<int> nodes[N];
vector<int> lastsmall[N];
vector<int> pref[N];

bool cmp(int i,int j){
  return dep[i]<dep[j];
}

void build(int a,int curdep){
  lft[a]=++top;
  maxdep=max(maxdep,curdep);
  dep[top]=curdep;

  for (auto &b:g[a]){
    build(b,curdep+1);
  }
  rgh[a]=top;
}

void update(int v){
  iss[v]=1;

  int i=bucket[v];
  int cur=0;
  for (int j=0;j<(int)pref[i].size();j++){
    cur+=iss[nodes[i][j]];
    pref[i][j]=cur;
  }
}

void unwrap(int id){
  if (all[id]==0||all[id]<thebest[id]){
    all[id]=0;
    return;
  }
  thebest[id]=all[id];
  for (int i=first[id];i<=last[id];i++){
    if (dep[i]<=all[id]&&iss[i]==0){
      update(i);
    }
  }
  all[id]=0;
}

void upd(int l,int r,int limit){
  if (bucket[l]==bucket[r]){
    unwrap(bucket[l]);
    for (int i=l;i<=r;i++) {
      if (dep[i]<=limit&&iss[i]==0){
        update(i);
      }
    }
    return;
  }
  unwrap(bucket[l]);
  unwrap(bucket[r]);
  for (int i=bucket[l]+1;i<bucket[r];i++){
    all[i]=max(all[i],limit);
  }

  for (int i=l;i<=last[bucket[l]];i++) if (dep[i]<=limit&&iss[i]==0)update(i);
  for (int i=first[bucket[r]];i<=r;i++) if (dep[i]<=limit&&iss[i]==0)update(i);


}

int get(int l,int r,int limit){
  limit=min(limit,maxdep);
  int sol=0;
  if (bucket[l]==bucket[r]){
    unwrap(bucket[l]);
    for (int i=l;i<=r;i++){
      if (iss[i]&&dep[i]<=limit){
        sol++;
      }
    }
    return sol;
  }
  unwrap(bucket[l]);
  unwrap(bucket[r]);
  for (int i=l;i<=last[bucket[l]];i++) if (iss[i]&&dep[i]<=limit)sol++;
  for (int i=first[bucket[r]];i<=r;i++) if (iss[i]&&dep[i]<=limit)sol++;


  for (int id=bucket[l]+1;id<bucket[r];id++){
    if (lastsmall[id][limit]>=0){
      sol+=pref[id][lastsmall[id][limit]];
    }
    int mn=min(limit,all[id]);
    if (lastsmall[id][mn]>=0){
      sol+=(lastsmall[id][mn]+1-pref[id][lastsmall[id][mn]]);
    }
  }

  return sol;
}

int main() {
  ios::sync_with_stdio(0); cin.tie(0);

  //freopen ("input","r",stdin);

  cin>>n;
  int rad=sqrt(n);
  for (int i=1;i<=n;i++){
    bucket[i]=(i-1)/rad+1;
    last[bucket[i]]=i;
    nodes[bucket[i]].push_back(i);
  }
  for (int i=n;i>=1;i--){
    first[bucket[i]]=i;
  }
  for (int i=bucket[1];i<=bucket[n];i++){
    pref[i].resize(last[i]-first[i]+1,0);
  }


  for (int i=1;i<n;i++){
    int x,y;
    cin>>x>>y;
    g[x].push_back(y);
  }

  build(1,0);


  for (int i=bucket[1];i<=bucket[n];i++){
    sort(nodes[i].begin(),nodes[i].end(),cmp);
    /// dep[nodes[i][j]]<=limit
    int pz=0;
    for (int limit=0;limit<=maxdep;limit++){
      while (pz<(int)nodes[i].size()&&dep[nodes[i][pz]]<=limit){
        pz++;
      }
      lastsmall[i].push_back(pz-1);
    }
  }


  for (int i=1;i<=n;i++){
    int is;
    cin>>is;
    if (is){
      upd(lft[i],lft[i],dep[lft[i]]);
    }
  }


  int q;
  cin>>q;
  while (q--){
    int type,x,k,l,r,val;
    cin>>type>>x>>k;
    l=lft[x];
    r=rgh[x];
    val=dep[l]+k;


    if (type==1){
      upd(l,r,val);
    }else{
      cout<<get(l,r,val)<<"\n";
    }
  }

  return 0;
}
