#include <iostream>
#include <vector>

using namespace std;

vector<int> g[201010];
bool know[201010];
int q;
void dfsMark(int v, int depth, int mx) {
    know[v] = true;
    if (depth >= mx)return;
    for (auto to : g[v]) {
        dfsMark(to, depth + 1, mx);
    }
}
void mark(int x, int k) {
    dfsMark(x, 0, k);
}

int ans = 0;
void dfsGet(int v, int depth, int mx) {
    ans += know[v];
    if (depth >= mx)return;
    for (auto to : g[v]) {
        dfsGet(to, depth + 1, mx);
    }
}
int get(int x, int k) {
    ans = 0;
    dfsGet(x, 0, k);
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }
    for (int i = 1; i <= n; i++)cin >> know[i];
    cin >> q;
    while (q--) {
        int type, x, k;
        cin >> type >> x >> k;
        if (type == 1) {
            mark(x, k);
        } else {
            cout << get(x, k) << '\n';
        }
    }
}

/**
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0
1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/
