#include <bits/stdc++.h>

#define lf (h << 1)
#define mf ((l + r) >> 1)
#define rf ((h << 1) | 1)
#define tree int h, int l, int r
#define left lf, l, mf
#define right rf, mf + 1, r
#define pb push_back

using namespace std;

const int N = 2e5 + 5;

bool used[N];
int n, q, timer, in[N], out[N], T[N], X[N], K[N], Qt[N], dep[N];
vector < int > v[N], Gr[N], Q[N];
set < int > st[10 * N];

int idx, val;
inline void ins(tree) {
	st[h].insert(val);
	if (l == r) return ;
	if (idx <= mf) {
		ins(left);
	}
		else {
		ins(right);		
	}
}

int L, R;
inline int get(tree) {
	if (R < l || r < L) return 1e9;
	if (L <= l && r <= R) {
		while (st[h].size() && used[(*st[h].begin())]) {
			st[h].erase(st[h].find(*st[h].begin()));
		}
		if (st[h].size()) 
			return (*st[h].begin());
		return 1e9;
 	}
 	return min(get(left), get(right));
}

inline void dfs(int x, int p) {
	in[x] = ++timer;
	dep[x] = dep[p] + 1;
	for (int i = 0; i < Gr[x].size(); ++i) {
		int id = Gr[x][i];
		idx = dep[X[id]] + K[id], val = id;
		ins(1, 1, 2 * n);
	}
	
	L = dep[x], R = 2 * n;
	Qt[x] = min(Qt[x], get(1, 1, 2 * n));
	for (int i = 0; i < v[x].size(); ++i) {
		int to = v[x][i];
		if (to == p) continue;
		dfs(to, x);
	}
	
	for (int i = 0; i < Gr[x].size(); ++i) {
		int id = Gr[x][i];
		used[id] = true;
	}
	out[x] = timer;
}

vector < int > G[5 * N], rG[5 * N];
int tt;

inline int fet(int h, int x) {
	int res = 0;
	while (x > 0) {
		res += G[h][x];
		x -= (x & -x);
	}
	return res;
}

inline void up(int h, int x) {
	while (x <= G[h].size()) {
		++G[h][x];
		x += (x & -x);
	}
}

inline int bs(int h, int val) {
	int lo = 0, hi = rG[h].size() - 1, mid, res = 0;
	while (lo <= hi) {
		mid = (lo + hi) / 2;
		if (rG[h][mid] <= val) 
			res = mid, lo = mid + 1;
				else 
			hi = mid - 1;
	}
	return res;
}

inline void upd(tree) {
	if (tt == 1) {
		rG[h].pb(val);
	}
		else 
	if (tt == 2) {
		assert(bs(h, val) > 0);
		up(h, bs(h, val)); 		
	}
	
	if (l == r) return;
	if (idx <= mf) {
		upd(left);	
	}
		else {
		upd(right);
	}
}

inline int get_ans(tree) {
	if (r < L || R < l) return 0;
	if (L <= l && r <= R) return fet(h, bs(h, val));
	return get_ans(left) + get_ans(right);
}

main () {
	ios::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	
	cin >> n;
	for (int i = 1; i < n; ++i) {
		int a, b;
		cin >> a >> b;
		v[a].pb(b);
		v[b].pb(a);
	}
	
	for (int i = 1; i <= n; ++i) {
		int x;
		cin >> x;
		x ^= 1;
		if (x) x = 1e9;
		Qt[i] = x;
	}
	
	cin >> q;
	for (int i = 1; i <= q; ++i) {
		cin >> T[i] >> X[i] >> K[i];
		if (T[i] == 1) {
			Gr[X[i]].pb(i);
		}
	}
	
	dfs(1, 1);
	for (int i = 1; i <= n; ++i) {
		if (Qt[i] == 1e9) continue;
		Q[Qt[i]].pb(i);
 		tt = 1;
		idx = in[i];
		val = dep[i];
		upd(1, 1, n);	
	}
	
	for (int i = 1; i <= 4 * n; ++i) {
		rG[i].pb(0);
		sort(rG[i].begin(), rG[i].end());
		rG[i].erase(unique(rG[i].begin(), rG[i].end()), rG[i].end());
		G[i].resize(2 * rG[i].size());
	}

 	T[0] = 1;
	for (int i = 0; i <= q; ++i) {
		if (T[i] == 1) {
			for (int j = 0; j < Q[i].size(); ++j) {
				int id = Q[i][j];
				tt = 2;
				idx = in[id];
				val = dep[id];
				upd(1, 1, n);
			}
		}
			else
		if (T[i] == 2) {
			L = in[X[i]], R = out[X[i]];
			val = min(n, dep[X[i]] + K[i]);
			cout << get_ans(1, 1, n) << "\n";
		}
	}
}
