#include <bits/stdc++.h> 

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;

vvi graph;
vi sons;
vi par;
vb full;
vb heard;

void dfss(int v, int p) {
	par[v] = p;
	sons[v] = 1;
	bool flag = true;
	for (int i = 0; i < graph[v].size(); i++) {
		int u = graph[v][i];
		if (u != p) {
			dfss(u, v);
			sons[v] += sons[u];
			if (!full[u]) flag = false;
		}
	}
	if (!heard[v]) flag = false;
	full[v] = flag;
}


int dfs2(int v, int p) {
	if (full[v]) return sons[v];
	int ans = 0;
	if (heard[v])ans++;
	for (int i = 0; i < graph[v].size(); i++) {
		int u = graph[v][i];
		if (u != p) {
			ans += dfs2(u, v);
		}
	}
	return ans;
}

bool isfull(int v) {
	if (par[v] == -1) return full[v];
	if (full[v]) return true;
	return isfull(par[v]);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	vi ans;

	int n, q;
	cin >> n;

	graph.resize(n + 1);
	full.resize(n + 1, false);
	heard.resize(n + 1, false);
	par.resize(n + 1, -1);
	sons.resize(n + 1, 0);

	int a, b;
	for (int i = 0; i < n - 1; i++) {
		cin >> a >> b;
		graph[a].push_back(b);
		graph[b].push_back(a);
	}

	for (int i = 0; i < n; i++) {
		cin >> a;
		heard[i + 1] = a;
	}

	dfss(1, -1);
	cin >> q;
	int typ;
	for (int i = 0; i < q; i++) {
		cin >> typ >> a >> b;
		if (typ == 2) {
			if (isfull(a)) {
				ans.push_back(sons[a]);
			}
			else {
				int curr = dfs2(a, par[a]);
				ans.push_back(curr);
			}
		}
		else {
			full[a] = true;
		}
	}

	for (int i = 0; i < ans.size(); i++) {
		cout << ans[i] << endl;
	}

	return 0;
}

