#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define tiii tuple<int, int, int>

vector<vector<pii>> ed;
vector<int> dist;
vector<int> depth;

void dfs(int cur, int pr){
    depth[cur] = depth[pr] + 1;
    for (auto [to, w] : ed[cur]){
        if (to == pr) continue;
        dist[to] = dist[cur] + w;
        dfs(to, cur);
    }

}

signed main() {

    int n; cin >> n;
    vector<int> s(n+1), e(n+1);
    for (int i = 1; i <= n; ++i) cin >> s[i];
    for (int i = 1; i <= n; ++i) cin >> e[i];

    ed.resize(n+1);
    for (int i = 2; i <= n; ++i){
        int p, w; cin >> p >> w;
        ed[p].push_back(make_pair(i, w));
    }

    depth.resize(n+1);
    dist.resize(n+1);
    dfs(1, 1);

    vector<tiii> v;
    for (int i = 1; i <= n; ++i){
        for (int j = 1; j <= n; ++j){
            if (depth[i] >= depth[j]) continue;
            v.push_back(make_tuple(dist[j] - dist[i], i, j));
        }
    }

    sort(v.rbegin(), v.rend());
    int m = v.size();
    int ans = 0;
    for (int i = 0; i < m; ++i){
        auto [dist, x, y] = v[i];
        if (dist < 0) break;

        int k = min(s[x], e[y]);
        ans += dist * k;
        s[x] -= k;
        e[y] -= k;
    }

    cout << ans << "\n";



    return 0;
}
