#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > ed;
vector<int> b;
vector<bool> all;
vector<int> sz;

void dfs(int v){
    sz[v] = 1;
    for (auto to : ed[v]){
        dfs(to);
        sz[v] += sz[to];
    }

}

void assign(int v){
    if (all[v]) return;
    all[v] = true;
    for (auto to : ed[v]){
        assign(to);
    }
}

int cnt(int v, int cur, int mx){
    if (cur > mx) return 0;
    if (all[v]) return sz[v];
    int res = b[v];
    for (auto to : ed[v]){
        res += cnt(to, cur+1, mx);
    }
    return res;
}

int main() {

    int n; cin >> n;
    ed.resize(n+1);
    for (int i = 0; i < n-1; ++i){
        int u, v; cin >> u >> v;
        ed[u].push_back(v);
    }
    b.resize(n+1);
    all.resize(n+1);
    sz.resize(n+1);
    for (int i = 1; i <= n; ++i) cin >> b[i];

    dfs(1);

    int q; cin >> q;
    for (int i = 0; i < q; ++i){
        int t, x, k; cin >> t >> x >> k;
        if (t == 1) assign(x);
        else cout << cnt(x, 0, k) << "\n";
    }


    return 0;
}
