#include <bits/stdc++.h>

using namespace std;

#define int long long

int k;

bool solve_heaps(vector<int> heaps) {
    if(heaps.size() == 0) {
        return 0;
    }

    int xored = 0;
    for(auto e : heaps)
        xored ^= e;

    return (xored != 0);
}

bool test() {
    int n; cin >> n;
    vector<pair<int, int>> h(n);
    for(auto &e : h)
        cin >> e.first >> e.second;

    int xored_a = 0;
    int xored_b = 0;
    for(auto e : h) {
        xored_a ^= e.first;
        xored_b ^= e.second;
    }

    return (xored_a != 0) && (xored_b != 0);
}

int32_t main()
{
    int q;
    cin >> k >> q;

    for(int i = 0; i < q; i++) {
        if(test() == 1)
            cout << "Win" << endl;
        else
            cout << "Loss" << endl;
    }

    return 0;
}
