#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
using namespace std;

#define ll long long
#define add push_back
#define mp make_pair

const int N = 200001;

vector<int> g[N];
vector<pair<int, int>> k;
int timer, tin[N], tout[N], ch[N], s[N];

int bfs(int v, int len) {
    int ans = 0, l;
    queue<pair<int, int>> q;
    q.push(mp(v, 0));
    if (s[v] == 1) ans++;
    while (!q.empty() && q.front().second != len) {
        v = q.front().first;
        l = q.front().second;
        q.pop();
        for (int i = 0; i < g[v].size(); i++) {
            if (s[g[v][i]] == 1) ans++;
            q.push(mp(g[v][i], l + 1));
        }
    }
    return ans;
}

void bfs_update(int v, int len) {
    int l;
    queue<pair<int, int>> q;
    q.push(mp(v, 0));
    s[v] = 1;
    while (!q.empty() && q.front().second != len) {
        v = q.front().first;
        l = q.front().second;
        q.pop();
        for (int i = 0; i < g[v].size(); i++) {
            s[g[v][i]] = 1;
            q.push(mp(g[v][i], l + 1));
        }
    }
}

int main() {
    int n, q;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        g[a].add(b);
    }
    for (int i = 1; i <= n; i++) cin >> s[i];
    cin >> q;
    while (q--) {
        int a, x, b;
        cin >> a >> x >> b;
        if (a == 2) cout << bfs(x, b) << endl;
        else bfs_update(x, b);
    }
    return 0;
}