#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 2e5;
vector<int> g[maxn];
int know[maxn];
int tin[maxn];
vector<int> euler;
int tout[maxn];
int st[maxn * 4];
int t[maxn * 4];

void ddd(int v) {
    tin[v] = euler.size();
    euler.push_back(v);
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        ddd(to);
    }
    tout[v] = euler.size() - 1;
}

void push(int v, int tl, int tr) {
    int tm = (tl + tr) / 2;
    if (st[v] == -1)
        return;
    t[v * 2] = st[v] * (tm - tl + 1);
    t[v * 2 + 1] = st[v] * (tr - (tm + 1) + 1);
    st[v * 2] = st[v * 2 + 1] = st[v];
    st[v] = -1;
}

void upd(int v, int tl, int tr, int l, int r, int val) {
    if (tl > r || tr < l)return;
    if (l <= tl && tr <= r) {
        t[v] = val * (tr - tl + 1);
        st[v] = val;
        return;
    }
    push(v, tl, tr);
    int tm = (tl + tr) / 2;
    upd(v * 2, tl, tm, l, r, val);
    upd(v * 2 + 1, tm + 1, tr, l, r, val);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l)return 0;
    if (l <= tl && tr <= r) {
        return t[v];
    }
    push(v, tl, tr);
    int tm = (tl + tr) / 2;
    return get(v * 2, tl, tm, l, r) +
           get(v * 2 + 1, tm + 1, tr, l, r);
}

void dfs(int v, int h, int k) {
    if (h > k)return;
    know[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        dfs(to, h + 1, k);
    }
}

int calc(int v, int h, int k) {
    if (h > k)return 0;
    int ans = know[v];
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        ans += calc(to, h + 1, k);
    }
    return ans;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    for (int m = 0; m < maxn * 4; ++m) {
        st[m] = -1;
    }
    int n;
    cin >> n;
    for (int l = 0; l < n - 1; ++l) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
    }
    ddd(0);
    for (int j = 0; j < n; ++j) {
        int y;
        cin >> y;
        know[j] = y;
        upd(1, 0, n - 1, tin[j], tin[j], y);
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        int x, k;
        cin >> x >> k;
        x--;
        if (type == 1) {
            upd(1, 0, n - 1, tin[x], tout[x], 1);
        } else {
            cout << get(1, 0, n - 1, tin[x], tout[x]) << '\n';
        }
    }

}