#include <bits/stdc++.h>
#define all(s) s.begin(), s.end()
#define fr first
#define sc second
using namespace std;

const int nmax = 200005;

int n, q, b[nmax], par[nmax], first[nmax], last[nmax], aib[2*nmax], sign[nmax];
vector<int>nod[nmax];
vector<int>euler;

void precalc(int s, int p = 0){
    euler.push_back(s);
    par[s] = p;
    for(auto it : nod[s]){
        if(it != p) precalc(it, s);
    }
    euler.push_back(s);
}

void update(int pos, int val){
    for(int i=pos;i<=400008;i+=(i&-i)){
        aib[i] += val;
    }
}

int query(int pos){
    int sum = 0;
    for(int i=pos;i>=1;i-=(i&-i)){
        sum += aib[i];
    }
    return sum;
}


void dfs(int s){
    if(sign[s]) return;
    else{
        sign[s] = 1;
        update(first[s], -b[s]);
        b[s] = 1;
        update(first[s], b[s]);
        for(auto it : nod[s]){
            if(it != par[s]) dfs(it);
        }
    }
}

int32_t main(){
   // freopen("input.in", "r", stdin);
    cin >> n;
    for(int i=1;i<n;i++){
        int x, y;
        cin >> x >> y;
        nod[x].push_back(y);
        nod[y].push_back(x);
    }
    for(int i=1;i<=n;i++) cin >> b[i];
    cin >> q;
    precalc(1);
    for(int i=0;i<(int)euler.size();i++){
        if(!first[euler[i]]) first[euler[i]] = (i + 1);
        last[euler[i]] = (i + 1);
    }
    for(int i=1;i<=n;i++){
        update(first[i], b[i]);
    }
    for(int i=1;i<=q;i++){
        int type, v, k;
        cin >> type >> v >> k;
        if(type == 1){
            dfs(v);
        }
        else{
            cout << query(last[v]) - query(first[v] - 1) << '\n';
        }
    }
}
