#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

// #define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int inf = 3e9;
const int maxn = 2e5 + 50;
vi r[maxn];
int t[4 * maxn];
void push(int v, int tl, int tr) {
	if (t[v] == tr - tl + 1) {
		if (2 * v + 1 < 4 * maxn) {
			int tm = (tl = tr) / 2;
			t[2 * v] = tm + 1 - tl;
			t[2 * v + 1] = tr - tm;
		}
	}
} 

int get(int v, int tl, int tr, int l, int r) {
	if (tr < l || tl > r)
		return 0;
	push(v, tl, tr);
	if (tl >= l && tr <= r) {
		return t[v];
	} else {
		int tm = (tl + tr) / 2;
		return get(2 * v, tl, tm, l, r) + get(2 * v + 1, tm + 1, tr, l, r);
	}
}

void update(int v, int tl, int tr, int l, int r) {
	if (tr < l || tl > r || t[v] == tr - tl + 1)
		return;
	if (tl >= l && tr <= r) {
		t[v] = tr - tl + 1;
	} else {
		int tm = (tl + tr) / 2;
		update(2 * v, tl, tm, l, r);
		update(2 * v + 1, tm + 1, tr, l, r);
		t[v] = t[2 * v] + t[2 * v + 1];
	}
}

int tim = -1;
int tin[maxn], tout[maxn];


void dfs(int v, int p = -1) {
	tin[v] = ++tim;
	for (auto &u : r[v]) {
		if (u != p)
			dfs(u, v);
	}
	tout[v] = tim;
}


void solve() {
	int n, q;
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		r[a].pb(b);
		r[b].pb(a);
	}
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		if (x)
			update(1, 0, n - 1, tin[i], tin[i]);
	}
	dfs(0);
	cin >> q;
	while (q--) {
		int t, v, k;
		cin >> t >> v >> k;
		v--;
		if (t == 1) {
			update(1, 0, n - 1, tin[v], tout[v]);
		} else {
			cout << get(1, 0, n - 1, tin[v], tout[v]) << '\n';
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--)
		solve();
}