#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

// #define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int inf = 3e9;
const int maxn = 2e5 + 50;
vi r[2 * maxn];
int d[2 * maxn];
int tim = 0;
int tin[2 * maxn], tout[2 * maxn];
vector<int> vr[2 * maxn];
vi pref[2 * maxn];
void dfs(int v, int p = -1) {
	tin[v] = tim++;
	d[v] = 1 + (p == -1 ? -1 : d[p]);
	vr[d[v]].pb(v);
	for (auto &u : r[v]) {
		if (u != p)
			dfs(u, v);
	}
	tout[v] = tim++;
}
int b[2 * maxn];
int ri[2 * maxn][18];
int bs[2 * maxn][18];


void solve() {
	int n, q;
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		r[a].pb(b);
		r[b].pb(a);
	}
	dfs(0);
	for (int i = 0; i < n; ++i) {
		int x;
		cin >> x;
		b[i] = x;
	}
	for (int i = 0; i <= n; ++i) {
		vr[i].insert(vr[i].begin(), n);
		pref[i].resize(vr[i].size());
		for (int j = 0; j < vr[i].size(); ++j) {
			pref[i][j] = b[vr[i][j]];
			if (j)
				pref[i][j] += pref[i][j - 1];
		}
	}
	for (int i = n - 1; i >= 0; --i) {
		for (int j = 0; j < vr[i].size(); ++j) {
			int l = 0, r = vr[i + 1].size();
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (tout[vr[i + 1][mid]] <= tout[vr[i][j]]) {
					l = mid;
				} else {
					r = mid;
				}
			}
			ri[vr[i][j]][0] = l;
			bs[vr[i][j]][0] = pref[i][j];
			for (int k = 1; k < 18; ++k) {
				// cout << j << ' ' << k << ' ' << vr[min(i + (1 << k - 1), n)]ri[vr[i][j]][k - 1]  << endl;
				bs[vr[i][j]][k] = bs[vr[i][j]][k - 1] + bs[vr[min(i + (1 << k - 1), n)][ri[vr[i][j]][k - 1]]][k - 1];
				ri[vr[i][j]][k] = ri[vr[min(i + (1 << k - 1), n)][ri[vr[i][j]][k - 1]]][k - 1];
			}
		}
	}
	cin >> q;
	while (q--) {
		int t, v, k;
		cin >> t >> v >> k;
		v--;
		if (t == 2) {
			int dep = d[v];
			int l = 0, r = vr[dep].size();
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (tin[vr[dep][mid]] <= tin[v]) {
					l = mid;
				} else {
					r = mid;
				}
			}
			int pos = l;
			pii now = {dep, pos};
			int ans = 0;
			k++;
			int _k = k;
			for (int j = 17; j >= 0; --j) {
				if (_k >= (1 << j)) {
					ans += bs[vr[now.f][now.s]][j];
					now.s = ri[vr[now.f][now.s]][j];
					now.f += (1 << j);
					_k -= (1 << j);
				}
			}
			if (pos) {
				now = {dep, pos - 1};
				_k = k;
				for (int j = 17; j >= 0; --j) {
					if (_k >= (1 << j)) {
						ans -= bs[vr[now.f][now.s]][j];
						now.s = ri[vr[now.f][now.s]][j];
						now.f += (1 << j);
						_k -= (1 << j);
					}
				}
			}
			cout << ans << endl;
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--)
		solve();
}