#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000007

using namespace std;

void announce (bool dali) {
    if (dali) cout<<"Win"<<endl;
    else cout<<"Loss"<<endl;
}

ll grundy[3001][12301];
ll k,n;
ll big[10001],small[10001];

ll mex (set<ll> brojki) {
    ll najm = 0;

    while (brojki.count(najm)) { najm++; }

    return najm;
}

ll calcGrundy(ll b, ll s) {
    if (grundy[b][s] != -1) return grundy[b][s];

    set<ll> site;

    for (ll i = 0; i<=b; i++) {
        for (ll j = 0; j<=s; j++) {
            if (i == b && j == s) continue;

            for (ll kCtr = k; kCtr<=2; kCtr++) site.insert(calcGrundy(i,j+(b-i)*kCtr));
        }
    }

    return grundy[b][s] = mex(site);
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    MS(grundy,-1);

    ll q;
    cin>>k>>q;

    calcGrundy(3000,3000);

    for (ll tt = 0; tt<q; tt++) {
        cin>>n;

        for (ll i = 0; i<n; i++) cin>>big[i];
        for (ll i = 0; i<n; i++) cin>>small[i];

        ll res = 0;

        for (ll i = 0; i<n; i++) res ^= grundy[big[i]][small[i]];

        announce(res != 0);
    }
}
