#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long dobule
#define ll long long 
#define _ << ' ' << 

using namespace __gnu_pbds;
using namespace std;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 3e3 + 5;

vector < pair < int, int > > g[N];

int s[N], e[N], h[N], sum[N];

void dfs(int v, int anc, int cur, int s) {
	h[v] = cur; 
	sum[v] = s;
	for (auto to : g[v]) {
		if (to.first != anc) {
			dfs(to.first, v, cur + 1, s + to.second);
		}
	}
}

int32_t main()
{
	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // LOCAL
	
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	int n;
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> s[i];
	}
	for (int i = 1; i <= n; i++) {
		cin >> e[i];
	}
	for (int i = 2; i <= n; i++) {
		int p, w;
		cin >> p >> w;
		g[p].push_back({ i, w });
		g[i].push_back({ p, w });
	}
	
	dfs(1, 0, 1, 0);
	
//	for (int i = 1; i <= n; i++) {
//		cout << i _ h[i] _ sum[i] << '\n';
//	}

	vector < pair < int, pair < int, int > > > all;
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			if (h[j] > h[i]) {
				all.push_back({ sum[j] - sum[i], { i, j } });
			}
		}
	}
	
	sort(all.rbegin(), all.rend());
	ll ans = 0;
	for (auto i: all) {
		int cost = i.first, a = i.second.first, b = i.second.second;
		int can = min(s[a], e[b]);
		ans += can * cost;
		s[a] -= can; s[b] -= can;
	}
	
	cout << ans << '\n';
	return 0;
}



