#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long dobule
#define ll long long 
#define _ << ' ' << 

using namespace __gnu_pbds;
using namespace std;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 3e5 + 5;

vector < int > g[N];

int b[N], s[N], e[N], h[N], tin[N], tout[N];

int n;

int timer = 0;

bool upper(int a, int b) {
	return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

void dfs(int v, int anc, int cur) {
	tin[v] = ++timer;
	h[v] = cur; 
	for (auto to : g[v]) {
		if (to != anc) {
			dfs(to, v, cur + 1);
		}
	}
	tout[v] = timer;
}

struct segmentTree {
	int s = 1;
	vector < int > t;
	vector < int > lazy;
	
	void build(int n) {
		while (s < n) s *= 2;
		t.resize(n * 5, 0);
		lazy.resize(n * 5, 0);
	}
	
	void push(int v, int vl, int vr) {
		if (lazy[v]) {
			t[v] = lazy[v] * (vr - vl + 1);
			lazy[v * 2] += lazy[v];
			lazy[v * 2 + 1] += lazy[v];
			lazy[v] = 0;
		}
	}
	
	void add(int v, int vl, int vr, int l, int r, int x) {
		push(v, vl, vr);
		if (vr < l || vl > r) {
			return;
		}
		if (vl >= l && vr <= r) {
			lazy[v] += x;
			push(v, vl, vr);
			return;
		}
		
		int mid = (vl + vr) / 2;
		add(v * 2, vl, mid, l, r, x);
		add(v * 2 + 1, mid + 1, vr, l, r, x);
		t[v] = t[v * 2] + t[v * 2 + 1];
	}
	
	void add(int l, int r, int x) {
		add(1, 1, s, l, r, x);
	}
	
	int getSum(int v, int vl, int vr, int l, int r) {
		push(v, vl, vr);
		if (vl > r || vr < l) {
			return 0;
		}
		if (vl >= l && vr <= r) {
			return t[v];
		}
		
		int mid = (vl + vr) / 2;
		return getSum(v * 2, vl, mid, l, r) + getSum(v * 2 + 1, mid + 1, vr, l, r);
	}
	
	int getSum(int l, int r) {
		return getSum(1, 1, s, l, r);
	}
};

int32_t main()
{
	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // LOCAL
	
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	cin >> n;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);	
	}
	for (int i = 1; i <= n; i++) {
		cin >> b[i];
	}
	
	dfs(1, 0, 0);
	
	segmentTree t;
	t.build(n + 5);
	
	for (int i = 1; i <= n; i++) {
		if (b[i]) {
			t.add(tin[i], tin[i], 1);
		}
	}

	int q;
    cin >> q;
    while (q--) {
        int type, x, k;
        cin >> type >> x >> k;
        
        if (type == 1) {
            t.add(tin[x], tout[x], 1);
        }
        else {
            int ans = t.getSum(tin[x], tout[x]);
            cout << ans << '\n';
        }
    }
	return 0;
}



