#include <bits/stdc++.h>
using namespace std;

const int N = 500000;

using ll = long long;

int s[N+5];
int e[N+5];

vector <pair <int, int>> graf[N+5];

priority_queue <pair <ll, int>> q[N+5];
int u[N+5];
int sz[N+5];
ll dp[N+5];

void dfs(int v, ll pre){
    if(graf[v].size() == 0){
        u[v] = v;
        q[v].push({pre, e[v]});
        return;
    }
    int mx = 0;
    for(auto pr : graf[v]){
        dfs(pr.first, pre + pr.second);
        dp[v] += dp[pr.first];
        if(!mx || sz[pr.first] > mx) mx = pr.first;
    }
    u[v] = u[mx];
    for(auto pr : graf[v]){
        if(pr.first == mx) continue;
        while(q[u[pr.first]].size()){
            pair <ll, int> x = q[u[pr.first]].top();
            q[u[v]].push(x);
            q[u[pr.first]].pop();
        }
        //q[u[pr.first]].shrink_to_fit();
    }
    while(s[v] > 0 && q[u[v]].size()){
        auto x = q[u[v]].top();
        pair <ll, ll> pr = x;
        if(pr.first <= pre) break;
        q[u[v]].pop();
        if(pr.second <= s[v]){
            s[v] -= pr.second;
            dp[v] += (pr.first - pre)*pr.second;
            q[u[v]].push({pre, pr.second});
        }
        else{
            pr.second -= s[v];
            dp[v] += (pr.first - pre)*s[v];
            q[u[v]].push({pr.first, pr.second});
            q[u[v]].push({pre, s[v]});
            s[v] = 0;
        }
    }
    q[u[v]].push({pre, e[v]});
}

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> s[i];
    }
    for(int i=1; i<=n; i++){
        cin >> e[i];
    }
    for(int i=2; i<=n; i++){
        int a, b;
        cin >> a >> b;
        graf[a].push_back({i, b});
    }
    dfs(1, 0);
    cout << dp[1] << "\n";
    return 0;
}
