/*#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")*/
#include <bits/stdc++.h>
using namespace std;

const int N = 500000;

using ll = long long;

int s[N+5];
int e[N+5];

vector <pair <int, int>> graf[N+5];

priority_queue <pair <int, int>> q[N+5];
int u[N+5];
int sz[N+5];
ll dp[N+5];

int pref[N+5];

int main(){
    ios_base::sync_with_stdio(false), cin.tie(0);

    int n;
    cin >> n;
    for(int i=1; i<=n; i++){
        cin >> s[i];
    }
    for(int i=1; i<=n; i++){
        cin >> e[i];
    }
    for(int i=2; i<=n; i++){
        int a, b;
        cin >> a >> b;
        graf[a].push_back({i, b});
    }
    for(int i=1; i<=n; i++){
        for(auto c : graf[i]) pref[c.first] = pref[i] + c.second;
    }
    for(int v=n; v>=1; v--){
        int pre = pref[v];
        if(graf[v].size() == 0){
            u[v] = v;
            q[v].push({pre, e[v]});
            continue;
        }
        int mx = 0;
        for(auto pr : graf[v]){
            dp[v] += dp[pr.first];
            if(!mx || sz[pr.first] > mx) mx = pr.first;
        }
        u[v] = u[mx];
        auto Q = q[u[v]];
        for(auto pr : graf[v]){
            if(pr.first == mx) continue;
            auto P = q[u[pr.first]];
            while(P.size()){
                pair <int, int> x = P.top();
                Q.push(x);
                P.pop();
            }
        }
        while(s[v] > 0 && Q.size()){
            auto x = Q.top();
            pair <int, int> pr = x;
            if(pr.first <= pre) break;
            Q.pop();
            if(pr.second <= s[v]){
                s[v] -= pr.second;
                dp[v] += 1LL*(pr.first - pre)*pr.second;
                Q.push({pre, pr.second});
            }
            else{
                pr.second -= s[v];
                dp[v] += 1LL*(pr.first - pre)*s[v];
                Q.push({pr.first, pr.second});
                Q.push({pre, s[v]});
                s[v] = 0;
            }
        }
        Q.push({pre, e[v]});
    }
    cout << dp[1] << "\n";
    return 0;
}
