#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define elif else if
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ld eps = 1e-7;

using namespace std;


void INPUT() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}


#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#endif // LOCAL


void get_params(vector < vector < pair < int, int > > > &nxt, vector < int > &depth, vector < ll > &score, int curr=0) {
    for(auto i: nxt[curr]) {
        depth[i.F] = depth[curr] + 1;
        score[i.F] = score[curr] + i.S;
        get_params(nxt, depth, score, i.F);
    }
}


void solve() {
    int n;
    cin >> n;
    vector < int > curr_cnt(n);
    for(auto &i: curr_cnt) {
        cin >> i;
    }
    vector < int > max_cnt(n);
    for(auto &i: max_cnt) {
        cin >> i;
    }
    vector < vector < pair < int, int > > > nxt(n);
    vector < pair < int, int > > prev(n);
    for(int i = 1; i < n; i++) {
        int vertex, weight;
        cin >> vertex >> weight;
        vertex--;
        nxt[vertex].eb(i, weight);
        prev[i] = {vertex, weight};
    }
    vector < int > depth(n);
    vector < ll > score(n);
    get_params(nxt, depth, score);
    vector < pair < int, int > > order(n); /// {depth, id}
    for(int i = 0; i < n; i++) {
        order[i] = {depth[i], i};
    }
    sort(rall(order));
    vector < map < ll, int, greater<> > > cands(n);
    ll ans = 0;
    for(auto v: order) {
        vector < ll > erasing;
        cout << endl;
        for(auto &i: cands[v.S]) {
            cerr << "CAND " << i.F << ' ' << i.S << ' ' << score[v.S] << endl;
            if(i.F - score[v.S] <= 0) {
                break;
            }
            if(i.S >= curr_cnt[v.S]) {
                ans += curr_cnt[v.S] * (i.F - score[v.S]);
                cerr << "ADD " << curr_cnt[v.S] * (i.F - score[v.S]) << endl;
                i.S -= curr_cnt[v.S];
                if(i.S == 0){
                    erasing.pb(i.F);
                }
                break;
            } else {
                ans += i.S * (i.F - score[v.S]);
                cerr << "ADD " << i.S * (i.F - score[v.S]) << endl;
                curr_cnt[v.S] -= i.S;
                i.S = 0;
                erasing.pb(i.F);
            }
        }
        cerr << "ANS " << v.S << ' ' << ans << endl;
        for(auto i: erasing) {
            cands[v.S].erase(i);
        }
        for(auto &i: cands[v.S]){
            cands[prev[v.S].F][i.F] += i.S;
        }
        cerr << "PREV " << prev[v.S].F << ' ' << max_cnt[v.S] << endl;
        cands[prev[v.S].F][score[v.S]] += max_cnt[v.S];
    }
    cout << ans << '\n';
}


int32_t main() {
    INPUT();
    int n = 1;
//    cin >> n;
    while(n--) {
        solve();
    }
    return 0;
}
