#include <bits/stdc++.h>

#define F first
#define S second
#define pb push_back
#define eb emplace_back
#define elif else if
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const ld eps = 1e-7;

using namespace std;


void INPUT() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
}


#ifndef LOCAL
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#endif // LOCAL


void get_params(vector < vector < int > > &nxt, vector < int > &depth, int curr=0) {
    for(auto i: nxt[curr]) {
        depth[i] = depth[curr] + 1;
        get_params(nxt, depth, i);
    }
}


void update(vector < vector < int > > &nxt, vector < int > &informed, int left, int v){
    informed[v] = 1;
    if(left > 0) {
        for(auto i: nxt[v]){
            update(nxt, informed, left - 1, i);
        }
    }
}


int cnt(vector < vector < int > > &nxt, vector < int > &informed, int left, int v){
    int ans = 0;
    ans += informed[v];
    if(left > 0) {
        for(auto i: nxt[v]){
            ans += cnt(nxt, informed, left - 1, i);
        }
    }
    return ans;
}


void solve() {
    int n;
    cin >> n;
    vector < vector < int > > nxt(n);
    vector < int > prev(n);
    for(int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        nxt[a].pb(b);
        prev[b] = a;
    }
    vector < int > depth(n);
    get_params(nxt, depth);
    vector < pair < int, int > > order(n); /// {depth, id}
    for(int i = 0; i < n; i++) {
        order[i] = {depth[i], i};
    }
    sort(rall(order));
    int curr_group_id = 0;
    ld sq = sqrt(n) - eps;
    vector < vector < int > > group_info;
    vector < vector < int > > group_info2;
    vector < int > vertex_group(n, -1);
    vector < int > gdepth(n);
    vector < int > informed(n);
    vector < int > ver;
    for(auto &i: informed) {
        cin >> i;
    }
    int q;
    cin >> q;
    while(q--) {
        int type, x, k;
        cin >> type >> x >> k;
        x--;
        if(type == 1) {
            update(nxt, informed, k, x);
        }else{
            cout << cnt(nxt, informed, k, x) << '\n';
        }
    }
}


int32_t main() {
    INPUT();
    int n = 1;
//    cin >> n;
    while(n--) {
        solve();
    }
    return 0;
}
