#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

struct Pair{
    int i, j, score;
    Pair(){}
    Pair( int _i, int _j, int _s ) : i(_i), j(_j), score(_s) {}
    const bool operator < ( const Pair &o ) const{
        if( score != o.score ) return score > o.score;
        if( i != o.i ) return i < o.i;
        return j < o.j;
    }
};

const int maxN = 100005;
int N;
int S[maxN], E[maxN], P[maxN], W[maxN];
const int INVALID = -3000;

int lineAssignment();

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> N;
    for( int i = 1 ; i <= N ; i++ ) cin >> S[i];
    for( int i = 1 ; i <= N ; i++ ) cin >> E[i];
    for( int i = 2 ; i <= N ; i++ ){ cin >> P[i] >> W[i]; }

    cout << lineAssignment() << endl;

}

int lineAssignment(){

    int rv = 0;
    int M = N-1;
    int A[M]; int nextNum = 1;
    for( int i = 0, j = M-1 ; i <= j ; i++, j-- ) A[i] = A[j] = nextNum++;

    for( int i = 2 ; i <= N ; i++ ){
        rv += A[i-2] * W[i];
    }

    return rv;

}