#include <bits/stdc++.h>
using namespace std;
#define LL long long
#define LD long double
#define INF (1<<30L)

const int maxN = 50005;
int N, Q;
vector <int> adj[maxN];
bool KNOWS[maxN] = {};
int maxSubordinatesAnnounced[maxN] = {};

void announcment( int, int );
int question( int, int );

int main(){ ios::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    cin >> N;
    for( int i = 0 ; i < N-1 ; i++ ){
        int x, y; cin >> x >> y;
        adj[x].push_back(y);
    }

    for( int i = 1 ; i <= N ; i++ ) cin >> KNOWS[i];

    cin >> Q;
    while( Q-- ){

        int t, x, k;
        cin >> t >> x >> k;

        if( t == 1 ) announcment( x, k );
        else         cout << question( x, k ) << endl;

    }

}

int question( int x, int k ){

    int rv = KNOWS[x];
    if( !k ) return rv;
    for( int j : adj[x] ) rv += question( j, k-1 );
    return rv;

}

void announcment( int x, int k ){

    KNOWS[x] = true;
    if( maxSubordinatesAnnounced[x] >= k ) return;
    maxSubordinatesAnnounced[x] = k;
    
    for( int j : adj[x] ) announcment( j, k-1 );

}