#include <bits/stdc++.h>

using namespace std;

#define fr first
#define sc second
#define mp make_pair

const int INF = -1e9;

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<int> s(n), e(n);
    for(auto &el: s)
        cin >> el;
    for(auto &el: e)
        cin >> el;

    vector<vector<int>> D(n, vector<int>(n, INF));
    for(int i = 1; i < n; ++i){
        int p, w;
        cin >> p >> w;
        D[p - 1][i] = w;
    }

    for(int k = 0; k < n; ++k){
        for(int i = 0; i < n; ++i){
            for(int j = 0; j < n; ++j){
                if(D[i][k] != INF && D[k][j] != INF)
                    D[i][j] = max(D[i][j], D[i][k] + D[k][j]);
            }
        }

//        for(int i = 0; i < n; ++i){
//            for(int j = 0; j < n; ++j)
//                cout << D[i][j] << ' ';
//            cout << '\n';
//        }
//        cout << '\n';
    }

    set<pair<int, pair<int, int>>> q;
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            if(D[i][j] != INF){
                q.insert(mp(D[i][j], mp(i, j)));
            }
        }
    }

    int ans = 0;
    while(!q.empty()){
        int ci = q.rbegin()->sc.fr, cj = q.rbegin()->sc.sc;
        q.erase(--q.end());
        if(D[ci][cj] <= 0) continue;
//        cout << ci << ' ' << cj << ' ' << D[ci][cj] << '\n';
        int del = min(s[ci], e[cj]);
        s[ci] -= del;
        e[cj] -= del;
        ans += del * D[ci][cj];
    }

    cout << ans << '\n';

    return 0;
}
