#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

#define int ll

const int N = 1 << 19, INF = 0x3f3f3f3f3f3f3f3f;

int s[N], e[N], p[N];
vector<pair<int, int>> g[N];
map<int, int> costs[N];
int depth[N];

pair<int, int> t[2 * N];

pair<int, int> tmax(int l, int r) {
	l += N;
	r += N;
	pair<int, int> res = {-INF, -1};
	while (l <= r) {
		if (l & 1)	res = max(res, t[l]);
		if (!(r & 1))	res = max(res, t[r]);
		l = (l + 1) / 2;
		r = (r - 1) / 2;
	}
	return res;
}

void tset(int i, int x) {
	t[i + N] = {x, i};
	i += N;
	i /= 2;
	while (i) {
		t[i] = max(t[2 * i], t[2 * i + 1]);
		i /= 2;
	}
}

int tin[N], tout[N];

void dfs(int u = 0, int d = 0) {
	static int timer = 0;
	tin[u] = timer++;
	depth[tin[u]] = d;
	if (e[u]) {
		costs[tin[u]] = {{0, e[u]}};
	}
	for (auto [v, w] : g[u]) {
		dfs(v, d + w);
	}
	tout[tin[u]] = timer;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> e[i];
	}
	for (int i = 1; i < n; ++i) {
		int w;
		cin >> p[i] >> w;
		g[--p[i]].push_back({i, w});
	}
	dfs();
	for (int i = 0; i < n; ++i) {
		if (e[i]) {
			t[N + i] = {depth[i], i};
		} else {
			t[N + i] = {-INF, -1};
		}
	}
	for (int i = N; i--; ) {
		t[i] = max(t[2 * i], t[2 * i + 1]);
	}
	ll ans = 0;
	for (int u = n; u--; ) {
		while (s[u]) {
			auto [bst, bst_to] = tmax(u, tout[u] - 1);
			bst -= depth[u];
			if (bst <= 0) {
				break;
			}
			int num = min(s[u], costs[bst_to].begin()->y);
			assert(num);
			s[u] -= num;
			ans += bst * ll(num);
			costs[bst_to][depth[bst_to] - depth[u]] += num;
			if ((costs[bst_to].begin()->y -= num) == 0) {
				costs[bst_to].erase(costs[bst_to].begin());
				tset(bst_to, depth[bst_to] - costs[bst_to].begin()->x);
			}
		}
	}
	cout << ans;
}