#include <bits/stdc++.h>

using namespace std;
const int NMAX = 500005;
int rmq[2*NMAX][20],niv[NMAX],ceau[2*NMAX],prim[NMAX],q,dist[NMAX],ordine[NMAX];
vector <pair <int,int> > v[NMAX];
void dfs(int x,int cost,int nivel)
{
    niv[x]=nivel;
    ceau[++q]=x;
    if (prim[x]==0)
    {
        prim[x]=q;
    }
    dist[x]=cost;
    for (int i=0; i<v[x].size(); i++)
    {
        dfs(v[x][i].first,cost+v[x][i].second,nivel+1);
        ceau[++q]=x;
    }
}
int lca(int x,int y)
{
    if (x==y)
    {
        return x;
    }
    x=prim[x];
    y=prim[y];
    if (x>y)
    {
        swap(x,y);
    }
    int k=log2(y-x);
    if (niv[rmq[x][k]]<niv[rmq[y-(1<<k)+1][k]])
    {
        return rmq[x][k];
    }
    return rmq[y-(1<<k)+1][k];
}
bool compare (int a,int b)
{
    int sal=lca(a,b);
    if (sal==a)
    {
        return dist[b]-dist[a]>0;
    }
    if (sal==b)
    {
        return dist[b]-dist[a]>0;
    }
    return a<b;
}
int distanta(int a,int b)
{
    int sal=lca(a,b);
    return dist[a]+dist[b]-2*dist[sal];
}
int acum;
bool comp2(int a,int b)
{
    return distanta(a,acum)>distanta(b,acum);
}
int n,val[NMAX],cap[NMAX],x,cost,i,j,bonjour[NMAX];
int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
#ifdef HOME
    ifstream cin("date.in");
    ofstream cout("date.out");
#endif // HOME
    cin>>n;
    for (i=1; i<=n; i++)
    {
        cin>>val[i];
    }
    for (i=1; i<=n; i++)
    {
        cin>>cap[i];
    }
    for (i=2; i<=n; i++)
    {
        cin>>x>>cost;
        v[x].push_back({i,cost});
    }
    dfs(1,0,1);
    for (i=1; i<=q; i++)
    {
        rmq[i][0]=ceau[i];
    }
    int lg=log2(q);
    int p=1;
    for (i=1; i<=lg; i++)
    {
        for (j=1; j<=q-p+1; j++)
        {
            if (niv[rmq[j][i-1]]<niv[rmq[j+p][i-1]])
            {
                rmq[j][i]=rmq[j][i-1];
            }
            else
            {
                rmq[j][i]=rmq[j+p][i-1];
            }
        }
        p=p*2;
    }
    for (i=1; i<=n; i++)
    {
        ordine[i]=i;
    }
    long long sum=0;
    sort (ordine+1,ordine+n+1,compare);
    for (i=1; i<=n; i++)
    {
        if (val[ordine[i]]==0)
        {
            continue;
        }
        acum=ordine[i];
        for (j=1; j<=n; j++)
        {
            bonjour[j]=j;
        }
        sort (bonjour+1,bonjour+n+1,comp2);
        for (j=1; j<=n; j++)
        {
            if (cap[bonjour[j]]==0||lca(bonjour[j],acum)!=acum)
            {
                continue;
            }
            if (distanta(acum,bonjour[j])<0)
            {
                break;
            }
            if (cap[bonjour[j]]<=val[ordine[i]])
            {
                val[ordine[i]]-=cap[bonjour[j]];
                sum=sum+1LL*distanta(acum,bonjour[j])*cap[bonjour[j]];
                cap[bonjour[j]]=0;
            }
            else
            {
                cap[bonjour[j]]-=val[ordine[i]];
                sum=sum+1LL*val[ordine[i]]*distanta(acum,bonjour[j]);
                break;
            }
        }
    }
    cout<<sum;
    return 0;
}
