#include <bits/stdc++.h>

using namespace std;
const int NMAX = 200005;
int niv[NMAX],ceau[NMAX],prim[NMAX],ult[NMAX],q;
vector <int> v[NMAX];
void dfs(int x,int nivel,int tata)
{
    niv[x]=nivel;
    ceau[++q]=x;
    prim[x]=q;
    for (int i=0;i<v[x].size();i++)
    {
        if (v[x][i]!=tata)
        {
            dfs(v[x][i],nivel+1,x);
        }
    }
    ceau[++q]=x;
    ult[x]=q;
}
struct Arbore
{
    int *arb;
    int *lazy;
    void Initialize(int lung)
    {
        arb = new int [(4*lung+1)];
        lazy = new int [(4*lung+1)];
        for (int i=1;i<=4*lung;i++)
        {
            arb[i]=0;
            lazy[i]=0;
        }
        return;
    }
    void propaga (int st,int dr,int nod)
    {
        if (st==dr)
        {
            return;
        }
        if (lazy[nod]==0)
        {
            return;
        }
        int mij=(st+dr)/2;
        lazy[2*nod]=lazy[nod];
        lazy[2*nod+1]=lazy[nod];
        arb[2*nod]=lazy[nod]*(mij-st+1);
        arb[2*nod+1]=lazy[nod]*(dr-(mij+1)+1);
        lazy[nod]=0;
        return;
    }
    void updatepoz(int st,int dr,int nod,int poz,int val)
    {
        propaga(st,dr,nod);
        if (st==dr)
        {
            arb[nod]=val;
            return;
        }
        int mij=(st+dr)/2;
        if (poz<=mij)
        {
            updatepoz(st,mij,2*nod,poz,val);
        }
        else
        {
            updatepoz(mij+1,dr,2*nod+1,poz,val);
        }
        arb[nod]=arb[2*nod]+arb[2*nod+1];
    }
    void update(int st,int dr,int nod,int ua,int ub,int val)
    {
        if (dr<ua||st>ub)
        {
            return;
        }
        propaga(st,dr,nod);
        if (ua<=st&&dr<=ub)
        {
            arb[nod]=val*(dr-st+1);
            lazy[nod]=val;
            return;
        }
        int mij=(st+dr)/2;
        update(st,mij,2*nod,ua,ub,val);
        update(mij+1,dr,2*nod+1,ua,ub,val);
        arb[nod]=arb[2*nod]+arb[2*nod+1];
    }
    int query(int st,int dr,int nod,int ua,int ub)
    {
        if (dr<ua||st>ub)
        {
            return 0;
        }
        propaga(st,dr,nod);
        if (ua<=st&&dr<=ub)
        {
            return arb[nod];
        }
        int mij=(st+dr)/2;
        return query(st,mij,2*nod,ua,ub)+query(mij+1,dr,2*nod+1,ua,ub);
    }
}Salut;
int n,i,x,y;
int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    #ifdef HOME
    ifstream cin("date.in");
    ofstream cout("date.out");
    #endif // HOME
    cin>>n;
    for (i=1;i<=n-1;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    dfs(1,1,0);
    Salut.Initialize(q+1);
    for (i=1;i<=n;i++)
    {
        cin>>x;
        if (x==0)
        {
            continue;
        }
        Salut.updatepoz(1,q,1,prim[i],1);
        Salut.updatepoz(1,q,1,ult[i],1);
    }
    int t;
    cin>>t;
    for (;t--;)
    {
        int tip,x,k;
        cin>>tip;
        if (tip==1)
        {
            cin>>x>>k;
            Salut.update(1,q,1,prim[x],ult[x],1);
        }
        else
        {
            cin>>x>>k;
            int rez= Salut.query(1,q,1,prim[x],ult[x]);
            rez=rez/2;
            cout<<rez<<'\n';
        }
    }
    return 0;
}
