#include <bits/stdc++.h>

using namespace std;
const int NMAX = 200005;
int niv[NMAX],q,mar[NMAX],max_fiu[NMAX];
vector <int> v[NMAX];
void dfs(int x,int nivel,int tata)
{
    niv[x]=nivel;
    mar[x]=1;
    for (int i=0;i<v[x].size();i++)
    {
        if (v[x][i]!=tata)
        {
            dfs(v[x][i],nivel+1,x);
            mar[x]+=mar[v[x][i]];
            if (mar[v[x][i]]>mar[max_fiu[x]])
            {
                max_fiu[x]=v[x][i];
            }
        }
    }
}
int arb[4*NMAX];
int lazy[4*NMAX];
void propaga(int st,int dr,int nod)
{
    if (st==dr)
        return;
    if (lazy[nod]==0)
    {
        return;
    }
    lazy[2*nod]+=lazy[nod];
    lazy[2*nod+1]+=lazy[nod];
    arb[2*nod]+=lazy[nod];
    arb[2*nod+1]+=lazy[nod];
    lazy[nod]=0;
    return;
}
void update(int st,int dr,int nod,int ua,int ub ,int val)
{
    if (dr<ua||st>ub)
        return;
    propaga(st,dr,nod);
    if (ua<=st&&dr<=ub)
    {
        arb[nod]+=val;
        lazy[nod]+=val;
        return;
    }
    int mij=(st+dr)/2;
    update(st,mij,2*nod,ua,ub,val);
    update(mij+1,dr,2*nod+1,ua,ub,val);
    arb[nod]=max(arb[2*nod],arb[2*nod+1]);
}
void updatepoz(int st,int dr,int nod,int poz,int val)
{
    if (st==dr)
    {
        arb[nod]=val;
        return;
    }
    int mij=(st+dr)/2;
    propaga(st,dr,nod);
    if (poz<=mij)
    {
        updatepoz(st,mij,2*nod,poz,val);
    }
    else
    {
        updatepoz(mij+1,dr,2*nod+1,poz,val);
    }
    arb[nod]=max(arb[2*nod],arb[2*nod+1]);
}
pair <int,int> query(int st,int dr,int nod)
{
    propaga(st,dr,nod);
    if (st==dr)
    {
        return {arb[nod],st};
    }
    int mij=(st+dr)/2;
    if (arb[2*nod]>=0&&arb[2*nod+1]>=0)
    {
        return query(st,mij,2*nod);
    }
    if (arb[2*nod]>=0&&arb[2*nod+1]<0)
    {
        return query(st,mij,2*nod);
    }
    if (arb[2*nod]<0&&arb[2*nod+1]>=0)
    {
        return query(mij+1,dr,2*nod+1);
    }
    return {-50000,0};
}
int n,i,x,y,timp[NMAX];
vector <pair <int,int>  > ev[NMAX];
vector <pair <int,int> > rasp;
int t;
void dfs2(int x,int tata)
{
    int j;
    update(1,t,1,1,t,-1);
    for (j=0;j<ev[x].size();j++)
    {
        timp[x]=min(timp[x],ev[x][j].first);
        updatepoz(1,t,1,ev[x][j].first,ev[x][j].second);
    }
    pair <int,int> sal=query(1,t,1);
    if (sal.first>=0)
    {
        timp[x]=min(timp[x],sal.second);
    }
    for (int i=0;i<v[x].size();i++)
    {
        if (v[x][i]!=tata)
        {
            dfs2(v[x][i],x);
        }
    }
    update(1,t,1,1,t,1);
    for (j=0;j<ev[x].size();j++)
    {
        updatepoz(1,t,1,ev[x][j].first,-500000);
    }
}
int ub(int x)
{
    return x&(-x);
}
int lung[NMAX];
int sol[NMAX];
vector < pair <int,int> > queryuri[NMAX];
map <int,int> op[25];
int aib[NMAX][25];
void updateaib(int poz,int val,int r)
{
    int i;
    for (i=poz;i<=n;i+=ub(i))
    {
        aib[i][r]+=val;
    }
    return;
}
int suma (int poz,int r)
{
    int sum=0,i;
    for (i=poz;i>=1;i-=ub(i))
    {
        sum=sum+aib[i][r];
    }
    return sum;
}
void dfs3(int x,int tata,int q)
{
    if (mar[x]==1)
    {
        if (timp[x]==0)
        {
            op[q][niv[x]]++;
            updateaib(niv[x],1,q);
        }
        int j;
        for (j=0;j<queryuri[x].size();j++)
        {
            int lim;
            lim=min(n,queryuri[x][j].second+niv[x]);
            sol[queryuri[x][j].first]=suma(lim,q);
        }
        return;
    }
    dfs3(max_fiu[x],x,q);
    if (timp[x]==0)
    {
        op[q][niv[x]]++;
        updateaib(niv[x],1,q);
    }
    for (int i=0;i<v[x].size();i++)
    {
        if (v[x][i]!=max_fiu[x]&&v[x][i]!=tata)
        {
            dfs3(v[x][i],x,q+1);
            for (auto ind: op[q+1])
            {
                op[q][ind.first]+=op[q+1][ind.first];
                updateaib(ind.first,op[q+1][ind.first],q);
                updateaib(ind.first,-op[q+1][ind.first],q+1);
            }
            op[q+1].clear();
        }
    }
    int j;
   for (j=0;j<queryuri[x].size();j++)
        {
            int lim;
            lim=min(n,queryuri[x][j].second+niv[x]);
            sol[queryuri[x][j].first]=suma(lim,q);
        }
    return;
}
int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(0);
    #ifdef HOME
    ifstream cin("date.in");
    ofstream cout("date.out");
    #endif // HOME
    cin>>n;
    for (i=1;i<=n-1;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    dfs(1,1,0);
    for (i=1;i<=n;i++)
    {
        cin>>x;
        if (x==0)
        {
            timp[i]=1e9;
        }
        else
        {
            timp[i]=0;
        }
    }
    int i;
    cin>>t;
    for (i=1;i<=t;i++)
    {
        sol[i]=-1;
    }
    for (i=1;i<=t;i++)
    {
        int tip,x,k;
        cin>>tip;
        if (tip==1)
        {
            cin>>x>>k;
            ev[x].push_back({i,k});
        }
        else
        if (tip==2)
        {
            cin>>x>>k;
            queryuri[x].push_back({i,k});
        }
    }
    dfs3(1,0,1);
    for (i=1;i<=t;i++)
    {
        if (sol[i]!=-1)
        {
            cout<<sol[i]<<'\n';
        }
    }
    return 0;
}
