#include<bits/stdc++.h>
using namespace std;
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;
#define ll long long
#define fir first
#define sec second
#define mp make_pair
#define pb push_back
#define sz size
#define en "\n"
int a[300000], n, q;
vector<vector<int> > g(300000);
vector<vector<pair<int, int> > > query(300000);
vector<pair<pair<int, int>, int> > t(300000);
int pr[300000];
void dfs0(int v, int par)
{
    pr[v] = par;
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != par)
            dfs0(g[v][i], v);
    return;
}
void dfs1(int v, int dst, int mx)
{
    if (dst > mx)
        return;
    a[v] = 1;
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != pr[v])
            dfs1(g[v][i], dst+1, mx);
    return;
}
int dfs2(int v, int dst, int mx)
{
    if (dst > mx)
        return 0;
    int nw = a[v];
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != pr[v])
            nw += dfs2(g[v][i], dst+1, mx);
    return nw;
}
void solve1()
{
    dfs0(0, 0);
    for (int i = 0; i < q; i++)
    {
        if (t[i].fir.fir == 1)
            dfs1(t[i].fir.sec, 0, t[i].sec);
        else
            cout << dfs2(t[i].fir.sec, 0, t[i].sec) << en;
    }
    return;
}
void solve2()
{

}
int tin[300000], tout[300000], tmx, tx[10000000], tsum[10000000];
void dfs3(int v, int par)
{
    tin[v] = tmx;
    tmx++;
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != par)
        {
            dfs3(g[v][i], v);
            tmx++;
        }
    tout[v] = tmx;
    return;
}
void push(int v, int l, int r)
{
    if (tx[v] == 1)
        tsum[v] = r-l+1;
    if (l != r)
    {
        tx[v*2+1] = max(tx[v*2+1], tx[v]);
        tx[v*2+2] = max(tx[v*2+2], tx[v]);
    }
    tsum[v] = max(tsum[v], tsum[v*2+1]+tsum[v*2+2]);
    return;
}
int u = 0;
void change(int l, int r, int lx, int rx, int v)
{
    push(v, l, r);
    if (l > rx || r < lx)
        return;
    if (l >= lx && r <= rx)
    {
        tx[v] = 1;
        push(v, l, r);
        return;
    }
    push(v, l, r);
    change(l, (l+r) / 2, lx, rx, v*2+1);
    change((l+r) / 2+1, r, lx, rx, v*2+2);
    tsum[v] = max(tsum[v], tsum[v*2+1]+tsum[v*2+2]);
    return;
}
int get(int l, int r, int lx, int rx, int v)
{

    push(v, l, r);
    if (l > rx || r < lx)
        return 0;
    if (l >= lx && r <= rx)
        return tsum[v];
    push(v, l, r);
    ll s = get(l, (l+r) / 2, lx, rx, v*2+1)+get((l+r) / 2+1, r, lx, rx, v*2+2);
    tsum[v] = tsum[v*2+1]+tsum[v*2+2];
    return s;
}
void solve3()
{
    dfs3(0, 0);
    for (int i = 0; i < n; i++)
        if (a[i] == 1)
        {
            change(0, 1e6, tin[i], tin[i], 0);
            change(0, 1e6, tout[i], tout[i], 0);
        }
    for (int i = 0; i < q; i++)
    {
        if (t[i].fir.fir == 1)
            change(0, 1e6, tin[t[i].fir.sec], tout[t[i].fir.sec], 0);
        else
            cout << get(0, 1e6, tin[t[i].fir.sec], tout[t[i].fir.sec], 0) / 2 << en;
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    for (int i = 0; i < n; i++)
        cin >> a[i];
    cin >> q;
    bool ok = true;
    for (int i = 0; i < q; i++)
    {
        cin >> t[i].fir.fir >> t[i].fir.sec >> t[i].sec;
        t[i].fir.sec--;
        if (t[i].fir.fir == 1)
            ok = false;
    }
    solve3();
}

//10
//1 2
//1 3
//2 4
//2 5
//3 6
//3 7
//3 8
//6 9
//6 10
//0 1 0 1 0 0  1 0 1 0
//12
//1 6 10
//1 1 10
//2 1 10
//2 2 10
//2 3 10
//2 4 10
//2 5 10
//2 6 10
//2 7 10
//2 8 10
//2 9 10
//2 10 10
