#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
ll s=0;
vector<ll> say;
ll c(ll x, vector<vector<ll>> &ch) {
	if(say[x]>0){
		return say[x];
	}
	if(ch[x].size()==0){
		say[x]=1;
	}
	say[x]=1;
	for(ll i:ch[x]){
		say[x]+=c(i, ch);
	}
	return say[x];
}
void query(ll x, vector<bool> &used, vector<vector<ll>> &ch, vector<bool> &changed){
    if(changed[x]){
		s= say[x];
		return;
	}
    if(used[x]){
        s++;
    }
    if(ch[x].size()==0){
        return;
    }
    for(ll i: ch[x]){
        query(i, used, ch, changed);
    }
    return;
}
void update(ll x, vector<bool> &used, vector<bool> &changed, vector<vector<ll>> &ch) {
    if(changed[x]){
		return;
	}
    used[x]=true;
    if(ch[x].size()==0){
        return;
    }
    for(ll i:ch[x]){
        update(i, used, changed, ch);
    }
    return;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n, i;
    cin>>n;
    vector<vector<ll>> ch(n);
    vector<bool> changed(n, 0);
    vector<bool> say(n, 0);
    for(i=1; i<n; i++){
        ll a, b;
        cin>>a>>b;
        a--, b--;
        ch[a].push_back(b);
    }
    vector<bool> used(n);
    say.resize(n, 0);
    for(i=0; i<n; i++){
        bool g;
        cin>>g;
        used[i]=g;
    }
    for(i=0; i<n; i++){
		c(i, ch);
	}
    ll q;
    cin>>q;
    while(q--){
        ll x, k, r;
        cin>>r>>x>>k;
        x--;
        if(r==1){
            update(x, used, changed, ch);
        }
        else {
            s=0;
            query(x, used, ch, changed);
            cout<<s<<endl;
        }
    }
}
