#include <bits/stdc++.h>
#define sz(x) (int)x.size()
#define F first
#define S second
using namespace std;
typedef long long ll;

const int N = 1e5 + 500;

int t[4 * N];
int pf[N];
set <pair <int, pair <int, int> > > se;
int s[N], e[N], a[N];

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = pf[l];
    } else {
        int md = (l + r) >> 1;
        build(v * 2, l, md);
        build(v * 2 + 1, md + 1, r);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
}

void upd(int v, int l, int r, int ps) {
    if (l == r) {
        t[v] = -1e9;
    } else {
        int md = (l + r) >> 1;
        if (ps <= md) {
            upd(v * 2, l, md, ps);
        } else {
            upd(v * 2 + 1, md + 1, r, ps);
        }
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
}

int get(int v, int l, int r, int tl, int tr) {
    if (tl > tr || tl > r || l > tr || l > r) {
        return -1;
    }
    if (l == r) {
        return l;
    }
    int md = (l + r) >> 1;
    int cur = -1;
    if (t[v * 2] == t[v]) {
        cur = get(v * 2, l, md, tl, tr);
    }
    if (cur == -1) {
        return get(v * 2 + 1, md + 1, r, tl, tr);
    }
    return cur;
}

int main()
{
    int n;
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> s[i];
    }
    for (int i = 1; i <= n; i++) {
        cin >> e[i];
    }
    for (int i = 2; i <= n; i++) {
        int p, w;
        cin >> p >> w;
        a[i - 1] = w;
    }
    for (int i = 1; i <= n; i++) {
        pf[i] = pf[i - 1] + a[i];
    }
    for (int i = 1; i <= n; i++) {
        if (e[i] == 0) {
            pf[i] = -1e9;
        }
    }
    build(1, 1, n - 1);
    set <pair <int, pair <int, int> > > se;
    for (int i = 1; i <= n; i++) {
        int l = i;
        int r = get(1, 1, n - 1, i, n - 1);
        int sum = 0;
        if (r == -1) {
            r = l;
        } else {
            sum = pf[r] - pf[l - 1];
            r++;
        }
        if (sum < 0) {
            r = l;
            sum = 0;
        }
        se.insert({sum, {l, r}});
    }
    ll ans = 0;
    while (sz(se)) {
        int sum = se.rbegin() -> F;
        int l = se.rbegin() -> S.F;
        int r = se.rbegin() -> S.S;
        if (l == r) {
            break;
        }
        if (!s[l]) {
            se.erase(--se.end());
            continue;
        }
        if (!e[r]) {
            se.erase(--se.end());
            upd(1, 1, n - 1, r - 1);
            int r = get(1, 1, n - 1, l, n - 1);
            if (r == -1) {
                r = l;
                sum = 0;
            } else {
                sum = pf[r] - pf[l - 1];
                r++;
            }
            if (sum < 0) {
                r = l;
                sum = 0;
            }
            se.insert({sum, {l, r}});
            continue;
        }
        int mn = min(s[l], e[r]);
        s[l] -= ; e[r] -= mn;
        ans += sum * 1ll * mn;
    }
    cout << ans;
}
