#include <bits/stdc++.h>
#define DIM 200010
using namespace std;

struct segment_tree{
    int cnt; /// cate sunt nenule
    int cnt1; /// cate sunt egale cu 1
    int lazy;
} aint[DIM*4];

int b[DIM],E[DIM],level[DIM],max_level[DIM],fth[DIM];
pair <int,int> poz[DIM];
vector <int> L[DIM],v[DIM],aib[DIM];
int n,q,i,j,x,y,tip,k,sol;

void dfs (int nod, int tata){
    E[++k] = nod;
    poz[nod].first = k;
    max_level[nod] = level[nod] = 1 + level[tata];
    v[level[nod]].push_back(nod);
    fth[nod] = tata;
    for (auto vecin : L[nod]){
        if (vecin != tata){
            dfs (vecin,nod);
            max_level[nod] = max (max_level[nod],max_level[vecin]);
        }
    }
    poz[nod].second = k;
}

void build (int nod, int st, int dr){
    if (st == dr){
        if (b[E[st]])
            aint[nod].cnt = aint[nod].cnt1 = 1;
        return;
    }
    int mid = (st+dr)>>1;
    build (nod<<1,st,mid);
    build ((nod<<1)|1,mid+1,dr);

    aint[nod].cnt = aint[nod<<1].cnt + aint[(nod<<1)|1].cnt;
    aint[nod].cnt1 = aint[nod<<1].cnt1 + aint[(nod<<1)|1].cnt1;
}


void update_lazy (int nod, int st, int dr){
    if (!aint[nod].lazy)
        return;
    if (st != dr){
        int mid = (st+dr)>>1;
        int fiu_st = nod<<1, fiu_dr = (nod<<1)|1;
        aint[fiu_st].cnt = mid-st+1;
        aint[fiu_st].lazy = 1;

        aint[fiu_dr].cnt = dr-mid;
        aint[fiu_dr].lazy = 1;
    }
    aint[nod].lazy = 0;
}

void update (int nod, int st, int dr, int x, int y){
    update_lazy (nod,st,dr);
    if (x <= st && dr <= y){


        //aint[nod].cnt1 = dr-st+1 - aint[nod].cnt;
        aint[nod].cnt = (dr-st+1);
        aint[nod].lazy = 1;


        update_lazy(nod,st,dr);
        return;
    }
    int mid = (st+dr)>>1;
    if (x <= mid)
        update (nod<<1,st,mid,x,y);
    if (y > mid)
        update ((nod<<1)|1,mid+1,dr,x,y);

    update_lazy (nod<<1,st,mid);
    update_lazy ((nod<<1)|1,mid+1,dr);
    aint[nod].cnt = aint[nod<<1].cnt + aint[(nod<<1)|1].cnt;
}

void query (int nod, int st, int dr, int x, int y){
    update_lazy (nod,st,dr);
    if (x <= st && dr <= y){
        sol += aint[nod].cnt;
        return;
    }
    int mid = (st+dr)>>1;
    if (x <= mid)
        query (nod<<1,st,mid,x,y);
    if (y > mid)
        query ((nod<<1)|1,mid+1,dr,x,y);
}

void update_aib (int nod, int p, int n, int val){
    for (;p<=n;p+=(p&-p))
        aib[nod][p] += val;
}
int query_aib (int nod, int p){
    int sol = 0;
    for (;p>=1;p-=(p&-p))
        sol += aib[nod][p];
    return sol;
}

int main (){

    //ifstream cin ("date.in");
    //ofstream cout ("date.out");

    cin>>n;
    for (i=1;i<n;i++){
        cin>>x>>y;
        L[x].push_back(y);
        L[y].push_back(x);
    }

    dfs (1,0);

    for (i=1;i<=n;i++)
        aib[i].resize(max_level[i] - level[i] + 2, 0);

    for (i=1;i<=n;i++){
        cin>>b[i];
        if (b[i]){
            int nod = i, niv = 1;
            while (nod){
                update_aib (nod,niv,max_level[nod] - level[nod] + 1,1);
                nod = fth[nod];
                niv++;
            }
        }
    }

    cin>>q;
    for (;q--;){
        cin>>tip>>x>>k;
        cout<<query_aib(x,min(k+1,max_level[x] - level[x] + 1))<<"\n";
    }

/*
    //build (1,1,n);

    cin>>q;
    for (;q--;){
        cin>>tip>>x>>k;
        if (tip == 1){
            for (int i=poz[x].first;i<=poz[x].second;i++){
                if (level[E[i]] <= level[x] + k)
                    b[E[i]] = 1;
                    //update (1,1,n,i,i);
            }
            //update (1,1,n,poz[x].first,poz[x].second);
        } else {
            sol = 0;
            //query (1,1,n,poz[x].first,poz[x].second);
            for (int i=poz[x].first;i<=poz[x].second;i++){
                if (level[E[i]] <= level[x] + k)
                    sol += b[E[i]];
                    //update (1,1,n,i,i);
            }
            cout<<sol<<"\n";
        }
    }

*/
    return 0;
}
