#include <bits/stdc++.h>

using namespace std;

using ll = long long;
#define dbg(x) cerr << #x << " " << x << "\n"

const int MAX_N = 5e5;
int N;
int S[1 + MAX_N], E[1 + MAX_N];
vector <pair <int, int>> gr[1 + MAX_N];
set <pair <int, int>> roads; /// first -> cost, second -> cap
ll ans = 0;
void get_st(int node, int inv_cost) {
    for (auto it : gr[node]) {
        int son = it.first;
        int w = it.second;
        get_st(son, inv_cost + w);
    }
    roads.insert({inv_cost, -node});
}
void calc_sol(int node, int inv_cost) {
    while (roads.size() && S[node] > 0) {
        auto it = prev(roads.end());
        int c = it->first;
        int from = -(it->second);
        int cost = c - inv_cost;
        if (cost > 0) {
            int take = min(S[node], E[from]);
            S[node] -= take;
            E[from] -= take;
        //    dbg(node);
        //    dbg(cost); dbg(take);
            ans += 1ll * cost * take;
            roads.erase(it);
            if (E[from] > 0)
                roads.insert({c, -from});
        }
        else
            break;
    }
    if (E[node] > 0)
        roads.erase({inv_cost, -node});
    for (auto it : gr[node]) {
        int son = it.first;
        int w = it.second;
        calc_sol(son, inv_cost + w);
    }
    if (E[node] > 0)
        roads.insert({inv_cost, -node});
}
int main() {
    cin >> N;
    for (int i = 1; i <= N; i++)
        cin >> S[i];
    for (int i = 1; i <= N; i++)
        cin >> E[i];
    for (int i = 2; i <= N; i++) {
        int p, w;
        cin >> p >> w;
        gr[p].push_back({i, w});
    }
    get_st(1, 0);
    calc_sol(1, 0);
    cout << ans << "\n";
    return 0;
}
