#include <bits/stdc++.h>
using namespace std;
#define dbg(x) cerr << #x << " " << x << "\n"
const int MAX_N = 2e5;
vector <int> gr[1 + MAX_N];
int B[1 + MAX_N];
int type[1 + MAX_N], X[1 + MAX_N], K[1 + MAX_N];
int N;
int level[1 + MAX_N];
int tag;

int L[1 + MAX_N];
int R[1 + MAX_N];
int nr;
void precalc(int node, int par) {
    L[node] = ++nr;
    for (int son : gr[node])
        if (son != par) {
            precalc(son, node);
        }
    R[node] = nr;
}
int lazy[1 + 4 * MAX_N], seg[1 + 4 * MAX_N];
void push(int node, int lb, int rb) {
    int lnode = node * 2, rnode = node * 2 + 1;
    if (lazy[node]) {
        seg[node] = rb - lb + 1;
        if (lb != rb) {
            lazy[lnode] = 1;
            lazy[rnode] = 1;
        }
        lazy[node] = 0;
    }
}

void update(int node, int lb, int rb, int ql, int qr) {
    push(node, lb, rb);
    if (ql <= lb && rb <= qr) {
        lazy[node] = 1;
        push(node, lb, rb);
        return;
    }
    int mid = (lb + rb) / 2, lnode = node * 2, rnode = node * 2 + 1;
    push(lnode, lb, mid);
    push(rnode, mid + 1, rb);
    if (ql <= mid)
        update(lnode, lb, mid, ql, qr);
    if (qr > mid)
        update(rnode, mid + 1, rb, ql, qr);
    seg[node] = seg[lnode] + seg[rnode];
}

void upd(int l, int r) {
    update(1, 1, nr, l, r);
}

int query(int node, int lb, int rb, int ql, int qr) {
    push(node, lb, rb);
    if (ql <= lb && rb <= qr) {
        return seg[node];
    }
    int mid = (lb + rb) / 2, lnode = node * 2, rnode = node * 2 + 1;
    int ans = 0;
    push(lnode, lb, mid);
    push(rnode, mid + 1, rb);
    if (ql <= mid)
        ans += query(lnode, lb, mid, ql, qr);
    if (qr > mid)
        ans += query(rnode, mid + 1, rb, ql, qr);
    return ans;
}
int qry(int l, int r) {
    return query(1, 1, nr, l, r);
}

int main() {
  //  freopen("news.in", "r", stdin);
   // freopen("news.out", "w", stdout);
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> N;
    for (int i = 1; i < N; i++) {
        int x, y;
        cin >> x >> y;
        gr[x].push_back(y);
        gr[y].push_back(x);
    }
    precalc(1, 0);
    for (int i = 1; i <= N; i++) {
        cin >> B[i];
        if (B[i] > 0)
            upd(L[i], L[i]);
    }
    int Q;
    cin >> Q;
    while (Q--) {
        int type, x, k;
        cin >> type >> x >> k;
        if (type == 1) {
            upd(L[x], R[x]);
        }
        else {
            cout << qry(L[x], R[x]) << "\n";
        }
    }
    return 0;
}
