#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 2e5 + 10;
ll s[N], e[N], p[N], w[N], sum[N];
multiset<array<ll, 3>> m;
vector<int> children[N];
ll ans = 0;
ll in[N], out[N];
void rec(int x) {
	static int timer = 0;
	in[x] = ++timer;
	for (int to : children[x]) {
		rec(to);
	}
	out[x] = ++timer;
}
bool isAnc(int x, int y) {
	return in[x] <= in[y] && out[x] >= out[y];
}
const int BUY = 0, SELL = 1;
void dfs(int x) {
	// cout << "before: ";
	// for (auto a : m) cout << a[0] << ' '; cout << ans << endl;
	sum[x] = sum[p[x]] + w[x];
	for (int rep = 0; rep < e[x]; ++rep) {
		if (!m.empty()) {
			auto a = *m.begin();
			if (a[0] <= sum[x]) {
				ans += sum[x] - a[0];
				m.erase(m.begin());
				m.insert({sum[x], x, a[2]});
			}
		}
	}
	for (int rep = 0; rep < s[x]; ++rep) {
		m.insert({sum[x], x, x});
	}
	// cout << "after: ";
	// for (auto a : m) {
	// 	cout << a[0] << ' ' << a[1] << ' ' << a[2] << '\n';
	// }
	// cout << ans << endl;
	for (int to : children[x]) {
		dfs(to);
	}
	vector<array<ll, 3>> toErase;
	for (auto a : m) {
		if (isAnc(x, a[2])) {
			toErase.push_back(a);
		}
	}
	for (auto a : toErase) {
		m.erase(m.find(a));
	}
}
int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> e[i];
	}
	for (int i = 2; i <= n; ++i) {
		cin >> p[i] >> w[i];
		children[p[i]].push_back(i);
	}
	rec(1);
	dfs(1);
	cout << ans << endl;
}