#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 2e5 + 10;
ll s[N], e[N], p[N], w[N], sum[N];
multiset<array<ll, 3>> m;
vector<int> children[N];
ll ans = 0;
void dfs(int x) {
   sum[x] = sum[p[x]] + w[x];
   while (e[x] > 0 && !m.empty()) {
      auto a = *m.begin();
      if (a[0] < sum[x]) {
         --e[x];
         ++e[a[2]];
         ans += sum[x] - a[0];
         m.erase(m.begin());
         m.insert({sum[x], a[1], x});
      } else {
         break;
      }
   }
   while (s[x] > 0) {
      m.insert({sum[x], x, x});
      --s[x];
   }
   for (int to : children[x]) {
      dfs(to);
   }
   vector<array<ll, 3>> toErase;
   for (auto a : m) {
      if (x == a[1]) {
         toErase.push_back(a);
      }
   }
   for (auto a : toErase) {
      m.erase(m.find(a));
   }
}
// bool check() {
//    int ok = 0;
//    for (int i = 1; i <= n; ++i) {
//       if (e[i] > 0) ok |= 1;
//       if (s[i] > 0) ok |= 2;
//    }
//    return ok == 3;
// }
int main() {
   ios::sync_with_stdio(0); cin.tie(0);
   int n;
   cin >> n;
   for (int i = 1; i <= n; ++i) {
      cin >> s[i];
   }
   for (int i = 1; i <= n; ++i) {
      cin >> e[i];
   }
   for (int i = 2; i <= n; ++i) {
      cin >> p[i] >> w[i];
      children[p[i]].push_back(i);
   }
   for (int rep = 0; rep < 100; ++rep) {
      while (!m.empty()) {
         auto a = *m.begin();
         if (a[1] == a[2]) {
            ++s[a[1]];
            ++e[a[1]];
         }
         m.erase(m.begin());
      }
      dfs(1);
   }
   cout << ans << endl;
}