#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 2e5 + 10, oo = 1e9 + 10;
int n;
int mark[N], in[N], out[N], d[N];
int depth = 0;
vector<int> children[N];
bool isAnc(int x, int y) {
	return !x || (in[x] <= in[y] && out[x] >= out[y]);
}
void dfs(int x) {
	static int T = 0;
	in[x] = ++T;
	d[x] = ++depth;
	for (int to : children[x]) {
		dfs(to);
	}
	--depth;
	out[x] = ++T;
}
int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		children[x].push_back(y);
	}
	for (int i = 1; i <= n; ++i) {
		cin >> mark[i];
	}
	dfs(1);
	int q; cin >> q;
	for (int i = 0; i < q; ++i) {
		int t, x, k;
		cin >> t >> x >> k;
		if (t == 1) {
			for (int v = 1; v <= n; ++v) {
				if (isAnc(x, v) && d[x] + k >= d[v]) {
					mark[v] = 1;
				}
			}
		} else {
			int ans = 0;
			for (int v = 1; v <= n; ++v) {
				if (isAnc(x, v) && d[x] + k >= d[v]) {
					ans += mark[v];
				}
			}
			cout << ans << '\n';
		}
	}
}