#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>


#define ll long long
#define pii pair<int, int>
#define pb push_back
#define f first
#define s second

using namespace std;
using namespace __gnu_pbds;

template < typename T >
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;


const int N = 1e5 * 5;

vector < int > g[N];
int a[N], pred[N], h[N];

void calc(int v)
{
    for (auto to: g[v])
    {
        if (to != pred[v])
        {
            pred[to] = v;
            h[to] = h[v] + 1;
            calc(to);
        }
    }
}


int id[N];
ordered_set < pii > s[N];
int res[N];
vector < pii > z[N];
void dfs(int v)
{
    s[id[v]].clear();
    if (a[v] == 1)
        s[id[v]].insert({h[v], v});
    for (auto to: g[v])
    {
        if (pred[v] == to)
            continue;
        dfs(to);
        if (s[id[to]].size() > s[id[v]].size())
            swap(id[to], id[v]);
        for (auto p: s[id[to]])
        {
            s[id[v]].insert(p);
        }

        s[id[to]].clear();
    }

    for (auto to: z[v])
    {
        int nom = to.s;
        int k = to.f;
        res[nom] = s[id[v]].order_of_key({h[v] + k, 1e9});
    }

    z[v].clear();
}

void dfss(int v, int k)
{
    a[v] = 1;
    if (k == 0) return;
    for (auto to: g[v])
    {
       if (to == pred[v]) continue;
       dfss(to, k - 1);
    }

    return;
}


int32_t main()
{

#ifdef LOCAL
    freopen("input.txt","r", stdin);
    freopen("output.txt","w",stdout);
#endif LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n;
    cin >> n;

    for (int i = 0; i < n - 1; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }

    calc(0);
    for (int i = 0; i < n; i++) id[i] = i;


    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    int q;
    cin >> q;


    int nm = 0;
    while (q--)
    {
        int typ, x, k;
        cin >> typ >> x >> k;
        x--;
        if (typ == 1)
        {
            dfs(0);
            dfss(x, k);
        }
        else
        {
            z[x].pb({k, nm});
            nm++;
        }
    }

    dfs(0);

    for (int i = 0; i < nm; ++i) cout << res[i] << "\n";




    return 0;
}
