#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using pi = pair<int, int>;

const int N = 5e5+7;

int n, s[N], c[N], h[N];
vector<pi> g[N];
ll ans;

struct cmp {
    bool operator () (int i, int j) {
        return h[i] != h[j] ? h[i] < h[j] : i < j;
    }
};

using pq_t =  priority_queue<int, vector<int>, cmp>;
pq_t q[N];

void unite(pq_t& a, pq_t& b) {
    if (a.size() < b.size()) swap(a, b);
    while (!b.empty()) {
        a.push(b.top()), b.pop();
    }
}

void dfs(int v) {
    q[v].emplace(v);
    for (auto [to, w] : g[v]) {
        h[to] = h[v] + w;
        dfs(to);
        unite(q[v], q[to]);
    }

    while (q[v].top() != v) {
        const int i = q[v].top();
        if (s[v] >= c[i]) {
            ans += (ll) (h[i] - h[v]) * c[i];
            // cout << v+1 << " --> " << i+1 << ", cnt=" << c[i] << ", b" << endl;
            s[v] -= c[i];
            c[v] += c[i];
            q[v].pop();
        } else {
            ans += (ll) (h[i] - h[v]) * s[v];
            // cout << v+1 << " --> " << i+1 << ", cnt=" << s[v] << ", a" << endl;
            c[i] -= s[v];
            c[v] += s[v];
            break;
        }
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; ++i) cin >> s[i];
    for (int i = 0; i < n; ++i) cin >> c[i];

    for (int i = 1; i < n; ++i) {
        int p, w; cin >> p >> w;
        g[p-1].emplace_back(i, w);
    }

    dfs(0);

    cout << ans << endl;
}