#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast", "-O3", "O3", "fast-math")

#define int long long
#define pii pair<int, int>
#define endl "\n"

int k, q;

bool solve() {
    int n;
    cin >> n;
    pii h[n];
    for (int i = 0; i < n; ++i) {
        int b, s;
        cin >> b >> s;
        h[i] = {s, b};
    }
    sort(h, h + n);
    vector<bool> used(n, false);
    vector<pii > heaps;
    for (int i = 1; i < n; ++i) {
        if (used[i] || used[i - 1]) continue;
        if (h[i].first == h[i - 1].first) {
            used[i] = used[i - 1] = true;
            continue;
        }
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i])
            heaps.push_back(h[i]);
    }
    int cnt = 0;
    for (int i = 1; i < heaps.size(); ++i)
        cnt += heaps[i].first - heaps[i - 1].first > 1;
    return cnt % 2 != 0;
}


signed main() {
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    cin >> k >> q;
    for (int i = 0; i < q; ++i) {
        bool res = solve();
        cout << (res ? "Win" : "Loss") << endl;
    }
}