#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast", "-O3", "O3", "fast-math")

#define int long long
#define pii pair<int, int>

vector<int> miners, capacity, psum;
vector<pii > order, parent;
vector<vector<pii>> gr;

int ans = 0, sum = 0, to, n;

void dfs(int v = 0, int d = 0) {
    order.emplace_back(-d, v);
    for (auto edge: gr[v]) {
        int to = edge.first;
        dfs(to, d + 1);
    }
}

void setPsum() {
    psum.push_back(0);
    for (int i = 0; i < n; ++i) {
        int v = order[i].second;
        psum.push_back(psum[i] + parent[v].second);
    }
}

void proceed(int v) {
    while (to > v && miners[v]) {
        while (to > v && (sum < 0 || !capacity[to])) {
            sum -= parent[to].second;
            to--;
        }
        if (to > v) {
//           ans += psum[v] - psum[to - 1];
            ans += sum;
            int removeMinersCnt = min(miners[v], capacity[to]);
            miners[v] -= removeMinersCnt, capacity[to] -= removeMinersCnt;
        }
    }
    sum += parent[v].second;
}

signed main() {
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();

    cin >> n;
    for (int i = 0; i < n; ++i) {
        vector<pii > buf;
        gr.push_back(buf);
    }
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        miners.push_back(m);
    }
    for (int i = 0; i < n; ++i) {
        int c;
        cin >> c;
        capacity.push_back(c);
    }
    parent.emplace_back(-1, 0);
    for (int i = 1; i < n; ++i) {
        int u, w;
        cin >> u >> w;
        gr[u - 1].push_back({i, w});
        parent.emplace_back(u - 1, w);
    }

    dfs();
    sort(order.begin(), order.end());
    setPsum();
    to = (int) order.size() - 1;

    for (auto o: order) {
        int cave = o.second;
        proceed(cave);
    }

    cout << ans;
}