#include <bits/stdc++.h>
using namespace std;

#define int long long

struct nod{
	int val;
	int sz=1;
	int s, e;
	multiset<pair<int, int>, greater<pair<int, int>>> ven;
	vector<int> out;
};

vector<nod> g;

void predfs(int x){
	for(auto it:g[x].out){
		g[it].val+=g[x].val;
		predfs(it);
		g[x].sz+=g[it].sz;
	}
}

void merge(int a, int b){
	for(auto it:g[b].ven){
		g[a].ven.insert(it);
	}
	while(!g[b].ven.empty()) g[b].ven.erase(g[b].ven.begin());
}

int sol=0;
void solve(int x){
	for(auto it:g[x].out){
		solve(it);
	}
	if(g[x].out.size()>0){
		int best=0;
		for(int i=1;i<g[x].out.size();++i){
			int it=g[x].out[i];
			if(g[it].ven.size()>g[g[x].out[best]].ven.size()) best=i;
		}
		swap(g[x].ven, g[g[x].out[best]].ven);
		for(auto it:g[x].out){
			if(it==g[x].out[best]) continue;
			merge(x, it);
		}
	}
	/*
	cout<<x<<"\n";
  for(auto it:g[x].ven) cout<<it.first<<" "<<it.second<<"\n";
  cout<<sol<<"\n";
	cout<<"\n";
	*/
	while(g[x].s){
		auto val=*(g[x].ven.begin());
		if(val.second>g[x].s){
			sol+=g[x].s*val.first;
			val.second-=g[x].s;
			g[x].s=0;
			g[x].ven.erase(g[x].ven.begin());
			g[x].ven.insert(val);
		}
		else{
			sol+=val.second*val.first;
			g[x].s-=val.second;
			val.second=0;
			g[x].ven.erase(g[x].ven.begin());
		}
	}
	if(g[x].e) g[x].ven.insert({g[x].val, g[x].e});
	/*
	cout<<x<<"\n";
  for(auto it:g[x].ven) cout<<it.first<<" "<<it.second<<"\n";
  cout<<sol<<"\n";
	cout<<"\n";
	cout<<"\n";
	*/
}

int32_t main(){
	int n;
	cin>>n;
	g.resize(n+1);
	for(int i=1;i<=n;++i){
		cin>>g[i].s;
	}
	for(int i=1;i<=n;++i){
		cin>>g[i].e;
	}
	for(int i=2;i<=n;++i){
		int x, w;
		cin>>x>>w;
		g[x].out.push_back(i);
		g[i].val=w;
	}
	predfs(1);
	for(int i=1;i<=n;++i){
		sol-=g[i].val*g[i].s;
		g[i].e+=g[i].s;
	}
	solve(1);
	cout<<sol<<"\n";
	return 0;
}




