#include <bits/stdc++.h>

using namespace std;

const int A_MAX = 10;
const int B_MAX = 200;

int K, Q;

int G[A_MAX + 2][B_MAX + 2];

bool occ[(A_MAX + 1) * (B_MAX + 1) + 2];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> K >> Q;

    for (int a = 0; a <= A_MAX; a++) {
        for (int b = 0; b <= B_MAX; b++) {
            for (int tb = 1; tb <= b; tb++) {
                occ[G[a][b - tb]] = true;
            }
            for (int ta = 1; ta <= a; ta++) {
                for (int tb = ta * K; tb <= B_MAX; tb++) {
                    occ[G[a - ta][tb]] = true;
                }
            }

            G[a][b] = 0;
            while (occ[G[a][b]] == true) {
                G[a][b]++;
            }

            for (int tb = 1; tb <= b; tb++) {
                occ[G[a][b - tb]] = false;
            }
            for (int ta = 1; ta <= a; ta++) {
                for (int tb = ta * K; tb <= B_MAX; tb++) {
                    occ[G[a - ta][tb]] = false;
                }
            }
        }
    }

    while (Q--) {
        int N;
        cin >> N;

        int xr = 0;
        for (int i = 0; i < N; i++) {
            int a, b;
            cin >> a >> b;
            if (b > B_MAX) {
                xr ^= (G[a][B_MAX] - B_MAX + b);
            } else {
                xr ^= G[a][b];
            }
        }

        cout << (xr == 0 ? "Loss" : "Win") << "\n";
    }

    return 0;
}
