#include <bits/stdc++.h>

using namespace std;

const int A_MAX = 10;
const int B_MAX = 200;

int K, Q;

int G[A_MAX + 2][B_MAX + 2];
int H[A_MAX + 2][B_MAX + 2];

bool occ[A_MAX + 2][B_MAX + 2];

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> K >> Q;

    for (int a = 0; a <= A_MAX; a++) {
        for (int b = 0; b <= B_MAX; b++) {
            for (int tb = 1; tb <= b; tb++) {
                occ[G[a][b - tb]][H[a][b - tb]] = true;
            }
            for (int ta = 1; ta <= a; ta++) {
                for (int tb = ta * K; tb <= B_MAX; tb++) {
                    occ[G[a - ta][tb]][H[a - ta][tb]] = true;
                }
            }

            G[a][b] = 0;
            while (true) {
                H[a][b] = 0;
                while (H[a][b] <= B_MAX && occ[G[a][b]][H[a][b]] == true) {
                    H[a][b]++;
                }
                if (H[a][b] > B_MAX) {
                    G[a][b]++;
                } else {
                    break;
                }
            }

            for (int tb = 1; tb <= b; tb++) {
                occ[G[a][b - tb]][H[a][b - tb]] = false;
            }
            for (int ta = 1; ta <= a; ta++) {
                for (int tb = ta * K; tb <= B_MAX; tb++) {
                    occ[G[a - ta][tb]][H[a - ta][tb]] = false;
                }
            }
        }
    }

    while (Q--) {
        int N;
        cin >> N;

        int xrG = 0;
        int xrH = 0;
        for (int i = 0; i < N; i++) {
            int a, b;
            cin >> a >> b;
            xrG ^= G[a][min(b, B_MAX)];
            xrH ^= (H[a][min(b, B_MAX)] + b - min(b, B_MAX));
        }

        cout << ((xrG == 0 && xrH == 0) ? "Loss" : "Win") << "\n";
    }

    return 0;
}
