#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 500000;

const ll INF = LLONG_MAX / 2;

int N;

int init[N_MAX + 2];
int maxEnd[N_MAX + 2];

int parent[N_MAX + 2];
int score[N_MAX + 2];

vector <int> sons[N_MAX + 2];

ll answer = 0;

void dfs (int u, multiset <int> &offers) {
    for (int v : sons[u]) {
        score[v] += score[u];
        multiset <int> sonOffers;
        dfs(v, sonOffers);
        for (int x : sonOffers) {
            offers.insert(x);
        }
    }
    while (init[u] > 0 && offers.empty() == false) {
        multiset <int> :: iterator it = prev(offers.end());
        if (*it - score[u] <= 0) {
            break;
        }
        answer += *it - score[u];
        offers.insert(score[u]);
        init[u]--;
        offers.erase(it);
    }
    while (maxEnd[u] > 0) {
        offers.insert(score[u]);
        maxEnd[u]--;
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int u = 1; u <= N; u++) {
        cin >> init[u];
    }
    for (int u = 1; u <= N; u++) {
        cin >> maxEnd[u];
    }
    for (int u = 2; u <= N; u++) {
        cin >> parent[u] >> score[u];
        sons[parent[u]].push_back(u);
    }

    multiset <int> offers;
    dfs(1, offers);

    cout << answer << "\n";

    return 0;
}
