#include <bits/stdc++.h>
#define ff(i,a,b) for(int i=a;i<b;i++)
#define ffi(i,a,b) for(int i=a;i<=b;i++)

using namespace std;

typedef pair<int,int> pii;
typedef priority_queue<pii,vector<pii>, greater<pii> > pq;
typedef long long ll;

const int maxn=5e5+10;

vector<pii> g[maxn];
int s[maxn],e[maxn],depth[maxn];
priority_queue<pair<int,pii> > paths;

void init(int node=1,int depth_curr=0,int prev=-1){
    depth[node]=depth_curr;
    for(pii i:g[node]){
        if(i.first==prev) continue;
        init(i.first,depth_curr+1,node);
    }
}

void dfs(int node,int start,int dist=0,int prev=-1){
    for(pii i:g[node]){
        if(depth[i.first]<depth[node]) continue;
        dfs(i.first,start,dist+i.second,node);
    }
    paths.push(make_pair(dist,make_pair(start,node)));
}

int main(){
    int n;
    cin>>n;
    ffi(i,1,n) cin>>s[i];
    ffi(i,1,n) cin>>e[i];
    ffi(i,2,n){
        int p,w;
        cin>>p>>w;
        g[p].push_back(make_pair(i,w));
        g[i].push_back(make_pair(p,w));
    }
    init();
    ffi(i,1,n) dfs(i,i);
    ll res=0;
    while(!paths.empty()){
        auto i=paths.top();
        if(i.first<=0) break;
        res+=min(s[i.second.first],e[i.second.second])*ll(i.first);
        int pom=min(s[i.second.first],e[i.second.second]);
        s[i.second.first]-=pom;
        e[i.second.second]-=pom;
        paths.pop();
    }
    cout<<res;
    return 0;
}
