#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 5;

int n;
int s[N], e[N];
int p[N], w[N];

vector<int> g[N];
priority_queue<pair<int, int>, vector<pair<int, int>>> q[N];
long long ans = 0;

void dfs(int v) {
	int large = -1;
	for (int u : g[v]) {
		dfs(u);
		if (large == -1 || q[u].size() > q[large].size()) {
			large = u;
		}
	}
	if (large != -1) {
		swap(q[v], q[large]);
	}
	for (int u : g[v]) {
		if (u != large) {
			while (!q[u].empty()) {
				q[v].push(q[u].top());
				q[u].pop();
			}
		}
	}

	if (e[v] > 0) {
		q[v].push({w[v], e[v]});
	}
	while (s[v] > 0 && !q[v].empty() && w[v] < q[v].top().first) {
		int val = q[v].top().first;
		int cnt = q[v].top().second;
		q[v].pop();
		int t = min(s[v], cnt);
		ans += t * 1ll * (val - w[v]);
		cnt -= t;
		s[v] -= t;
		q[v].push({w[v], t});
		if (cnt > 0) {
			q[v].push({val, cnt});
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> e[i];
	}
	for (int i = 2; i <= n; ++i) {
		cin >> p[i] >> w[i];
	}

	for (int i = 2; i <= n; ++i) {
		g[p[i]].push_back(i);
		w[i] += w[p[i]];
	}

	dfs(1);
	cout << ans << endl;
	return 0;
}
