#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;

int n, q;
vector<int> g[N];
int b[N];

int tin[N], tout[N], timer;
int ord[N];
int h[N];

void dfs(int v, int p = -1) {
	tin[v] = timer++;
	ord[tin[v]] = v;
	for (int u : g[v]) {
		if (u != p) {
			h[u] = h[v] + 1;
			dfs(u, v);
		}
	}
	tout[v] = timer;
}

pair<int, int> t[2 * N];

void upd(int i) {
	t[i + n] = {N, ord[i]};
	i += n;
	while (i > 1) {
		t[i >> 1] = min(t[i], t[i ^ 1]);
		i >>= 1;
	}
}

pair<int, int> find_min(int l, int r) {
	pair<int, int> res = {N, N};
	l += n;
	r += n;
	while (l < r) {
		if (l & 1) {
			res = min(res, t[l]);
			++l;
		}
		if (r & 1) {
			--r;
			res = min(res, t[r]);
		}
		l >>= 1;
		r >>= 1;
	}
	return res;
}

vector<int> c[N];
vector<int> f[N];

void fake_add(int i, int j) {
	for (++i; i < N; i += i & -i) {
		c[i].push_back(j);
	}
}

void add(int i, int j) {
	for (++i; i < N; i += i & -i) {
		int jj = lower_bound(c[i].begin(), c[i].end(), j) - c[i].begin();
		for (++jj; jj < (int)f[i].size(); jj += jj & -jj) {
			++f[i][jj];
		}
	}
}

int get(int r, int z) {
	int res = 0;
	for (; r > 0; r -= r & -r) {
		int i = lower_bound(c[r].begin(), c[r].end(), z) - c[r].begin();
		for (; i > 0; i -= i & -i) {
			res += f[r][i];
		}
	}
	return res;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int x, y;
		cin >> x >> y;
		g[x].push_back(y);
		g[y].push_back(x);
	}
	for (int i = 1; i <= n; ++i) {
		cin >> b[i];
	}

	timer = 0;
	h[1] = 0;
	dfs(1);

	for (int i = 0; i < n; ++i) {
		t[i + n] = {h[ord[i]], ord[i]};
	}
	for (int i = n - 1; i > 0; --i) {
		t[i] = min(t[2 * i], t[2 * i + 1]);
	}

	for (int i = 1; i <= n; ++i) {
		fake_add(tin[i], h[i]);
	}
	for (int i = 0; i < N; ++i) {
		sort(c[i].begin(), c[i].end());
		c[i].erase(unique(c[i].begin(), c[i].end()), c[i].end());
		f[i].resize(c[i].size() + 1);
	}
	for (int i = 1; i <= n; ++i) {
		if (b[i] == 1) {
			add(tin[i], h[i]);
		}
	}

	cin >> q;
	while (q--) {
		int type, x, k;
		cin >> type >> x >> k;
		if (type == 1) {
			while (true) {
				auto mn = find_min(tin[x], tout[x]);
				if (mn.first > h[x] + k) {
					break;
				}
				int v = mn.second;
				if (b[v] == 0) {
					b[v] = 1;
					add(tin[v], h[v]);
				}
				upd(tin[v]);
			}
		} else {
			cout << get(tout[x], h[x] + k + 1) - get(tin[x], h[x] + k + 1) << "\n";
		}
	}
	return 0;
}
