#include <bits/stdc++.h>

using namespace std;
#define pii pair<int, int>
#define pb(x) push_back(x)
#define ll long long

const int max_n = 2e5 + 1;

vector<pii> gr[max_n];
int dist[max_n];
int w[max_n];
int tin[max_n], tout[max_n];
int cntt = 0;


bool is_par(int par, int son) {
	return tin[par] <= tin[son] && tout[son] <= tout[par];
}

void dfs(int v) {
	tin[v] = cntt++;
	for (auto to : gr[v])
		dist[to.first] = dist[v] + to.second, dfs(to.first);
	tout[v] = cntt++;
}

void print(auto st) {
	for (auto k : st)
		cout << k.first << " " << k.second << '\n';
	cout << '\n';
}

signed main() {
	cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> s(n), e(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 0; i < n; i++)
		cin >> e[i];
	for (int i = 1; i < n; i++) {
		int p, ww;
		cin >> p >> ww;
		gr[p - 1].emplace_back(i, ww);
	}
	dfs(0);
	deque<int> deq;
	deq.pb(0);
	set<pii, greater<pii>> st;
	for (int i = 0; i < n; i++)
		if (e[i])
			st.insert({dist[i], i});
	ll ans = 0;
	while (deq.size()) {
		int x = deq.front();
		deq.pop_front();
		vector<int> del;
		//cout << x << '\n';
		//print(st);
		for (auto o : st) {
			if (is_par(x, o.second)) {
				if (o.first - dist[x] <= 0) continue;
				int k = min(s[x], e[o.second]);
				s[x] -= k;
				e[o.second] -= k;
				ans += 1LL * (o.first - dist[x]) * k;
				if (e[o.second] == 0)
					del.pb(o.second);
				if (s[x] == 0)
					break;
			}
		}
		for (int o : del)
			st.erase({dist[o], o});
		for (auto to : gr[x])
			deq.pb(to.first);
		//cout << ans << '\n';
	}
	cout << ans << '\n';
}