#include <map>
#include <set>
#include <vector>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

pair<int, int> operator ^(const pair<int, int> &a, const pair<int, int> &b) {
  return make_pair(a.first ^ b.first, a.second ^ b.second);
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int k, q;
  cin >> k >> q;
  while (q--) {
    int n;
    cin >> n;
    pair<int, int> ans(0, 0);
    while (n--) {
      int b, s;
      cin >> b >> s;
      if (b % 2)
        ans = ans ^ make_pair(1, s % 2);
      else
        ans = ans ^ make_pair(0, s);
    }
    if (ans == make_pair(0, 0))
      cout << "Lose\n";
    else
      cout << "Win\n";
  }
  return 0;
}