#include "bits/stdc++.h"

using namespace std;
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int MAXN = 5e5 + 1;
vector<vector<int>> g(MAXN);
vector<int> fu(MAXN), d(MAXN);

void dfs(int v, int D) {
    d[v] = D++;
    for (auto w:g[v])
        dfs(w, D);
}

void upd(int v, int D) {
    if (d[v] <= D)
        fu[v] = 1;
    else
        return;
    for (auto w: g[v])
        upd(w, D);
}

int get(int v, int D) {
    if (d[v] > D)
        return 0;
    int cnt = fu[v];
    for (auto w:g[v])
        cnt += get(w, D);
    return cnt;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
    }
    for (int i = 0; i < n; ++i)
        cin >> fu[i];
    dfs(0, 0);
    int q;
    cin >> q;
    while (q--) {
        int t, x, k;
        cin >> t >> x >> k;
        --x;
        if (t == 1)
            upd(x, d[x] + k);
        else
            cout << get(x, d[x] + k) << "\n";
    }


}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}