#include "bits/stdc++.h"

using namespace std;
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int MAXN = 5e5 + 1;
vector<vector<int>> g(MAXN);
vector<int> fu(MAXN), d(MAXN), tin(MAXN), tout(MAXN), posin(MAXN), posout(MAXN);
vector<pair<int, int>> a;
int T = 0, n, R = 1 << 18;
vector<int> sum(MAXN), ps(MAXN);

void dfs(int v) {
    tin[v] = T++;
    for (auto w:g[v])
        dfs(w);
    tout[v] = T++;
}

void init() {
    dfs(0);
    a.assign(n, {0, 0});
    sum.assign(2 * R, 0);
    ps.assign(2 * R, 0);
    for (int i = 0; i < n; ++i)
        a[i] = {tin[i], i};
    sort(all(a));
    for (int i = 0; i < n; ++i) {
        posin[a[i].second] = i;
        pair<int, int> pii = {tout[a[i].second], -1};
        posout[a[i].second] = lower_bound(all(a), pii) - a.begin();
    }
    for (int i = 0; i < n; ++i)
        if (fu[i]) {
            int x = R + posin[i];
            while (x > 0) {
                sum[x]++;
                x >>= 1;
            }
        }
}

void upd(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return;
    if (ps[x])
        return;
    if (ql <= xl && xr <= qr) {
        sum[x] = (xr - xl);
        ps[x] = 1;
        return;
    }
    int mid = (xl + xr) >> 1;
    upd(x * 2, xl, mid, ql, qr);
    upd(x * 2 + 1, mid, xr, ql, qr);
    sum[x] = sum[x * 2] + sum[x * 2 + 1];
}

void upd(int x) {
    int l = posin[x];
    int r = posout[x];
    upd(1, 0, R, l, r);
}

void push(int x, int xl, int xr) {
    int mid = (xl + xr) >> 1;
    if (ps[x] == 1) {
        sum[x * 2] = mid - xl;
        sum[x * 2 + 1] = xr - mid;
        ps[x * 2] = 1;
        ps[x * 2 + 1] = 1;
        ps[x] = 0;
    }
}

int get(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return sum[x];
    push(x, xl, xr);
    int mid = (xl + xr) >> 1;
    return get(x * 2, xl, mid, ql, qr) + get(x * 2 + 1, mid, xr, ql, qr);
}

int get(int x) {
    int l = posin[x];
    int r = posout[x];
    return get(1, 0, R, l, r);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
    }
    for (int i = 0; i < n; ++i)
        cin >> fu[i];
    init();
    int q;
    cin >> q;
    while (q--) {
        int t, x, k;
        cin >> t >> x >> k;
        --x;
        if (t == 1)
            upd(x);
        else
            cout << get(x) << "\n";
    }


}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}