#include "bits/stdc++.h"

using namespace std;
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int MAXN = 5e5 + 1;
const int inf = 1e18;
int T = 0, n, R = 1 << 18;
vector<vector<int>> g(MAXN);
vector<int> fu(2 * R), d(2 * R, inf), tin(2 * R, inf), tout(2 * R, inf), posin(2 * R, inf), posout(2 * R, inf);
vector<pair<int, int>> a(2 * R);
vector<set<pair<int, int>>> not_used(2 * R);
vector<vector<int>> sum(2 * R), t(2 * R);
vector<int> to_del;

void dfs(int v, int D) {
    d[v] = D++;
    tin[v] = T++;
    for (auto w:g[v])
        dfs(w, D);
    tout[v] = T++;
}

void init(int x, int xl, int xr) {
    int len = xr - xl;
    if (xl + 1 == xr) {
        t[x].push_back(a[x - R].second);
        sum[x].resize(len * 2);
        not_used[x].insert({d[a[x - R].second], a[x - R].second});
        return;
    }
    int mid = (xl + xr) >> 1;
    init(x * 2, xl, mid);
    init(x * 2 + 1, mid, xr);
    int l = 0;
    int r = 0;
    len /= 2;
    while (l < len && r < len)
        if (d[t[x * 2][l]] < d[t[x * 2 + 1][r]]) t[x].push_back(t[x * 2][l++]);
        else t[x].push_back(t[x * 2 + 1][r++]);
    while (l < len) t[x].push_back(t[x * 2][l++]);
    while (r < len) t[x].push_back(t[x * 2 + 1][r++]);
    len = (xr - xl);
    sum[x].resize(len * 2);
    for (int i = 0; i < sz(t[x]); ++i)
        not_used[x].insert({d[t[x][i]], t[x][i]});
}

void init() {
    dfs(0, 0);
    for (int i = 0; i < sz(a); ++i)
        a[i] = {tin[i], i};
    sort(all(a));
    for (int i = 0; i < sz(a); ++i) {
        posin[a[i].second] = i;
        pair<int, int> pii = {tout[a[i].second], -1};
        posout[a[i].second] = lower_bound(all(a), pii) - a.begin();
    }
    init(1, 0, R);
}

int fnd_ind(int x, int MAXD) {
    int l = -1;
    int r = sz(t[x]);
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        if (d[t[x][mid]] > MAXD)
            r = mid;
        else
            l = mid;
    }
    return r;
}

void fff(int x, int MAXD) {
    for (auto[D, i]:not_used[x]) {
        if (D > MAXD)
            break;
        to_del.push_back(i);
    }
}

void upd(int x, int MAXD, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return;
    if (ql <= xl && xr <= qr) {
        fff(x, MAXD);
        return;
    }
    int mid = (xl + xr) >> 1;
    upd(x * 2, MAXD, xl, mid, ql, qr);
    upd(x * 2 + 1, MAXD, mid, xr, ql, qr);
}

void upd(int x, int MAXD) {
    int l = posin[x];
    int r = posout[x];
    upd(1, MAXD, 0, R, l, r);
}

int get_X(int XXX, int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return sum[XXX][x];
    int mid = (xl + xr) >> 1;
    return get_X(XXX, x * 2, xl, mid, ql, qr) + get_X(XXX, x * 2 + 1, mid, xr, ql, qr);
}

int get(int x, int MAXD, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return get_X(x, 1, 0, xr - xl, 0, fnd_ind(x, MAXD));
    int mid = (xl + xr) >> 1;
    return get(x * 2, MAXD, xl, mid, ql, qr) + get(x * 2 + 1, MAXD, mid, xr, ql, qr);
}

int get(int x, int MAXD) {
    int l = posin[x];
    int r = posout[x];
    return get(1, MAXD, 0, R, l, r);
}

void ff(int XXX, int x) {
    int y = fnd_ind(XXX, d[x])-1;
    y += sz(t[XXX]);
    while (y > 0) {
        sum[XXX][y]++;
        y >>= 1;
    }
}

void f() {
    for (auto x:to_del) {
        int ind = posin[x] + R;
        while (ind > 0) {
            ff(ind, x);
            not_used[ind].erase({d[x], x});
            ind >>= 1;
        }
    }
    to_del.clear();
}

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
    }

    init();

    for (int i = 0; i < n; ++i) {
        cin >> fu[i];
        if (fu[i])
            to_del.push_back(i);
    }
    f();
    int q;
    cin >> q;
    while (q--) {
        int ty, x, k;
        cin >> ty >> x >> k;
        --x;
        if (ty == 1) {
            upd(x, d[x] + k);
        } else
            cout << get(x, d[x] + k) << "\n";
        f();
    }
//    for (int i = 0; i < sz(sum[2]); ++i)
//        cout << sum[2][i] << " ";


}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}