#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 4e5 + 5;

int n, q;
ve<int> g[N];
int b[N];

int tin[N], tout[N], dep[N];
ve<int> st;

oset<pii> F[N];
int mx_id;

void upd(int pos, int x) {
    while(pos < sz(st)) {
        F[pos].insert({x, mx_id++});
        pos = pos | (pos + 1);
    }
}

int get(int pos, int x) {
    int sum = 0;
    while(pos >= 0) {
        sum += F[pos].ook(mp(x, -1e9));
        pos = (pos & (pos + 1)) - 1;
    }
    return sum;
}

int get(int l, int r, int x) {
    return get(r, x) - get(l - 1, x);
}

void dfs(int v = 0, int p = 0, int dep = 0) {
    tin[v] = sz(st);
    st.pb(v);
    ::dep[v] = dep;

    fe(to, g[v]) {
        if(to == p) continue;
        dfs(to, v, dep + 1);
    }

    tout[v] = sz(st);
    st.pb(v);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 0, n - 2) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        g[a].pb(b);
        g[b].pb(a);
    }

    dfs();

    fr(i, 0, n - 1) {
        cin >> b[i];
        if(b[i]) {
            upd(tin[i], dep[i]);
        }
    }

    cin >> q;

    fr(i, 0, q - 1) {
        int t;
        cin >> t;

        assert(t != 1);

        if(t == 1) {
            int x, k;
            cin >> x >> k;
            x--;
        }

        if(t == 2) {
            int x, k;
            cin >> x >> k;
            x--;

            cout << get(tin[x], tout[x], dep[x] + k + 1) << "\n";
        }
    }

    return 0;
}
