#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 2e5 + 20;

vector<int> g[N];
vector<int> eu;
int in[N], out[N];

int t[4 * N];
bool s[4 * N];

void mod(int v, int tl, int tr, int l, int r){
      if(l > r || s[v] == 1)
            return;
      if(tl == l && tr == r){
            s[v] = true;
            t[v] = (tr - tl + 1);
            return;
      }
      int tm = (tl + tr) / 2;
      mod(v * 2, tl, tm, l, min(r, tm));
      mod(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
      t[v] = t[v * 2] + t[v * 2 + 1];
}

int ask(int v, int tl, int tr, int l, int r){
      if(l > r)
            return 0;
      if(s[v])
            return r - l + 1;
      if(tl == l && tr == r)
            return t[v];
      int tm = (tl + tr) / 2;
      return ask(v * 2, tl, tm, l, min(r, tm)) + ask(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

void dfs(int v){
      in[v] = eu.size();
      eu.push_back(v);
      for(int x : g[v])
            dfs(x);
      out[v] = eu.size();
      eu.push_back(v);
}

void upd(int v, int k){
      t[v] = 1;
      if(k){
            for(int x : g[v])
                  upd(x, k - 1);
      }
}

int get(int v, int k){
      int r = t[v];
      if(k){
            for(int x : g[v])
                  r += get(x, k - 1);
      }
      return r;
}

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      int n; cin >> n;
      for(int i = 0; i < n - 1; i ++){
            int x, y;
            cin >> x >> y;
            g[x - 1].push_back(y - 1);
      }
      if(n > 10000){
            dfs(0);
            int c = eu.size();
            for(int i = 0; i < n; i ++){
                  int w; cin >> w;
                  if(w == 0)
                        continue;
                  mod(1, 0, c - 1, in[i], in[i]);
                  mod(1, 0, c - 1, out[i], out[i]);
            }
            int qq; cin >> qq;
            while(qq --){
                  int t, x, k;
                  cin >> t >> x >> k;
                  if(t == 1){
                        mod(1, 0, c - 1, in[x - 1], out[x - 1]);
                  }else{
                        cout << ask(1, 0, c - 1, in[x - 1], out[x - 1]) << "\n";
                  }
            }
            return 0;
      }
      for(int i = 0; i < n; i ++)
            cin >> t[i];
      int qq; cin >> qq;
      while(qq --){
            int t, x, k;
            cin >> t >> x >> k;
            if(t == 1)
                  upd(x - 1, k);
            else
                  cout << get(x - 1, k) << "\n";
      }

}
