#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef tree<int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> orset;

const int N = 4e5 + 20;

vector<int> g[N];
vector<int> eu;
int in[N], out[N], w[N];

int t[4 * N];
bool s[4 * N];

void mod(int v, int tl, int tr, int l, int r){
      if(l > r || s[v] == 1)
            return;
      if(tl == l && tr == r){
            s[v] = true;
            t[v] = (tr - tl + 1);
            return;
      }
      int tm = (tl + tr) / 2;
      mod(v * 2, tl, tm, l, min(r, tm));
      mod(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
      t[v] = t[v * 2] + t[v * 2 + 1];
}

int ask(int v, int tl, int tr, int l, int r){
      if(l > r)
            return 0;
      if(s[v])
            return r - l + 1;
      if(tl == l && tr == r)
            return t[v];
      int tm = (tl + tr) / 2;
      return ask(v * 2, tl, tm, l, min(r, tm)) + ask(v * 2 + 1, tm + 1, tr, max(l, tm + 1), r);
}

void dfs(int v){
      in[v] = eu.size();
      eu.push_back(v);
      for(int x : g[v])
            dfs(x);
      out[v] = eu.size();
      eu.push_back(v);
}

void upd(int v, int k){
      t[v] = 1;
      if(k){
            for(int x : g[v])
                  upd(x, k - 1);
      }
}

int get(int v, int k){
      int r = t[v];
      if(k){
            for(int x : g[v])
                  r += get(x, k - 1);
      }
      return r;
}

const int M = 2e5 + 20;
int res[M];
vector<pair<int, int>> kek[M];
orset* mp[M];
int delta[M];

void rec(int v){
      for(int x : g[v])
            rec(x);
      int bg = -1;
      for(int x : g[v]){
            if(bg == -1 || mp[bg]->size() < mp[x]->size())
                  bg = x;
      }
      if(bg == -1){
            mp[v] = new orset();
      }else{
            swap(mp[v], mp[bg]);
            delta[v] = delta[bg];
      }
      for(int x : g[v]){
            if(x == bg)
                  continue;
            if(mp[x]->size() > mp[v]->size()){
                  swap(mp[x], mp[v]);
            }
            for(int e : *mp[x]){
                  mp[v]->insert(e + delta[x] - delta[v]);
//                  (*mp[v])[e.first + 1] += e.second;
            }
      }
      delta[v] ++;
      if(w[v])
            mp[v]->insert(0 - delta[v]);
//      cout << v + 1 << " : " << delta[v] << endl;
//      for(auto e : *mp[v]){
//            cout << e << endl;
//      }
      for(auto [k, i] : kek[v]){
            res[i] = mp[v]->order_of_key(k + 1 - delta[v]);
      }
}


//5
//1 2
//1 3
//3 4
//3 5
//0 1 1 1 0
//3
//2 1 1
//2 3 0
//2 3 1

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      int n; cin >> n;
      for(int i = 0; i < n - 1; i ++){
            int x, y;
            cin >> x >> y;
            g[x - 1].push_back(y - 1);
      }
      if(n > 10000){
            for(int i = 0; i < n; i ++)
                  cin >> w[i];
            int qq; cin >> qq;
            vector<tuple<int, int, int>> qu;
            bool sub2 = true;
            for(int i = 0; i < qq; i ++){
                  int t, x, k;
                  cin >> t >> x >> k;
                  if(k != n)
                        sub2 = false;
                  qu.emplace_back(t, x, k);
            }
            if(sub2){
                  dfs(0);
                  int c = eu.size();
                  for(int i = 0; i < n; i ++){
                        if(w[i] == 0)
                              continue;
                        mod(1, 0, c - 1, in[i], in[i]);
                        mod(1, 0, c - 1, out[i], out[i]);
                  }
                  for(auto [t, x, k] : qu){
                        if(t == 1){
                              mod(1, 0, c - 1, in[x - 1], out[x - 1]);
                        }else{
                              cout << ask(1, 0, c - 1, in[x - 1], out[x - 1]) / 2 << "\n";
                        }
                  }
            }else{
//                  cout << "nice" << endl;
                  for(int i = 0; i < qq; i ++){
                        auto [t, x, k] = qu[i];
                        kek[x - 1].emplace_back(k, i);
                  }
                  rec(0);
                  for(int i = 0; i < qq; i ++)
                        cout << res[i] << "\n";
            }
            return 0;
      }
      for(int i = 0; i < n; i ++)
            cin >> t[i];
      int qq; cin >> qq;
      while(qq --){
            int t, x, k;
            cin >> t >> x >> k;
            if(t == 1)
                  upd(x - 1, k);
            else
                  cout << get(x - 1, k) << "\n";
      }

}

//
//5
//1 2
//1 3
//3 4
//3 5
//0 0 0 0 0
//5
//2 1 6
//2 3 6
//1 3 6
//2 1 6
//2 4 6
