#include <bits/stdc++.h>
#define fr(i, n, m) for(int i = (n); i < (m); i++)
#define pb push_back
#define st first
#define nd second
#define pq priority_queue
#define all(x) begin(x), end(x)

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int mxn = 2e5+5;
int n;
int s[mxn];
int e[mxn];
vector<pair<int,int> > g[mxn];

ll psum[mxn];

ll Psum[mxn];
ll Nsum[mxn];



int parent[mxn];
ll wparent[mxn];


void dfs(int u){
	for(auto e : g[u]){
		psum[e.st] = psum[u] + wparent[e.st];
		Psum[e.st] = Psum[u];
		Nsum[e.st] = Nsum[u];
		
		if(e.nd < 0) Nsum[e.st] += wparent[e.st];
		else Psum[e.st] += e.nd;
		
		dfs(e.st);
	}
}

ll do_the_algo(){
	
	pq<pair<ll,  pii> > Q;
	
	fr(i, 1, n){
		int p = i;
		do{
			p = parent[p];
			Q.push({psum[i]-psum[p], {p, i}});
		}while(p != 0);
	}
	
	ll ans = 0;
	
	while(!Q.empty()){
		int u = Q.top().nd.st;
		int v = Q.top().nd.nd;
		
		Q.pop();
		
		ll sum = psum[v] - psum[u];
		if(sum < 0) continue;
		
		int use = min(s[u], e[v]);
		s[u] -= use;
		e[v] -= use;
		
		ans += sum * use;
	}
	
	return ans;
}


int main(){
	cin >> n;
	fr(i, 0, n) cin >> s[i];
	fr(i, 0, n) cin >> e[i];
	fr(i, 1, n){
		int x, w;
		cin >> x >> w;
		--x;
		g[x].pb({i, w});
		parent[i] = x;
		wparent[i] = w;
		
	}
	dfs(0);
	
	
	vector<pair<ll, pii> > v;
	
	fr(i, 1, n){
		int p = i;
		do{
			p = parent[p];
			v.pb({psum[i]-psum[p], {p, i}});
		}while(p != 0);
	}
	sort(all(v));
	
	ll best = do_the_algo();
	
	fr(i, 0, (int)v.size()){
		int p = v[i].nd.st;
		int j = v[i].nd.nd;
		do{
			wparent[j] = -1e9;
			j = parent[j];
		
		}while(p != j);
		dfs(0);
		best = max(best, do_the_algo());
		
	}
	cout<<best<<endl;
	
	
	
	
	
	
	
	
	
	
	return 0;
}
