#pragma GCC optimize(Ofast,enroll-loops)
#pragma GCC target(avx2,bmi,bmi2,lzcnt)

#include <iostream>
#include <vector>
#include <random>
#include <set>
#include <map>

#define fi first
#define se second

using namespace std;

int count(vector<pair<int, int>> & a, int k)
{
    int res1 = 0, res2 = 0;
    for (int i = 0; i < a.size(); ++i)
    {
        if (k <= a[i].se && a[i].first > 0)
        {
            if (a[i].first % (a[i].second / k + 1) != 0 || a[i].second >= a[i].first * k) res1 ^= 1;
        }
        res2 ^= a[i].se;
        
    }
    if ((res2 > 0) ^ (res1 > 0)) return 1;
    else return 0;
}

void solve(int k)
{
    int n, res1 = 0, res2 = 0, t = 0, ans = 1, sth;

    cin >> n;
    vector<pair<int, int>> a(n);
    
    for (auto& i : a) cin >> i.fi >> i.se;
    if (k > 0)
    {
        for (int i = 0; i < n; ++i)
        {
            t ^= a[i].se;
            if (k <= a[i].se && a[i].first > 0)
            {
                if (a[i].first % (a[i].second / k + 1) != 0 || a[i].second >= a[i].first * k) res1 ^= 1;
            }
        }
        if (t > 0)
        {
            for (int i = 0; i < n; ++i)
            {
                if (a[i].second >= (t ^ a[i].second))
                {
                    if ((a[i].first % ((a[i].second ^ t) / k + 1) != 0 || (a[i].second ^ t) >= a[i].first * k) ^ (a[i].first % (a[i].second / k + 1) != 0 || a[i].second >= a[i].first * k)) res1 ^= 1;
                    ans = min(ans, t ^ res1);
                    if ((a[i].first % ((a[i].second ^ t) / k + 1) != 0 || (a[i].second ^ t) >= a[i].first * k) ^ (a[i].first % (a[i].second / k + 1) != 0 || a[i].second >= a[i].first * k)) res1 ^= 1;
                }
            }
            if (ans == 1) cout << "Loss" << '\n';
            else cout << "Win" << '\n';
        }
        else
        {
            if (count(a, k) == 0) cout << "Loss" << '\n';
            else cout << "Win" << '\n';
        }
        return;
    }
    for (int i = 0; i < n; ++i)
    {
        res1 ^= a[i].first;
        res2 ^= a[i].se;
    }
    if ((res2) || (res1)) cout << "Win" << '\n';
    else cout << "Loss" << '\n';
}

map<vector<pair<int, int>>, int> x, x1;

int mex(set<int>& a)
{
    for (int i = 0;; ++i)
    {
        if (a.find(i) == a.end()) return i;
    }
}
int gr(vector<pair<int, int>> a)
{
    set<int> pos;
    int sum = a[0].first + a[0].second + a[1].first + a[1].second + a[2].first + a[2].second;
    if (sum == 0) return 0;
    for (int i = 0; i < 3; ++i)
    {
        for (int j = 0; j <= a[i].first; ++j)
        {
            for (int k = 0; k <= a[i].second; ++k)
            {
                if (j + k > 0)
                {
                    for (int t = 1 * j; t <= 4 * j; ++t)
                    {

                        vector<pair<int, int>> temp = a;
                        if (j > 0) temp[i].se += t - k;
                        else temp[i].second += -k;
                        temp[i].first += -j;
                        if (x[temp] != 0) pos.insert(x[temp] - 1);
                        else pos.insert(gr(temp));
                    }

                }
            }
        }
    }
    x[a] = mex(pos) + 1;
    return x[a] - 1;
}

int gr1(vector<pair<int, int>> a)
{
    set<int> pos;
    int sum = a[0].first + a[0].second + a[1].first + a[1].second + a[2].first + a[2].second;
    if (sum == 0) return 0;
    for (int i = 0; i < 3; ++i)
    {
        for (int j = 0; j <= a[i].first; ++j)
        {
            for (int k = 0; k <= a[i].second; ++k)
            {
                if (j + k > 0)
                {
                    for (int t = 0; t <= 4 * j; ++t)
                    {

                        vector<pair<int, int>> temp = a;
                        if (j > 0) temp[i].se += t - k;
                        else temp[i].second += -k;
                        temp[i].first += -j;
                        if (x1[temp] != 0) pos.insert(x1[temp] - 1);
                        else pos.insert(gr(temp));
                    }

                }
            }
        }
    }
    x1[a] = mex(pos) + 1;
    return x1[a] - 1;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    int q, k;
    cin >> k >> q;
    for(int i = 0; i < q; ++i)
    {
        solve(k);
    }
    /*vector<pair<int, int>> data;
    for (int i = 0; i < 1; ++i)
    {
        /*do {
            data = vector<pair<int, int>>(3);
            for (int j = 0; j < 3; ++j)
            {
                data[j] = { rand() % 4, rand() % 4 };
                
            }
        } while (data[0].fi != 0 && data[1].fi != 0 && data[2].fi != 0);
        data = vector<pair<int, int>>(3);
        for (int a = 0; a < 16; a ++)
        {
            for (int b = a; b < 16; b ++)
            {
                for (int c = b; c < 16; c++)
                {
                    data[0] = { a % 4, a / 4 };
                    data[1] = { b % 4, b / 4 };
                    data[2] = { c % 4, c / 4 };
                    int gg = gr(data);
                    if (gg != 0)
                    {
                        for (int j = 0; j < 3; ++j)
                        {
                            cout << "(" << data[j].fi << " " << data[j].second << ") ";
                        }
                        solve(1, data);
                        //cout << ((data[0].fi + 1) ^ (data[1].fi + 1) ^ (data[2].first + 1)) << ((data[0].se + 1) ^ (data[1].se + 1) ^ (data[2].se + 1)) << '\n';
                        cout << '\n';
                    }
                }
            }
        }
        cout << ".";
        /*int l = 0;
        for (int j = 0; j < 3; ++j)
        {
            cout << "(" << data[j].fi << " " << data[j].second << ") ";
            l ^= data[j].first + data[j].second;
        }
        cout << '\n' << gr(data) << " " << (data[0].first ^ data[1].first ^ data[2].first) << " " << (data[0].se ^ data[1].se ^ data[2].se) << " " << l << '\n';

    }
    
    cout << gr({ {1, 0}, {0, 2}, {1, 3} });*/
    return 0;
}