#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const long long N = 5e5 + 5;



vector<long long> fii[N], v;
long long m[N], av[N], w[N];
struct path {
  long long a, b;
  long long w;
  bool operator<(const path& P) const {
    if (w != P.w) return w > P.w;
    return m[a] < m[P.a];
  }
};
vector<path> p;

void dfs(long long nod) {
  long long s = w[nod];
  if (av[nod])
    for (long long i = v.size() - 1; i >= 0; --i) {
      if (m[v[i]] && s > 0)
        p.push_back({v[i], nod, s});
      s += w[v[i]];
    }
  v.push_back(nod);
  for (auto f : fii[nod])
    dfs(f);
  v.pop_back();
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  long long n;
  cin >> n;
  for (long long i = 1; i <= n; ++i)
    cin >> m[i];
  for (long long i = 1; i <= n; ++i)
    cin >> av[i];
  for (long long i = 2; i <= n; ++i) {
    long long tata;
    cin >> tata >> w[i];
    fii[tata].push_back(i);
  }
  dfs(1);
  sort(p.begin(), p.end());
  long long ans = 0;
  for (auto i : p) {
    long long cati = min(m[i.a], av[i.b]);
    if (cati == 0)
      continue;
    ans += i.w * cati;
    m[i.a] -= cati;
    av[i.b] -= cati;
  }
  cout << ans << "\n";
  return 0;
}
