#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define double long double
#define endl '\n'
#define pb push_back
#define mp make_pair
#define in insert
#define er erase
#define sz size
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
#define INF LONG_LONG_MAX

ll n, b[50004], dist[50005], used[50005], qq;
vector<ll> vec[50005];
queue<ll> q;

void clearq()
{
    while(!q.empty())
    {
        q.pop();
    }
}

void resetused()
{
    for(ll i=1;i<=n;i++)
        used[i]=0;
}

void BFS1(ll d)  /// tell news
{
    while(!q.empty())
    {
        ll node=q.front();
        q.pop();
        if(dist[node]==d){break;}
        for(ll i:vec[node])
        {
            if(used[i]==0)
            {
                used[i]=1;
                b[i]=1;
                q.push(i);
                if(dist[i]){dist[i]=0;}
                dist[i]=dist[node]+1;
            }
        }
    }
    clearq();
}


ll BFS2(ll d)  /// ask who knows news
{
    ll res=0;
    while(!q.empty())
    {
        ll node=q.front();
        q.pop();
        if(dist[node]==d){break;}
        for(ll i:vec[node])
        {
            if(used[i]==0)
            {
                used[i]=1;
                if(b[i]){res++;}
                q.push(i);
                if(dist[i]){dist[i]=0;}
                dist[i]=dist[node]+1;
            }
        }
    }
    clearq();
    return res;
}

void solve()
{
    cin>>n;
    for(ll i=1;i<n;i++)
    {
        ll x, y;
        cin>>x>>y;
        vec[x].pb(y);
    }
    for(ll i=1;i<=n;i++)
    {
        cin>>b[i];
    }
    cin>>qq;
    while(qq--)
    {
        ll c, x, k;
        cin>>c>>x>>k;
        if(c==1)
        {
            q.push(x);
            b[x]=1;
            resetused();
            used[x]=1;
            if(dist[x]){dist[x]=0;}
            BFS1(k);
        }
        else
        {
            ll ans=b[x];
            q.push(x);
            resetused();
            used[x]=1;
            if(dist[x]){dist[x]=0;}
            cout<<b[x]+BFS2(k)<<endl;
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    ll tc=1;
    //cin>>tc;
    while(tc--)
    {
        solve();
    }
    return 0;
}
