#include<bits/stdc++.h>
using namespace std;

#define pb push_back
#define ll long long
#define sz(a) (int)a.size()
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()

#define int long long
const int N = 105;
ll path[N][N], s[N], e[N], aaa[N], bbb[N];
const ll inf = 1e12;
vector<pair<int,int>> adj[N];
void dfs(int u, int par, int node){
    for(auto x: adj[u]){
        int v = x.first, w = x.second;
        if(v == par)continue;
        path[node][v] = path[node][u] + w;
        dfs(v, u, node);
    }
}

void solve(){
    int n;
    cin >> n;
    for(int i = 0;i < n; ++i){
        cin >> s[i];
        aaa[i] = s[i];
    }
    for(int i = 0;i < n; ++i){
        cin >> e[i];
        bbb[i] = e[i];
    }

    for(int i = 0;i < n; ++i)for(int j = 0;j < n; ++j)path[i][j] = -inf;

    for(int i = 1;i < n; ++i){
        int u, w;
        cin >> u >> w;
        --u;
        adj[u].pb({i, w});
    }
    for(int i = 0;i < n; ++i){
        path[i][i] = 0;
        dfs(i, i, i);
    }
    vector<int> a(n);
    for(int i = 0;i < n; ++i)a[i] = i;
    ll mxx = 0;
    do{
        for(int i = 0;i < n; ++i){
             s[i] = aaa[i];
             e[i] = bbb[i];
        }
        ll ans = 0;
        while(true){
        int mx = -1;
        int startt, endd;
        for(auto i: a){
            for(int j = 0;j < n; ++j){
                if(s[i] && e[j] && path[i][j] > 0 && mx < path[i][j]){
                    startt = i, endd = j;
                    mx = path[i][j];
                }
            }
        }
        if(mx == -1)break;
        int x = min(s[startt], e[endd]);
        ans += mx * x;
        s[startt] -= x;
        e[endd] -= x;
        mxx = max(mxx, ans);
    }
    }while(next_permutation(all(a)));
    cout << mxx << "\n";
}

int32_t main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int t = 1;
    //cin >> t;

    while(t--){
        solve();
    }
}
