#include <bits/stdc++.h>
#define ll long long
#define all(x) (x).begin(),(x).end()

#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = 2e5 + 5;
vector <int> gr[N];
vector <int> eu;

int in[N], out[N], h[N];

inline void dfs(int v, int p = -1) {
    eu.push_back(v);
    in[v] = eu.size() - 1;
    for (auto to : gr[v]) if (to != p) {
        h[to] = h[v] + 1; dfs(to, v);
    }
    out[v] = eu.size() - 1;
}

int t[4 * N], fl[4 * N];
inline void build(int v, int vl, int vr, vector<int> &a) {
    if (vl == vr) { t[v] = a[vl]; return; }
    int m = vl + vr >> 1;
    build(2 * v + 1, vl, m, a);
    build(2 * v + 2, m + 1, vr, a);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}
inline void push(int v, int vl, int vr) {
    if (!fl[v]) return;
    if (vl != vr) {
        for (auto u : {2 * v + 1, 2 * v + 2}) {
            fl[u] |= fl[v];
        }
    }
    t[v] = vr - vl + 1;
    fl[v] = 0;
}
inline void upd(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (l > r) return;
    else if (vl == l && vr == r) {
        fl[v] = 1;
        push(v, vl, vr);
        return;
    }
    int m = vl + vr >> 1;
    upd(2 * v + 1, vl, m, l, min(r, m));
    upd(2 * v + 2, m + 1, vr, max(l, m + 1), r);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}
inline int get(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (l > r) return 0;
    else if (vl == l && vr == r) return t[v];
    int m = vl + vr >> 1;
    int a = get(2 * v + 1, vl, m, l, min(r, m));
    int b = get(2 * v + 2, m + 1, vr, max(l, m + 1), r);
    return a + b;
}

int f[N];
inline void upd(int i, int x) { i += 2;
    for (; i < N; i += i & -i) f[i] += x;
}

inline int get(int i) {
    i += 2;
    int ans = 0;
    for (; i; i -= i & -i) ans += f[i];
    return ans;
}

inline int get(int l, int r) { return get(r) - get(l - 1); }

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int v, u;
        cin >> v >> u, --v, --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }

    dfs(0);
    vector <int> p(n);
    for (int i = 0; i < n; ++i) cin >> p[i];

    int q;
    cin >> q;

    if (n <= (int)5e4 && q <= (int)5e4) {
        while (q--) {
            int t;
            cin >> t;
            if (t == 2) {
                int v, k;
                cin >> v >> k, --v;

                int ans = 0;
                for (int i = in[v]; i <= out[v]; ++i) {
                    if (h[eu[i]] <= h[v] + k)
                        ans += p[eu[i]];
                }
                cout << ans << '\n';
            }
            else {
                int v, k;
                cin >> v >> k, --v;

                int ans = 0;
                for (int i = in[v]; i <= out[v]; ++i) {
                    if (h[eu[i]] <= h[v] + k)
                        p[eu[i]] = 1;
                }
            }
        }
    }
    else {

        bool s4 = 1;
        vector <tuple<int, int, int, int>> qq(q);

        for (int i = 0; i < q; ++i) {

            int t, v, k;
            cin >> t >> v >> k, --v;

            s4 &= t == 2;

            qq[i] = make_tuple(h[v] + k, v, t, i);
        }

        if (!s4) {
            vector <int> a(n);
            for (int i = 0; i < n; ++i) a[i] = p[eu[i]];

            build(0, 0, n - 1, a);

            for (auto &[hh, v, t, i] : qq) {
                if (t == 1) upd(0, 0, n - 1, in[v], out[v]);
                else cout << get(0, 0, n - 1, in[v], out[v]) << '\n';
            }
        }
        else {
            sort(all(qq));

            vector <pair<int, int>> ar;
            ar.reserve(n);

            for (int i = 0; i < n; ++i) {
                if (p[eu[i]]) {
                    ar.push_back({h[eu[i]], i});
                }
            }
            sort(all(ar));

            int ptr = 0;
            vector <int> ans(q);
            for (auto &[h, v, t, id] : qq) {
                while (ptr < ar.size() && ar[ptr].first <= h) {
                    upd(ar[ptr].second, 1);
                    ++ptr;
                }
                ans[id] = get(in[v], out[v]);
            }
            for (auto i : ans) cout << i << '\n';
        }
    }
}
/**
13
1 2
1 3
2 4
4 5
4 6
4 7
3 8
8 10
3 9
9 11
9 12
9 13
0 0 0 0 0 0 0 0 0 0 0 0 0
5
1 8 10
1 11 10
2 3 10
1 3 10
2 1 10
*/

/**
13
1 2
1 3
2 4
4 5
4 6
4 7
3 8
8 10
3 9
9 11
9 12
9 13
0 1 1 0 0 1 1 1 1 0 1 1 0
15
2 1 1
2 1 2
2 1 3
2 1 4
2 1 5
2 2 1
2 2 2
2 2 3
2 3 5
2 3 1
2 3 5
2 10 10
2 8 2
2 9 1
2 9 5
*/
