#include<bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)

int n, timer = 0;
vector<vector<int>> g;
vector<int> tin, lTin, rTin, h, euler;

void dfs(int v) {
    tin[v] = timer++;
    euler.push_back(v);
    lTin[v] = tin[v], rTin[v] = tin[v];
    for(int u : g[v]){
        h[u] = h[v] + 1;
        dfs(u);
        ckmin(lTin[v], lTin[u]);
        ckmax(rTin[v], rTin[u]);
    }
}

struct SegmentTree {
    vector<int> t;
    int n;

    SegmentTree() {}

    void init(int N) {
        n = N;
        t.clear();
        t.resize(4 * n);
    }

    void upd(int v, int tl, int tr, int id, int x) {
        if (tl == tr)t[v] = x;
        else {
            int tm = (tl + tr) / 2;
            if (id <= tm)upd(v * 2, tl, tm, id, x);
            else upd(v * 2 + 1, tm + 1, tr, id, x);
            t[v] = t[v * 2] + t[v * 2 + 1];
        }
    }

    void upd(int id, int x) {
        upd(1, 0, n - 1, id, x);
    }

    int get_sum(int v, int tl, int tr, int l, int r) {
        if (tl > r || l > tr)return 0;
        if (l <= tl && tr <= r)return t[v];
        int tm = (tl + tr) / 2;
        return get_sum(v * 2, tl, tm, l, r) + get_sum(v * 2 + 1, tm + 1, tr, l, r);
    }

    int get_sum(int l, int r) {
        return get_sum(1, 0, n - 1, l, r);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    g.resize(n);
    tin.resize(n);
    rTin.resize(n);
    lTin.resize(n);
    h.resize(n);

    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        g[--x].push_back(--y);
    }

    dfs(0);

    vector<int> knows(n);
    for(int i = 0; i < n; ++i) cin >> knows[i];

    
    int q;
    cin >> q;
    while(q--){
        int type, v, k;
        cin >> type >> v >> k;
        --v;

        if(type == 1){
            for(int i = lTin[v]; i <= rTin[v]; ++i){
                if(h[euler[i]] <= h[v] + k)knows[euler[i]] = 1;
            }
        }else{
            int res =0;
            for(int i = lTin[v]; i <= rTin[v]; ++i){
                if(h[euler[i]] <= h[v] + k)res += knows[euler[i]];
            }
            cout << res << '\n';
        }
    }
}
