#include <bits/stdc++.h>
#define pii pair <int, int>
#define pii64 pair <int64, int64>
#define long long int64
using namespace std;
const int maxn = 200200;
vector <int> ad [maxn];
bitset <maxn> know;
bitset <maxn> full;
vector <int> ch;

int dfs (int u) {
    for (auto v: ad[u]) {
        ch[u]+=dfs(v);
    }
    ch[u]++;
    return ch[u];
}

int get (int x) {
    queue <int> q;
    q.push(x);
    int rs = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (full[u]) {
            rs+=ch[u];
            continue;
        }
        if (know[u]) rs++;
        for (auto v: ad[u]) {
            q.push(v);
        }
    }
    return rs;
}
void update (int x) {
    queue <int> q;
    q.push(x);
    int rs = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (full[u]) continue;
        know[u] = 1;
        full[u] = 1;
        for (auto v: ad[u]) {
            q.push(v);
        }
    }
}


int main() {
    cin.tie(0); ios::sync_with_stdio(false);
    int n,q;
    cin >> n;
    for (int i = 0; i < n - 1; i++){
        int x,y;
        cin >> x >> y;
        ad[x].push_back(y);
    }
    dfs(1);
    for (int i = 1; i <= n; i++){
        int t;
        cin >> t;
        know[i] = !!t;
    }
    cin >> q;
    while (q--) {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 2) {
            cout << get(x) << "\n";
        }
        else {
            update(x);
        }
    }
    return 0;
}
