#include <bits/stdc++.h>

using namespace std;

const int NMAX = 2e5 + 5;

vector<int>v[NMAX];
int state[NMAX], nrfii[NMAX], nrtot[NMAX];
int rez;

void DFS_1(int nod, int h) {
    state[nod] = 1;
    if (h == 0) {
        return;
    }
    for (int fiu : v[nod]) {
        DFS_1(fiu, h - 1);
    }
}

void DFS_2(int nod, int h) {
    rez += state[nod];
    if (h == 0) {
        return;
    }
    for (int fiu : v[nod]) {
        DFS_2(fiu, h - 1);
    }
}

void DFS_aflu_fii(int nod) {
    int sum = 0;
    for (int fiu : v[nod]) {
        DFS_aflu_fii(fiu);
        sum += nrfii[fiu];
    }
    nrfii[nod] = sum + 1;
}

void DFS_sum_init(int nod) {
    int sum = 0;
    for (int fiu : v[nod]) {
        DFS_sum_init(fiu);
        sum += nrtot[fiu];
    }
    nrtot[nod] = sum + state[nod];
}

void DFS_1_prim(int nod) {
    if (nrtot[nod] != nrfii[nod]) {
        nrtot[nod] = nrfii[nod];
        for (int fiu : v[nod]) {
            DFS_1_prim(fiu);
        }
    }
}



int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    long long  n;

    cin >> n;
    long long sr = 0;
    for (int i = 1; i < n; i++) {
        int a, b;
        cin >> a >> b;
        sr += b;
        v[a].push_back(b);
    }

    long long rooot = ((long long)n * (n + 1) / 2 - sr) ;
    int root = rooot;

    for (int i = 1; i <= n; i++) {
        cin >> state[i];
     //   cout << state[i] << " ";
    }

  //  cout << "\n\n";

    int q;
    cin >> q;

    /*
    for (int cq = 1; cq <= q; cq++) {
        int type, x ,k;
        cin >> type >> x >> k;
        if (type == 1) {
            DFS_1(x, k);
        }
        else {
            rez = 0;
            DFS_2(x, k);
            cout << rez << "\n";
        }
    }
*/
 //   cout << "\n\n";

    DFS_aflu_fii(root);
 //   for (int i = 1; i <= n; i++)
    //    cout << nrfii[i] << " ";

    DFS_sum_init(root);
  //  for (int i = 1; i <= n; i++)
   //     cout << nrtot[i] << " ";
    for (int cq = 1; cq <= q; cq++) {
        int type, x ,k;
        cin >> type >> x >> k;
        if (type == 1) {
            DFS_1_prim(x);
        }
        else {
            rez = 0;
            rez = nrtot[x];
            cout << rez << "\n";
        }
    }


    return 0;
}

/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2



*/
