#include <bits/stdc++.h>

using namespace std;


int N, Q, state[200004];
vector<int> G[200004];


void broadcast(int nod, int k, int level = 0) {
    state[nod] = true;
    if(level == k) return;
    for(auto it : G[nod]) {
        broadcast(it, k, level + 1);
    }
}

int check(int nod, int k, int level = 0) {
    int sum = 0;
    sum += state[nod];
    if(level == k) return sum;
    for(auto it : G[nod]) {
        sum += check(it, k, level + 1);
    }
    return sum;
}


int main()
{
    cin >> N;
    for(int i = 1; i < N; i++) {
        static int x, y;
        cin >> x >> y;
        G[x].push_back(y);
    }
    for(int i = 1; i <= N; i++) {
        cin >> state[i];
    }
    cin >> Q;
    for(int i = 1; i <= Q; i++) {
        int tip, x, k;
        cin >> tip >> x >> k;
        if(tip == 1) {
            broadcast(x, k);
        } else if(tip == 2) {
            cout << check(x, k) << "\n";
        }
    }
    return 0;
}
