#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

//#define int long long

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

vector < vector <int> > a;
vector <int> b, dp;
vector < vector <int> > binup;
int deg = 0;

/*void dfs1(int v, int d){
    dp[v] = d;
    binup[0][v] = v;
    for(auto to : a[v]){
        dfs1(to, d + 1);
        dp[v] = max(dp[v], dp[to]);
    }

    for(int i = 0; i < a[v].size(); ++i){
        if(dp[a[v][i]] == dp[v]){
            binup[0][v] = a[v][i];
            for(int j = 1; j < deg; ++j){
                binup[j][v] = binup[j - 1][binup[j - 1][v]];
            }
            swap(a[v][i], a[v][0]);
            break;
        }
    }
}

struct seg_tree{
    vector <ordered_set> t;
    vector < vector <int> > p;

    void in(int v, int tl, int tr, ){

    }
};*/

int otv = 0;

vector <int> hod, g, gr;
void dfs(int v){
    hod.push_back(v);
    g[v] = hod.size() - 1;
    for(auto to : a[v]){
        dfs(to);
    }

    gr[v] = hod.size() - 1;
}

/*void dfs1(int v, int k, int d){
    if(d > k){
        return;
    }

    b[v] = 1;
    for(auto to : a[v]){
        dfs1(to, k, d + 1);
    }
}

void dfs2(int v, int k, int d){
    if(d > k){
        return;
    }

    otv += b[v];
    for(auto to : a[v]){
        dfs2(to, k, d + 1);
    }
}*/

struct seg_tree{
    vector <int> t;
    vector <int> p;

    void push(int v, int tl, int tr){
        if(p[v] != 0){
            int tm = (tl + tr) / 2;
            p[v * 2] = p[v];
            p[v * 2 + 1] = p[v];
            t[v * 2] = p[v] * (tm - tl);
            t[v * 2 + 1] = p[v] * (tr - tm);
            p[v] = 0;
        }
    }

    void build(int v, int tl, int tr, vector <int> & h){
        if(tl + 1 == tr){
            t[v] = h[tl];
            return;
        }

        int tm = (tl + tr) / 2;
        build(v * 2, tl, tm, h);
        build(v * 2 + 1, tm, tr, h);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    void update(int v, int l, int r, int tl, int tr, int val){
        if(tr <= l || tl >= r){
            return;
        }

        if(tl >= l && tr <= r){
            t[v] = val * (tr - tl);
            p[v] = val;
            return;
        }

        push(v, tl, tr);
        int tm = (tl + tr) / 2;
        update(v * 2, l, r, tl, tm, val);
        update(v * 2 + 1, l, r, tm, tr, val);
        t[v] = t[v * 2] + t[v * 2 + 1];
    }

    int quer(int v, int l, int r, int tl, int tr){
        if(tr <= l || tl >= r){
            return 0;
        }

        if(tl >= l && tr <= r){
            return t[v];
        }

        push(v, tl, tr);
        int tm = (tl + tr) / 2;
        return quer(v * 2, l, r, tl, tm) + quer(v * 2 + 1, l, r, tm, tr);
    }
};

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    a.resize(n);
    dp.resize(n);
    b.resize(n);

    while((1 << deg) <= n){
        deg++;
    }
    deg++;

    binup.resize(deg, vector <int> (n));

    for(int i = 0; i < n - 1; ++i){
        int x, y;
        cin >> x >> y;
        a[--x].push_back(--y);
    }

    g.resize(n);
    gr.resize(n);
    dfs(0);

    vector <int> h(n);
    for(int i = 0; i < n; ++i){
        cin >> b[i];
        h[g[i]] = b[i];
    }

    seg_tree t;
    t.t.resize(4 * n);
    t.p.resize(4 * n);
    t.build(1, 0, n, h);

    int q;
    cin >> q;
    for(int T = 0; T < q; ++T){
        int f, x, k;
        cin >> f >> x >> k;
        --x;
        if(f == 1){
            t.update(1, g[x], gr[x] + 1, 0, n, 1);
        }else{
            cout << t.quer(1, g[x], gr[x] + 1, 0, n) << '\n';
        }
    }
}