#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;

struct DP {
    map<int, int> have;
    ll start = 0;
    int add = 0;

    void insert(int x, int len) {
        x -= add;
        have[x] += len;
    }
};

void merge(DP &a, DP &b) {
    if (a.have.size() < b.have.size()) {
        swap(a.have, b.have);
        swap(a.add, b.add);
    }
    a.start += b.start;
    for(auto &[x, y] : b.have) {
        a.insert(x + b.add, y);
    }
    b.have.clear();
}

const int maxN = 5e5 + 10;
DP dp[maxN];
vector<int> g[maxN];
int e[maxN], s[maxN];
int w[maxN];

void dfs(int v) {
    for(auto &u : g[v]) {
        dfs(u);
        merge(dp[v], dp[u]);
    }
    dp[v].insert(0, e[v]);
    while(s[v] > 0) {
        int k = dp[v].have.rbegin()->first;
        if (k + dp[v].add == 0) break;
        int len;
        if (dp[v].have[k] > s[v]) {
            len = s[v];
            dp[v].have[k] -= s[v];
        } else {
            len = dp[v].have[k];
            dp[v].have.erase(k);
        }
        k += dp[v].add;
        dp[v].start += 1ll * k * len;
        s[v] -= len;
        dp[v].insert(0, len);
    }
    if (v == 1) return;
    dp[v].add += w[v];
}

void solve() {
    int n; cin >> n;
    for(int i = 1; i <= n; ++i) cin >> s[i];
    for(int i = 1; i <= n; ++i) cin >> e[i];
    for(int i = 2; i <= n; ++i) {
        int p;
        cin >> p >> w[i];
        g[p].push_back(i);
    }
    dfs(1);
    cout << dp[1].start << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}