#include<bits/stdc++.h>
using namespace std;
#define ll int
#define f(i,a,b) for(int i = a;i < b;i++)
#define vll vector<ll>
#define pb push_back
vector<vll>adj;
//ll par[200005] = {0};
//ll depth[200005] = {0};
ll b[200005];
ll tin[200005],tout[200005];
ll tim = 1;
void dfs(ll idx,ll p){
    //par[idx] = p;
    tin[idx] = tim;
    tim++;
    for(auto x:adj[idx]){
        if(x != p){
            //depth[x] = depth[idx] + 1;
            dfs(x,idx);
        }
    }
    tout[idx] = tim-1;
}
struct node{
    ll sum = 0,lazy = 0;
};
node seg[800005];
void update(ll s,ll e,ll qs,ll qe,ll idx){
    if(qs <= s && e <= qe){
        seg[idx].sum = e - s + 1;
        seg[idx].lazy = 1;
        return;
    }
    if(s > qe || qs > e){
        return;
    }
    ll mid = (s+e)/2;
    if(seg[idx].lazy == 1){
        seg[idx*2].sum = mid - s + 1;
        seg[idx*2+1].sum = e - mid;
        seg[idx*2].lazy = seg[idx*2+1].lazy = 1;
        seg[idx].lazy = 0;
    }
    update(s,mid,qs,qe,idx*2);
    update(mid+1,e,qs,qe,idx*2+1);
    seg[idx].sum = seg[idx*2].sum + seg[idx*2+1].sum;
}
ll query(ll s,ll e,ll qs,ll qe,ll idx){
    if(qs <= s && e <= qe){
        return seg[idx].sum;
    }
    if(s > qe || qs > e){
        return 0;
    }
    ll mid = (s+e)/2;
    if(seg[idx].lazy == 1){
        seg[idx*2].sum = mid - s + 1;
        seg[idx*2+1].sum = e - mid;
        seg[idx*2].lazy = seg[idx*2+1].lazy = 1;
        seg[idx].lazy = 0;
    }
    ll a = query(s,mid,qs,qe,idx*2);
    ll b = query(mid+1,e,qs,qe,idx*2+1);
    seg[idx].sum = seg[idx*2].sum + seg[idx*2+1].sum;
    return a + b;
}
int main(void){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll n;
    cin>>n;
    adj.assign(n+5,vll());
    f(i,0,n-1){
        ll x,y;
        cin>>x>>y;
        adj[x].pb(y);
        adj[y].pb(x);
    }
    f(i,0,n){
        cin>>b[i+1];
        if(b[i+1]){
            update(1,n,i+1,i+1,1);
        }
    }
    dfs(1,0);
    ll q;
    cin>>q;
    while(q--){
        ll t,x,k;
        cin>>t>>x>>k;
        if(t == 1){
            update(1,n,tin[x],tout[x],1);
        }
        else{
            cout<<query(1,n,tin[x],tout[x],1)<<"\n";
        }
    }
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/


