#include <bits/stdc++.h>

using namespace std;
const int N = 2e5 + 5;
vector <int> g[N];

int seg[4 * N];
int lazy[4 * N];
int n, q;
int v[N], lvl[N], dad[N];
int length[4 * N];
int in[N], out[N], cod[N];
int s = 0, timp;
void dfs(int nod)
{
    in[nod] = ++timp;
    cod[timp] = nod;
    lvl[nod] = lvl[dad[nod]] + 1;
    for (auto son : g[nod])
        if (son != dad[nod])
        {
            dad[son] = nod;
            dfs(son);
        }
    out[nod] = timp;
}
void dfs1(int t, int nod, int x, int k)
{
    if (t == 1)
        v[nod] = 1;
    s += v[nod];
    for (auto son : g[nod])
        if (son != dad[nod] && lvl[son] - lvl[x] <= k)
            dfs1(t, son, x, k);
}
void sbt2()
{
    while(q--)
    {
        int t, x, k;
        cin >> t >> x >> k;
        s = 0;
        dfs1(t, x, x, k);
        if (t == 2)
            cout << s << '\n';
    }
}

void build(int nod, int l, int r)
{
    if (r < l)
        return;
    if (l == r)
    {
        seg[nod] = v[cod[l]];
        length[nod] = 1;
        return;
    }
    int ls = 2 * nod, rs = ls + 1, mid = (l + r) / 2;
    build(ls, l, mid);
    build(rs, mid + 1, r);
    seg[nod] = seg[ls] + seg[rs];
    length[nod] = length[ls] + length[rs];
}
void push(int nod, int ls, int rs)
{
    lazy[ls] = 1;
    lazy[rs] = 1;
    seg[ls] = length[ls];
    seg[rs] = length[rs];
    lazy[nod] = 0;
}
void upd(int nod, int l, int r, int ql, int qr)
{
    int ls = 2 * nod, rs = ls + 1, mid = (l + r) / 2;
    if (lazy[nod])
        push(nod, ls, rs);
    if (ql <= l && r <= qr)
    {
        lazy[nod] = 1;
        seg[nod] = length[nod];
        return;
    }
    if (ql <= mid)
        upd(ls, l, mid, ql, qr);
    if (mid < qr)
        upd(rs, mid + 1, r, ql, qr);
    seg[nod] = seg[ls] + seg[rs];
}
int qry(int nod, int l, int r, int ql, int qr)
{
    int ans = 0, ls = 2 * nod, rs = ls + 1, mid = (l + r) / 2;
    if (lazy[nod])
        push(nod, ls, rs);
    if (ql <= l && r <= qr)
        return seg[nod];
    if (ql <= mid)
        ans += qry(ls, l, mid, ql, qr);
    if (mid < qr)
        ans += qry(rs, mid + 1, r, ql, qr);
    return ans;
}
void sbt3()
{
    build(1, 1, n);
    /*for (int i = 1; i <= n; i++)
        cout << in[i] << " ";
    cout << endl;
    for (int i = 1; i <= n; i++)
        cout << out[i] << " ";
    cout << endl;*/
    while (q--)
    {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 1)
            upd(1, 1, n, in[x], out[x]);
        else
            cout << qry(1, 1, n, in[x], out[x]) << '\n';
    }
}
int main()
{
    //freopen("g.in", "r", stdin);
    //freopen("g.out", "w", stdout);
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }
    dfs(1);
    for (int i = 1; i <= n; i++)
        cin >> v[i];
    cin >> q;
    if (n <= 10000 && q <= 10000)
        sbt2();
    else
        sbt3();
    ///sbt4();
    return 0;
}
