#include <bits/stdc++.h>

using namespace std;
const int N = 2e5 + 5;
const int LG = 20;
vector <int> g[N];
int subarb[N];
int seg[4 * N];
int lazy[4 * N];
int bfscod[N]; ///bfscod[i] = al catelea e nodul i in bfs
int bfsord[N]; ///bfsord[i] = al i lea nod in bfs
int n, q;
int cod2[N];
int v[N], lvl[N], dad[N];
int length[4 * N];
int in[N], out[N], cod[N];
int s = 0, timp;
int rmq[N][LG];
void dfs(int nod)
{
    ///rmq[nod][0] = dad[nod];
    subarb[nod] = v[nod];
    in[nod] = ++timp;
    cod[timp] = nod;
    lvl[nod] = lvl[dad[nod]] + 1;
    for (auto son : g[nod])
        if (son != dad[nod])
        {
            dad[son] = nod;
            dfs(son);
            subarb[nod] += subarb[son];
        }
    out[nod] = timp;
}
void build(int nod, int l, int r)
{
    if (r < l)
        return;
    if (l == r)
    {
        seg[nod] = subarb[bfsord[l]];
        length[nod] = 1;
        return;
    }
    int ls = 2 * nod, rs = ls + 1, mid = (l + r) / 2;
    build(ls, l, mid);
    build(rs, mid + 1, r);
    seg[nod] = seg[ls] + seg[rs];
}
void upd(int nod, int l, int r, int ql, int qr)
{
    int ls = 2 * nod, rs = ls + 1, mid = (l + r) / 2;
    if (ql <= l && r <= qr)
    {
        lazy[nod] = 1;
        seg[nod] = length[nod];
        return;
    }
    if (ql <= mid)
        upd(ls, l, mid, ql, qr);
    if (mid < qr)
        upd(rs, mid + 1, r, ql, qr);
    seg[nod] = seg[ls] + seg[rs];
}
int qry(int nod, int l, int r, int ql, int qr)
{
    int ans = 0, ls = 2 * nod, rs = ls + 1, mid = (l + r) / 2;
    if (ql <= l && r <= qr)
        return seg[nod];
    if (ql <= mid)
        ans += qry(ls, l, mid, ql, qr);
    if (mid < qr)
        ans += qry(rs, mid + 1, r, ql, qr);
    return ans;
}
int viz[N];
void bfs()
{
    queue <int> q;
    q.push(1);
    bfscod[1] = 1;
    bfsord[1] = 1;
    int ind = 1;
    while(!q.empty())
    {
        int x = q.front();
        q.pop();
        bfsord[ind] = x;
        bfscod[x] = ind++;
        for (auto son : g[x])
            q.push(son);
    }
}
int minnod[N][LG];
int maxnod[N][LG];
void sbt4()
{
    bfs();
   /* for (int i = 1; i <= n; i++)
        cout << bfsord[i] << " ";
    cout << endl;
    for (int i = 1; i <= n; i++)
        cout << bfscod[i] << " ";
    cout << endl;
    */for (int i = 1; i <= n; i++)
        rmq[bfscod[i]][0] = bfscod[dad[i]];
    for (int j = 1; j < LG; j++)
        for (int i = 1; i <= n; i++)
            rmq[i][j] = rmq[rmq[i][j - 1]][j - 1];
    build(1, 1, n);
    ///NU am update uri => raspunsul e suma din subarb - suma rasp subarb ale nodurilor de pe level k. daca faci bfs => e hot ca le ai in ordine si poti sa ai 2 aint
    ///le parcurg ca bfs
    ///min[x][lvl] => ca un rmq dar pentru nodul cu indice minim in bfs --> minim =stii tu iulia.
    ///max[x][lvl] => ca un rmq dar pentru nodul cu indice maxim in bfs
    ///ans pt x = subarb[x] - suma pe intervalu minim, maxim
    for (int i = 1; i <= n; i++)
    {
        //bfscod
        minnod[i][0] = n + 1;
        for (auto j : g[i])
        {
            minnod[i][0] = min(minnod[i][0], bfscod[j]);
            maxnod[i][0] = max(maxnod[i][0], bfscod[j]);
        }
    }
    while(q--)
    {
        int t, x, k;
        cin >> t >> x >> k;
        k++;
        int a = -1, b = -1;

        ///caut binar nodul cel mai mic care are rmq al k lea stramos = bfscod[x]
        ///caut binar nodul cel mai mare care are rmq al k lea stramos = bfscod[x]
        int st = 1, dr = n;
        while (st <= dr)
        {
            int mid = (st + dr) / 2;
            int p = (1 << LG), lg = LG, y, kk = k;
            y = mid;
            while(kk)
            {
                if (kk >= p)
                {
                    kk -= p;
                    y = rmq[y][lg];
                }
                p /= 2;
                lg--;
            }
            if (y >= bfscod[x])
            {
                if (y == bfscod[x])
                a = mid;
                dr = mid - 1;
            }
            else
                st = mid + 1;
        }

        st = 1, dr = n;
        while (st <= dr)
        {
            int mid = (st + dr) / 2;
            int p = (1 << LG), lg = LG, y, kk = k;
            y = mid;
            while(kk)
            {
                if (kk >= p)
                {
                    kk -= p;
                    y = rmq[y][lg];
                }
                p /= 2;
                lg--;
            }
            if (y <= bfscod[x])
            {
                if (y == bfscod[x])
                b = mid;
                st = mid + 1;
            }
            else
                dr = mid - 1;
        }

        if (a > b || b < 1 || a < 1 || a > n || b > n)
            cout << subarb[x] << '\n';
        else
        cout << subarb[x] - qry(1, 1, n, a, b) << '\n';
    }
}
int main()
{
    //freopen("g.in", "r", stdin);
    //freopen("g.out", "w", stdout);
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }
    for (int i = 1; i <= n; i++)
        cin >> v[i];
    dfs(1);
    cin >> q;
    sbt4();
    return 0;
}
