#include <bits/stdc++.h>

#define INF 1e9
#define pb push_back
#define pause system("pause")
#define exit exit(0)
#define endl '\n'

using namespace std;
using ull = unsigned long long;
using ll = long long;

typedef pair<int, int> pii;
const int N = 500005;

int k, q, n, s[N], e[N], d[N], ft[N], lt[N], eu[N << 1], ptr;
vector<pii> g[N];
pii tr[N << 3];

void dfs(int u, int p = -1) {
	eu[ptr] = u;
	ft[u] = ptr++;
	for (auto v : g[u]) {
		if (v.first != p) {
			d[v.first] = d[u] + v.second;
			dfs(v.first, u);
		}
	}
	lt[u] = ptr - 1;
}

void build(int v, int vl, int vr) {
	if (vl == vr) {
		tr[v] = { d[eu[vl]], eu[vl] };
		return;
	}

	int m = (vl + vr) >> 1;
	build(v + v, vl, m);
	build(v + v + 1, m + 1, vr);
	tr[v] = max(tr[v + v], tr[v + v + 1]);
}

void upd(int v, int vl, int vr, int i, int x) {
	if (vl == vr) {
		tr[v] = { x, eu[vl] };
		return;
	}

	int m = (vl + vr) >> 1;
	if (i <= m) {
		upd(v + v, vl, m, i, x);
	} else {
		upd(v + v + 1, m + 1, vr, i, x);
	}

	tr[v] = max(tr[v + v], tr[v + v + 1]);
}

pii get(int v, int vl, int vr, int l, int r) {
	if (r < vl || vr < l) {
		return { -INF, -1 };
	}
	
	if (l <= vl && vr <= r) {
		return tr[v];
	}

	int m = (vl + vr) >> 1;
	return max(get(v + v, vl, m, l, r), get(v + v + 1, m + 1, vr, l, r));
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> s[i];
	}

	for (int i = 1; i <= n; ++i) {
		cin >> e[i];
	}

	for (int i = 2, p, w; i <= n; ++i) {
		cin >> p >> w;
		g[i].pb({ p, w });
		g[p].pb({ i, w });
	}

	dfs(1);
	build(1, 0, ptr - 1);

	set<pair<pii, int>, greater<pair<pii, int>>> st;
	for (int i = 1; i <= n; ++i) {
		if (s[i] != 0) {
			pii v = get(1, 0, ptr - 1, ft[i], lt[i]);
			v.first -= d[i];
			if (v.first > 0) {
				st.insert({ v, i });
			}
		}
	}

	ll ans = 0;
	while (!st.empty()) {
		auto x = *st.begin();
		st.erase(st.begin());

		int i = x.second, u = x.first.second, val = x.first.first;
		if (val <= 0) break;
		if (e[u] > s[i]) {
			ans += (ll)s[i] * val;
			e[u] -= s[i];
		} else {
			ans += (ll)e[u] * val;
			s[i] -= e[u];
			e[u] = 0;
			upd(1, 0, ptr - 1, ft[u], -INF);
			pii v = get(1, 0, ptr - 1, ft[i], lt[i]);
			v.first -= d[i];
			st.insert({ v, i });
		}
	}

	cout << ans << endl;
	//pause;
	return 0;
}