#include<bits/stdc++.h>
#define int long long
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<vector<int>> d;
vector<int> is;

void make(int vertex, int h) {
    is[vertex] = 1;
    if (h == 0) {
        return;
    }
    for (int q : d[vertex]) {
        make(q, h-1);
    }
}

int ans(int vertex, int h) {
    int sum1 = is[vertex];
    if (h == 0) {
        return sum1;
    }
    for (int q : d[vertex]) {
        sum1 += ans(q, h-1);
    }
    return sum1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    d.assign(n, {}), is.assign(n, -1);
    for (int q = 0; q < n-1; q++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        d[x].push_back(y);
    }
    for (int q = 0; q < n; q++) {
        cin >> is[q];
    }
    cin >> m;
    for (int q = 0; q < m; q++) {
        int type, x, k;
        cin >> type >> x >> k;
        x--;
        if (type == 1) {
            make(x, k);
        } else {
            cout << ans(x, k) << endl;
        }
    }
    return 0;
}
