#include <bits/stdc++.h>
using namespace std;


vector<int> dist(5*100000+1,0);
vector<int> e(5*100000+1,0);


bool compr(pair<int,int> p1,pair<int,int> p2) {
	return p1.second<p2.second;

}

int dijkstra(int r, vector<vector<pair<int,int>>> &adj) {

	//int mx=-INT_MAX;
	int mx=0;
	int res=r;
	vector<bool> vis(5*100000+1,0);

	dist[r]=0;

	priority_queue<pair<int,int>> q;

	q.push({0,r});

	while (!q.empty()) {

		int w=q.top().first;
		int s=q.top().second;
		q.pop();


		vis[s]=1;
		dist[s]=w;
		if (w>mx && e[s]>0) {
			mx=w;
			res=s;
		}

		for (auto [a,b]:adj[s]) {

			if (vis[a]==0) {
				q.push({dist[s]+b,a});
				//q.push({a,dist[s]-b});
			}
		}
	}

	return res;

}



int main() {
	cin.tie(nullptr);
	cin.sync_with_stdio(false);

	int n;
	cin>>n;
	vector<vector<pair<int,int>>> adj(n+1);
	vector<int> s(n+1,0);

	for (int i=0;i<n;i++) {
		cin>>s[i+1];
	}
	for (int i=0;i<n;i++) {
		cin>>e[i+1];
	}
	int p,w;
	for (int i=0;i<n-1;i++) {
		cin>>p>>w;
		adj[p].push_back({i+2,w});
	}

	//dijkstra(1,adj);
	long long sum=0;

	for (int i=0;i<n;i++) {

		if (s[i]==0) continue;

		int t=dijkstra(i,adj);

		while (t!=i) {

			//cout<<dist[t]<<' '<<t<<'\n';

			while (e[t]>0 && s[i]>0) {
				sum+=dist[t];
				e[t]--;
				s[i]--;
			}

			if (s[i]==0) break;

			t=dijkstra(i,adj);


		}




	}

	cout<<sum;






	return 0;

}