#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

const int N = 2e5 + 55;

int a[N];
int ht[N];
int tin[N];
int tout[N];
vector <int> g[N];
set <int> mas[N];
vector <int> cur[N];
int timer = 0;

void dfs(int v, int h = 1) {
//    cout << "|| " << v << ' ' << h << '\n';
    ht[v] = h;
    tin[v] = ++timer;
    if (!a[v]) mas[h].insert(tin[v]);
    cur[h].pb(tin[v]);
    for (auto to : g[v]) {
        dfs(to, h + 1);
    }
    tout[v] = timer;
}

void upd(int v, int h) {
    for (int i = ht[v]; i <= ht[v] + h; i ++) {
        auto it = mas[i].lower_bound(tin[v]);
        if (it == mas[i].end()) continue;
        vector <int> vec;
        while (it != mas[i].end() && *(it) <= tout[v]) {
            vec.pb(*(it));
//            cout << *it << '\n';
            it = next(it);
        }
        for (auto it1 : vec) {
            mas[i].erase(it1);
        }
    }
}

int get(int v, int h) {
    int ans = 0;
    for (int i = ht[v]; i <= ht[v] + h; i ++) {
        auto it = mas[i].lower_bound(tin[v]);
        int tmp = 0;
        while (it != mas[i].end() && *(it) <= tout[v]) {
            tmp ++;
            it = next(it);
        }
        auto l = lower_bound(cur[i].begin(), cur[i].end(), tin[v]);
        auto r = upper_bound(cur[i].begin(), cur[i].end(), tout[v]) - 1;
        if (l == cur[i].end()) continue;
        if (l > r) continue;
//        cout << v << "| " << i << ' ' << *l << ' ' << *r << ' ' << tmp << '\n';
        ans += (r - l + 1 - tmp);
    }
    return ans;
}

main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i ++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
    }
    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
    }
    dfs(1);
    int q;
    cin >> q;
    while (q --) {
        int c, x, k;
        cin >> c >> x >> k;
        if (c == 1) {
            upd(x, k);
//            cout << "---\n";
        }
        else {
            cout << get(x, k) << '\n';
        }
    }
}
