#include <bits/stdc++.h>
#define int long long
#define pb push_back

using namespace std;

const int N = 2e5 + 55;

int a[N];
int ht[N];
int hh[N];
int h1[N];
int tin[N];
int tout[N];
vector <int> g[N];
set <int> mas[N];
multiset <int> t[4 * N];
vector <int> t1[4 * N];
vector <int> cur[N];
set <int> curen;
int timer = 0;
int n;

multiset <int> Merge(multiset <int> x, multiset <int> y) {
    for (auto it : y) x.insert(it);
    return x;
}

vector <int> Merge1(vector <int> v1, vector <int> v2) {
    int l1 = 0, l2 = 0;
    vector <int> vec;
    while (l1 < v1.size() && l2 < v2.size()) {
        if (v1[l1] < v2[l2]) vec.pb(v1[l1 ++]);
        else vec.pb(v2[l2 ++]);
    }
    while (l1 < v1.size()) {
        vec.pb(v1[l1 ++]);
    }
    while (l2 < v2.size()) {
        vec.pb(v2[l2 ++]);
    }
    return vec;
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        if (hh[tl]) {
            t[v].insert(hh[tl]);
        }
        t1[v].pb(h1[tl]);
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m + 1, tr);
    t[v] = Merge(t[v * 2], t[v * 2 + 1]);
    t1[v] = Merge1(t1[v * 2], t1[v * 2 + 1]);
}

int get1(int v, int tl, int tr, int l, int r, int l1, int r1) {
    if (l > r) return 0;
    if (tl == l && tr == r) {
        auto rr = upper_bound(t1[v].begin(), t1[v].end(), r1);
        auto ll = lower_bound(t1[v].begin(), t1[v].end(), l1);
        return (rr - ll);
    }
    int m = (tl + tr) / 2;
    return get1(v * 2, tl, m, l, min(r, m), l1, r1) + get1(v * 2 + 1, m + 1, tr, max(m + 1, l), r, l1, r1);
}

void get(int v, int tl, int tr, int l, int r, int ch) {
    if (l > r) return;
    if (tl == l && tr == r) {
        for (auto it : t[v]) {
            if (it > ch) break;
            curen.insert(it);
        }
        return;
    }
    int m = (tl + tr) / 2;
    get(v * 2, tl, m, l, min(r, m), ch);
    get(v * 2 + 1, m + 1, tr, max(m + 1, l), r, ch);
}

void update(int v, int tl, int tr, int pos, int cur) {
    t[v].erase(t[v].find(cur));
    if (tl == tr) return;
    int m = (tl + tr) / 2;
    if (pos <= m) update(v * 2, tl, m, pos, cur);
    else update(v * 2 + 1, m + 1, tr, pos, cur);
}

void dfs(int v, int h = 1) {
    ht[v] = h;
    tin[v] = ++timer;
    h1[tin[v]] = h;
    if (!a[v]) mas[h].insert(tin[v]), hh[tin[v]] = h;
    cur[h].pb(tin[v]);
    for (auto to : g[v]) {
        dfs(to, h + 1);
    }
    tout[v] = timer;
}

void upd(int v, int h) {
    get(1, 1, n, tin[v], tout[v], ht[v] + h);
    for (auto i : curen) {
        auto it = mas[i].lower_bound(tin[v]);
        if (it == mas[i].end() || *(it) > tout[v]) {
            cout << "SUS";
            exit(0);
        }
        vector <int> vec;
        while (it != mas[i].end() && *(it) <= tout[v]) {
            vec.pb(*(it));
            it = next(it);
        }
        for (auto it1 : vec) {
            update(1, 1, n, it1, i);
            mas[i].erase(it1);
        }
    }
    curen.clear();
}

int get(int v, int h) {
    int ans = 0;
    get(1, 1, n, tin[v], tout[v], ht[v] + h);
    int last = ht[v] - 1;
    for (auto i : curen) {
        if (i - 1 != last) {
            ans += get1(1, 1, n, tin[v], tout[v], last + 1, i - 1);
        }
        last = i;
        auto it = mas[i].lower_bound(tin[v]);
        if (it == mas[i].end() || *(it) > tout[v]) {
            cout << "SUS";
            exit(0);
        }
        int tmp = 0;
        while (it != mas[i].end() && *(it) <= tout[v]) {
            tmp ++;
            it = next(it);
        }
        auto l = lower_bound(cur[i].begin(), cur[i].end(), tin[v]);
        auto r = upper_bound(cur[i].begin(), cur[i].end(), tout[v]) - 1;
        if (l == cur[i].end()) continue;
        if (l > r) continue;
        ans += (r - l + 1 - tmp);
    }
    if (last != ht[v] + h) {
        ans += get1(1, 1, n, tin[v], tout[v], last + 1, ht[v] + h);
    }
    curen.clear();
    return ans;
}

main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i ++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
    }
    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
    }
    dfs(1);
    build(1, 1, n);
    int q;
    cin >> q;
    while (q --) {
        int c, x, k;
        cin >> c >> x >> k;
        if (c == 1) {
            upd(x, k);
        }
        else {
            cout << get(x, k) << '\n';
        }
    }
}
