#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#define int long long
#define pb push_back
#define ft first
#define sc second

using namespace std;
using namespace __gnu_pbds;

const int N = 2e5 + 55;

typedef tree <pair <int, int>, null_type, less<pair <int, int> >, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int a[N];
int ht[N];
int hh[N];
int h1[N];
int tin[N];
int tout[N];
vector <int> g[N];
int t[4 * N];
int prom[4 * N];
vector <int> t1[4 * N];
int timer = 0;
int n;
int cnn = 0;
int cnn1 = 0;

void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v] = hh[tl];
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

void push(int v, int tl, int tr) {
    if (prom[v]) {
        t[v] = (tr - tl + 1) * prom[v];
        if (tl != tr) {
            prom[v * 2] = prom[v];
            prom[v * 2 + 1] = prom[v];
        }
        prom[v] = 0;
    }
}

void update(int v, int tl, int tr, int l, int r, int cur) {
    if (l > r) return;
    push(v, tl, tr);
    if (tl == l && tr == r) {
        prom[v] = cur;
        return;
    }
    int m = (tl + tr) / 2;
    update(v * 2, tl, m, l, min(r, m), cur);
    update(v * 2 + 1, m + 1, tr, max(m + 1, l), r, cur);
    push(v * 2, tl, m);
    push(v * 2 + 1, m + 1, tr);
    t[v] = t[v * 2] + t[v * 2 + 1];
}

int get(int v, int tl, int tr, int l, int r) {
    if (l > r) return 0;
    push(v, tl, tr);
    if (tl == l && tr == r) {
        return t[v];
    }
    int m = (tl + tr) / 2;
    return get(v * 2, tl, m, l, min(r, m)) + get(v * 2 + 1, m + 1, tr, max(m + 1, l), r);
}

void dfs(int v, int h = 1) {
    ht[v] = h;
    tin[v] = ++timer;
    h1[tin[v]] = h;
    if (!a[v]) hh[tin[v]] = 1;
    for (auto to : g[v]) {
        dfs(to, h + 1);
    }
    tout[v] = timer;
}

main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i ++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
    }
    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
    }
    dfs(1);
    build(1, 1, n);
    int q;
    cin >> q;
    while (q --) {
        int c, v, h;
        cin >> c >> v >> h;
        if (c == 1) {
            update(1, 1, n, tin[v], tout[v], 1);
        }
        else {
            cout << get(1, 1, n, tin[v], tout[v]) << '\n';
        }
    }
}
