#include <bits/stdc++.h>
typedef long long ll;
#define endl '\n'
using namespace std;
const int N=200050;
vector<int>g[N];
int b[N];
int timer=0;
int tin[N],tout[N],pos[N];
int d[N];
void dfs(int v){
    tin[v]=++timer;
    pos[tin[v]]=v;
    for (int to:g[v]){
        d[to]=d[v]+1;
        dfs(to);
    }
    tout[v]=timer;
}

struct vectT{
    vector<pair<pair<int,int>,int> >u;
    vector<int>t;
    void build(int v,int l,int r){
        if (l==r){
            t[v]=u[l].second;
            return;
        }
        int m=(l+r)/2;
        build(v+v,l,m);
        build(v+v+1,m+1,r);
        t[v]=t[v+v]+t[v+v+1];
    }
    void B(){
        sort(u.begin(),u.end());
        t.resize((int)u.size()*4,0);
        build(1,0,(int)u.size()-1);
    }
    int get(int v,int l,int r,int L,int R){
        if (l>R || r<L) return 0;
        if (l>=L && r<=R) return t[v];
        int m=(l+r)/2;
        return get(v+v,l,m,L,R)+get(v+v+1,m+1,r,L,R);
    }
    void upd(int v,int l,int r,int pos){
        if (l==r){
            u[l].second=1;
            t[v]=1;
            return;
        }
        if (t[v]==r-l+1) return;
        int m=(l+r)/2;
        if (pos<=m) upd(v+v,l,m,pos);
        else upd(v+v+1,m+1,r,pos);
        t[v]=t[v+v]+t[v+v+1];
    }
    void dfs(int v,int l,int r,int L,int R,vector<int>&order){
        if (l>R || r<L || t[v]==r-l+1) return;
        if (l==r){
            order.push_back(u[l].first.second);
            return;
        }
        int m=(l+r)/2;
        dfs(v+v,l,m,L,R,order);
        dfs(v+v+1,m+1,r,L,R,order);
    }
};

vectT t[N*4];
void build(int v,int l,int r){
    for (int i=l;i<=r;i++){
        t[v].u.push_back({{d[pos[i]],pos[i]},b[pos[i]]});
    }
    t[v].B();
    if (l==r) return;
    int m=(l+r)/2;
    build(v+v,l,m);
    build(v+v+1,m+1,r);
}
int get(int v,int l,int r,int L,int R,int x){
    if (l>R || r<L) return 0;
    if (l>=L && r<=R){
//        for (auto y:t[v].u) cout<<y.first<<" "<<y.second<<endl;
        pair<pair<int,int>,int>fnd={{x,1000000001},1000000001};
        int r1=upper_bound(t[v].u.begin(),t[v].u.end(),fnd)-t[v].u.begin()-1;
//        cout<<"AAA "<<r1<<endl;
        return t[v].get(1,0,t[v].u.size()-1,0,r1);
    }
    int m=(l+r)/2;
    return get(v+v,l,m,L,R,x)+get(v+v+1,m+1,r,L,R,x);
}
void upd(int v,int l,int r,int pos){
    pair<pair<int,int>,int>fnd={{d[pos],pos},0};
    int r1=lower_bound(t[v].u.begin(),t[v].u.end(),fnd)-t[v].u.begin();
    t[v].upd(1,0,(int)t[v].u.size()-1,r1);
    if (l==r) return;
    int m=(l+r)/2;
    if (tin[pos]<=m) upd(v+v,l,m,pos);
    else upd(v+v+1,m+1,r,pos);
}

void dfsT(int v,int l,int r,int L,int R,int x,vector<int>&order){
    if (l>R || r<L) return;
    if (l>=L && r<=R){
        pair<pair<int,int>,int>fnd={{x,1000000001},1000000001};
        int r1=upper_bound(t[v].u.begin(),t[v].u.end(),fnd)-t[v].u.begin()-1;
        if (r1>=0) t[v].dfs(1,0,(int)t[v].u.size()-1,0,r1,order);
        return;
    }
    int m=(l+r)/2;
    dfsT(v+v,l,m,L,R,x,order);
    dfsT(v+v+1,m+1,r,L,R,x,order);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n;cin>>n;
    for (int i=1;i<n;i++){
        int x,y;cin>>x>>y;
        g[x].push_back(y);
    }
    for (int i=1;i<=n;i++) cin>>b[i];
    d[1]=0;
    dfs(1);
    build(1,1,n);
    int Q;cin>>Q;
    for (int it=1;it<=Q;it++){
        int type,x,k;cin>>type>>x>>k;
        if (type==1){
            vector<int>order;
            dfsT(1,1,n,1,n,d[x]+k,order);
            for (int v:order){
                upd(1,1,n,v);
            }
//            return 1;
//            upd(1,1,n,tin[x],tout[x],d[x]+k);
        } else {
            cout<<get(1,1,n,tin[x],tout[x],d[x]+k)<<endl;
        }
    }
    return 0;
}
/**
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
2
1 1 2
2 3 4

9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
**/
