#include <bits/stdc++.h>
using namespace std;
#define vint vector<int>
#define pb push_back
vector<vint> adj;

vint know;

void dfs1(int u, int dist, int k)
{
    know[u] = 1;
    if(dist == k)
    {
        return;
    }
    for(auto v : adj[u])
    {
        dfs1(v, dist+1, k);
    }
}

int dfs2(int u, int dist, int k)
{
    int ans = 0;
    if(know[u])
    {
        ans++;
    }
    if(dist == k)
    {
        return ans;
    }
    for(auto v : adj[u])
    {
        ans+=dfs2(v, dist+1, k);
    }
    return ans;
}

void solve()
{
    int n;
    cin >> n;
    for(int i = 0; i <= n; i++)
    {
        vint now;
        adj.pb(now);
    }
    for(int i = 0; i < n-1; i++)
    {
        int u, v;
        cin >> u >> v;
        adj[u].pb(v);
    }
    int b;
    know.assign(n+1, 0);
    for(int i = 0; i < n; i++)
    {
        cin >> b;
        know[i+1] = b;
    }
    int q;
    cin >> q;
    for(int i = 0; i < q; i++)
    {
        int type;
        cin >> type;
        if(type == 1)
        {
            int u, k;
            cin >> u >> k;
            dfs1(u, 0, k);
        }
        else
        {
            int u, k;
            cin >> u >> k;
            cout << dfs2(u, 0, k) << endl;
        }
    }
}

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    solve();
}

/*
6
1 1 1 1 1 1
1 1 1 1 1 1
1 1
2 1
3 100
4 -1
5 -1

6
1 1 1 1 1 1
1 1 1 1 1 1
1 1
2 1
3 1
4 1
5 1
*/

