#include <bits/stdc++.h>

using namespace std;


#define ll          long long
#define nil         NULL
#define forn(i,n)   for(int i = 0; i < n; i++)

#define forbe(i,b,e)    for(int i = b; i < e; i++)
#define all(v)      v.begin(),v.end()
#define rall(v)     v.rbegin(),v.rend()
#define pb          push_back

#define endl        '\n'

ll n;
ll q;
vector<ll>adj[200001];
ll prec[200001];
bool b[200001];
ll p[200001];
ll c[200001];
ll ans;

void input1(){
    scanf("%lld", &n);
    ll x , y;
        //scanf("%lld", &x);

    forn(i,n-1){
        scanf("%lld", &x);
        scanf("%lld", &y);
        adj[x].pb(y);
        p[y] = x;
    }

    forn(i,n){
        scanf("%lld", &x);
        b[i+1] = x;
    }

    scanf("%lld", &q);
}

void dfs1(ll j, ll pr){
    prec[j] = b[j];
    c[j] = 0;
    for(auto u : adj[j]){
        dfs1(u,j);
        prec[j] += prec[u];
        c[j] += c[u] + 1;
    }
}

ll dfs3(ll j, ll k){
    if(!k){
        if(b[j]) return 0;
        b[j] = 1;
        prec[j]++;
        return 1;
    }

    ll dif = !b[j];
    b[j] = 1;
    for(auto u: adj[j]){
        dif += dfs3(u, k-1);
    }

    prec[j]+=dif;
    return dif;
}

void dfs2(ll j, ll k){
    if(!k){
        ans -= prec[j];
        return;
    }

    for(auto u: adj[j]){
        dfs2(u, k-1);
    }
}

void query1(ll x, ll k){
    ans = prec[x];
    dfs2(x, k+1);
    printf("%lld\n", ans);
}

void query2(ll x, ll k){
    ll dif = dfs3(x,k);
    while(dif && p[x]){
        x = p[x];
        prec[x] += dif;
    }
}

void query11(ll x){
    printf("%lld", prec[x]);
}

void dfs12(ll x){
    if (prec[x] == c[x] + 1) return;

    prec[x] = c[x] + 1;
    for(auto u : adj[x]){
        dfs12(u);
    }
}

void query12(ll x){
    ll dif = prec[x];
    dfs12(x);
    dif = prec[x] - dif;
    while(dif && p[x]){
        x = p[x];
        prec[x] += dif;
    }
}

int main(){
    input1();
    dfs1(1,0);

    ll x, y, z;
    p[1] = 0;
    while(q--){
        scanf("%lld", &x);
        scanf("%lld", &y);
        scanf("%lld", &z);

        if(n > 1000){
            if(x-1) query11(y);
            else    query12(y);
        }else {
            if(x-1) query1(y,z);
            else    query2(y,z);
        }
    }
}
