#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"

using namespace std;
int K;
int findxor(vector<int> a) {
    int res = 0;
    for (auto i : a)
        res ^= i;
    return res;
}
void solve() {
    int n;
    cin >> n;
    vector<int> b(n), s(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i] >> s[i];
    }
    if (K == 0) {
        if (findxor(b) != 0 or findxor(s) != 0) {
            cout << "Win\n";
        } else {
            cout << "Loss\n";
        }
    } else {
        if (findxor(s) != 0) {
            cout << "Win\n";
        } else {
            cout << "Loss\n";
        }
    }
}
int main() {
    int n;
    cin >> K >> n;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}
