#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#define all(a) (a).begin(), (a).end()
using namespace std;
int K;
int findxor(vector<int> a) {
    int res = 0;
    for (auto i : a)
        res ^= i;
    return res;
}
vector<vector<pair<int, int>>> nim;
void solve() {
    int n;
    cin >> n;
    int r1 = 0, r2 = 0;
    vector<int> b(n), s(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i] >> s[i];
        if (s[i] < 1004) {
            r1 ^= nim[b[i]][s[i]].first;
            r2 ^= nim[b[i]][s[i]].second;
        } else {
            r1 ^= nim[b[i]].back().first;
            r2 ^= nim[b[i]].back().second + s[i] - 1004;
        }
    }
    if (r1 != 0 or r2 != 0) {
        cout << "Win\n";
    } else {
        cout << "Loss\n";
    }
}

int mex(vector<int> a) {
    int ind = 0;
    int k = 0;
    while (1) {
        while (ind != a.size() and a[ind] < k)
            ind++;
        if (ind == a.size() or a[ind] > k) {
            break;
        }
        k += K;
    }
    return k;
}
void chch() {
    int n = 20, m = 1005;
    nim.assign(n, vector<pair<int, int>>(m));
    for (int i = 0; i < n; ++i) {
        //vector<int> seen(n);
        for (int j = 0; j < m; ++j) {
            if (j != 0 and nim[i][j-1].first == i or (K != 0 and j % K != 0)) {
                nim[i][j] = nim[i][j-1];
                nim[i][j].second++;
                continue;
            }
            vector<vector<int>> a(n);
            for (int k = 0; k < j; k += K) {
                a[nim[i][k].first].push_back(nim[i][k].second);
            }
            for (int k = 1; k <= i; ++k) {
                for (int l = k * K; l < m; l += K) {
                    a[nim[i-k][l].first].push_back(nim[i-k][l].second);
                }
            }
            for (int q = 0; q < n; ++q) {
                sort(all(a[q]));
                int x = mex(a[q]);
                if (x + i * K < m) {
                    //cerr << q << endl;
                    nim[i][j] = {q, x};
                    break;
                }
            }
            //if (seen[nim[i][j].first] == 0)
            //    cout << nim[i][j].first << ' ' << j << ' ' << nim[i][j].second << '\t';
            //seen[nim[i][j].first] = 1;
            //cout << "{" << nim[i][j].first << ", " << nim[i][j].second << "}\t";
        }
        //cout << '\n';
    }
    //exit(0);
}
int main() {
    cin >> K;
    chch();
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}
