#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#include "set"
using namespace std;
void mrgset(pair<multiset<pair<int, int>>, int> &a, pair<multiset<pair<int, int>>, int> &b) {
    if (a.first.size() < b.first.size())
        swap(a, b);
    int cd = b.second - a.second;
    for (auto i : b.first) {
        i.first += cd;
        a.first.insert(i);
    }
}
vector<vector<pair<int, int>>> g;
vector<int> s, e;
long long ans = 0;
pair<multiset<pair<int, int>>, int> dfs(int v, int p) {
    pair<multiset<pair<int, int>>, int> st = {{}, 0};
    int se = e[v] + s[v];
    //st.first.insert({0, e[v]});
    for (auto [i, c] : g[v]) {
        if (i != p) {
            auto st2 = dfs(i, v);
            st2.second += c;
            mrgset(st, st2);
        }
    }
    while (s[v] != 0 and !st.first.empty() and (st.first.rbegin()->first + st.second > 0)) {
        int k = min(s[v], (--st.first.end())->second);
        s[v] -= k;
        pair<int, int> a = *--st.first.end();
        st.first.erase(--st.first.end());
        a.second -= k;
        ans += k * (a.first + st.second);
        if (a.second != 0)
            st.first.insert(a);
    }
    if (se - s[v])
        st.first.insert({-st.second,se - s[v]});
    return st;
}
int main() {
    int n;
    cin >> n;
    s.assign(n, {});
    e.assign(n, {});
    g.assign(n, {});
    for (auto &i : s)
        cin >> i;
    for (auto &i : e)
        cin >> i;
    for (int i = 1; i < n; ++i) {
        int a, b;
        cin >> a >> b;a--;
        g[i].push_back({a, b});
        g[a].push_back({i, b});
    }
    dfs(0, -1);
    cout << ans;
}
