#include <bits/stdc++.h>

#define pb push_back

using namespace std;

typedef long long ll;
#define int ll
typedef pair<int, int> pii;

const int SIZE = 2e5 + 5;
const int INF = 1e9;

int n, s[SIZE], e[SIZE], p[SIZE], w[SIZE];

pair<int, pii> get_for(int i) {
    int mx = 0, mxsum = 0, x = i, sum = 0;
    while(1) {
        if(p[x] == x) break;
        sum += w[x];
        x = p[x];
        if(s[x]) {
            if(sum > mxsum) {
                mx = x;
                mxsum = sum;
            }
        }
    }
    return {mxsum, {i, mx}};
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> e[i];
    }

    for(int i = 1; i < n; i++) {
        cin >> p[i] >> w[i];
        p[i]--;
    }

    priority_queue<pair<int, pii>> pq;

    for(int i = 0; i < n; i++) {
        int x = i, sum = 0;
        while(1) {
            sum += w[x];
            x = p[x];
            pq.push({sum, {i, x}});
            if(x == p[x]) break;
        }
    }

    int ans = 0;

    while(!pq.empty() && pq.top().first > 0) {
        auto cost = pq.top().first, mine = pq.top().second.first, miner = pq.top().second.second;
        auto t = pq.top();
        pq.pop();
        if(e[mine] == 0 || s[miner] == 0) {
            continue;
        }

        ans += cost;
        e[mine]--;
        s[miner]--;

        pq.push(t);
    }

    cout << ans;

    return 0;
}
