#include <bits/stdc++.h>
using namespace std;

#define add push_back
#define len(a) ((int)a.size())
#define endl '\n'

const int N = 2e5 + 5;

long long n, q;
long long h[N];
bool k[N];
vector<int> g[N];

void dfs(int v){
	for(int i = 0; i < len(g[v]); i++){
		int to = g[v][i];
		if(h[to] != 0) continue;
		h[to] = h[v] + 1;
		dfs(to);
	}
}

int query(int id, int v, int H){
	if(id == 1) k[v] = true;
	int ret = k[v];
	for(int i = 0; i < len(g[v]); i++){
		int to = g[v][i];
		if(h[to] < h[v] || h[to] > H) continue;
		ret += query(id, to, H);
	}
	return ret;
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for(int i = 1; i < n; i++){
		int u, v;
		cin >> u >> v;
		g[u].add(v);
		g[v].add(u);
	}
	h[1] = 1;
	dfs(1);
	for(int i = 1; i <= n; i++){
		cin >> k[i];
	}
	cin >> q;
	int id, X, K;
	for(int i = 0; i < q; i++){
		cin >> id >> X >> K;
		if(id == 1){
			query(1, X, h[X] + K);
		}
		else {
			cout << query(2, X, h[X] + K) << '\n';
		}
	}
	return 0;
}
