#include <bits/stdc++.h>
using namespace std;

#define add push_back
#define len(a) ((int)a.size())
#define pii pair<int, int>
#define fr first
#define sc second
#define endl '\n'

const int N = 2e5 + 5;

long long n, q;
long long tin[N], tout[N], h[N], cnt[N], clrd[N];
long long TIMER = 0;
bool k[N];
vector<int> g[N];
vector<int> vh[N];
vector<pii> pref[N];

void dfs(int v){
	tin[v] = ++TIMER;
	cnt[v] = 1;
	clrd[v] = k[v];
	for(int i = 0; i < len(g[v]); i++){
		int to = g[v][i];
		if(h[to] != 0) continue;
		h[to] = h[v] + 1;
		dfs(to);
		cnt[v] += cnt[to];
		clrd[v] += clrd[to];
	}
	if(vh[h[v]].empty()) vh[h[v]].add(0);
	vh[h[v]].add(tin[v]);
	
	if(pref[h[v]].empty()) pref[h[v]].add({0, 0});
	pref[h[v]].add({pref[h[v]].back().fr + cnt[v], pref[h[v]].back().sc + clrd[v]});
	
	tout[v] = TIMER;
}

int query(int v, int K){
	int H = h[v] + K + 1;
	int ret = clrd[v];
	//cout << "----" << endl << H << endl;
	if(vh[H].empty()) return ret;
	int sl = lower_bound(vh[H].begin(), vh[H].end(), tin[v]) -  vh[H].begin();
	int sr = lower_bound(vh[H].begin(), vh[H].end(), tout[v]) - vh[H].begin();
	sl--;
	if(vh[H][sr] != tout[v]) sr--;
	//cout << sl << " " << sr << endl;
	//cout << ret << " " << pref[H][sr].sc - pref[H][sl].sc << endl;
	return ret - pref[H][sr].sc + pref[H][sl].sc; 
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for(int i = 1; i < n; i++){
		int u, v;
		cin >> u >> v;
		g[u].add(v);
		g[v].add(u);
	}
	for(int i = 1; i <= n; i++){
		cin >> k[i];
	}
	h[1] = 1;
	dfs(1);	
	cin >> q;
	int id, X, K;
	for(int i = 0; i < q; i++){
		cin >> id >> X >> K;
		cout << query(X, K) << endl;
	}
	return 0;
}
