#include <bits/stdc++.h>
using namespace std;

#define add push_back
#define len(a) ((int)a.size())
#define pii pair<int, int>
#define fr first
#define sc second
#define endl '\n'

const int N = 2e5 + 5;

long long n, q;
long long  h[N], r[N], last, ind[N];
bool k[N];
vector<int> ts;
vector<int> g[N];

int t[4 * N];
bool d[4 * N];

void build(int v, int l, int r){
	if(l == r){
		t[v] = k[ts[l]];
		return;
	}
	int mid = (l + r) / 2;
	build(2 * v, l, mid);
	build(2 * v + 1, mid + 1, r);
	t[v] = t[2 * v] + t[2 * v + 1];
}

void push(int v, int l, int r){
	if(!d[v]) return;
	if(l == r){
		t[v] = 1;
		return;
	}
	t[v] = r - l + 1;
	d[2 * v] = true;
	d[2 * v + 1] = true;
}

void update(int v, int l, int r, int tl, int tr){
	if(l == tl && r == tr){
		d[v] = true;
		push(v, l, r);
		return;
	}
	if(t[v] == (r - l + 1) || d[v]) { push(v, l, r); return; }
	int mid = (l + r) / 2;
	if(tr <= mid) update(2 * v, l, mid, tl, tr);
	else if(tl >= mid + 1) update(2 * v + 1, mid + 1, r, tl, tr);
	else {
		update(2 * v, l, mid, tl, mid);
		update(2 * v + 1, mid + 1, r, mid + 1, tr);
	}
	t[v] = t[2 * v] + t[2 * v + 1];
}

int get(int v, int l, int r, int tl, int tr){
	if(tl == l && tr == r){
		push(v, l, r);
		return t[v];
	}
	if(t[v] == (r - l + 1) || d[v]) { push(v, l, r); return tr - tl + 1; }
	int mid = (l + r) / 2;
	if(tr <= mid) return get(2 * v, l, mid, tl, tr);
	if(tl >= mid + 1) return get(2 * v + 1, mid + 1, r, tl, tr);
	return get(2 * v, l, mid, tl, mid) + get(2 * v + 1, mid + 1, r, mid + 1, tr);
}

void dfs(int v){
	last = v;
	ind[v] = len(ts);
	ts.add(v);
	for(int i = 0; i < len(g[v]); i++){
		int to = g[v][i];
		if(h[to] != 0) continue;
		h[to] = h[v] + 1;
		dfs(to);
	}
	r[v] = last;
	//cout << v << " " << r[v] << " " << ind[v] << endl;	
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for(int i = 1; i < n; i++){
		int u, v;
		cin >> u >> v;
		g[u].add(v);
		g[v].add(u);
	}
	for(int i = 1; i <= n; i++){
		cin >> k[i];
	}
	
	ts.add(0);
	h[1] = 1;
	dfs(1);	

	build(1, 1, n);
	
	cin >> q;
	int id, X, K;
	for(int i = 0; i < q; i++){
		cin >> id >> X >> K;
		if(id == 1){
			update(1, 1, n, ind[X], ind[r[X]]);
		}
		else {
			cout << get(1, 1, n, ind[X], ind[r[X]]) << endl;
		}
	}
	return 0;
}
