#include <bits/stdc++.h>
using namespace std;

const int maxn = 5e5+5;
int n;
int s [maxn], e [maxn];
vector <pair <int, int> > adj [maxn];
pair <int, int> par [maxn];
long long ans;

void dfs (int a){

    for (auto p : adj [a]){
        dfs (p.second);
    }
    sort (adj [a].begin (), adj [a].end ());
    reverse (adj [a].begin (), adj [a].end ());
    for (auto p : adj [a]){
        if (p.first > 0){
            int x = min (e [p.second], s [a]);
            ans += x * p.first;
            s [a] -= x;
            e [p.second] -= x;
            e [a] += x;
        }
        if (a != 1 && e [p.second] > 0) adj [par [a].second].push_back ({par [a].first + p.first, p.second});
    }

}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;

    for (int i = 1; i <= n; i ++) cin >> s [i];
    for (int i = 1; i <= n; i ++) cin >> e [i];
    for (int i = 2; i <= n; i ++){
        int p, w;
        cin >> p >> w;
        adj [p].push_back ({w, i});
        par [i] = {w, p};
    }

    dfs (1);
    cout << ans << '\n';

}