#include <bits/stdc++.h>
using namespace std;

const int maxn = 2e5 + 5;
int n, q;
vector <int> adj [maxn];
bool knows [maxn];

int dfs (int a, int k, bool tell){

    int cnt = knows [a];
    if (tell) knows [a] = 1;
    if (k == 0) return cnt;
    for (int i : adj [a]){
        cnt += dfs (i, k - 1, tell);
    }
    return cnt;

}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;
    for (int i = 1; i < n; i ++){
        int x, y;
        cin >> x >> y;
        adj [x].push_back (y);
    }
    for (int i = 1; i <= n; i ++) cin >> knows [i];
    cin >> q;
    for (int i = 0; i < q; i ++){
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 1) dfs (x, k, 1);
        else cout << dfs (x, k, 0) << '\n';
    }

}