#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 200, MAX_K = 1e7 + 10;
int win[MAX_N][MAX_N];
int k, q, n;

int calc(int a, int b) {
    if(b > MAX_N) {
        return mod;
    }
    if(win[a][b] != -1) {
        return win[a][b];
    }
    win[a][b] = 0;
    set<int> st;
    for(int i = 0; i <= a; i += max(1, a)) {
    //for(int i = 0; i <= a; i += 1) {
        for(int j = 0; j <= b; j ++) {
            if(i + j == 0) {continue;}
            for(int add = k * i; add < MAX_N; add ++) {
                st.insert(calc(a - i, b - j + add));
            }
        }
    }
    while(st.find(win[a][b]) != st.end()) {
        win[a][b] ++;
    }
    return win[a][b];
}

void solve() {
    int n;
    cin >> n;
    int cnt = 0, xr = 0;
    for(int i = 0; i < n; i ++) {
        int b, s;
        cin >> b >> s;
        cnt ^= b;
        xr ^= s;
        if(b != 0) {
            assert(s == 0);
        }
    }
    if(cnt != 0) {
        cout << "Win" << endl;
    } else {
        if(xr != 0) {
            cout << "Win" << endl;
        } else {
            cout << "Loss" << endl;
        }
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> k;
    int q;
    cin >> q;
    while(q --) {
        solve();
    }

    return 0;
}
