#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const ll MAX_N = 5e5 + 10;;
const ll MAX_K = 2e3 + 10;
ll sz[MAX_N];
ll s[MAX_N], e[MAX_N];
ll d[MAX_N];
ll n;
vector<pair<ll, ll> > g[MAX_N];

void dfs2(ll x, ll p, ll w) {
    d[x] = d[p] + w;
    for(auto it : g[x]) {
        if(it.first == p) {continue;}
        dfs2(it.first, x, it.second);
    }
}

void solveBad() {
    priority_queue<ll> pq;
    ll ans = 0;
    for(ll i = 1; i <= n; i ++) {
        for(int j = 0; j < e[i] + s[i]; j ++) {
            pq.push(-d[i]);
        }
        for(int j = 0; j < e[i]; j ++) {
            ans += d[i] + pq.top();
            pq.pop();
        }
    }
    cout << ans << endl;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> n;
    for(ll i = 1; i <= n; i ++) {
        cin >> s[i];
    }
    for(ll i = 1; i <= n; i ++) {
        cin >> e[i];
    }
    for(ll i = 2; i <= n; i ++) {
        ll p, w;
        cin >> p >> w;
        g[p].push_back({i, w});
    }
    dfs2(1, 0, 0);
    solveBad();
    return 0;
}