#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#define endl "\n"
#endif
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 1 << 18;

pair<int, bool> val[MAX_N];
vector<int> tree[2 * MAX_N];

void build(int curr, int l, int r) {
    tree[curr].resize(0);
    if(l == r) {
        if(val[l].second) {
            tree[curr].push_back(val[l].first);
        }
        return;
    }
    int m = (l + r) / 2ll;
    build(curr * 2, l, m);
    build(curr * 2 + 1, m + 1, r);
    merge(tree[curr * 2].begin(), tree[curr * 2].end(), tree[curr * 2 + 1].begin(), tree[curr * 2 + 1].end(), back_inserter(tree[curr]));
}

int sum(int curr, int l, int r, int ql, int qr, int dl, int dr) {
    if(ql <= l && r <= qr) {
        auto start = lower_bound(tree[curr].begin(), tree[curr].end(), dl) - tree[curr].begin();
        auto end = lower_bound(tree[curr].begin(), tree[curr].end(), dr + 1) - tree[curr].begin();
        return end - start;
    } else if(ql > r || qr < l) {return 0;}
    int m = (l + r) / 2ll;
    return sum(curr * 2, l, m, ql, qr, dl, dr) + sum(curr * 2 + 1, m + 1, r, ql, qr, dl, dr);
}

vector<int> g[MAX_N];
int in[MAX_N], out[MAX_N], d[MAX_N], tme = -1;
int n, q;

void dfs(int x, int p) {
    in[x] = ++ tme;
    for(auto it : g[x]) {
        if(it == p) {continue;}
        d[it] = d[x] + 1;
        dfs(it, x);
    }
    out[x] = tme;
}

const int SQRT = 1000;

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> n;
    for(int i = 0; i < n - 1; i ++) {
        int a, b;
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    dfs(1, 0);
    for(int i = 1; i <= n; i ++) {
        bool on;
        cin >> on;
        val[in[i]] = {d[i], on};
    }

    int q;
    cin >> q;
    int WHEN = 0;
    while(q --) {
        if(WHEN % SQRT == 0) {
            build(1, 0, n - 1);
        }
        WHEN ++;

        int t;
        cin >> t;
        if(t == 2) {
            int x, k;
            cin >> x >> k;
            cout << sum(1, 0, n - 1, in[x], out[x], d[x], d[x] + k) << endl;
        }
    }

    return 0;
}
