#include<iostream>
#include<bits/stdc++.h>
#define endl "\n"
using namespace std;

int const MAXN=100000;
int n, q, lev[MAXN], kn[MAXN], used[MAXN], k, cnt;
vector<int> v[MAXN];

void BFS(int i)
{
    lev[i]=1;
    queue<int> q;
    q.push(i);
    while(!q.empty())
    {
        int w=q.front();
        q.pop();
        for(int j=0;j<v[w].size();j++)
        {
            if(!lev[v[w][j]])
            {
                lev[v[w][j]]=lev[w]+1;
                q.push(v[w][j]);
            }
        }
    }
}

int BFS_type2(int i)
{
    memset(used,0,sizeof(used));
    used[i]=1;
    queue<int> q;
    q.push(i);
    cnt+=kn[i];
    while(!q.empty())
    {
        int w=q.front();
        q.pop();
        if(used[w]<=k)
        {
            for(int j=0;j<v[w].size();j++)
            {
                if(!used[v[w][j]])
                {
                    cnt+=kn[v[w][j]];
                    used[v[w][j]]=used[w]+1;
                    q.push(v[w][j]);
                }
            }
        }
    }
    return cnt;
}

void BFS_type1(int i)
{
    memset(used,0,sizeof(used));
    used[i]=1;
    queue<int> q;
    q.push(i);
    kn[i]=1;
    while(!q.empty())
    {
        int w=q.front();
        q.pop();
        if(used[w]<=k)
        {
            for(int j=0;j<v[w].size();j++)
            {
                if(!used[v[w][j]])
                {
                    kn[v[w][j]]=1;
                    used[v[w][j]]=used[w]+1;
                    q.push(v[w][j]);
                }
            }
        }
    }
}

/*void DFS(int i, int r)
{
    used[i]=1;
    kn[v[i][j]]=1;
    int sz=v[i].size();
    for(int j=0;j<sz;j++)
    {
        if(!used[v[i][j]])
        {
            used[v[i][j]]=1;
            kn[v[i][j]]=1;
            DFS(v[i][j]);
        }
    }
}*/

void read()
{
    int x, y, type;
    cin>>n;
    for(int i=1;i<n;i++)
    {
        cin>>x>>y;
        v[x].push_back(y);
    }
    for(int i=1;i<=n;i++)
    {
        cin>>kn[i];
    }
    BFS(1);
    cin>>q;
    for(int i=1;i<=q;i++)
    {
        cin>>type>>x>>k;
        cnt=0;
        if(type==1)
        {
            BFS_type1(x);
        }
        else
        {
            cout<<BFS_type2(x)<<endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
	return 0;
}
