#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 2003
#define MAXV 2003
using namespace std;
int n;
int e[MAXN];
int s[MAXN];
int miners[MAXN];
int dist[MAXN][MAXN];
int cnt = 0;

struct edge
{
    int ver, w;
    edge (int _ver, int _w)
    {
        ver = _ver;
        w = _w;
    }
};

vector <edge> adj[MAXN];

struct path
{
    int from, to, w;
    path (int _from, int _to, int _w)
    {
        from = _from;
        to = _to;
        w = _w;
    }

    bool operator <(const path &p) const
    {
        return w > p.w;
    }
};

vector <path> paths;

void input()
{
    cin >> n;
    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
    }
    for (int i = 1; i <= n; ++i)
    {
        cin >> e[i];
    }

    for (int i = 1; i <= n; ++i)
        for (int j = 1; j <= n; ++j)
            dist[i][j] = -MAXV * n;

    for (int i = 1; i <= n; ++i)
    {
        //dist[i][i] = -MAXV * n;
        miners[i] = 0;
    }

    for (int i = 1; i < n; ++i)
    {
        int p, w;
        cin >> p >> w;
        dist[p][i + 1] = w;
        adj[p].push_back(edge(i + 1, w));
    }
}

void dfs(int tmp, int cost, int start, int par = -1)
{
    paths.push_back(path(start, tmp, cost));
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        edge nb = adj[tmp][i];
        if (nb.ver != par)
            dfs(nb.ver, cost + nb.w, start, tmp);
    }
}

void init()
{
    for (int i = 1; i <= n; ++i)
    {
        dfs(i, 0, i);
    }

//    for (int i = 1; i <= n; ++i)
//        for (int k = 1; k <= n; ++k)
//            for (int j = 1; j <= n; ++j)
//                //if (dist[i][k] > -MAXV * n && dist[k][j] > -MAXV * n)
//                    dist[i][j] = max(dist[i][j], dist[i][k] + dist[k][j]);
//
//    for (int i = 1; i <= n; ++i)
//        for (int j = 1; j <= n; ++j)
//        {
//            if (dist[i][j] > -MAXV * n && i != j)
//                paths.push_back(path(i, j, dist[i][j]));
//        }
}

void solve()
{
    init();
    sort (paths.begin(), paths.end());
    int sz = paths.size();

    /*
    for (int i = 0; i < sz; ++i)
    {
        cout << paths[i].from << " -> " << paths[i].to << ": " << paths[i].w << endl;
    }
    */

    for (int i = 0; i < sz; ++i)
    {
        path tmp = paths[i];
        if (tmp.w < 0)
            break;

        /*
        cout << endl;
        cout << tmp.from << " -> " << tmp.to << ": " << tmp.w << endl;
        cout << miners[tmp.to] << " / " << e[tmp.to] << endl;
        cout << s[tmp.from] << endl;
        */

        if (miners[tmp.to] >= e[tmp.to])
            continue;
        if (s[tmp.from] <= 0)
            continue;

        int min1 = min(s[tmp.from], e[tmp.to] - miners[tmp.to]);
        //cout << "min: " << min1 << endl;
        cnt += min1 * tmp.w;

        s[tmp.from] -= min1;
        miners[tmp.to] += min1;
    }

    cout << cnt << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();


    return 0;
}

/**

5
5 1 0 0 0
100 1 1 2 4
1 6
1 1
2 2
2 -1

*/
