#include<iostream>
#include<vector>
using namespace std;

const int MAXN=2e5;

vector<int> graph[MAXN];
int b[MAXN];

void Update(int idx, int k)
{
    b[idx]=1;

    if(k==0)
    {
        return;
    }

    for(int node:graph[idx])
    {
        Update(node, k-1);
    }

    return;
}

int GetCount(int idx, int k)
{
    int res=b[idx];

    if(k==0)
    {
        return res;
    }

    for(int node:graph[idx])
    {
        res+=GetCount(node, k-1);
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n; i++)
    {
        dgr[i]=0;
    }

    for(int i=0; i<n-1; i++)
    {
        int x, y;
        cin >> x >> y;
        x--, y--;
    }

    for(int i=0; i<n; i++)
    {
        cin >> b[i];
    }

    int q;
    cin >> q;

    while(q--)
    {
        int t, x, k;
        cin >> t >> x >> k;
        x--;

        if(t==1)
        {
            Update(x, k);
        }
        else
        {
            cout << GetCount(x, k) << "\n";
        }
    }

    return 0;
}
