#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define ll long long
#define fr first
#define sc second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template<class T> using matrix = vector<vector<T>>;
template<class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int n, q;
matrix<int> G;
vector<int> know;

int dfs(int u, int d, int D, int up = 0){
	if(d > D) return 0;
	if(up) know[u] = 1;
	int ans = know[u];
	for(auto v : G[u]){
		ans += dfs(v, d + 1, D, up);
	}
	return ans;
}

int main(){
	cin >> n;
	G = matrix<int>(n + 1);
	know = vector<int>(n + 1);
	for(int i = 0; i < n - 1; i ++){
		int u, v; cin >> u >> v;
		G[u].pb(v);
	}
	for(int i = 1; i <= n; i ++) cin >> know[i];
	cin >> q;
	for(int i = 0; i < q; i ++){
		int t, k, x; cin >> t >> x >> k;
		if(t == 1) dfs(x, 0, k, 1);
		if(t == 2) cout << dfs(x, 0, k) << endl;
	}
}
/**
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

1
3
0
6
3
4
6
*/