#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define ll long long
#define fr first
#define sc second
#define pb push_back
#define de(x) cout << #x << " = " << x << endl;

using namespace std;
using namespace __gnu_pbds;

template<class T> using matrix = vector<vector<T>>;
template<class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MAXN = 2e5 + 5;

int n, q, T = 0, last;
matrix<int> G;
matrix<pair<int, int>> lvl;
vector<int> tin, tout, ans, dep, know;

void dfs(int u = 1, int d = 0){
	tin[u] = ++ T;
	lvl[d].pb({u, 0});
	dep[u] = d;
	ans[u] = know[u];
	for(auto v : G[u]){
		dfs(v, d + 1);
		ans[u] += ans[v];
	}
	tout[u] = T;
}

void init(){
	know = dep = tin = tout = ans = vector<int>(n + 1);
	lvl = matrix<pair<int, int>>(n + 1);
	G = matrix<int>(n + 1);
}

int main(){
	cin >> n;
	init();
	for(int i = 0; i < n - 1; i ++){
		int u, v; cin >> u >> v;
		G[u].pb(v);
	}
	for(int i = 1; i <= n; i ++) cin >> know[i];
	dfs();
	for(int i = 0; i < n; i ++){
		if(lvl[i].empty()){
			last = i - 1;
			break;
		}
		for(int j = 0; j < lvl[i].size(); j ++){
			lvl[i][j].sc = (j ? lvl[i][j - 1].sc : 0) + ans[lvl[i][j].fr];
		}
	}
	cin >> q;
	for(int i = 0; i < q; i ++){
		int t, x, k; cin >> t >> x >> k;
		k += dep[x] + 1;
		if(lvl[k].empty() || k > last){
			cout << ans[x] << endl;
		}
		else{
			int l = 0, r = lvl[k].size() - 1, lb = 0, rb = 0;
			while(l <= r){
				int m = (l + r) / 2;
				if(tin[x] <= tin[lvl[k][m].fr]){
					r = m - 1;				
					lb = m;
				}
				else{
					l = m + 1;
				}
			}
			l = lb; r = lvl[k].size() - 1;
			while(l <= r){
				int m = (l + r) / 2;
				if(tout[lvl[k][m].fr] <= tout[x]){
					l = m + 1;
					rb = m;
				}
				else{
					r = m - 1;
				}
			}
			cout << ans[x] - (lvl[k][rb].sc - (lb ? lvl[k][lb - 1].sc : 0))<< endl;
		}
	}
}
/**
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

1
3
0
6
3
4
6


7
1 2
1 3
2 4
2 5
3 6
3 7
0 0 1 0 1 0 0

4
2 3 1
2 3 0
2 1 1
2 1 2

10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
7
2 1 1
2 4 4
2 3 0
2 3 4
2 1 1
2 4 4
2 3 2

1
3
0
4
1
3
3
*/