#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int x, k;
int ans = 0;
int b[MAXN + 5];
int d[MAXN + 5];
vector<int> G[MAXN + 5];

void DFS0(int u)
{
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        d[v] = d[u] + 1;
        DFS0(v);
    }
}

void solve(int t, int u)
{
    if (d[u] - d[x] > k) return;

    if (t == 1) b[u] = 1;
    else if (b[u]) ans++;
    for (int i = 0; i < G[u].size(); ++ i)
    {
        int v = G[u][i];
        solve(t, v);
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        G[x].push_back(y);
    }

    d[1] = 0;
    DFS0(1);

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    int q;
    cin >> q;

    for (int i = 1; i <= q; ++ i)
    {
        int t;
        cin >> t >> x >> k;

        ans = 0;
        solve(t, x);

        if (t == 2) cout << ans << endl;
    }

    return 0;
}
