#include <iostream>
#include <vector>

#define endl '\n'

using namespace std;

struct Mine {
    int counter, limit;

    Mine() : counter(0), limit(0) {}
    Mine(int _counter, int _limit) : counter(_counter), limit(_limit) {}
};

const int MAXN = 5e5 + 3;
Mine mines[MAXN];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int i = 0; i < n; ++i) {
        cin >> mines[i].counter;
    }
    for (int i = 0; i < n; ++i) {
        cin >> mines[i].limit;
    }

    vector<int> grades(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        int from;
        cin >> from >> grades[i];
    }

    grades.push_back(-1);
    
    int res = 0;
    int curr_sum = 0, first_num = -1, last_num = 0;

    for (int i = 0; i < n; ++i) {
        if (grades[i] > 0) {
            if (first_num == -1) {
                first_num = grades[i];
            } else {
                last_num = grades[i];
            }

            curr_sum += 2 * grades[i];
            continue;
        }

        if (first_num == -1) {
            continue;
        }

        res += curr_sum - first_num;
        if (last_num != -1) {
            res -= last_num;
        }
        
        curr_sum = 0;
        first_num = last_num = -1;
    }

    cout << res << endl;
return 0;
}