#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
struct path
{
    int from;
    int to;
    int weight;
};
vector<path> paths;
int nodes;
vector<int> s, e;
bool cmp(path p1, path p2)
{
    int first = p1.weight * s[p1.from];
    int second = p2.weight * s[p2.from];
    return first > second;
}
void Input(){
    cin>>nodes;
    int temp, temp1;
    for(int i = 0; i < nodes; ++i)
    {
        cin>>temp;
        s.push_back(temp);
    }
    for(int i = 0; i < nodes; ++i)
    {
        cin>>temp;
        e.push_back(temp);
    }
    for(int i = 1; i < nodes; ++i)
    {
        cin>>temp>>temp1;
        path curr;
        curr.from = temp - 1;
        curr.to = i;
        curr.weight = temp1;
        paths.push_back(curr);
    }
}
void FillPaths(){
    for(int i = nodes - 1; i > 0; --i)
    {
        int par, parWeight;
        for(int j = 0; j < paths.size(); ++j)
        {
            if(paths[j].to == i)
            {
                par = paths[j].from;
                parWeight = paths[j].weight;
            }
            else if(paths[j].from == i)
            {
                path temp;
                temp.from = par;
                temp.to = paths[j].to;
                temp.weight = parWeight + paths[j].weight;
                paths.push_back(temp);
            }
        }
    }
    sort(paths.begin(),paths.end(), cmp);
}
void PrintPaths(){
    for(int i = 0; i < paths.size(); ++i)
    {
        path curr = paths[i];
        cout<<curr.from<<" "<<curr.to<<" "<<curr.weight<<endl;
    }
}

int main()
{
    int result = 0;
    Input();
    FillPaths();
    //PrintPaths();

    for(int i = 0; i < paths.size(); ++i)
    {
        if(paths[i].weight < 0) break;
        path curr = paths[i];
        if(s[curr.from]){
            //cout<<curr.from<<" "<<curr.to<<" "<<curr.weight<<" "<<s[curr.from]<<" "<<e[curr.to]<<endl;
            int possible = min(e[curr.to], s[curr.from]);
            result += curr.weight * possible;
            s[curr.from] -= possible;
            e[curr.to] -= possible;
        }
    }
    cout<<result<<endl;
    return 0;
}
