#include <iostream>
#include <set>
#include <iterator>
#include <map>
#include <vector>
#include <algorithm>
#include <cstdio>
using namespace std;

int N,People[100010],Maxes[100010],Points[100010],Parent[100010];
vector<int> gr[100010];
map<int,pair<int,int> >BestPaths;
bool used[100010];

void DFS(int start,int node,int sum)
{
	if(used[node])return;
	used[node]=true;
	if(start!=node)BestPaths[sum]={start,node};
	for(int i=0;i<gr[node].size();i++)
		DFS(start,gr[node][i],sum+Points[gr[node][i]]);
}

int CalcAllPaths()
{
	int total=0;
	for(int i=1;i<=N;i++)
	{
		fill(used,used+100010,false);
		DFS(i,i,0);
	}
	for(map<int,pair<int,int> >::reverse_iterator it=BestPaths.rbegin();it!=BestPaths.rend();it++)
	{
		int p = (*it).first;
		int p1 = (*it).second.first;
		int p2 = (*it).second.second;
		int M=min(People[p1],Maxes[p2]);
		if(p<0)return total;
		People[p1]-=M;
		Maxes[p2]-=M;
		total+=M*p;		
		cout<<p<<" "<<p1<<" "<<p2<<endl;
	}
	return total;
}

int init()
{
	int p1,p2;
	scanf("%d",&N);
	for(int i=1;i<=N;i++)
		scanf("%d",&People[i]);
	for(int i=1;i<=N;i++)
		scanf("%d",&Maxes[i]);
	for(int i=1;i<N;i++)
	{
		scanf("%d%d",&p1,&p2);
//		Parent[i+1]=p1;
//		Points[i+1]=p2;
		gr[p1].push_back(i+1);
	}
}


int main()
{
	init();
	cout<<CalcAllPaths()<<endl;
}