#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;
vector<int> gr[100010];
int N,Q;
bool colored[100010];

void Color(int pos,int depth)
{
	queue<pair<int,int> > BFS;
	BFS.push({pos,0});
	while(!BFS.empty())
	{
		pair<int,int> curr=BFS.front();
		BFS.pop();
		colored[curr.first]=true;
		if(curr.second<depth)
		for(int i=0;i<gr[curr.first].size();i++)
			BFS.push({gr[curr.first][i],curr.second+1});
	}
}

int Count(int pos,int depth)
{
	int total=0;
	queue<pair<int,int> > BFS;
	BFS.push({pos,0});
	while(!BFS.empty())
	{
		pair<int,int> curr=BFS.front();
		BFS.pop();
		if(colored[curr.first])total++;
		if(curr.second<depth)
		for(int i=0;i<gr[curr.first].size();i++)
			BFS.push({gr[curr.first][i],curr.second+1});
	}	
	return total;
}

void solve()
{
	int a,b,c;
	for(int i=0;i<Q;i++)
	{
		scanf("%d%d%d",&a,&b,&c);
		if(a==1)Color(b,c);
		else cout<<Count(b,c)<<endl;
	}
}

void init()
{
	int a,b;
	scanf("%d",&N);
	for(int i=1;i<N;i++)
	{
		scanf("%d%d",&a,&b);
		gr[a].push_back(b);
	}
	cout<<"OK"<<endl;
	for(int i=1;i<=N;i++)
		scanf("%d",&colored[i]);
	scanf("%d",&Q);
	cout<<"OK"<<endl;
	
}

int main()
{
	init();
	solve();
}