#include<bits/stdc++.h>
using namespace std;
const int maxn = 200005;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int n,q;
vector<int>v[maxn];
map<int,int>m;
int tree[maxn*4];
int br_list[maxn*4];
int news[maxn];
int news2[maxn];
int sz_tree[maxn];
int ans_cnt = 0;
int last_idx = 1;
int lazy[maxn*4];
void get_ans(int w, int k)
{
    if( k == 0 )
    {
        ans_cnt += news[w];
        return;
    }
    int sz = v[w].size();
    ans_cnt += news[w];
    for(int i=0;i<sz;i++)
    {
        int nb = v[w][i];
        get_ans(nb,k-1);
    }
    return;
}
void update(int w, int k )
{
    if( k == 0 )
    {
        news[w] = 1;
        return;
    }
    int sz = v[w].size();
    news[w] = 1;
    for(int i=0;i<sz;i++)
    {
        int nb = v[w][i];
        update(nb,k-1);
    }
    return;
}
void print1()
{
    cin >> q;
    for(int i=1; i<=q; i++)
    {
        int t,x,k;
        cin >> t >> x >> k;
        if( t == 1 )
        {
            update(x,k);
        }
        else if( t == 2 )
        {
            ans_cnt = 0;
            get_ans(x,k);
            cout << ans_cnt << endl;
        }
    }
}
void get_new_idx(int w)
{
    m[w] = last_idx;
    last_idx += 1;
    int sz = v[w].size();
    int t_sz = 1;
    for(int i=0;i<sz;i++)
    {
        int nb = v[w][i];
        get_new_idx(nb);
        t_sz += sz_tree[m[nb]];
    }
    sz_tree[m[w]] = t_sz;
    return;
}
void make_tree(int i, int l, int r)
{
    if( l == r )
    {
        br_list[i] = 1;
        tree[i] = news2[l];
        return;
    }
    int m = (l+r)/2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    tree[i] = tree[i*2] + tree[i*2+1];
    br_list[i] = br_list[i*2] + br_list[i*2+1];
    return;
}
void push_lazy(int i)
{
    if( lazy[i] == 1 )
    {
        int t_cnt = br_list[i] - tree[i];
        tree[i] += t_cnt;
        lazy[i*2] = 1;
        lazy[i*2+1] = 1;
    }
    lazy[i] = 0;
    return;
}
void update(int i, int l, int r, int ql, int qr)
{
    push_lazy(i);
    if( ql == l && r == qr )
    {
        lazy[i] = 1;
        push_lazy(i);
        return;
    }
    int m = (l+r)/2;
    if( qr <= m ) update(i*2,l,m,ql,qr);
    if( ql > m ) update(i*2+1,m+1,r,ql,qr);
    else
    {
        update(i*2,l,m,ql,m);
        update(i*2+1,m+1,r,m+1,qr);
    }
    push_lazy(i*2);
    push_lazy(i*2+1);
    tree[i] = tree[i*2] + tree[i*2+1];
    return;
}
int query(int i, int l, int r, int ql, int qr)
{
    if( ql == l && qr == r )
    {
        return tree[i];
    }
    int m = (l+r)/2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    return query(i*2,l,m,ql,m) + query(i*2+1,m+1,r,m+1,qr);
}
void print2()
{
    get_new_idx(1);
    for(int i=1;i<=n;i++)
    {
        int nb = m[i];
        news2[nb] = news[i];
    }
    cin >> q;
    for(int i=1;i<=q;i++)
    {
        int t,x,k;
        cin >> t >> x >> k;
        if( t == 1 )
        {
            int from = m[x];
            int to = from + sz_tree[from] - 1;
            update(1,1,n,from,to);
        }
        else
        {
            int from = m[x];
            int to = from + sz_tree[from] - 1;
            cout << query(1,1,n,from,to) << endl;;
        }
    }
}
void read()
{
    cin >> n;
    for(int i=1; i<n; i++)
    {
        int x,y;
        cin >> x>> y;
        v[x] .push_back(y);
    }
    for(int i=1; i<=n; i++)
    {
        cin >> news[i];
    }
    if( n <= 10000 ) print1();
    else print2();

}
int main()
{
    read();
    return 0;
}
