#include<bits/stdc++.h>
const long long maxn = 400005;
using namespace std;
struct t_query
{
    int t1;
    int x1;
    int k1;
    t_query(){};
    t_query(int t2, int x2 , int k2)
    {
        t1 = t2;
        x1 = x2;
        k1 = k2;
    }
};
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
long long n,q;
vector<int>v[maxn];
vector<t_query>qq;
map<int,int>m;
long long tree[maxn*4];
long long br_list[maxn*4];
long long news[maxn];
long long news2[maxn];
long long sz_tree[maxn];
long long ans_cnt = 0;
long long last_idx = 1;
long long lazy[maxn*4];
void get_ans(long long w, long long k)
{
    if( k == 0 )
    {
        ans_cnt += news[w];
        return;
    }
    long long sz = v[w].size();
    ans_cnt += news[w];
    for(long long i=0;i<sz;i++)
    {
        long long nb = v[w][i];
        get_ans(nb,k-1);
    }
    return;
}
void update(long long w, long long k )
{
    if( k == 0 )
    {
        news[w] = 1;
        return;
    }
    long long sz = v[w].size();
    news[w] = 1;
    for(long long i=0;i<sz;i++)
    {
        long long nb = v[w][i];
        update(nb,k-1);
    }
    return;
}
void print1()
{
    for(long long i=0; i<q; i++)
    {
        long long t,x,k;
        //cin >> t >> x >> k;
        t = qq[i].t1;
        x = qq[i].x1;
        k = qq[i].k1;
        if( t == 1 )
        {
            update(x,k);
        }
        else if( t == 2 )
        {
            ans_cnt = 0;
            get_ans(x,k);
            cout << ans_cnt << endl;
        }
    }
}
void get_new_idx(long long w)
{
    m[w] = last_idx;
    last_idx += 1;
    long long sz = v[w].size();
    long long t_sz = 1;
    for(long long i=0;i<sz;i++)
    {
        long long nb = v[w][i];
        get_new_idx(nb);
        t_sz += sz_tree[m[nb]];
    }
    sz_tree[m[w]] = t_sz;
    return;
}
void make_tree(long long i, long long l, long long r)
{
    if( l == r )
    {
        br_list[i] = 1;
        tree[i] = news2[l];
        return;
    }
    long long m = (l+r)/2;
    make_tree(i*2,l,m);
    make_tree(i*2+1,m+1,r);
    tree[i] = tree[i*2] + tree[i*2+1];
    br_list[i] = br_list[i*2] + br_list[i*2+1];
    return;
}
void push_lazy(long long i)
{
    if( lazy[i] == 1 )
    {
        long long t_cnt = br_list[i] - tree[i];
        tree[i] += t_cnt;
        lazy[i*2] = 1;
        lazy[i*2+1] = 1;
    }
    lazy[i] = 0;
    return;
}
void update(long long i, long long l, long long r, long long ql, long long qr)
{
    //cout << l << " " << r << " " << ql << " " << qr << endl;
    push_lazy(i);
    if( ql == l && r == qr )
    {
        lazy[i] = 1;
        push_lazy(i);
        return;
    }
    long long m = (l+r)/2;
    if( qr <= m ) update(i*2,l,m,ql,qr);
    else if( ql > m ) update(i*2+1,m+1,r,ql,qr);
    else
    {
        update(i*2,l,m,ql,m);
        update(i*2+1,m+1,r,m+1,qr);
    }
    push_lazy(i*2);
    push_lazy(i*2+1);
    tree[i] = tree[i*2] + tree[i*2+1];
    return;
}
long long query(long long i, long long l, long long r, long long ql, long long qr)
{
    push_lazy(i);
    push_lazy(i*2);
    push_lazy(i*2+1);
    if( ql == l && qr == r )
    {
        return tree[i];
    }
    long long m = (l+r)/2;
    if( qr <= m ) return query(i*2,l,m,ql,qr);
    if( ql > m ) return query(i*2+1,m+1,r,ql,qr);
    return query(i*2,l,m,ql,m) + query(i*2+1,m+1,r,m+1,qr);
}
void print2()
{
    get_new_idx(1);
    for(long long i=1;i<=n;i++)
    {
        long long nb = m[i];
        news2[nb] = news[i];
    }
    make_tree(1,1,n);
    //cin >> q;
    for(long long i=0;i<q;i++)
    {
        long long t,x,k;
        //cin >> t >> x >> k;
        t = qq[i].t1;
        x = qq[i].x1;
        k = qq[i].k1;
        if( t == 1 )
        {
            long long from = m[x];
            long long to = from + sz_tree[from] - 1;
            update(1,1,n,from,to);
        }
        else
        {
            //cout << 1111 << endl;
            long long from = m[x];
            long long to = from + sz_tree[from] - 1;
            cout << query(1,1,n,from,to) << endl;;
        }
    }
}
void read()
{
    cin >> n;
    for(long long i=1; i<n; i++)
    {
        long long x,y;
        cin >> x>> y;
        v[x] .push_back(y);
    }
    for(long long i=1; i<=n; i++)
    {
        cin >> news[i];
    }
    int lamp = 0;
    cin >> q;
    for(int i=1;i<=q;i++)
    {
        int t,x,k;
        cin >>t>>x>>k;
        if( t == 1 ) lamp = 1;
        t_query q1(t,x,k);
        qq.push_back(q1);
    }
    if( n <= 10000 ) print1();
    else  if( lamp == 1 ) print2();
    //else print3();

}
main()
{
    read();
    return 0;
}
/*
5
1 2
1 3
2 4
2 5
0 1 1 0 0
*/
