#include <bits/stdc++.h>

#pragma GCC optimize "-O3"

#define endl '\n'
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;

void setIO() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

int k;
int n;
vector<int> b, s;

void read() {
    cin >> n;

    b.resize(n);
    s.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i] >> s[i];
    }
}

void solve() {
    int x = 0;
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        if (b[i] == 1) {
            cnt++;
        }

        x ^= s[i];
    }

    if (x) {
        if (cnt & 1) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    } else {
        if (cnt & 1) {
            cout << "Win\n";
        } else {
            cout << "Loss\n";
        }
    }
}

int main() {
    setIO();

    int q;
    cin >> k >> q;

    while (q--) {
        read();

        solve();
    }
}
