#include<bits/stdc++.h>
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("Ofast")
#pragma GCC targeg("avx2")
using namespace std;
const int maxn=2048;
struct edge
{
    int p,from,to;
    edge(){}
    edge(int p,int from,int to):p(p),from(from),to(to){}
    bool operator<(const edge &e)const
    {
        return p<e.p;
    }
};
struct node
{
    int p,to;
    node(){}
    node(int p,int to):p(p),to(to){}
};
priority_queue<edge>q;
int n;
int miners[maxn];
int maximum[maxn];
vector<node>v[maxn];
void read()
{
    scanf("%d",&n);
    int i;
    for(i=1;i<=n;i++)
        scanf("%d",&miners[i]);
    for(i=1;i<=n;i++)
        scanf("%d",&maximum[i]);
    int par,p;
    node cur;
    for(i=2;i<=n;i++)
    {
        scanf("%d%d",&par,&cur.p);
        cur.to=i;
        v[par].push_back(cur);
    }
}
void DFS(int ver,int dist,int gver)
{
    int i,sz=v[ver].size();
    edge cur;
    for(i=0;i<sz;i++)
    {
        cur.p=dist+v[ver][i].p;
        cur.to=v[ver][i].to;
        cur.from=gver;
        q.push(cur);
        DFS(v[ver][i].to,dist+v[ver][i].p,gver);
    }
}
void init_heap()
{
    for(int i=1;i<=n;i++)
        DFS(i,0,i);
}
void init_ans()
{
    int ans=0;
    edge cur;
    while(!q.empty())
    {
        cur=q.top();
        q.pop();
        if(cur.p<1)break;
        //cout<<cur.from<<' '<<cur.to<<' '<<cur.p<<endl;
        if(miners[cur.from]&&maximum[cur.to])
        {
            ans+=(cur.p*min(miners[cur.from],maximum[cur.to]));
            miners[cur.from]-=min(miners[cur.from],maximum[cur.to]);
            miners[cur.to]-=min(miners[cur.from],maximum[cur.to]);
        }
        //cout<<ans<<"\n\n";
    }
    printf("%d\n",ans);
}
int main()
{
	/*ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);*/
	read();
	init_heap();
	init_ans();
return 0;
}
