#include <iostream>
#include <vector>
#define endl "\n"
#define ll long long
using namespace std;

const int maxn=2*(1e3)+10;
ll razstoqnie[maxn][maxn],br[maxn],cap[maxn],tree[maxn];
vector<pair<ll,ll> > child[maxn];
bool prazno[maxn],isdef[maxn][maxn];

void build(ll curr){
    if(curr!=1){
        isdef[1][curr]=true;
    }
    if(child[curr].size()==0){
        return;
    }
    for(ll i=0;i<child[curr].size();i++){
        tree[child[curr][i].first]=tree[curr]+child[curr][i].second;
        razstoqnie[1][child[curr][i].first]=tree[child[curr][i].first];
        build(child[curr][i].first);
    }
}

void def(ll curr, ll from){
    if(curr!=from){
        isdef[from][curr]=true;
    }
    for(ll i=0;i<child[curr].size();i++){
        def(child[curr][i].first,from);
    }
}

int main(){
ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);
    ll n,from,w,i,j;
    cin >> n;
    for(i=1;i<=n;i++){
        cin >> br[i];
        if(br[i]==0){
            prazno[i]=true;
        }
    }
    for(i=1;i<=n;i++){
        cin >> cap[i];
    }
    for(i=2;i<=n;i++){
        cin >> from >> w;
        child[from].push_back({i,w});
    }
    build(1);
    for(i=2;i<=n;i++){
        def(i,i);
    }
    for(i=1;i<n;i++){
        for(j=i+1;j<=n;j++){
            if(isdef[i][j]){
                razstoqnie[i][j]=razstoqnie[1][j]-razstoqnie[1][i];
            }
        }
    }
    ll ans=0;
    while(true){
        ll maxres=0,from=0,to;
        for(i=1;i<n;i++){
            for(j=i+1;j<=n;j++){
                if(cap[j]>0 and br[i]>0){
                    if(maxres<razstoqnie[i][j] or (maxres==razstoqnie[i][j] and (br[i]<br[from] or maxres==0))){
                        maxres=razstoqnie[i][j];
                        from=i;
                        to=j;
                    }
                }
            }
        }
        if(maxres>0){
            ll mini=min(cap[to],br[from]);
            ans+=mini*maxres;
            cap[to]-=mini;
            br[from]-=mini;
        }else{
            break;
        }
    }
    cout << ans << endl;
return 0;
}
