#include <bits/stdc++.h>

#define ENDL '\n'

namespace {
struct heap {
    int big;
    int small;
};

auto mex(std::unordered_set<int> const& values) {
    auto res = 0;
    for (; values.find(res) != values.end(); ++res) {
    }

    return res;
}

auto solve(std::vector<heap>& heaps, int k) {
    std::function<int(heap)> recurse;
    recurse = [&](heap state) {
        std::unordered_set<int> children;
        for (auto x = 0; x <= state.big; ++x) {
            for (auto y = 0; y <= state.small; ++y) {
                if (!x && !y) {
                    continue;
                }

                for (auto t = 0; t <= (bool)x; ++t) {
                    auto new_state = heap{};

                    new_state.small = state.small - y;

                    new_state.big -= state.big - x;
                    new_state.small += k * x + t;

                    children.insert(recurse(new_state));
                }
            }
        }

        return mex(children);
    };

    auto res = 0;
    for (auto& heap : heaps) {
        res ^= recurse(heap);
    }

    return res;
}
}  // namespace

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int k, q;
    std::cin >> k >> q;

    while (q--) {
        int n;
        std::cin >> n;

        std::vector<heap> heaps(n);
        for (auto i = 0; i < n; ++i) {
            std::cin >> heaps[i].big >> heaps[i].small;
        }

        auto res = solve(heaps, k);
        std::cout << (res ? "Loss" : "Win") << ENDL;
    }

    return 0;
}
