#include <bits/stdc++.h>

#define ENDL '\n'

namespace {
template <class T>
using vec = std::vector<T>;

template <class T>
using mat = vec<vec<T>>;

using heap = std::pair<int, int>;

auto mex(std::unordered_set<int> const& values) {
    auto res = 0;
    for (; values.find(res) != values.end(); ++res) {
    }

    return res;
}

auto solve(vec<heap>& heaps, int k) {
    std::map<heap, int> dp;

    std::function<int(heap&)> recurse;
    recurse = [&](heap& state) {
        auto res = dp.find(state);

        if (res == dp.end()) {
            std::unordered_set<int> children;
            for (auto x = 0; x <= state.first; ++x) {
                for (auto y = 0; y <= state.second; ++y) {
                    if (!x && !y) {
                        continue;
                    }

                    for (auto t = 0; t <= (bool)x; ++t) {
                        auto old_big = state.first;
                        auto old_small = state.second;

                        state.second -= y;

                        state.first -= x;
                        state.second += k * x + t;

                        children.insert(recurse(state));

                        state.first = old_big;
                        state.second = old_small;
                    }
                }
            }

            auto val = mex(children);
            res = dp.emplace_hint(res, state, val);
        }

        return res->second;
    };

    auto res = 0;
    for (auto& heap : heaps) {
        res ^= recurse(heap);
    }

    return res;
}
}  // namespace

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int k, q;
    std::cin >> k >> q;

    while (q--) {
        int n;
        std::cin >> n;

        vec<heap> heaps(n);
        for (auto i = 0; i < n; ++i) {
            std::cin >> heaps[i].first >> heaps[i].second;
        }

        auto res = solve(heaps, k);
        std::cout << (res ? "Win" : "Loss") << ENDL;
    }

    return 0;
}
