#include <bits/stdc++.h>

#define ENDL '\n'

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int k, q; // k = 0
    std::cin >> k >> q;

    while (q--) {
        int n;
        std::cin >> n;

        auto res = 0;
        auto big_cnt = 0;
        auto max_small = 0;

        std::vector<std::pair<int, int>> big_heaps;

        while (n--) {
            int big, small;
            std::cin >> big >> small;

            if (big) {
                big_heaps.emplace_back(big, small);
            } else {
                max_small = std::max(max_small, small);
            }
        }

        for (auto& [big, small] : big_heaps) {
            res ^= (max_small + big + small + 1);
        }

        std::cout << (res ? "Win" : "Loss") << ENDL;
    }

    return 0;
}
