#include <bits/stdc++.h>

#define ENDL '\n'

int main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);

    int k, q; // k = 0
    std::cin >> k >> q;

    while (q--) {
        int n;
        std::cin >> n;

        auto res = 0;
        std::vector<std::pair<int, int>> big_heaps;

        while (n--) {
            int big, small;
            std::cin >> big >> small;

            if (big) {
                big_heaps.emplace_back(big, small);
            } else {
                res ^= small;
            }
        }

        auto t = 1 << ((int)std::log2(res) - 1);
        for (auto& big_heap : big_heaps) {
            res ^= (big_heap.first + big_heap.second + t + 1);
        }

        std::cout << (res ? "Win" : "Loss") << ENDL;
    }

    return 0;
}
