#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e4+10;
vector <int> v[MAXN];
bool fl[MAXN];
void dfs_fill(int x, int k) {
    fl[x]=1;
    if (k==0) return;
    for (auto i:v[x]) {
        dfs_fill(i,k-1);
    }
}
int dfs_find(int x, int k) {
    int res;
    res=fl[x];
    if (k==0) return res;
    for (auto i:v[x]) {
        res+=dfs_find(i,k-1);
    }
    return res;
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, a, b;
    cin >> n;
    for (int i=0;i<n-1;i++) {
        cin >> a >> b;
        v[a].push_back(b);
    }
    for (int i=1;i<=n;i++) cin >> fl[i];
    int q, type, x, k;
    cin >> q;
    for (int i=0;i<q;i++) {
        cin >> type >> x >> k;
        if (type==1) dfs_fill(x,k);
        else cout << dfs_find(x,k) << endl;
    }
    return 0;
}
