#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
#define int long long
#define MAXN 200005
int br, q;
vector<int> tree[MAXN];
int parent[MAXN];
int news[MAXN];
void tell(int v, int k){
    news[v] = 1;
    if(k == 0) return;
    for(int i : tree[v]){
        tell(i, k - 1);
    }
}
int num(int v, int k){
    if(k == 0) return news[v];
    int sum = 0;
    for(int i : tree[v]){
        sum += num(i, k - 1);
    }
    sum += news[v];
    return sum;
}
signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> br;
    for(int i = 0; i < br - 1; ++i){
        int from, to; cin >> from >> to;
        tree[from].push_back(to);
        parent[to] = from;
    }
    for(int i = 1; i <= br; ++i){
        cin >> news[i];
    }
    cin >> q;
    for(int i = 0; i < q; ++i){
        int type, x, k; cin >> type >> x >> k;
        if(type == 1){
            tell(x, k);
        }
        else{
            cout << num(x, k) << endl;
        }
    }
    return 0;
}