#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;

#define FORi(i,a,b) for(int i=((int)a);i<((int)b);i++)
#define FOR(i,n) FORi(i,0,n)
#define FOA(v,a) for(auto v : a)

#define INF 400001
#define MID ((l+r)/2)

#define BS 10

typedef vector<int> vi;
struct seg{
	seg *L, *R;
	int val=0;
	int cnt=0;
	int laz=0;

	void build(vi &a, int l=0, int r=INF){
		if(l==r) cnt = a[l];
		else{
			L = new seg;
			R = new seg;
			L->build(a,l,MID);
			R->build(a,MID+1,r);
			cnt = L->cnt + R->cnt;
		}
	}

	void push(int l, int r){
		if(laz){
			L->val = L->cnt;
			L->laz = 1;
			R->val = R->cnt;
			R->laz = 1;
		}
		laz = 0;
	}

	int query(int rl, int rr, int l=0, int r=INF){
		if(rl<=l && r<=rr) return val;
		else if(l>rr || rl>r) return 0;
		else{
			push(l,r);
			return L->query(rl,rr,l,MID) + R->query(rl,rr,MID+1,r);
		}
	}

	void update(int rl, int rr, int ff=0, int l=0, int r=INF){
		if(rl<=l && r<=rr){
			//cout<<"Updated "<<l<<endl;
			if(ff) val = 1;
			else val = cnt;

			if(l!=r) laz = 1;
		}
		else if(l>rr || rl>r) return;
		else{
			push(l,r);
			L->update(rl,rr,ff, l,MID);
			R->update(rl,rr,ff,MID+1,r);
			val = L->val + R->val;

		}
	}

	void print(int l=0, int r=INF){
		if(l==r) cout<<"("<<l<<": "<<cnt<<" "<<val<<") ";
		else{
			L->print(l,MID);
			R->print(MID+1,r);
		}
	}

};

int n;
vector<vi> adj;
vector<int> kn;
vi par;
vi cnt;
vi tin, tout;
int t=0;
vi path;
int pre[200040][BS+1];
vi nxt[200040];
void dfs(int s=1, int p=-1){
	tin[s] = ++t;
	cnt[s] = 1;
	par[s] = p;
	if(path.size()>=BS){
		nxt[path[path.size()-BS]].push_back(s);
	}
	path.push_back(s);
	FORi(i,max(0, (int)path.size()-BS),path.size()) pre[path[i]][0] += (kn[s]==1);
	FOA(v,adj[s]) if(v!=p) dfs(v,s), cnt[s]+=cnt[v];
	FORi(i,1,(n+BS-1) / BS){
		pre[s][i] = pre[s][0];
		FOA(x, nxt[s]) pre[s][i] += pre[x][i-1];
	}
	tout[s] = ++t;
	path.pop_back();
}

int main(){
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin>>n;
	adj.assign(n+1, vi());
	kn.resize(n+1);
	tin.resize(n+1);
	tout.resize(n+1);
	cnt.resize(n+1);
	par.resize(n+1);
	FOR(i,n-1){
		int a, b;
		cin>>a>>b;
		adj[a].push_back(b);
		adj[b].push_back(a);
	}
	FOR(i,n) cin>>kn[i+1];
	dfs(1);
	//FORi(i,1,n) cout<<i<<" "<<tin[i]<<endl;
	//cout<<endl;
	/*
	vi ct(INF+1);
	FORi(i,1,n+1) ct[tin[i]] = 1;
	seg s;
	s.build(ct);
	FORi(i,1,n+1){
		if(kn[i]){
			//cout<<"Updating "<<tin[i]<<endl;
			s.update(tin[i], tin[i], 1);
		}
	}*/
	/*
	FORi(i,1,n+1){
		cout<<i<<": ";
		FOA(v,nxt[i]) cout<<v<<" ";
		cout<<endl;
	}
	cout<<endl;
	FORi(i,1,n+1){
		cout<<i<<": ";
		FOR(j,3) cout<<pre[i][j]<<" ";
		cout<<endl;
	}*/
	int qqq;
	cin>>qqq;
	while(qqq--){
		int qq, x, k;
		cin>>qq>>x>>k;
		if(qq==1){
			//s.update(tin[x], tout[x]);
		}
		else{
			int ind = k / BS;
			int ans=0;
			if(ind>0) ans = pre[x][ind-1];
			//cout<<"init "<<ans<<endl;
			queue<int> q;
			q.push(x);
			q.push(-1);
			int d=0;
			while(q.size()>1 && d<ind){
				int t = q.front();
				q.pop();
				if(t==-1) q.push(-1), d++;
				else{
					FOA(v, nxt[t]) q.push(v);
				}
			}

			d=0;
			while(q.size()>1 && d<=k%BS){
				int t = q.front();
				//cout<<t<<" ";
				q.pop();
				if(t==-1) q.push(-1), d++;
				else{
					if(kn[t]) ans++;
					FOA(v, adj[t]) if(v!=par[t]) q.push(v);
				}
			}
			cout<<ans<<endl;
		}
	}
}
