#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
#define endl '\n'
#define all(x) (x).begin(),(x).end()
const int N = 5e5+5;
const ll INF = 2e18;

ll start[N],fin[N];
vector<vector<pl> > a(N);
vector<pl> d;
int tin[N],tout[N];
int T = 1;

void dfs1(int s, int e){
    tin[s] = T++;

    for(auto x : a[s]){
        if(x.F == e)continue;
        d[x.F] = {d[s].F + x.S, x.F};
        dfs1(x.F,s);
    }

    tout[s] = T;
}

bool ancestor(int x, int y){/// if x ancestor of y->true
    return tin[x] <= tin[y] && tin[y] < tout[x];
}

ll ans;

int main (){
int n;
cin>>n;

d.assign(n+1,{-INF,0});

int i;
for(i=1;i<=n;i++)
    cin>>start[i];
for(i=1;i<=n;i++)
    cin>>fin[i];

for(i=2;i<=n;i++){
    int x = i,y,z;
    cin>>y>>z;
    a[x].push_back({y,z});
    a[y].push_back({x,z});
}

d[1] = {0,1};
dfs1(1,1);

sort(all(d));

assert(d.size()-1 == n);
set<int> ss;

for(i=0;i<=n;i++){
    ss.insert(d[i].S);
}

assert(ss.size()==n+1 && (*ss.begin()) == 0);
auto it = ss.end();
it--;
assert((*it) == n);

for(int j = 0;j<=n;j++){
    int s = d[j].S;
    if(s == 0)continue;

    int i = d.size() - 1;
    while(d[i].F - d[j].F > 0 && start[s] > 0){
        int y = d[i].S;
        assert(1<=y && y<=(d.size()-1));
        if(fin[y] == 0 || ancestor(s,y) == false){
            i--;
            continue;
        }
        ll temp = min(start[s],fin[y]);
        start[s] -= temp;
        fin[y] -= temp;
        ans += (d[i].F - d[j].F)*temp;
        i--;
    }
}


cout<<ans<<endl;
}
