#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef pair<int,int> pi;
typedef pair<ll,ll> pl;
#define F first
#define S second
#define endl '\n'
#define all(x) (x).begin(),(x).end()
const int N = 5e5+5;
const ll INF = 2e18;

ll start[N],fin[N];
vector<vector<pl> > a(N);
vector<pl> d;
vector<int> tin(N,-1),tout(N,-1);
int T = 1;
int n;
int par[N];

void dfs1(int s, int e){
    tin[s] = T++;

    for(auto x : a[s]){
        if(x.F == e)continue;
        d[x.F] = {d[s].F + x.S, x.F};
        par[x.F] = s;
        dfs1(x.F,s);
    }

    tout[s] = T;
}

bool ancestor(int x, int y){/// if x ancestor of y->true
    assert(1<=x && x<=n && 1<=y && y<=n);
    assert(tin[x] != -1 && tin[y] != -1 && tout[x] != -1 && tout[y] != -1);
    bool f = tin[x] <= tin[y] && tin[y] < tout[x];
    bool c = false;
    while(y != -1){
        if(y == x){
            c = true;break;
        }
        y = par[y];
    }
    assert(c == f);
    return f;
}

ll ans;

int main (){

cin>>n;

d.assign(n+1,{-INF,0});

int i;
for(i=1;i<=n;i++)
    cin>>start[i];
for(i=1;i<=n;i++)
    cin>>fin[i];

for(i=2;i<=n;i++){
    int x = i,y,z;
    cin>>y>>z;
    a[x].push_back({y,z});
    a[y].push_back({x,z});
}

par[1] = -1;
d[1] = {0,1};
dfs1(1,1);

/// sort(all(d));

assert(d.size()-1 == n);
set<int> ss;

for(i=0;i<=n;i++){
    ss.insert(d[i].S);
}

assert(ss.size()==n+1 && (*ss.begin()) == 0);
auto it = ss.end();
it--;
assert((*it) == n);

while(true){

    int i,j;
    int l = -1,r = -1;
    ll dist = 0;
    for(i=1;i<=n;i++){
        ll maxi = 0;
        int idx = -1;
        if(start[i] == 0)
            continue;

        for(j=1;j<=n;j++){
            if(fin[j] == 0 || ancestor(i,j) == false)continue;
            if(maxi < d[j].F - d[i].F){
                maxi = d[j].F - d[i].F;
                idx = j;
            }
        }
        if(maxi > dist){
            dist = maxi;
            assert(idx != -1);
            l = i;
            r = idx;
        }
    }
    if(dist == 0)break;
    ll temp = min(start[l],fin[r]);
    start[l] -= temp;
    fin[r] -= temp;
    ans += dist*temp;

}


/*
for(int j = 0;j<=n;j++){
    int s = d[j].S;
    if(s == 0)continue;

    int i = d.size() - 1;
    while(d[i].F - d[j].F > 0 && start[s] > 0){
        int y = d[i].S;
        assert(1<=y && y<=(d.size()-1));
        if(fin[y] == 0 || ancestor(s,y) == false){
            i--;
            continue;
        }
        ll temp = min(start[s],fin[y]);
        start[s] -= temp;
        fin[y] -= temp;
        ans += (d[i].F - d[j].F)*temp;
        i--;
    }
}
*/

cout<<ans<<endl;
}


/*

6
2 3 7 6 9 100
0 5 8 5 5 5
1 -5
1 -2
3 4
3 7
2 10
*/
