#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>

#define upmin(a, b) a = min(a, b)
#define upmax(a, b) a = max(a, b)
#define pr(x) cout << x << endl
#define wpr(x) cout << #x << ": " << x << endl
#define wprv(x) cout << #x << ": " << endl; for(auto it : x) cout << it << " "; cout << endl;
#define wprvv(x) cout << #x << ": " << endl; for(auto it : x) {for(auto it2 : it) cout << it2<< " "; cout << endl;}
#define rep(i, s, e) for(ll i = s; i < e; i++)

using namespace std;
using ll = long long;
using vll = vector<ll>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pll = pair<ll, ll>;
using vpll = vector<pll>;
using vvpll = vector<vpll>;
using vb = vector<bool>;
using vvb = vector<vb>;

const ll maxn = 30;
ll k, q;
vvb dp;
void solve()
{
	ll n;
	cin >> n;
	vll a(n);
	vll b(n);
	bool haveb = false;
	rep(i, 0, n) {
		ll at, bt;
		cin >> bt >> at;
		a[i] = at;
		b[i] = bt;
		if (bt > 0) haveb = true;
	}
	ll xora = 0, xorb = 0;
	rep(i, 0, n) xora ^= a[i];
	rep(i, 0, n) xorb ^= b[i];
	upmin(xora, maxn - (ll)1);
	if (dp[xora][xorb]) {
		pr("Win");
	}
	else {
		pr("Loss");
	}
	/*
	if (!haveb) {
		if (xora > 0) {
			pr("Win");
		}
		else {
			pr("Loss");
		}
	}
	else {
		if (xorb > 0) {
			pr("Win");
		}
		else {
			if (xora > 0) {
				pr("Win");
			}
			else {
				pr("Loss");
			}
			
		}
	}
	*/
}


void calc_dp()
{
	/*
	dp[xorA][xorB] = can we win this way?
	*/
	dp.resize(maxn, vb(maxn, 0));
	dp[0][0] = 0;
	rep(b, 0, maxn) {
		rep(a, 0, maxn) {
			// calc dp[i][j]
			//cout << "a: " << a << " b: " << b << endl;
			rep(takeA, 1, a + 1) {
				dp[a][b] = (!dp[a - takeA][b]) || dp[a][b];
				if (dp[a][b]) {
					//wpr(takeA);
					break;
				}
			}
		}
		for (ll a = maxn - 1; a >= 0; a--) {
			rep(takeB, 1, b + 1) {
				rep(addA, k * takeB, maxn - a) {
					dp[a][b] = (!dp[a + addA][b - takeB]) || dp[a][b];
					if (dp[a][b]) {
						//wpr(takeB);
						break;
					}
				}
			}
		}
	}
	//wprvv(dp);
}


int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> k >> q;
	calc_dp();
	rep(asdf, 0, q) {
		solve();
	}
}

/*

3 2
2
1 5
3 2
3
0 3
2 1
3 2


*/