#include <bits/stdc++.h>
#define ub(x) (x&(-x))

using namespace std;

constexpr int NMAX = 2e5 + 5;

struct Question {
    int x, k;
};

Question Que[NMAX];
vector <int> ask[NMAX];
int N, Q;
int B[NMAX];
vector <int> G[NMAX];

int sol[NMAX];
map <int, int> mp[NMAX];
int Level[NMAX];

void Dfs (int Node, int dad = 0) {
    Level[Node] = Level[dad] + 1;
    for (auto it : G[Node])
        Dfs(it, Node);

}

void Read () {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for (int i = 1; i < N; ++ i ) {
        int x,y;
        cin >> x >> y;

        G[x].push_back(y);
    }

    for (int i = 1; i <= N; ++ i )
        cin >> B[i];
}

vector <int> asc;
void SolveDfs (int Node) {

    asc.push_back(Node);
    for (auto it : G[Node]) {
        SolveDfs(it);
        if (mp[it].size() > mp[Node].size())
            swap(mp[it], mp[Node]);

        for (auto val : mp[it])
            mp[Node][val.first] += val.second;
    }

    if (B[Node] == 1)
        mp[Node][Level[Node]] ++;

    for (auto it : ask[Node]) {
        int ans = 0;
        int val = Que[it].k;

        for (auto i : mp[Node]) {
            if (i.first <= val) ans += i.second;
            else break;
        }

        sol[it] = ans;
    }
}

bool cmp (int a, int b) {
    return (Que[a].k < Que[b].k);
}

void Solve () {
    cin >> Q;
    for (int i = 1; i <= Q; ++ i ) {
        int tip, x, k;
        cin >> tip >> Que[i].x >> Que[i].k;

        Que[i].k += Level[Que[i].x];
        ask[Que[i].x].push_back(i);
    }

    for (int i = 1; i <= N; ++ i )
        sort(ask[i].begin(), ask[i].end(), cmp);

    SolveDfs(1);

    for (int i = 1; i <= Q; ++ i )
        cout << sol[i] << '\n';
}

int main () {
    Read();
    Solve();
    return 0;
}
