#include <iostream>
#include <cstdio>
#include <vector>

int p [ 500'005 ] = { 0 } ;
std::vector<int> c [ 500'005 ] ;
std::vector<int> w [ 500'005 ] ;

int s [ 500'005 ] = { 0 } ;
int e [ 500'005 ] = { 0 } ;

std::pair<int,int> push ( int root , int score = 0 ) {
	std::pair<int,int> b = { root , score * ( s [ root ] < e [ root ] ) };
	for ( int i = 0 ; i < c [ root ].size ( ) ; i++ ) {
		std::pair<int,int> t = push ( c [ root ][ i ] , score + w [ root ][ i ] ) ;
		if ( t.second >= b.second )
			b = t ;
	}
	return b;
}

int dfs ( int root ) {
	int ans = 0 ;
	for ( int i = 0 ; i < c[ root ].size() ; i++ ) {
		ans += dfs ( c [ root ][ i ] ) ;
	}
	int k = s [ root ] ;
	for ( int j = 0 ; j < k ; j++ ) {
		std::pair<int,int> r = push ( root ) ;
		if ( r.second > 0 ) {
			// printf ( "%d was moved to %d\n" , root + 1 , r.first + 1) ;
			s [ r.first ]++;
			s [ root ]--;
			ans += r.second;
		}else{
			break;
		}
	}
	return ans ;
}

int main ( void ) {
	int N ;
	scanf ( " %d" , &N ) ;
	for ( int i = 0 ; i < N ; i++ ) {
		scanf ( " %d" , &s [ i ] ) ;
	}
	for ( int i = 0 ; i < N ; i++ ) {
		scanf ( " %d" , &e [ i ] ) ; e [ i ] = e [ i ] + s [ i ] ;
	}
	for ( int i = 1 ; i < N ; i++ ) {
		int P , W ;
		scanf ( " %d %d" , &P , &W ) ; P--;
		c [ P ].push_back ( i ) ;
		w [ P ].push_back ( W ) ;
	}
	printf ( "%d\n" , dfs ( 0 ) ) ;
	return 0;
}
