#include <iostream>
#include <cstdio>
#include <cstring>
#include <cmath>
#include <algorithm>
#include <vector>
struct Node {
    int Flag;
    int Parent;
    int Children;
    std::vector<int> Child;
} A [ 200'005 ];
void Update ( int root , int levels ) {
    A [ root ].Flag = std::max ( levels + 1 , A [ root ].Flag ) ;
}
int Fix ( int root , int targ ) {
	if ( root > 0 ) {
		if ( A [ root ].Parent > 0 ) {
			Fix ( A [ root ].Parent , root ) ;
		}
		Update ( targ , A [ root ].Flag - 2 ) ;
	}
}
int Query ( int root , int levels ) {
    int Answer = A [ root ].Flag > 0 ;
    if ( levels ) {
        for ( int i = 0 ; i < A [ root ].Child.size ( ) ; i++ ) {
                Update ( A [ root ].Child [ i ] , A [ root ].Flag - 2 ) ;
                Answer += Query ( A [ root ].Child[ i ] , levels - 1 ) ;
        }
    }
    return Answer;
}
int main ( void ) {
    int N ;
    scanf ( "%d" , &N ) ;
    for ( int i = 0 ; i < N - 1 ; i++ ) {
        int x , y ;
        scanf ( " %d %d" , &x , &y ) ;
        A [ y ].Parent = x;
        A [ x ].Child.push_back ( y ) ;
    }
    A [ 1 ].Parent = -1;
    for ( int i = 1 ; i <= N ; i++ ) {
        scanf ( " %d" , &A [ i ].Flag ) ;
    }
    int Q ;
    scanf ( " %d" , &Q ) ;
    for ( int i = 0 ; i < Q ; i++ ) {
        int c , x , k ;
        scanf ( " %d %d %d" , &c , &x , &k ) ;
        if ( c == 1 ) Update ( x , k ) ;
        else if ( c == 2 ) {
                Fix ( A [ x ].Parent , x ) ;
                printf ( "%d\n" , Query ( x , k )) ;
        }
    }
    return 0 ;
}
