#include <bits/stdc++.h>

using namespace std;

#define pb push_back

const int N = 1e4 + 10;
vector<int> g[N];
int colored[N], par[N];

void build(int v, int p = -1) {
    par[v] = p;
    for (auto u: g[v]) {
        if (u != par[v])
            build(u, v);
    }
}

void color(int v, int l) {
    colored[v] = 1;
    if (l == 0)
        return;
    for (auto u: g[v]) {
        if (par[v] != u)
            color(u, l - 1);
    }
}

int ans(int v, int l) {
    int kolvo = colored[v];
    if (l == 0)
        return kolvo;
    for (auto u: g[v]) {
        if (par[v] != u)
            kolvo += ans(u, l - 1);
    }
    return kolvo;
}

void solve() {
    int n, x, y, tp, k;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
    }
    for (int i = 0; i < n; i++) {
        cin >> colored[i];
    }
    int q;
    cin >> q;
    while (q--) {
        cin >> tp >> x >> k;
        x--;
        if (tp == 1) {
            color(x, k);
        }else{
            cout << ans(x, k) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}