#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define f first
#define s second

const int N = 2e5 + 10;
vector<int> g[N];
int colored[N], sum[N], par[N], used[N], kolvo[N];

pair<int, int> build(int v, int p = -1) {
    par[v] = p;
    sum[v] = colored[v];
    kolvo[v] = 1;
    for (auto u: g[v]) {
        if (u != par[v]) {
            pair<int, int> u1 = build(u, v);
            sum[v] += u1.f;
            kolvo[v] += u1.s;
        }
    }
    return {sum[v], kolvo[v]};
}

void color(int v) {
    used[v] = colored[v] = 1;
    sum[v] = kolvo[v];
    for (auto u : g[v]){
        if (u != par[v] && !used[u])
            color(u);
    }
}

void solve() {
    int n, x, y, tp, k;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
    }
    for (int i = 0; i < n; i++) {
        cin >> colored[i];
    }
    int q;
    cin >> q;
    while (q--) {
        cin >> tp >> x >> k;
        x--;
        if (tp == 1) {
            color(x);
        }else{
            cout << sum[x] << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}