#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 2e5 + 10, inf = 1e9;
vector<int> g[N];
int colored[N], tin[N], tout[N], timer = 0, line[2 * N], par[N], level[N], pos[N], alter[N];

void build(int v, int l = 0, int p = -1) {
    tin[v] = timer++;
    par[v] = p;
    level[v] = l;
    for (auto u: g[v]) {
        if (u == par[v])
            continue;
        build(u, l + 1, v);
    }
    tout[v] = timer++;
}

pii t[4 * N];

vector<pii > mas, last;

void build_t(int v, int l, int r) {
    if (l == r - 1) {
        t[v] = mas[l];
    } else {
        int mid = (r + l) / 2;
        build_t(2 * v + 1, l, mid);
        build_t(2 * v + 2, mid, r);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
}

void update(int v, int l, int r, int position) {
    if (l == r - 1) {
        t[v].f = inf;
    } else {
        int mid = (r + l) / 2;
        if (position < mid) {
            update(2 * v + 1, l, mid, position);
        } else {
            update(2 * v + 2, mid, r, position);
        }
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
}

pii get(int v, int l, int r, int tl, int tr) {
    if (tl <= l && tr >= r)
        return t[v];
    if (tl >= r || tr <= l)
        return {inf, inf};
    int mid = (r + l) / 2;
    return min(get(2 * v + 1, l, mid, tl, tr), get(2 * v + 2, mid, r, tl, tr));
}

int ans(int v, int l) {
    int kolvo = colored[v];
    if (l == 0)
        return kolvo;
    for (auto u: g[v]) {
        if (par[v] != u)
            kolvo += ans(u, l - 1);
    }
    return kolvo;
}

void solve() {
    int n, x, y, tp, k;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
    }
    for (int i = 0; i < n; i++) {
        cin >> colored[i];
    }
    build(0);
    for (int i = 0; i < n; i++) {
        mas.pb({level[i], i});
    }
    sort(mas.begin(), mas.end());
//    for (auto u : mas){
//        cout << u.f << ' ' << u.s << endl;
//    }
    for (int i = 0; i < 2 * N; i++) {
        line[i] = n;
    }
    for (int i = 0; i < n; i++) {
        if (line[mas[i].f] == n) {
            line[mas[i].f] = i;
        }
    }
    for (int i = 0; i < n; i++) {
        mas[i].f = tout[mas[i].s];
        pos[mas[i].s] = i;
        alter[i] = mas[i].s;
    }
//    for (auto u : mas){
//        cout << u.f << ' ' << u.s << endl;
//    }
    last = mas;
    build_t(0, 0, n);
    for (int i = 0; i < n; i++) {
        if (colored[i]) {
//            cout << i << endl;
            update(0, 0, n, pos[i]);
            mas[pos[i]].f = inf;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        cin >> tp >> x >> k;
        x--;
        if (tp == 1) {
            while (get(0, 0, n, line[level[x]], line[level[x] + k + 1]).f <= tout[x]) {
                int v = get(0, 0, n, line[level[x]], line[level[x] + k + 1]).s;
                update(0, 0, n, v);
                mas[v].f = inf;
//                cout << alter[v] << endl;
                colored[alter[v]] = 1;
            }
        } else {
            cout << ans(x, k) << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}