#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define f first
#define s second
#define pii pair<int, int>

const int N = 2e5 + 10, inf = 1e9;
vector<int> g[N];
int colored[N], tin[N], tout[N], timer = 0, line[2 * N], par[N], level[N], pos[N], alter[N];

void build(int v, int l = 0, int p = -1) {
    tin[v] = timer++;
    par[v] = p;
    level[v] = l;
    for (auto u: g[v]) {
        if (u == par[v])
            continue;
        build(u, l + 1, v);
    }
    tout[v] = timer++;
}

pii t[4 * N];

vector<pii > mas;

void build_t(int v, int l, int r) {
    if (l == r - 1) {
        t[v] = mas[l];
    } else {
        int mid = (r + l) / 2;
        build_t(2 * v + 1, l, mid);
        build_t(2 * v + 2, mid, r);
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
}

void update(int v, int l, int r, int position) {
    if (l == r - 1) {
        t[v].f = inf;
    } else {
        int mid = (r + l) / 2;
        if (position < mid) {
            update(2 * v + 1, l, mid, position);
        } else {
            update(2 * v + 2, mid, r, position);
        }
        t[v] = min(t[2 * v + 1], t[2 * v + 2]);
    }
}

pii get(int v, int l, int r, int tl, int tr) {
    if (tl <= l && tr >= r)
        return t[v];
    if (tl >= r || tr <= l)
        return {inf, inf};
    int mid = (r + l) / 2;
    return min(get(2 * v + 1, l, mid, tl, tr), get(2 * v + 2, mid, r, tl, tr));
}

const int LG = 20;
int t_r[LG][N], pos_r[LG][N], tree[LG][4 * N], n;

void update_r(int v, int l, int r, int deep, int i) {
    if (l == r - 1) {
        tree[deep][v] = 1;
    } else {
        int mid = (r + l) / 2;
        if (i < mid) {
            update_r(2 * v + 1, l, mid, deep, i);
        } else {
            update_r(2 * v + 2, mid, r, deep, i);
        }
        tree[deep][v] = tree[deep][2 * v + 1] + tree[deep][2 * v + 2];
    }
}

void build_tr(int deep, int l, int r) {
    if (l == r - 1) {
        t_r[deep][l] = mas[l].s;
        pos_r[deep][t_r[deep][l]] = l;
        if (colored[t_r[deep][l]]) {
            update_r(0, 0, n, deep, l);
        }
    } else {
        int mid = (r + l) / 2;
        build_tr(deep + 1, l, mid);
        build_tr(deep + 1, mid, r);
        int it1 = l, it2 = mid;
        int it_now = l;
        while (it_now != r) {
            if (it1 == mid) {
                t_r[deep][it_now] = t_r[deep + 1][it2];
                it_now++;
                it2++;
            } else if (it2 == r) {
                t_r[deep][it_now] = t_r[deep + 1][it1];
                it_now++;
                it1++;
            } else {
                if (tout[t_r[deep + 1][it1]] <= tout[t_r[deep + 1][it2]]) {
                    t_r[deep][it_now] = t_r[deep + 1][it1];
                    it_now++;
                    it1++;
                } else {
                    t_r[deep][it_now] = t_r[deep + 1][it2];
                    it_now++;
                    it2++;
                }
            }
        }
        for (int i = l; i < r; i++) {
            pos_r[deep][t_r[deep][i]] = i;
        }
        for (int i = l; i < r; i++) {
            if (colored[t_r[deep][i]]) {
                update_r(0, 0, n, deep, i);
            }
        }
    }
}

int get_r(int v, int l, int r, int tl, int tr, int deep) {
    if (tl <= l && tr >= r)
        return tree[deep][v];
    if (tl >= r || tr <= l)
        return 0;
    int mid = (r + l) / 2;
    return get_r(2 * v + 1, l, mid, tl, tr, deep) + get_r(2 * v + 2, mid, r, tl, tr, deep);
}

int ans(int l, int r, int tl, int tr, int deep, int val1, int val2) {
    if (tl <= l && tr >= r) {
        int l_now = l - 1, r_now = r;
        while (r_now > l_now + 1) {
            int mid = (r_now + l_now) / 2;
            if (tout[t_r[deep][mid]] <= val1) {
                l_now = mid;
            } else {
                r_now = mid;
            }
        }
        if (l_now == l - 1)
            return 0;
        int last = l_now;
        l_now = l - 1, r_now = r;
        while (r_now > l_now + 1) {
            int mid = (r_now + l_now) / 2;
            if (tout[t_r[deep][mid]] >= val2) {
                r_now = mid;
            } else {
                l_now = mid;
            }
        }
        if (r_now == r)
            return 0;
        return get_r(0, 0, n, r_now, last + 1, deep);
    }
    if (tl >= r || tr <= l)
        return 0;
    int mid = (r + l) / 2;
    return ans(l, mid, tl, tr, deep + 1, val1, val2) + ans(mid, r, tl, tr, deep + 1, val1, val2);
}

int get_id(int v, int l, int r, int tl, int tr, int deep) {
    if (tree[deep][v] == r - l)
        return inf;
    if (tl <= l && tr >= r) {
        if (r == l + 1)
            return t_r[deep][l];
        int mid = (r + l) / 2;
        if (tree[deep][2 * v + 1] != mid - l) {
            return get_id(2 * v + 1, l, mid, tl, tr, deep);
        } else {
            return get_id(2 * v + 2, mid, r, tl, tr, deep);
        }
    }
    if (tl >= r || tr <= l)
        return inf;
    int mid = (r + l) / 2;
    int u = get_id(2 * v + 1, l, mid, tl, tr, deep);
    if (u != inf)
        return u;
    return get_id(2 * v + 2, mid, r, tl, tr, deep);
}

int search(int l, int r, int tl, int tr, int deep, int val1, int val2) {
    if (tl <= l && tr >= r) {
        int l_now = l - 1, r_now = r;
        while (r_now > l_now + 1) {
            int mid = (r_now + l_now) / 2;
            if (tout[t_r[deep][mid]] <= val1) {
                l_now = mid;
            } else {
                r_now = mid;
            }
        }
        if (l_now == l - 1)
            return inf;
        int last = l_now;
        l_now = l - 1, r_now = r;
        while (r_now > l_now + 1) {
            int mid = (r_now + l_now) / 2;
            if (tout[t_r[deep][mid]] >= val2) {
                r_now = mid;
            } else {
                l_now = mid;
            }
        }
        if (r_now == r)
            return inf;
        int u = get_id(0, 0, n, r_now, last + 1, deep);
        return u;
    }
    if (tl >= r || tr <= l)
        return inf;
    int mid = (r + l) / 2;
    int fst = search(l, mid, tl, tr, deep + 1, val1, val2);
    if (fst != inf)
        return fst;
    return search(mid, r, tl, tr, deep + 1, val1, val2);
}

void solve() {
    int x, y, tp, k;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
    }
    for (int i = 0; i < n; i++) {
        cin >> colored[i];
    }
    build(0);
    for (int i = 0; i < n; i++) {
        mas.pb({level[i], i});
    }
    sort(mas.begin(), mas.end());
    for (int i = 0; i < 2 * N; i++) {
        line[i] = n;
    }
    for (int i = 0; i < n; i++) {
        if (line[mas[i].f] == n) {
            line[mas[i].f] = i;
        }
    }
    for (int i = 0; i < n; i++) {
        mas[i].f = tout[mas[i].s];
        pos[mas[i].s] = i;
        alter[i] = mas[i].s;
    }
    build_tr(0, 0, n);
    build_t(0, 0, n);
    for (int i = 0; i < n; i++) {
        if (colored[i]) {
            update(0, 0, n, pos[i]);
            mas[pos[i]].f = inf;
            for (int j = 0; j < LG; j++) {
                update_r(0, 0, n, j, pos_r[j][i]);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        cin >> tp >> x >> k;
        x--;
        if (tp == 1) {
            int v = search(0, n, line[level[x]], line[level[x] + k + 1], 0, tout[x], tin[x]);
            while (v != inf) {
                mas[v].f = inf;
                colored[v] = 1;
                for (int j = 0; j < LG; j++) {
                    update_r(0, 0, n, j, pos_r[j][v]);
                }
                v = search(0, n, line[level[x]], line[level[x] + k + 1], 0, tout[x], tin[x]);
            }
        } else {
            cout << ans(0, n, line[level[x]], line[level[x] + k + 1], 0, tout[x], tin[x]) << endl;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
}