#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

int k;

unordered_map<ll, int> mapa;

int encode(int a, int b) {
    return 3001LL * b + a;
}

int grundy(int a, int b) {
    if (mapa.count(encode(a, b))) {
        return mapa[encode(a, b)];
    } 
    if (a + b == 0) {
        return 0;
    }
    vector<int> arr;
    for (int i = 0; i <= a; i++) {
        for (int j = 0; j <= b; j++) {
            if (i + j != 0) {
                int a1 = a - i;
                int b1 = (b - j) + i * k;
                arr.push_back(grundy(a1, b1));
            }
        } 
    }
    sort(arr.begin(), arr.end());
    arr.erase(unique(arr.begin(), arr.end()), arr.end());
    if (arr.back() == (int) arr.size() - 1) {
        return mapa[encode(a, b)] = arr.back() + 1;
    }
    for (int i = 0; ; i++) {
        if (arr[i] != i) {
            return i;
        }
    }
    assert(false);
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    int tot = 0;
    for (auto [a, b] : arr) {
        tot ^= grundy(a, b);
    }
    if (tot == 0) {
        cout << "Loss" << '\n';
    } else {
        cout << "Win\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> k;
    int t = 1;
    cin >> t; // comment if no multitest
    while (t--) {
        solve();
    }
}
