#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

#define int ll

const int INF = 1e18 + 228;

int n;

vector<int> s, e;
vector<vector<pair<int, int>>> ch;

vector<vector<int>> dp;

void run(int v) {
    for (auto [u, w] : ch[v]) {
        run(u);
    }
    vector<int> arr;
    vector<int> dp1(e[v] + 1);
    for  (auto [u, w] : ch[v]) {
        dp1.resize(dp1.size() + dp[u].size() - 1, -INF);
        auto dp2 = dp1;
        for (int i = 1; i < (int) dp[u].size(); i++) {
            for (int j = i; j < (int) dp2.size(); j++) {
                dp2[j] = max(dp2[j], dp1[j - i] + dp[u][i] + i * w);
            }
        } 
        dp1 = dp2;
    }
    dp[v].resize(max((int) 1, (int) dp1.size() - s[v]), -INF);
    dp[v] = dp1;
    for (int i = 1; i <= s[v]; i++) {
        for (int j = 0; j + i < (int)dp1.size(); j++) {
            dp[v][j] = max(dp[v][j], dp1[j + i]);
        }
    }
}

void solve() {
    cin >> n;
    s.resize(n);
    e.resize(n);
    for  (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for  (int i = 0; i < n; i++) {
        cin >> e[i];
    }
    ch.resize(n);
    for (int i = 1; i < n; i++) {
        int from, w;
        cin >> from >> w;
        from--;
        ch[from].push_back({i, w});
    }
    dp.resize(n);
    run(0);
    cout << dp[0][0] << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
