#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ldb;

const int MAXN = 2e5 + 228;

int n;
vector<int> ch[MAXN];
int tin[MAXN];
int tout[MAXN];
int depth[MAXN];
int cur_time = 0;

void dfs(int v) {
    tin[v] = cur_time++;
    for (int u : ch[v]) {
        depth[cur_time] = depth[tin[v]] + 1;
        dfs(u);
    }
    tout[v] = cur_time;
}

int arr[MAXN];

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        ch[a].push_back(b);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
       cin >> arr[tin[i]];
    } 
    int q;
    cin >> q;
    while (q--) {
        int t, v, d;
        cin >> t >> v >> d;
        v--;
        if (t == 1) {
            for (int i = tin[v]; i < tout[v]; i++) {
                if (depth[i] - depth[tin[v]] <= d) {
                    arr[i] = 1;
                }
            }
        } else {
            int ans = 0;
            for (int i = tin[v]; i < tout[v]; i++) {
                if (depth[i] - depth[tin[v]] <= d) {
                    ans += arr[i];
                }
            }
            cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) {
        solve();
    }
}
