#include <bits/stdc++.h>
using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int,int>pi;
typedef vector<pi> vpi;

#define GLHF ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0)
#define pb push_back
#define out(x) {cout << x << "\n";return;}

void solve();
int main(){
    GLHF;
    solve();
}

const int maxn=5e4+1;
vi g[maxn];
int tin[maxn],tout[maxn],a[maxn],dep[maxn];
int timer=0;

void dfs(int src,int par){
    tin[src]=++timer;
    if(par!=-1)
        dep[src]=dep[par]+1;
    for(int nbr:g[src])
        if(nbr!=par)
            dfs(nbr,src);
    tout[src]=timer;
}
void solve(){
    int n;
    cin >> n;

    for(int i=0; i<n-1; i++){
        int u,v;
        cin >> u>> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    dfs(1,-1);
    for(int i=1; i<=n; i++){
        int x;
        cin >> x;
        a[tin[i]]=x;
    }

    int q;
    cin >> q;

    while(q--){
        int op,x,k;
        cin >> op >> x >> k;

        if(op==1){
            for(int i=tin[x];i<=tout[x]; i++)
                if(dep[i]<=dep[x]+k)
                    a[i]=1;
        }
        else{
            int ans=0;
            for(int i=tin[x]; i<=tout[x]; i++)
                if(dep[i]<=dep[x]+k)
                    ans+=a[i];
            cout << ans << "\n";
        }

    }
}