#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/rope>

using namespace __gnu_pbds;
using namespace __gnu_cxx;
using namespace std;

bool solve0(int n, vector<pair<int, int>>& v) {
    int sum = 0;
    for (auto [i, j] : v) {
        sum ^= i + j;
    }
    return sum;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int k, q;
    cin >> k >> q;
    while (q--) {
        int n;
        cin >> n;
        vector<pair<int, int>> v(n);
        for (auto& [i, j] : v) {
            cin >> i >> j;
        }
        if (k == 0) {
            cout << (solve0(n, v) ? "Win\n" : "Loss\n");
        }
    }
    return 0;
}