#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,popcnt")
#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/rope>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;
//using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

int findPrice(int i, int j, vector<vector<pair<int, int>>>& g) {
    if (i == j) {
        return 0;
    }
    int res = -1e7;
    for (auto [k, w] : g[i]) {
        res = max(res, w + findPrice(k, j, g));
    }
    return res;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> s(n);
    for (auto& i : s) {
        cin >> i;
    }
    vector<int> e(n);
    for (auto& i : e) {
        cin >> i;
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        --p;
        g[p].push_back({i, w});
    }
    vector<int> v(n);
    for (int i = 0; i < n; ++i) {
        v[i] = i;
    }
    int res = -1e9;
    while (true) {
        int curr = 0;
        for (int i = 0; i < n; ++i) {   
            curr += findPrice(i, v[i], g);
        }
        res = max(res, curr);
        if (!next_permutation(v.begin(),  v.end())) {
            break;
        }
    }
    cout << res << '\n';
    return 0;
}
