#include <bits/stdc++.h>
#define speed ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
#define ll long long
#define pill pair<ll, ll>
#define mp make_pair
#define f first
#define s second
#define pb push_back
using namespace std;

const ll N = 1e6;

ll n, q;
vector<ll> g[N];
ll s[N], gl[N];

void prec(ll v, ll p = 0ll) {
	gl[v] = gl[p] + 1;	
	for(auto u : g[v]) {
		if(u != p)
			prec(u, v);
	}
}

void color(ll v, ll ogr) {
	s[v] = 1;
	for(auto u : g[v]) {
		if(gl[u] > gl[v] && gl[u] <= ogr)
			color(u, ogr); 
	}
}
ll get(ll v, ll ogr) {
    ll ans = s[v];
	for(auto u : g[v]) {
		if(gl[u] > gl[v] && gl[u] <= ogr)
			ans += get(u, ogr); 
	}
	return ans;
}


int main() {
	speed;
	cin >> n;
	for(int i = 1; i < n; i++) {
		ll a, b;
		cin >> a >> b;
		g[a].pb(b);
		g[b].pb(a);
	}
	for(int i = 1; i <= n; i++) 
		cin >> s[i];
	prec(1, 0);
	cin >> q;
	while(q--) {
		ll t, x, k;
		cin >> t >> x >> k;
		if(t == 1)
			color(x, k + gl[x]); 
		else
			cout << get(x, k + gl[x]) << '\n';
	}
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1
0 1 0 1
1
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/