#include <bits/stdc++.h>
using namespace std;
#define MAXN 10005

vector<int> ch[MAXN];
int b[MAXN],st_val[MAXN];
int N,Q;
int s[MAXN],e[MAXN];//start, end of subtree in preorder traversal
int dfs_timer;
int st[4*MAXN],lazy[4*MAXN];

void build(int v=1,int start=1,int end=N){
    if(start==end){
        st[v]=st_val[start];
        lazy[v]=0;
        return;
    }
    int mid=(start+end)/2;
    build(2*v,start,mid);
    build(2*v+1,mid+1,end);
    st[v]=st[2*v]+st[2*v+1];
}

void update(int from,int to,int v=1,int start=1,int end=N){
    if(start==from&&end==to){
        st[v]=end-start+1;
        lazy[v]=1;
        return;
    }
    //propagate
    int mid=(start+end)/2;
    if(lazy[v]){
        update(start,mid,2*v,start,mid);
        update(mid+1,end,2*v+1,mid+1,end);
        lazy[v]=0;
    }
    if(to<=mid){
        update(from,to,2*v,start,mid);
    }else if(from>mid){
        update(from,to,2*v+1,mid+1,end);
    }else{
        update(from,mid,2*v,start,mid);
        update(mid+1,to,2*v+1,mid+1,end);
    }
    st[v]=st[2*v]+st[2*v+1];
}

int query(int from,int to,int v=1,int start=1,int end=N){
    if(start==from&&end==to){
        return st[v];
    }
    //propagate
    int mid=(start+end)/2;
    if(lazy[v]){
        update(start,mid,2*v,start,mid);
        update(mid+1,end,2*v+1,mid+1,end);
        lazy[v]=0;
    }
    if(to<=mid){
        return query(from,to,2*v,start,mid);
    }else if(from>mid){
        return query(from,to,2*v+1,mid+1,end);
    }else{
        return query(from,mid,2*v,start,mid)+query(mid+1,to,2*v+1,mid+1,end);
    }
}

void dfs(int curr){
    s[curr]=++dfs_timer;
    st_val[s[curr]]=b[curr];
    for(int to:ch[curr]){
        dfs(to);
    }
    e[curr]=dfs_timer;
}

int main(){
    scanf("%d",&N);
    for(int i=0;i<N-1;i++){
        int x,y;
        scanf("%d%d",&x,&y);
        ch[x].push_back(y);
    }
    for(int i=1;i<=N;i++){
        scanf("%d",&b[i]);
    }
    dfs(1);
    build();
    scanf("%d",&Q);
    while(Q--){
        int t,x,k;
        scanf("%d%d%d",&t,&x,&k);
        if(t==1){
            update(s[x],e[x]);
        }else{
            printf("%d\n",query(s[x],e[x]));
        }
    }
}