#include <bits/stdc++.h>

using namespace std;

#define pb push_back

struct dot
{
    //int super = 0;
    vector <int> desc[21];
    bool act;
    int precomp[21];
}tree[200001];


int ask (int node, int k)
{
    int pow2 = 1;
    int ct = 0;
    while (pow2 <= k)
    {
        pow2*=2;
        ct++;
    }
    if (pow2!=1)
    {
        ct--;
        pow2/=2;
    }
    else
    {
        return tree[node].precomp[0];
    }
    int sum = tree[node].precomp[ct];
    for (auto next : tree[node].desc[ct])
    {
        sum += (ask(next, k - pow2) - tree[next].precomp[0]);
    }
    return sum;
}

void lift (int node)
{
    tree[node].precomp[0] = tree[node].act;
    for (int i=1; i<19; i++)
    {
        tree[node].precomp[i] = tree[node].precomp[i-1];
        for (auto next : tree[node].desc[i])
        {
            lift(next);
            tree[node].precomp[i] += tree[next].precomp[i-1];
            for (auto mem : tree[next].desc[i])
            {
                tree[node].desc[i+1].pb(mem);
            }
        }
    }
}

int main()
{
    int n;
    cin>>n;
    for (int i=0; i<n-1; i++)
    {
        int a, b;
        cin>>a>>b;
        //tree[b].super = a;
        tree[a].desc[1].pb(b);
    }
    for (int i=1; i<=n; i++)
    {
        int a;
        cin>>a;
        tree[i].act = a;
    }
    lift(1);
    int q;
    cin>>q;
    for (int i=0; i<q; i++)
    {
        int type, node, k;
        cin>>type>>node>>k;
        if (type == 2)
        {
            //cout<<"from "<<l<<" to "<<r<<"\n";
            //print();
            cout<<ask(node, k)<<"\n";
        }
    }
}

