#include <bits/stdc++.h>

#define lf (h << 1)
#define mf ((l + r) >> 1)
#define rf ((h << 1) | 1)
#define tree int h, int l, int r
#define left lf, l, mf
#define right rf, mf + 1, r
#define ll long long
#define pb push_back
#define f first
#define s second

using namespace std;

const int N = 5e5 + 5;

ll ans;
int n, timer, in[N], O[N], out[N], e[N], s[N], d[N];
vector < pair < int , int > > v[N];

inline void dfs(int x) {
	in[x] = ++timer;
	O[timer] = x;
	for (int i = 0; i < v[x].size(); ++i) {
		int to = v[x][i].f, cost = v[x][i].s;
		d[to] = cost + d[x];
		dfs(to);
	}
	out[x] = timer;
}

main () {
	ios::sync_with_stdio(false);
	cin.tie(NULL), cout.tie(NULL);
	
	cin >> n;
	for (int i = 1; i <= n; ++i) cin >> s[i];
	for (int i = 1; i <= n; ++i) cin >> e[i];
	for (int i = 2; i <= n; ++i) {
		int p, c;
		cin >> p >> c;
		v[p].pb({i, c});
	}
	
	dfs(1);
	vector < pair < int , pair < int , int > > > vc;
	for (int i = 1; i <= n; ++i) {
		for (int j = in[i]; j <= out[i]; ++j) {
			int x = O[j];
			vc.pb({d[x] - d[i], {i, x}});
		}
	}
	sort(vc.begin(), vc.end());
	for (int i = vc.size() - 1; i >= 0; --i) {
		int a = vc[i].s.f, b = vc[i].s.s, cost = vc[i].f;
		int tot = min(s[a], e[b]);
		if (cost <= 0) break; 
		if (tot > 0) {
			s[a] -= tot;
			e[b] -= tot;
			ans += 1ll * cost * tot;
		}
	}
	cout << ans << "\n";
}
