#include <bits/stdc++.h> 

using namespace std;

typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<bool> vb;
typedef long long ll;
typedef vector<ll> vll;


vvi graph;
vi e;
vi s;

vll ow;
vll sub;

ll query(ll l, ll r) {
	if (l-1<0) return sub[r];
	return sub[r] - sub[l - 1];
}

int find(int k, int n) {
	int ans = 0;
	for (int i = 0; i < n; i++) {
		int e = ow.size() - 1 - i;
		int s = e - (k-1);
		if (s < 0)break;
		int cur = query(s, e);
		if (cur > 0) ans += cur;
	}
	return ans;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n;
	cin >> n;

	graph.resize(n + 1);
	s.resize(n + 1);
	e.resize(n + 1);
	ow.resize(n-1);
	sub.resize(n-1);

	ll a, b;

	for (int i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> e[i];
	}
	ll ans = 0;
	for (int i = 0; i < n - 1; i++) {
		cin >> a >> b;
		if (b > 0) ans += b;
		ow[i] = b;
	}

	sub[0] = ow[0];
	for (int i = 1; i < ow.size(); i++) {
		sub[i] = sub[i - 1] + ow[i];
	}

	for (int i = 1; i < n; i++) {
		ll curr = find(i, n);
		ans = max(ans, curr);
	}

	cout << ans;


	return 0;
}

