#include <bits/stdc++.h>

using namespace std;

const int N=200010;
vector<int> g[N];
int know[N], tin[N], tout[N], tree[4*N], push[4*N];
int t;

void dfs(int v)
{
    t++;
    tin[v]=t;
    for (int i=0; i<g[v].size(); i++)
    {
        dfs(g[v][i]);
    }
    tout[v]=t;
}

void built_tree(int v, int l, int r)
{
    if (l == r) tree[v]=know[l];
    else
    {
        int med=(l+r)/2;
        built_tree(2*v+1, med+1, r);
        built_tree(2*v, l, med);
        tree[v]=tree[2*v+1]+tree[2*v];
    }
}

bool update(int v, int tl, int tr, int l, int r)
{
    if ((l > tr) || (r < tl)) return 0;
    if ((tr == r) && (tl == l))
    {
        tree[v]= tr-tl+1;
        push[v]=1;
        return 0;
    }
    int med=(tl+tr)/2;
    if (push[v]==1)
    {
        tree[v]= tr-tl+1;
        push[v]=0;
        push[2*v]=1;
        tree[2*v]=med-tl+1;
        push[2*v+1]=1;
        tree[2*v+1]=tr-med;
        return 0;
    }

    if ( r <= med)
    {
        bool flag= update(2*v, tl, med, l, r);
        tree[v]=tree[2*v]+tree[2*v+1];
        return 0;
    }
    if ( l > med)
    {
        bool flag= update(2*v+1, med+1, tr, l, r);
        tree[v]=tree[2*v]+tree[2*v+1];
        return 0;
    }
    bool flag= update(2*v, tl, med, l, med);
    flag= update(2*v+1, med+1, tr, med+1, r);
    tree[v]=tree[2*v]+tree[2*v+1];
    return 0;
}


long long return_ans(int v, int tl, int tr, int l, int r)
{
    //cout << v << " " << tl << " " << tr << " " << l << " " << r << '\n';
    if ((tl==l) && (tr==r)) return tree[v];
    int med=(tl+tr)/2;
    if (push[v]==1)
    {
        tree[v]= tr-tl+1;
        push[v]=0;
        push[2*v]=1;
        tree[2*v]=med-tl+1;
        push[2*v+1]=1;
        tree[2*v+1]=tr-med;
        return r-l+1;
    }
    if (tree[v]==tr-tl+1) return r-l+1;
    if ( r <= med)
    {
        return return_ans(2*v, tl, med, l, r);
    }
    if ( l > med)
    {
        return return_ans(2*v+1, med+1, tr, l, r);
    }
    return return_ans(2*v, tl, med, l, med)+return_ans(2*v+1, med+1, tr, med+1, r);
}


int n, u, v, q, x, k, flag;

int main()
{
    //ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    //cout << (1 << 2) << '\n';
    cin >> n;
    for (int i=1; i<n; i++)
    {
        cin >> u >> v;
        g[u].push_back(v);
    }
    dfs(1);
    for (int i=1; i<=n; i++) cin >> know[tin[i]];
    built_tree(1,1,n);
    cin >> q;
    for (int i=1; i<=q; i++)
    {
        cin >> flag >> x >> k;
        //cout << tin[x] << " " << tout[x] << '\n';
        if (flag==2) cout << return_ans(1, 1, n, tin[x], tout[x])<< '\n';
        else update(1,1,n, tin[x], tout[x]) << '\n';
    }
    return 0;
}
