#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pii pair<int, int>
#define f first
#define s second
#define tiii tuple<int, int, int>

vector<int> depth;
vector<vector<pii>> ed;
vector<int> dist;
vector<int> s;
vector<int> e;
vector<vector<pii>> arr;
vector<set<int>> child;

void dfs(int cur){

    for (auto [to, w] : ed[cur]){
        depth[to] = depth[cur] + 1;
        dist[to] = dist[cur] + w;
        dfs(to);
        child[cur].insert(to);
        child[cur].insert(child[to].begin(), child[to].end());
    }
}

int calc(int cur){
    int n = depth.size() - 1;
    int res = 0;
    for (auto [to, w] : ed[cur]){
        res += calc(to);
    }

    vector<pii> v;
    for (int i = 1; i <= n; ++i){
        if (!child[cur].count(i)) continue;
        v.push_back(make_pair(dist[i] - dist[cur], i));
    }

    sort(v.rbegin(), v.rend());
    int m = v.size();
    for (int i = 0; i < m; ++i){
        if (v[i].f <= 0) break;
        int k = min(s[cur], e[v[i].s]);
        s[cur] -= k;
        e[v[i].s] -= k;


        bool flag = true;
        while (flag){
            sort(arr[v[i].s].rbegin(), arr[v[i].s].rend());
            int a = arr[v[i].s].size();
            flag = false;
            for (int j = a-1; j >= 0; --j){
                if (dist[v[i].s] - dist[arr[v[i].s][j].f] >= v[i].f) break;
                if (s[cur] == 0) break;
                int x = min(s[cur], arr[v[i].s][j].s);
                if (x != 0) flag = true;
                s[cur] -= x;
                s[arr[v[i].s][j].f] += x;
                k += x;
                res -= x * (dist[v[i].s] - dist[arr[v[i].s][j].f]);
                if (x == arr[v[i].s][j].s) arr[v[i].s].pop_back();
                else arr[v[i].s][j].s -= x;
            }

            for (auto [to, w] : ed[cur]){
                res += calc(to);
            }
        }


        res += k * v[i].f;
        arr[v[i].s].push_back(make_pair(cur, k));
    }



    return res;

}

signed main() {

    int n; cin >> n;
    ed.resize(n+1);
    depth.resize(n+1);
    dist.resize(n+1);
    s.resize(n+1);
    e.resize(n+1);
    arr.resize(n+1);
    child.resize(n+1);

    for (int i = 1; i <= n; ++i) cin >> s[i];
    for (int i = 1; i <= n; ++i) cin >> e[i];

    for (int i = 2; i <= n; ++i){
        int p, w; cin >> p >> w;
        ed[p].push_back({i, w});
    }

    dfs(1);
    cout << calc(1) << "\n";


    return 0;
}
