#include <bits/stdc++.h>

using namespace std;

vector<int> t;
vector<bool> lazy;
vector< vector<int> > ed;
vector<int> b;
vector<int> label;
vector<int> edge;
vector<int> mn;
vector<int> mx;
int k = 1;

void build(int v, int tl, int tr){
    if (tl == tr){
        t[v] = b[edge[tl]];
        return;
    }
    int tm = (tl + tr) / 2;
    build(v*2, tl, tm);
    build(v*2+1, tm+1, tr);
    t[v] = t[v*2] + t[v*2+1];
}

void push(int v, int tl, int tr){
    if (!lazy[v]) return;
    lazy[v] = false;
    lazy[v*2] = lazy[v*2+1] = true;
    int tm = (tl + tr) / 2;
    t[v*2] = tm - tl + 1;
    t[v*2+1] = tr - tm;
}

void update(int v, int tl, int tr, int l, int r){
    if (tl == l && tr == r){
        lazy[v] = true;
        t[v] = tr - tl + 1;
        return;
    }

    push(v, tl, tr);

    int tm = (tl + tr) / 2;
    if (l <= tm) update(v*2, tl, tm, l, min(r, tm));
    if (r > tm) update(v*2+1, tm+1, tr, max(l, tm+1), r);

    t[v] = t[v*2] + t[v*2+1];
}

int sum(int v, int tl, int tr, int l, int r){
    if (tl == l && tr == r) return t[v];

    push(v, tl, tr);
    int res = 0;
    int tm = (tl + tr) / 2;
    if (l <= tm) res += sum(v*2, tl, tm, l, min(r, tm));
    if (r > tm) res += sum(v*2+1, tm+1, tr, max(l, tm+1), r);

    return res;
}

void dfs(int v){
    label[v] = k;
    mn[v] = mx[v] = k;
    edge[k++]= v;
    for (auto to : ed[v]){
        dfs(to);
        mn[v] = min(mn[v], mn[to]);
        mx[v] = max(mx[v], mx[to]);
    }

}



int main() {

    int n; cin >> n;
    ed.resize(n+1);
    for (int i = 0; i < n-1; ++i){
        int u, v; cin >> u >> v;
        ed[u].push_back(v);
    }
    b.resize(n+1);
    for (int i = 1; i <= n; ++i) cin >> b[i];

    t.resize(4*n + 5);
    lazy.resize(4*n + 5);
    mn.resize(n+1);
    mx.resize(n+1);
    label.resize(n+1);
    edge.resize(n+1);
    dfs(1);
    build(1, 1, n);

    int q; cin >> q;
    for (int i = 0; i < q; ++i){
        int tp, x, kx; cin >> tp >> x >> kx;
        if (tp == 1) update(1, 1, n, mn[x], mx[x]);
        else cout << sum(1, 1, n, mn[x], mx[x]) << "\n";
    }


    return 0;
}
