#include <iostream>
#include <fstream>
#include <vector>

using namespace std;
const int NMAX = 100000;



int knows[NMAX], father[NMAX];
vector<int> neighs[NMAX];

void setFather(int node, int fth)
{
    father[node] = fth;
    int i, len = neighs[node].size();
    for (i = 0; i < len; i++)
        if (neighs[node][i] != fth)
        setFather(neighs[node][i], node);
}
int getKn(int node, int k, int curr)
{
    if (curr > k)
        return 0;

    int i, len = neighs[node].size(), add = 0;
    if (knows[node] == 1)
        add = 1;
    for (i = 0; i < len; i++)
        if (neighs[node][i] != father[node])
            add += getKn(neighs[node][i], k, curr + 1);
    return add;
}
void upd(int node, int k, int curr)
{
    knows[node] = 1;
    if (curr >= k)
        return;
    int i, len = neighs[node].size();
    for (i = 0; i < len; i++)
        if (neighs[node][i] != father[node])
            upd(neighs[node][i], k, curr + 1);
}



int main()
{
    int n, i, type, x, k, v1, v2, q;
    cin >> n;
    for (i = 0; i < n - 1; i++)
    {
        cin >> v1 >> v2;
        v1--, v2--;
        neighs[v1].push_back(v2);
        neighs[v2].push_back(v1);
    }
    setFather(0, -1);
    for (i = 0; i < n; i++)
        cin >> knows[i];
    cin >> q;
    for (i = 0; i < q; i++)
    {
        cin >> type >> x >> k;
        if (type == 1)
            upd(x - 1, k, 0);
        else
            cout << getKn(x - 1, k, 0) << '\n';
    }
    return 0;
}
