#include <bits/stdc++.h>

using namespace std;
#define int long long
const int maxn = 5e5;
vector<int> g[maxn];
bool know[maxn];

void dfs(int v, int h, int k) {
    if (h > k)return;
    know[v] = true;
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        dfs(to, h + 1, k);
    }
}

int calc(int v, int h, int k) {
    if (h > k)return 0;
    int ans = know[v];
    for (int i = 0; i < g[v].size(); ++i) {
        int to = g[v][i];
        ans += calc(to, h + 1, k);
    }
    return ans;
}

signed main() {
    cin.tie();
    cout.tie();
    ios_base::sync_with_stdio(false);
#ifdef foo
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    for (int l = 0; l < n - 1; ++l) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].push_back(y);
    }
    for (int j = 0; j < n; ++j) {
        int y;
        cin >> y;
        know[j] = y;
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        int x, k;
        cin >> x >> k;
        x--;
        if (type == 1) {
            dfs(x, 0, k);
        } else {
            cout << calc(x, 0, k) << '\n';
        }
    }

}