#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int inf = 3e9;

const int maxn = 5e5 + 50;
int a[maxn], b[maxn];
vector<pii> r[maxn];
int untin[2 * maxn + 10];



int tim = -1;
int tin[maxn], tout[maxn];

int d[maxn];
pair<int, int> t[4 * maxn];

set<pii> gay[maxn];

void build(int v, int tl, int tr) {
	if (tl == tr) {
		if (gay[untin[tl]].size() == 0)
			t[v] = {inf, inf};
		else
			t[v] = {-d[untin[tl]], untin[tl]};
	} else {
		int tm = (tl + tr) / 2;
		build(2 * v, tl, tm);
		build(2 * v + 1, tm + 1, tr);
		t[v] = min(t[2 * v], t[2 * v + 1]);
		// cout << v << ' ' << t
	}
}

pii get(int v, int tl, int tr, int l, int r) {
	if (tr < l || tl > r)
		return {inf, inf};
	if (tl >= l && tr <= r) {
		return t[v];
	} else {
		int tm = (tl + tr) / 2;
		return min(get(2 * v, tl, tm, l, r), get(2 * v + 1, tm + 1, tr, l, r));
	}
}

void update(int v, int tl, int tr, int i, pii x) {
	if (tl == tr) {
		t[v] = x;
	} else {
		int tm = (tl + tr) / 2;
		if (i <= tm)
			update(2 * v, tl, tm, i, x);
		else
			update(2 * v + 1, tm + 1, tr, i, x);
		t[v] = min(t[2 * v + 1], t[2 * v]);
	}
}

void dfs(int v, int p = -1) {
	tin[v] = ++tim;
	untin[tin[v]] = v;
	if (p == -1)
		d[v] = 0;
	for (auto &[u, w] : r[v]) {
		if (u != p) {
			d[u] = d[v] + w;
			dfs(u, v);
		}
	}
	tout[v] = tim;
}

int ans = 0;
int n;

void dfs2(int v, int p = -1) {
	for (auto &[u, w] : r[v]) {
		if (u != p) {
			dfs2(u, v);
		}
	}
	while (a[v] > 0) {
		pii x = get(1, 0, n - 1, tin[v], tout[v]);
		if (-d[v] <= x.f || x.s >= inf) {
			break;
		}
		pii b = *gay[x.s].begin();
		gay[x.s].erase(gay[x.s].begin());
		int take = min(b.s, a[v]);
		a[v] -= take;
		ans += (-d[v] - b.f) * take;
		if (b.s > take) {
			gay[x.s].insert({b.f, b.s - take});
		}
		gay[x.s].insert({-d[v], take});
		update(1, 0, n - 1, tin[x.s], {gay[x.s].begin()->f, x.s});
	}
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	
	for (int i = 1; i < n; ++i) {
		int x, w;
		cin >> x >> w;
		x--;
		r[x].pb({i, w});
	}
	dfs(0);
	for (int i = 0; i < n; ++i) {
		if (b[i])
			gay[i].insert({-d[i], b[i]});
	}
	build(1, 0, n - 1);
	dfs2(0);
	cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
}