#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int inf = 1e18;

const int maxn = 5e5 + 50;
int a[maxn], b[maxn];
vector<pii> r[maxn];


int ans = 0;
int n;

multiset<pii> ms[maxn];
int d[maxn];

int dfs2(int v, int p = -1) {
	if (p == -1)
		d[v] = 0;
	int now = v;
	for (auto &[u, w] : r[v]) {
		if (u != p) {
			d[u] = d[v] + w;
			int x = dfs2(u, v);
			if (ms[x].size() > ms[now].size())
				swap(x, now);
			for (auto &i : ms[x])
				ms[now].insert(i);
		}
	}
	while (a[v] > 0 && ms[now].size()) {
		pii b = *ms[now].begin();
		ms[now].erase(ms[now].begin());
		if (-d[v] <= b.f)
			break;
		int take = min(b.s, a[v]);
		a[v] -= take;
		ans += (-d[v] - b.f) * take;
		if (b.s > take) {
			ms[now].insert({b.f, b.s - take});
		}
		ms[now].insert({-d[v], take});
	}
	if (b[v])
		ms[now].insert({-d[v], b[v]});
	return now;
}

void solve() {
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	
	for (int i = 1; i < n; ++i) {
		int x, w;
		cin >> x >> w;
		x--;
		r[x].pb({i, w});
	}
	dfs2(0);
	cout << ans << endl;
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	solve();
}