#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define int ll
#define f first
#define s second
#define pii pair<int, int>
#define vi vector<int>
#define pb push_back

const int inf = 3e9;
const int maxn = 2e5 + 50;
vi r[maxn];
int b[maxn];
int par[maxn];

void dfs(int v, int p = -1) {
	par[v] = p;
	for (auto &u : r[v]) {
		if (u != p)
			dfs(u, v);
	}
}

void dfs2(int v, int k) {
	b[v] = 1;
	if (k) {
		for (auto &u : r[v]) {
			if (u != par[v])
				dfs2(u, k - 1);
		}
	}
}

int dfs3(int v, int k) {
	int ans = b[v];
	if (k) {
		for (auto &u : r[v]) {
			if (u != par[v])
				ans += dfs3(u, k - 1);
		}
	}
	return ans;
}

void solve() {
	int n, q;
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		r[a].pb(b);
		r[b].pb(a);
	}
	for (int i = 0; i < n; ++i) {
		cin >> b[i];
	}
	dfs(0);
	cin >> q;
	while (q--) {
		int t, v, k;
		cin >> t >> v >> k;
		v--;
		if (t == 1) {
			dfs2(v, k);
		} else {
			cout << dfs3(v, k) << '\n';
		}
	}
}

signed main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	int t = 1;
	while (t--)
		solve();
}