#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000007

using namespace std;

void announce (bool dali) {
    if (dali) cout<<"Win"<<endl;
    else cout<<"Loss"<<endl;
}

int grundy[3001][12301];
int k,n;
int big[10001],small[10001];

int mex (set<int> brojki) {
    int najm = 0;

    while (brojki.count(najm)) { najm++; }

    return najm;
}

int calcGrundy(int b, int s) {
    if (grundy[b][s] != -1) return grundy[b][s];

    set<int> site;

    for (int i = 0; i<=b; i++) {
        for (int j = 0; j<=s; j++) {
            if (i == b && j == s) continue;

            for (int kCtr = k; kCtr<=2; kCtr++) site.insert(calcGrundy(i,j+(b-i)*kCtr));
        }
    }

    return grundy[b][s] = mex(site);
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    MS(grundy,-1);

    int q;
    cin>>k>>q;

    calcGrundy(3000,3000);

    for (int tt = 0; tt<q; tt++) {
        cin>>n;

        for (int i = 0; i<n; i++) cin>>big[i];
        for (int i = 0; i<n; i++) cin>>small[i];

        int res = 0;

        for (int i = 0; i<n; i++) res ^= grundy[big[i]][small[i]];

        announce(res != 0);
    }
}
