#include <bits/stdc++.h>

typedef long long ll;

#define MS(x,y) memset((x), (y), sizeof((x)))
#define pb push_back
#define MN 1000000007

using namespace std;

int n;
vector<int> pat[100001];
int niza[100001];

void dfsTell(int pos, int k) {
    niza[pos] = 1;

    if (k == 0) return;

    for (auto it:pat[pos]) dfsTell(it,k-1);
}

int dfsSum(int pos, int k) {
    int ret = niza[pos];

    if (k == 0) return ret;

    for (auto it:pat[pos]) ret += dfsSum(it,k-1);

    return ret;
}

int main() {
    #ifdef LOCAL_DEBUG
        fstream cin("in.txt");
    #endif

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    for (int i = 0; i<n-1; i++) {
        int a,b;
        cin>>a>>b;

        //a--; b--;

        pat[a].pb(b);
    }

    for (int i = 1; i<=n; i++) cin>>niza[i];

    int q;
    cin>>q;

    for (int i = 0; i<q; i++) {
        int type,x,k;
        cin>>type>>x>>k;

        if (type == 1) dfsTell(x,k);
        else cout<<dfsSum(x,k)<<endl;
    }
}
