#pragma GCC optimize("Ofast")
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define sz(x) (int)x.size()
#include <bits/stdc++.h>
#define ld long dobule
#define ll long long 
#define _ << ' ' << 

using namespace __gnu_pbds;
using namespace std;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int N = 1e4 + 5;

vector < int > g[N];

int b[N], s[N], e[N], h[N], tin[N], tout[N];

int timer = 0;

bool upper(int a, int b) {
	return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

void dfs(int v, int anc, int cur) {
	tin[v] = timer++;
	h[v] = cur; 
	for (auto to : g[v]) {
		if (to != anc) {
			dfs(to, v, cur + 1);
		}
	}
	tout[v] = timer++;
}

int32_t main()
{
	#ifdef LOCAL 
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // LOCAL
	
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	
	int n;
	cin >> n;
	for (int i = 1; i < n; i++) {
		int u, v;
		cin >> u >> v;
		g[u].push_back(v);
		g[v].push_back(u);
	}
	for (int i = 1; i <= n; i++) {
		cin >> b[i];
	}
	
	dfs(1, 0, 0);
	
	int q;
	cin >> q;
	while (q--) {
		int type, x, k;
		cin >> type >> x >> k;
		
		if (type == 1) {
			for (int i = 1; i <= n; i++) {
				if (h[i] >= h[x] && h[i] - h[x] <= k && upper(x, i)) {
					b[i] = 1;
				}
			}
		}
		else {
			int ans = 0;
			for (int i = 1; i <= n; i++) {
				if (h[i] >= h[x] && h[i] - h[x] <= k && upper(x, i)) {
					ans += b[i];
				}
			}
			cout << ans << '\n';
		}
	}
	return 0;
}



