#include <iostream>
#include <algorithm>
#include <set>
using namespace std;
#define pii pair<int, int>
#define pizd pair<long long, pii>

const int N = 2002;
const long long inf = -1e18;

int n;
int s[N], e[N];
pii par[N];
multiset<pizd> m;

void up(int v, int p, long long sum) {
    if (p == 0) return;
    m.insert(pizd(sum, pii(p, v)));
    sum += par[p].second;
    p = par[p].first;
    up(v, p, sum);
}

int main() {
    cin >> n;
    for (int i = 1; i <= n; i++) cin >> s[i];
    for (int i = 1; i <= n; i++) cin >> e[i];
    for (int i = 2; i <= n; i++) {
        int p, w;
        cin >> p >> w;
        par[i] = pii(p, w);
    }
    for (int i = 2; i <= n; i++) {
        up(i, par[i].first, par[i].second);
    }
    long long ans = 0;
    for (auto it = m.rbegin(); it != m.rend(); it++) {
        long long len = (*it).first;
        if (len <= 0) break;
        int l = (*it).second.first, r = (*it).second.second;
        int mn = min(s[l], e[r]);
        if (mn <= 0) continue;
        ans += len * mn;
        s[l] -= mn;
        e[r] -= mn;
    }
    cout << ans << endl;
    return 0;
}