#include <iostream>
#include <vector>
using namespace std;
const int N = 1e4 + 2;

int n, q;
vector<int> g[N];
int p[N];
bool b[N];

void dupd(int v, int k, int i) {
	if (i > k) return;
	b[v] = 1;
	for (int j = 0; j < g[v].size(); j++) {
		dupd(g[v][j], k, i + 1);
	}
}

int dque(int v, int k, int i) {
	if (i > k) return 0;
	int ret = b[v];
	for (int j = 0; j < g[v].size(); j++) {
		ret += dque(g[v][j], k, i + 1);
	}
	return ret;
}

int main() {
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		g[x].push_back(y);
		p[y] = x;
	}
	for (int i = 1; i <= n; i++) {
		cin >> b[i];
	}
	cin >> q;
	for (int i = 0; i < q; i++) {
		int t, x, k;
		cin >> t >> x >> k;
		if (t == 1) {
			dupd(x, k, 0);
		}
		else {
			cout << dque(x, k, 0) << endl;
		}
	}
	return 0;
}
