#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

using namespace std;
typedef long long ll;
#define int long long 

int n, k;
int b[10010];
int s[10010];

inline void solve()
{
    cin >> n;

    bool was = false;
    for (int i = 1; i <= n; ++i)
    {
        cin >> b[i] >> s[i];
        was |= b[i];
    }

    if (was)
    {
        cout << "Win\n";
        return;
    }

    int x = 0;
    for (int i = 1; i <= n; ++i) x ^= s[i] + b[i];
    cout << (x == 0 ? "Loss" : "Win") << '\n';
}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> k >> q;
    while (q--)
    {
        solve();
    }
    return 0;
}