#include <iostream>
#include <vector>
#include <string>
#include <iomanip>
#include <set>
#include <map>
#include <cmath>

using namespace std;
typedef long long ll;
#define int long long 

int n, k;
int b[10010];
int s[10010];
int dp[100][100];

inline void solve()
{
    cin >> n;

    for (int i = 1; i <= n; ++i)
    {
        cin >> b[i] >> s[i];
    }

    if (k == 0)
    {
        int cnt = 0;
        for (int i = 1; i <= n; ++i) cnt ^= b[i];
        int x = 0;
        for (int i = 1; i <= n; ++i) x ^= s[i];

        bool ans;
        if (cnt != 0)
        {
            ans = true;
        }
        else
        {
            ans = x != 0;
        }

        cout << (ans ? "Win" : "Loss") << '\n';
        return;
    }
    else if (k == 1)
    {
        int xa = 0, xb = 0;
        for (int i = 1; i <= n; ++i)
        {
            if (s[i] == 0) xa ^= s[i];
            else if (s[i] >= 10 || dp[b[i]][s[i]] >= 10) xb ^= b[i];
            else xa ^= dp[b[i]][s[i]];
        }

        bool ans;
        if (xb != 0)
        {
            ans = true;
        }
        else
        {
            ans = xa != 0;
        }

        cout << (ans ? "Win" : "Loss") << '\n';
        return;
    }

}

signed main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    int q;
    cin >> k >> q;

    if (k == 1)
    {
        for (int i = 0; i <= 5; ++i)
        {
            for (int j = 0; j < 100; ++j)
            {
                set <int> can;
                for (int k = j - 1; k >= 0; --k)
                {
                    can.insert(dp[i][k]);
                }

                for (int f = i - 1; f >= 0; --f)
                {
                    for (int k = i - f; k < 100; ++k)
                    {
                        can.insert(dp[f][k]);
                    }
                }

                for (int v = 0;; ++v)
                {
                    if (can.count(v)) continue;
                    dp[i][j] = v;
                    break;
                }
            }
        }

        //for (int i = 0; i <= 5; ++i)
        //{
        //    for (int j = 0; j < 50; ++j)
        //    {
        //        cout << dp[i][j] << ' ';
        //    }
        //    cout << '\n';
        //}
    }

    while (q--)
    {
        solve();
    }
    return 0;
}