#include <bits/stdc++.h>
using namespace std;

#define x first
#define y second
#define all(x) begin(x), end(x)
#define sz(x) ((int) (x).size())
using ll = long long;
using ld = long double;

#define int ll

const int N = 5e5 + 10;

int s[N], e[N], p[N];
vector<pair<int, int>> g[N];
map<int, int> costs[N];

int depth[N];
vector<int> anc[N];

void dfs(int u = 0, int d = 0) {
	depth[u] = d;
	if (e[u]) {
		anc[u].push_back(u);
		costs[u] = {{0, e[u]}};
	}
	for (auto [v, w] : g[u]) {
		dfs(v, d + w);
		anc[u].insert(end(anc[u]), all(anc[v]));
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> s[i];
	}
	for (int i = 0; i < n; ++i) {
		cin >> e[i];
	}
	for (int i = 1; i < n; ++i) {
		int w;
		cin >> p[i] >> w;
		g[--p[i]].push_back({i, w});
	}
	dfs();
	ll ans = 0;
	for (int u = n; u--; ) {
		while (s[u]) {
			int bst_to = -1, bst = 0;
			for (int v : anc[u]) {
				int cst = depth[v] - depth[u] - costs[v].begin()->x;
				if (cst > bst) {
					bst_to = v;
					bst = cst;
				}
			}
			// cout << bst_to << " " << bst << endl;
			if (bst <= 0) {
				break;
			}
			int num = min(s[u], costs[bst_to].begin()->y);
			assert(num);
			s[u] -= num;
			ans += bst * ll(num);
			if ((costs[bst_to].begin()->y -= num) == 0) {
				costs[bst_to].erase(costs[bst_to].begin());
			}
			costs[bst_to][depth[bst_to] - depth[u]] += num;
		}
	}
	cout << ans;
}