#include <bits/stdc++.h>
#pragma GCC Optimize("O3")
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef tree<pair<int,int>,null_type,less<pair<int,int> >,rb_tree_tag,tree_order_statistics_node_update> super_set;
#define endl '\n'
#define all(var) var.begin(),var.end()
const int N = 2e5+7;
vector<int> G[N];
int C[N],tin[N],tout[N],in_pos[N],depth[N],timer = 0;
void dfs(int v,int depth = 0){
    tin[v] = ++timer;
    in_pos[timer] = v;
    ::depth[v] = depth;
    for(int to:G[v]) {
        dfs(to,depth+1);
    }
    tout[v] = timer;
}
vector<int> T[N<<1];
int P[N<<1];
vector<int> total[N<<1];
int mod[N<<1];
void buildtree(int t,int tl,int tr){
    if (tl==tr){
        if (C[in_pos[tl]]==1)
            T[t].push_back(depth[in_pos[tl]]);
        total[t].push_back(depth[in_pos[tl]]);
        return;
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    P[nl] = P[nr] = t;
    buildtree(nl,tl,tm);
    buildtree(nr,tm+1,tr);
    merge(all(T[nl]),all(T[nr]),back_inserter(T[t]));
    merge(all(total[nl]),all(total[nr]),back_inserter(total[t]));
}

const int INF = 1e9;
int get(int t,int tl,int tr,int l,int r,int val){
    if (l>tr || tl>r)
        return 0;
    if (l<=tl && tr<=r){
        return (upper_bound(all(T[t]),val)-T[t].begin());
    }
    int tm = (tl+tr)>>1;
    int nl = t+1,nr = t+((tm-tl+1)<<1);
    return get(nl,tl,tm,l,r,val)+get(nr,tm+1,tr,l,r,val);
}
void solve(){
    int n;
    scanf("%d",&n);
    for(int i = 1;i<n;++i){
        int x,y;
        scanf("%d%d",&x,&y);
        G[x].push_back(y);
    }
    for(int i = 1;i<=n;++i){
        scanf("%d",&C[i]);
    }
    dfs(1);
    P[0] = -1;
    buildtree(0,1,n);
    int q;
    scanf("%d",&q);
    set<pair<int,int> > del;
    while(q--){
        int type,x,k;
        scanf("%d%d%d",&type,&x,&k);


        printf("%d\n",get(0,1,n,tin[x],tout[x],depth[x]+k));

    }
}
int main(){
    ios_base::sync_with_stdio(0); cin.tie(0);
    int t = 1;
    while(t--)
        solve();
}