
#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vsi = vector<set<ll>>;

#ifndef DEBUG
#define endl '\n';
#endif

#ifdef DEBUG
template<typename X, typename Y>
ostream& operator<<(ostream& s, const pair<X, Y>& v) {
  s << "{" << v.first << ", " << v.second << "}";

  return s;
}
#endif

template<typename X, typename Y>
istream& operator>>(istream& s, pair<X, Y>& v) {
  s >> v.first >> v.second;

  return s;
}

template<typename T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }

  return s;
}

template<typename T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }

  return s;
}

void solve();

//ll k;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

//  ll t;
//  cin >> k >> t;
//  while (t--)
  solve();
}

// ----

ll n;
vi p;
vsi gr;
vi b;

ll t1_dfs_q(ll v, ll k) {
  ll ans = 0;
  if (b[v] == 1) ++ans;
  if (k == 0) return ans;
  for (auto u: gr[v]) {
    ans += t1_dfs_q(u, k - 1);
  }
  return ans;
}

void t1_dfs_n(ll v, ll k) {
  b[v] = 1;
  if (k == 0) return;
  for (auto u: gr[v]) {
    t1_dfs_n(u, k - 1);
  }
}

void solve() {
  cin >> n;
  p.resize(n, -1);
  gr.resize(n);
  for (int i = 0; i < n - 1; ++i) {
    ll x, y;
    cin >> x >> y;
    --x, --y;
    p[y] = x;
    gr[x].insert(y);
  }

  b.resize(n);
  cin >> b;

  ll q;
  cin >> q;

  vii st;
  st.reserve(n);

  for (int qq = 0; qq < q; ++qq) {
    ll t, x, k;
    cin >> t >> x >> k;
    --x;

    st.clear();
    st.push_back({x, k});

    if (t == 1) {
      while (not st.empty()) {
        auto[v, s] = st.back();
        st.pop_back();
        b[v] = 1;
        if (s > 0) {
          for (auto u: gr[v]) {
            st.push_back({u, s - 1});
          }
        }
      }
    } else {
      ll ans = 0;
      while (not st.empty()) {
        auto[v, s] = st.back();
        st.pop_back();
        ans += b[v];
        if (s > 0) {
          for (auto u: gr[v]) {
            st.push_back({u, s - 1});
          }
        }
      }
      cout << ans << endl;
    }
  }
}
