
#ifdef DEBUG
#define _GLIBCXX_DEBUG
#endif

#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using vi = vector<ll>;
using vvi = vector<vi>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vsi = vector<set<ll>>;

#ifndef DEBUG
#define endl '\n';
#endif

#ifdef DEBUG
template<typename X, typename Y>
ostream& operator<<(ostream& s, const pair<X, Y>& v) {
  s << "{" << v.first << ", " << v.second << "}";

  return s;
}
#endif

template<typename X, typename Y>
istream& operator>>(istream& s, pair<X, Y>& v) {
  s >> v.first >> v.second;

  return s;
}

template<typename T>
istream& operator>>(istream& s, vector<T>& v) {
  for (int i = 0; i < v.size(); ++i) {
    s >> v[i];
  }

  return s;
}

template<typename T>
ostream& operator<<(ostream& s, const vector<T>& v) {
  for (auto e: v) {
    s << e << ' ';
  }

  return s;
}

void solve();

//ll k;

int main() {
  ios_base::sync_with_stdio(false);
  cout.tie(nullptr);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

//  ll t;
//  cin >> k >> t;
//  while (t--)
  solve();
}

// ----

ll n;

ll sn;

vi p;
vsi gr;
vi b;

namespace v2 {

vi s_b;
vi s_cnt;
vi s_sz;
vi s_p;
vvi s_list;

void precalc_list(ll v, ll k, ll orig) {
  if (k == 0) {
    s_list[orig].push_back(v);
    s_p[v] = orig;
    return;
  }
  s_cnt[orig] += b[v];
  s_sz[orig]++;
  for (auto u: gr[v]) {
    precalc_list(u, k - 1, orig);
  }
}

void precalc_list() {
  for (int i = 0; i < n; ++i) {
    precalc_list(i, sn, i);
  }
}

}

void solve() {
  cin >> n;
  sn = (ll) sqrt(n);
  p.resize(n, -1);
  gr.resize(n);
  for (int i = 0; i < n - 1; ++i) {
    ll x, y;
    cin >> x >> y;
    --x, --y;
    p[y] = x;
    gr[x].insert(y);
  }

  b.resize(n);
  cin >> b;

  ll q;
  cin >> q;

  vii st;
  st.reserve(n);

  v2::s_cnt.resize(n);
  v2::s_b.resize(n);
  v2::s_list.resize(n);
  v2::s_sz.resize(n);
  v2::s_p.resize(n);

  v2::precalc_list();

  for (int qq = 0; qq < q; ++qq) {
    ll t, x, k;
    cin >> t >> x >> k;
    --x;

    st.clear();
    st.push_back({x, k});

    if (n <= 10'000 and false) {
      if (t == 1) {
        while (not st.empty()) {
          auto[v, s] = st.back();
          st.pop_back();
          b[v] = 1;
          if (s > 0) {
            for (auto u: gr[v]) {
              st.push_back({u, s - 1});
            }
          }
        }
      } else {
        ll ans = 0;
        while (not st.empty()) {
          auto[v, s] = st.back();
          st.pop_back();
          ans += b[v];
          if (s > 0) {
            for (auto u: gr[v]) {
              st.push_back({u, s - 1});
            }
          }
        }
        cout << ans << endl;
      }
    } else {
      if (t == 1) {
        while (not st.empty()) {
          auto[v, s] = st.back();
          st.pop_back();
          if (b[v] == 0) {
            b[v] = 1;
            ll u = v;
            for (int i = 0; i < sn and u != -1; ++i) {
              v2::s_cnt[u]++;
              u = p[u];
            }
          }
          if (s > 0) {
            for (auto u: gr[v]) {
              st.push_back({u, s - 1});
            }
          }
        }

//        v2::s_cnt.clear();
//        v2::s_cnt.resize(n);
//        v2::s_b.clear();
//        v2::s_b.resize(n);
//        v2::s_list.clear();
//        v2::s_list.resize(n);
//        v2::s_sz.clear();
//        v2::s_sz.resize(n);
//        v2::s_p.clear();
//        v2::s_p.resize(n);
//
//        v2::precalc_list();
      } else {
        ll ans = 0;
        while (not st.empty()) {
          auto[v, s] = st.back();
          st.pop_back();

          if (s < sn - 1) {
            ans += b[v];
            if (s > 0) {
              for (auto u: gr[v]) {
                st.push_back({u, s - 1});
              }
            }
          } else if (s == sn - 1) {
//            if (v2::s_b[v]) ans += v2::s_sz[v];
            ans += v2::s_cnt[v];
          } else {
            ans += v2::s_cnt[v];
            for (auto u: v2::s_list[v]) {
              st.push_back({u, s - (sn - 1) - 1});
            }
          }
        }
        cout << ans << endl;
      }
    }
  }
}
