#include <iostream>
#include <vector>
#include <set>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}

const int N = 1e4 + 100, INF = 1e18;

int k, q, n, b[N], s[N];

void solve() {
    cin >> k >> q;
    while (q--) {
        cin >> n;
        for (int i = 0; i < n; i++) {
            cin >> b[i] >> s[i];
        }
        int xr = 0, sum = 0;
        for (int i = 0; i < n; i++) {
            xr ^= s[i];
            sum += b[i];
        }
        if (sum > 0) {
            if (sum % 2 == 0) {
                cout << "Loss\n";
            } else {
                cout << "Win\n";
            }
        } else {
            if (xr == 0) {
                cout << "Loss\n";
            } else {
                cout << "Win\n";
            }
        }

    }
}