#include <iostream>
#include <vector>
#include <set>

using namespace std;

void solve();

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}

#define int long long

const int N = 5e5 + 100, INF = 1e18;

int n, s[N], c[N], d[N], ans, ps[N];
vector<pair<int, int>> a[N];
multiset<pair<int, int>> se[N];

void dfs(int v, int p) {
    int mx = -INF, pos = -INF;
    for (auto to : a[v]) {
        if (to.first == p) continue;
        d[to.first] = d[v] + to.second;
        dfs(to.first, v);
        if (se[ps[to.first]].size() > mx) {
            mx = se[ps[to.first]].size();
            pos = to.first;
        }
    }
    if (pos != -INF) {
        ps[v] = ps[pos];
        for (auto to : a[v]) {
            if (to.first == p) continue;
            if (to.first != pos) {
                for (pair<int, int> x : se[ps[to.first]]) {
                    se[ps[v]].insert(x);
                }
            }
        }
    } else {
        ps[v] = v;
    }
    int ss = s[v];
    while (!se[ps[v]].empty() && s[v] > 0) {
        pair<int, int> z = (*se[ps[v]].begin());
        if (-z.first - d[v] < 0) break;
        se[ps[v]].erase(se[ps[v]].begin());
        if (s[v] >= z.second) {
            s[v] -= z.second;
            ans += (-z.first - d[v]) * z.second;
        } else {
            ans += (-z.first - d[v]) * s[v];
            z.second -= s[v];
            se[ps[v]].insert(z);
            s[v] = 0;
        }
    }
    se[ps[v]].insert({-d[v], c[v] + ss - s[v]});
}

void solve() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int i = 0; i < n; i++) {
        cin >> c[i];
    }
    for (int i = 1; i < n; i++) {
        int p, w;
        cin >> p >> w;
        p--;
        a[p].push_back({i, w});
    }
    dfs(0, 0);
    cout << ans;
}