#include <iostream>
#include <vector>
#include <queue>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 5e5 + 1;
const int ROOT = 1;

int N, s[NMAX], e[NMAX];
int w[NMAX];

vector < int > G[NMAX];

auto cmp = [] (PII A, PII B)
{
    if(!(A.first > B.first))
        return 1;

    return 0;
};
priority_queue < PII, vector < PII >, decltype(cmp) > H(cmp);

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> s[i];
    for(int i = 1; i <= N; ++i)
        cin >> e[i];

    for(int i = 2; i <= N; ++i)
    {
        int p = 0;
        cin >> p;

        G[p].push_back(i);

        cin >> w[i];
    }

    return;
}

int sp[NMAX];
bool Sel[NMAX];

static inline void Solve ()
{
    for(int i = 2; i <= N; ++i)
        sp[i] = sp[i - 1] + w[i], H.push({sp[i], i});

    long long ans = 0;
    long long scad = 0;

    for(int i = 1; i < N; ++i)
    {
        while(!H.empty() && Sel[H.top().second])
            H.pop();

        if(H.empty())
            break;

        int pos = H.top().second;
        Sel[pos] = 1;

        int Val = H.top().first - scad;
        H.pop();

        if(Val > 0)
            ans += 1LL * Val;

        scad += 1LL * w[i + 1];
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
