#include <iostream>
#include <vector>
#include <queue>

using namespace std;

typedef pair < int, int > PII;

const int NMAX = 5e5 + 1;
const int ROOT = 1;

int N, s[NMAX], e[NMAX];
int w[NMAX];
vector < int > G[NMAX];

auto cmp1 = [] (PII A, PII B)
{
    if(!(A.first > B.first))
        return 1;

    return 0;
};
priority_queue < PII, vector < PII >, decltype(cmp1) > H_M(cmp1);

auto cmp2 = [] (PII A, PII B)
{
    if(!(A.first < B.first))
        return 1;

    return 0;
};
priority_queue < PII, vector < PII >, decltype(cmp2) > H_m(cmp2);

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i <= N; ++i)
        cin >> s[i];
    for(int i = 1; i <= N; ++i)
        cin >> e[i];

    for(int i = 2; i <= N; ++i)
    {
        int p = 0;
        cin >> p;

        G[p].push_back(i);

        cin >> w[i];
    }

    return;
}

int sp[NMAX];

static inline void Solve ()
{
    H_M.push({0, 1});
    H_m.push({0, 1});

    for(int i = 2; i <= N; ++i)
        sp[i] = sp[i - 1] + w[i], H_M.push({sp[i], i}), H_m.push({sp[i - 1], i});

    long long ans = 0;

    while(!H_M.empty() && !H_m.empty())
    {
        while(!H_M.empty() && e[H_M.top().second] <= 0)
            H_M.pop();

        if(H_M.empty())
            break;

        while(!H_m.empty() && s[H_m.top().second] <= 0)
            H_m.pop();

        if(H_m.empty())
            break;

        ans += 1LL * (H_M.top().first - H_m.top().first);
        --e[H_M.top().second], H_M.pop();
        --s[H_m.top().second], H_m.pop();
    }

    cout << ans << '\n';

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
