#include <iostream>
#include <vector>

using namespace std;

const int NMAX = 2e5 + 1;

int N;
bool b[NMAX];
vector < int > G[NMAX];

int Q;

static inline void Read ()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);

    cin >> N;

    for(int i = 1; i < N; ++i)
    {
        int x = 0, y = 0;
        cin >> x >> y;

        G[x].push_back(y);
    }

    for(int i = 1; i <= N; ++i)
        cin >> b[i];

    return;
}

static inline void Go (int Node, int Rem)
{
    if(Rem < 0)
        return;

    b[Node] = 1;

    for(auto it : G[Node])
        Go(it, Rem - 1);

    return;
}

int CNT = 0;

static inline void Query (int Node, int Rem)
{
    if(Rem < 0)
        return;

    CNT += b[Node];

    for(auto it : G[Node])
        Query(it, Rem - 1);

    return;
}

static inline void TestCase ()
{
    int type = 0, x = 0, k = 0;
    cin >> type >> x >> k;

    if(type == 1)
        Go(x, k);
    else
    {
        CNT = 0;

        Query(x, k);

        cout << CNT << '\n';
    }

    return;
}

static inline void Solve ()
{
    cin >> Q;

    while(Q--)
        TestCase();

    return;
}

int main()
{
    Read();

    Solve();

    return 0;
}
