#include <bits/stdc++.h>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;

const int NMAX = 1000001;
const int nr_of_bits = 21;
const int MOD = 1000000007;
const ll INF = (1LL << 55);

struct edge
{
    ll from, to, cap, cost;
} edges[NMAX * 2 + 10];

ll distt[NMAX], distn[NMAX], dist[NMAX], viz[NMAX], last[NMAX], s[NMAX], e[NMAX];

int main()
{
//    ifstream cin(".in");
//    ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i, n;
    cin >> n;
    for(i = 1; i <= n; i++)
    {
        cin >> s[i];
    }
    for(i = 1; i <= n; i++)
    {
        cin >> e[i];
    }
    for(int i = 2; i <= n; i++)
    {
        int a, b;
        cin >> a >> b;
        dist[i] = dist[i - 1] + b;
    }
    priority_queue <pii> pq;
    ll sol = 0;
    for(i = 1; i <= n; i++)
    {
        while(e[i] > 0 && pq.size())
        {
            ll best = -pq.top().first;
            ll ini = pq.top().second;
            ll ap = min(1LL * pq.top().second, e[i]);
            if(dist[i] - best > 0)
            {
                pq.pop();
                sol += (dist[i] - best) * ap;
                pq.push({-dist[i], ap});
                e[i] -= ap;
                if(ini - ap > 0){
                    pq.push({best, ini - ap});
                }
            }else{
                break;
            }
        }
        pq.push({-dist[i], s[i] + e[i]});
    }
    cout << sol;
    return 0;
}
