#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse", "sse2", "avx")

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree <int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered;

const ll NMAX = 200001;
const ll nr_of_bits = 21;
const ll MOD = 1000000007;
const ll INF = (1LL << 59);

int n, lvl[NMAX], stamp, sz[NMAX];
pii timp[NMAX];

ordered st[NMAX];

vector <int> v[NMAX], qq[NMAX];
int maxim[NMAX], viz[NMAX];
int eh[NMAX];
int cod[NMAX];

void DFS(int node, int p)
{
    for(auto x : v[node])
    {
        if(x == p)
            continue;
        DFS(x, node);

    }
    cod[node] = node;
    if(maxim[node] != 0)
    {
        cod[node] = cod[maxim[node]];
    }
    if(viz[node])
    {
        st[cod[node]].insert(lvl[node]);
    }
    for(auto x : v[node])
    {
        if(x == p || x == maxim[node])
            continue;
        for(auto y : st[cod[x]])
        {
            st[cod[node]].insert(y);
        }
    }
    for(auto x : qq[node])
    {
        debugs(x);
        debug(eh[x] + 1);
        eh[x] = st[cod[node]].order_of_key(eh[x] + 1);
    }
}

void DFS1(int node, int p)
{
    lvl[node] = lvl[p] + 1;
    for(auto x : v[node])
    {
        if(x == p)
            continue;
        DFS1(x, node);
        sz[node] += sz[x];
        if(maxim[node] == 0 || sz[x] > sz[maxim[node]])
            maxim[node] = x;
    }
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    cin >> n;
    for(i = 1; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    lvl[1] = 1;
    DFS1(1, 0);
    for(i = 1; i <= n; i++)
    {
        int x;
        cin >> x;
        if(x)
            viz[i] = 1;
    }
    int q;
    cin >> q;
    for(i = 1; i <= q; i++)
    {
        int a, b, k;
        cin >> a >> b >> k;
        qq[b].push_back(i);
        eh[i] = lvl[b] + k;
    }
    DFS(1, 0);
    for(i = 1; i <= q; i++)
    {
        cout << eh[i] << "\n";
    }
    return 0;
}
