#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define debug(x) cerr << #x << " " << x << "\n"
#define debugs(x) cerr << #x << " " << x << " "
#pragma GCC optimize("Ofast", "unroll-loops")
#pragma GCC target("sse", "sse2", "avx")

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair <int, int> pii;
typedef tree <int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update> ordered;

const ll NMAX = 200001;
const ll nr_of_bits = 21;
const ll MOD = 1000000007;
const ll INF = (1LL << 59);

int n, lvl[NMAX], stamp, sz[NMAX];
pii timp[NMAX];

class AINT{
public:
    int lazy[NMAX * 4], aint[NMAX * 4];
    void propaga(int node, int st, int dr){
        if(!lazy[node])
            return;
        if(st != dr){
            lazy[node * 2] = lazy[node];
            lazy[node * 2 + 1] = lazy[node];
        }
        aint[node] = (dr - st + 1);
        lazy[node] = 0;
    }
    void update(int node, int st, int dr, int a, int b){
        propaga(node, st, dr);
        if(a <= st && dr <= b){
            lazy[node] = 1;
            return;
        }
        int mid = (st + dr) / 2;
        if(a <= mid){
            update(node * 2, st, mid, a, b);
        }
        if(b > mid){
            update(node * 2 + 1, mid + 1, dr, a, b);
        }
        propaga(node * 2, st, mid);
        propaga(node * 2 + 1, mid + 1, dr);
        aint[node] = aint[node * 2] + aint[node * 2 + 1];
    }
    int query(int node, int st, int dr, int a, int b){
        propaga(node, st, dr);
        if(a <= st && dr <= b)
            return aint[node];
        int mid = (st + dr) / 2;
        int s = 0;
        if(a <= mid)
            s += query(node * 2, st, mid, a, b);
        if(b > mid)
            s += query(node * 2 + 1, mid + 1, dr, a, b);
        return s;
    }
}st;

vector <int> v[NMAX];

void DFS(int node, int p){
    timp[node].first = ++stamp;
    for(auto x : v[node]){
        if(x == p)
            continue;
        DFS(x, node);
    }
    timp[node].second = stamp;
}

int main()
{
//    ifstream cin(".in");
//    ofstream cout(".out");
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int i;
    cin >> n;
    for(i = 1; i < n; i++){
        int x, y;
        cin >> x >> y;
        v[x].push_back(y);
        v[y].push_back(x);
    }
    DFS(1, 0);
    for(i = 1; i <= n; i++){
        int x;
        cin >> x;
        if(x)
        st.update(1, 1, n, timp[i].first, timp[i].first);
    }
    int q;
    cin >> q;
    while(q--){
        int a, x, k;
        cin >> a >>  x >> k;
        if(a == 1){
            st.update(1, 1, n, timp[x].first, timp[x].second);
        }else{
            cout << st.query(1, 1, n, timp[x].first, timp[x].second) << "\n";
        }
    }
    return 0;
}
