#include <cstdio>
#include <utility>
#include <vector>

const int N = 500000;
int n, up[N], s[N], e[N], ord[N], in[N];
std::vector<std::pair<int, int> > g[N];
long long ans = 0;

void dfs(int v)
{
    static int dt = 0;
    ord[dt] = v;
    in[v] = dt++;
    for (int i = 0; i < (int)g[v].size(); ++i) {
        up[g[v][i].first] = up[v] + g[v][i].second;
        dfs(g[v][i].first);
    }
    e[v] += s[v];
    bool any = 0;
    do {
        any = false;
        int mx = up[v], id;
        for (int i = in[v]; i < dt - 1; ++i) if (e[ord[i]] && up[ord[i]] > mx) {
            mx = up[ord[i]];
            id = ord[i];
        }
        if (mx > up[v]) {
            any = 1;
            int amt = std::min(s[v], e[id]);
            s[v] -= amt;
            e[id] -= amt;
            ans += (long long)amt * (mx - up[v]);
        }
    } while (any && s[v]);
}

int main()
{
    scanf("%d", &n);
    for (int i = 0; i < n; ++i) scanf("%d", s + i);
    for (int i = 0; i < n; ++i) scanf("%d", e + i);
    for (int i = 1; i < n; ++i) {
        int p, w;
        scanf("%d%d", &p, &w);
        g[p - 1].push_back(std::make_pair(i, w));
    }
    dfs(0);
    printf("%lld\n", ans);
    return 0;
}
/*
5
5 1 0 0 0
100 1 1 2 4
1 6
1 1
2 2
2 -1
*/
