#include<bits/stdc++.h>
#define fi first
#define se second
#define pb push_back
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
typedef long long ll;
typedef long double ld;

using namespace std;
const int N = (int)2e5 + 1;

vector < int > g[N];
int used[N], tin[N], tout[N], h[N], T, pred[N];


vector < pair < int , int > > lst[N];
void dfs(int v , int p, int lvl){
    tin[v] = T++;
    h[v] = lvl;
    pred[v] = p;
    for(auto &u : g[v]){
        if(u != p){
            dfs(u , v, lvl + 1);
        }
    }
    lst[h[v]].push_back({tin[v] , v});
    tout[v] = T - 1;
}
const int buben = 470;
int alr[N];
int b[N];
int mx[N];


int add[N];
void dfs1(int v , int p, int cur){
    if(mx[v] != -1){
        add[h[v]]++;
        add[h[v]+mx[v]+1]--;
    }
    cur += add[h[v]];
    if(cur > 0 || b[v] > 0){
        alr[v] = 1;
    }
    for(auto &u : g[v]){
        if(u != p){
            dfs1(u , v , cur);
        }
    }
    if(mx[v] != -1){
        add[h[v]]--;
        add[h[v]+mx[v]+1]++;
    }
}

int sz[N];


bool anc(int u , int v){
    return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}
bool check(int v , int k , int u){
    if(h[u] >= h[v] && h[u] <= h[v] + k && anc(v , u)){
        return true;
    }
    return false;
}

int sumblock[N], gt[N];
void adD(int l , int r, int pl){
    while(l <= r){
        if(l % buben == 0 && l + buben - 1 <= r){
            sumblock[l / buben]+=pl;
            l += buben;
        }else{
            gt[l] += pl;
            l++;
        }
    }
}
int get_in_dot(int v){
    if(sumblock[v / buben]){
        return 1;
    }
    if(gt[v] > 0)
        return 1;
    return 0;
}
vector < int > now;
vector < int > pref[N];
int ptr[N];
vector < pair < int , int > >  ADD[N];
vector < pair < int , int > > DEL[N];
int H;
int LVL;
void dfs3(){
    for(int lvl = 0; lvl <= LVL + 1; ++lvl){
        for(auto &u : ADD[lvl]){
            adD(u.fi , u.se , + 1);
        }
        for(auto &u : DEL[lvl]){
            adD(u.fi , u.se , - 1);
        }
        for(auto &x : lst[lvl]){
            if(!alr[x.se] && get_in_dot(x.fi)){
                now.pb(x.se);
            }
        }
    }

}
void doit(int v , int p, int lvl){
    sz[v] = alr[v];
    for(auto u : g[v]){
        if(u != p){
            doit(u , v, lvl + 1);
            sz[v] += sz[u];
        }
    }
    pref[lvl][ptr[lvl]] = (ptr[lvl] == 0 ? 0 : pref[lvl][ptr[lvl]-1]) + sz[v];
    ptr[lvl]++;
}
void doit1(){
    fill(ptr , ptr + N , 0);
    doit(0 , -1 , 0);
}
int sum(int lvl , int l , int r){
    if(lvl >= N || pref[lvl].empty())
        return 0;
    int id = lower_bound(all(lst[lvl]), make_pair(l , -1)) - lst[lvl].begin();
    int idr = lower_bound(all(lst[lvl]) , make_pair(r + 1,  - 1)) - lst[lvl].begin() - 1;
    if(id <= idr){
        return pref[lvl][idr] - (id == 0 ? 0 : pref[lvl][id - 1]);
    }else
        return 0;
}
int answer(int v, int k){
    return sum(h[v], tin[v] , tout[v]) - sum(h[v] + k + 1 , tin[v] , tout[v]);
}
mt19937 rng(time(NULL));
signed main(){
    ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0);

    bool debug = 0;
    int n;

    if(!debug){
        cin >> n;

    }else
        n = N-1;
    for(int i = 0 ; i < n - 1; ++i){
        int u , v;
        if(!debug){
        cin >> u >> v;
        }else{
            u = 1 , v = n;
        }
        --u , --v;
        g[u].pb(v);
        g[v].pb(u);
    }


    for(int i = 0 ; i < n; ++i){
        if(!debug)
        cin >> b[i];
        else
            b[i] = rng() % 2;
    }
    dfs(0 , -1, 0);

    for(int i = 0; i < n; ++i)
        LVL = max(h[i] , LVL);

    for(int i = 0; i < n; ++i){
        pref[i].resize(sz(lst[i]));
    }
    int q;
    if(!debug){
    cin >> q;
    }else{
        q = N - 1;
    }
    vector < array < int ,3 > > que(q);
    for(auto &i : que){
        if(!debug){
        cin >> i[0] >> i[1] >> i[2];
        }else{
            i[0] = rng() % 2;
            i[1] = rng() % n + 1;
            i[2] = rng() % n;
        }
        i[1]--;
    }
    fill(mx , mx + N , -1);
    vector < int > ans(q);
    for(int idb = 0; idb * buben < q; ++idb){
        int l = idb * buben , r = (idb + 1) * buben - 1;
        r = min(r , q - 1);
        now.clear();

        for(int i = l; i <= r; ++i){
            if(que[i][0] == 1){
                int v = que[i][1];
                ADD[h[v]].push_back({tin[v], tout[v]});
                if(h[v] + que[i][2] + 1 <= LVL)
                DEL[h[v] + que[i][2] + 1].push_back({tin[v], tout[v]});
            }
        }

        dfs1(0 , -1 , 0);


        doit1();
        dfs3();





        for(auto &x : now){
            bool have = 0;
            for(int i = l; i <= r; ++i){
                if(que[i][0] == 1){
                    if(check(que[i][1], que[i][2], x)){
                        have = 1;
                    }
                }else{
                    if(check(que[i][1], que[i][2] , x))
                        ans[i] += have;
                }
            }
        }
        for(int i = l; i <= r; ++i){
            if(que[i][0] == 2){
                ans[i] += answer(que[i][1] , que[i][2]);
            }
        }

        for(int i = l; i <= r; ++i){
            if(que[i][0] == 1){
                int v = que[i][1];
                ADD[h[v]].clear();
                DEL[h[v] + que[i][2] + 1].clear();
            }
        }
        fill(gt , gt + N , 0);
        for(int f = 0; f < N/ buben + 1; ++f)
            sumblock[f] = 0;

        for(int i = l; i <= r; ++i){
            if(que[i][0] == 1){
                mx[que[i][1]] = max(mx[que[i][1]] , que[i][2]);
            }
        }

    }
    for(int i = 0 ; i < q; ++i){
        if(que[i][0] == 2){
            cout << ans[i] << '\n';
        }
    }

    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
9
2 1 100000
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

*/
