#include <bits/stdc++.h>
#define N 2500
#define PB push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pri(x) cout << x << endl
#define endl '\n'
#define _ << " " <<

using namespace std;

typedef long long ll;
typedef short int si;
typedef long double ld;

vector <int> cur;

vector <pair <int, int> > g[N];

ll h[N], s[N], e[N];

vector <pair <int, pair <int, int> > > vr;

void dfs(int v, ll s)
{
    h[v] = s;

    for (auto it : cur)
        vr.PB({s - h[it], {it, v}});

    cur.PB(v);

    for (auto it : g[v])
    {
        dfs(it.F, s + it.S);
    }

    cur.pop_back();
}

bool cmp(pair <int, pair <int, int> > a, pair <int, pair <int, int> > b)
{
    if (a.F != b.F)
        return a.F > b.F;

    if (a.S.F != b.S.F)
        return a.S.F > b.S.F;

    return a.S.S < b.S.S;
}

int main()
{
    ios_base::sync_with_stdio(0); istream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n;

    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> s[i];

    for (int i = 1; i <= n; i++)
        cin >> e[i];

    for (int i = 2; i <= n; i++)
    {
        int p, w;

        cin >> p >> w;

        g[p].PB({i, w});
    }

    dfs(1, 0);

    ll ans = 0;

    sort(all(vr), cmp);

    for (auto it : vr)
    {
        if (it.F <= 0)
            break;

        int sk = min(s[it.S.F], e[it.S.S]);

        s[it.S.F] -= sk;
        e[it.S.S] -= sk;

        ans += 1ll * sk * it.F;
    }

    pri(ans);
}
