#include <bits/stdc++.h>
#define N 200500
#define PB push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
#define sz(x) int(x.size())
#define pri(x) cout << x << endl
#define endl '\n'
#define _ << " " <<

using namespace std;

typedef long long ll;
typedef short int si;
typedef long double ld;

int t[N * 4], psh[N * 4];

int in[N], out[N];

vector <int> cur, g[N];

void push(int v, int tl, int tr)
{
    if (psh[v] == 0)
        return;

    if (t[v] != tr - tl + 1)
    {
        t[v] = tr - tl + 1;

        if (tl != tr)
        {
            psh[v + v] = psh[v];

            psh[v + v + 1] = psh[v];
        }
    }

    psh[v] = 0;
}

void upd(int v, int tl, int tr, int l, int r)
{
    push(v, tl, tr);

    if (tr < l || r < tl)
        return;

    if (l <= tl && tr <= r)
    {
        psh[v] = 1;

        push(v, tl, tr);

        return;
    }

    int md = (tl + tr) >> 1;

    upd(v + v, tl, md, l, r);

    upd(v + v + 1, md + 1, tr, l, r);

    t[v] = t[v + v] + t[v + v + 1];
}

int get(int v, int tl, int tr, int l, int r)
{
    push(v, tl, tr);

    if (tr < l || r < tl)
        return 0;

    if (l <= tl && tr <= r)
        return t[v];

    int md = (tl + tr) >> 1;

    return get(v + v, tl, md, l, r) + get(v + v + 1, md + 1, tr, l, r);
}

void dfs(int v)
{
    in[v] = sz(cur);

    cur.PB(v);

    for (auto it : g[v])
    {
        dfs(it);
    }

    out[v] = sz(cur) - 1;
}

int main()
{
    ios_base::sync_with_stdio(0); istream::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    int n;

    cin >> n;

    for (int i = 2; i <= n; i++)
    {
        int x, y;

        cin >> x >> y;

        g[x].PB(y);
    }

    dfs(1);

    for (int i = 1; i <= n; i++)
    {
        int x;

        cin >> x;

        if (x == 1)
            upd(1, 0, n - 1, in[i], in[i]);
    }

    int q;

    cin >> q;

    while (q--)
    {
        int t, x, k;

        cin >> t >> x >> k;

        if (t == 1)
        {
            upd(1, 0, n - 1, in[x], out[x]);
        }
        else
        {
            pri(get(1, 0, n - 1, in[x], out[x]));
        }
    }
}
