#include<bits/stdc++.h>
using namespace std;
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<pair<int, int>, null_type, less<pair<int, int> >, rb_tree_tag, tree_order_statistics_node_update> oset;
#define ll long long
#define fir first
#define sec second
#define mp make_pair
#define pb push_back
#define sz size
#define en "\n"
int a[300000], n, q;
vector<vector<int> > g(300000);
vector<vector<pair<int, int> > > query(300000);
int ans[300000];
vector<oset> x(300000);
int pr[300000], s[300000];
int f(int a)
{
    if (a == pr[a])
        return a;
    return pr[a] = f(pr[a]);
}
void union_sets(int a, int b)
{
    a = f(a);
    b = f(b);
    if (a != b)
    {
        if (s[a] < s[b])
            swap(a, b);
        while (x[b].sz() > 0)
        {
            oset::iterator it = x[b].begin();
            x[a].insert(*it);
            x[b].erase(it);
        }
        pr[b] = a;
    }
    return;
}
void dfs(int v, int par, int dst)
{
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != par)
            dfs(g[v][i], v, dst+1);
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != par)
            union_sets(v, g[v][i]);
    for (int i = 0; i < query[v].sz(); i++)
    {
        int t = f(v);
        int p = query[v][i].fir;
        int dt = query[v][i].sec;
        int l = dst, r = dst+dt;
        if (x[t].lower_bound(mp(l, -1)) != x[t].end())
        {
            if (x[t].lower_bound(mp(r, 1e9)) != x[t].end())
            {

                int p1 = x[t].order_of_key(*(x[t].lower_bound(mp(l, -1))));
                oset::iterator it = x[t].lower_bound(mp(r, 1e9));
                it--;
                int p2 = x[t].order_of_key(*it);
                ans[p] = max(0, p2-p1+1);
            }
            else
            {
                int p1 = x[t].order_of_key(*(x[t].lower_bound(mp(l, -1))));
                oset::iterator it = x[t].end();
                it--;
                int p2 = x[t].order_of_key(*it);
                ans[p] = max(0, p2-p1+1);
            }
        }
    }
}
void solve2()
{
    dfs(0, 0, 0);
    for (int i = 0; i < q; i++)
        cout << ans[i] << ' ';
    cout << en;
}
int dx[300000];
void dfs0(int v, int par, int dst)
{
    dx[v] = dst;
    for (int i = 0; i < g[v].sz(); i++)
        if (g[v][i] != par)
            dfs0(g[v][i], v, dst+1);
    return;
}
int main()
{
    ios::sync_with_stdio(0);
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }
    for (int i = 0; i < n; i++)
        cin >> a[i];
    cin >> q;
    bool ok = true;
    for (int i = 0; i < q; i++)
    {
        pair<pair<int, int>, int> t;
        cin >> t.fir.fir >> t.fir.sec >> t.sec;
        query[t.fir.sec-1].pb(mp(i, t.sec));
    }
    dfs0(0, 0, 0);
    for (int i = 0; i < n; i++)
    {
        pr[i] = i;
        if (a[i] == 1)
        {
            s[i] = 1;
            x[i].insert(mp(dx[i], i));
        }
    }
    solve2();
}

//10
//1 2
//1 3
//2 4
//2 5
//3 6
//3 7
//3 8
//6 9
//6 10
//0 1 0 1 0 0  1 0 1 0
//10
//2 1 10
//2 2 10
//2 3 10
//2 4 10
//2 5 10
//2 6 10
//2 7 10
//2 8 10
//2 9 10
//2 10 10
