#include <bits/stdc++.h>

using namespace std;
const int NMAX = 2e5;
vector <int> g[NMAX + 5];
int tin[NMAX + 5], tout[NMAX + 5], timer, re[NMAX + 5], d[NMAX + 5];
bool news[NMAX + 5];
void dfs(int u, int v) {
    tin[u] = ++timer; re[timer] = u;
    d[u] = d[v] + 1;
    for(int adj : g[u]) if(adj != v)
        dfs(adj, u);
    tout[u] = timer;
}
void update(int u, int k) {
    k += d[u];
    for(int i = tin[u]; i <= tout[u]; i++)
        if(d[re[i]] <= k)
            news[i] = true;
}
int query(int u, int k) {
    k += d[u];
    int res = 0;
    for(int i = tin[u]; i <= tout[u]; i++)
        if(d[re[i]] <= k)
            res += news[i];
    return res;
}

int main()
{
    ios_base :: sync_with_stdio(false); cin.tie(nullptr);
    int n, q, t, x, y;
    cin >> n;
    for(int i = 1; i < n; i++)
        cin >> x >> y,
        g[x].push_back(y),
        g[y].push_back(x);
    dfs(1, 0);
    for(int i = 1; i <= n; i++)
        cin >> news[tin[i]];
    cin >> q;
    for(int i = 1; i <= q; i++) {
        cin >> t >> x >> y;
        if(t == 1) update(x, y);
        else cout << query(x, y) << "\n";
    }
    return 0;
}
