#include <bits/stdc++.h>

using namespace std;
const int NMAX = 2e5;
vector <int> g[NMAX + 5];
int tin[NMAX + 5], tout[NMAX + 5], timer, re[NMAX + 5], d[NMAX + 5], n;
bool news[NMAX + 5];
int t[2 * NMAX + 5], len[2 * NMAX + 5];
bool lazy[2 * NMAX + 5];

void build(int ll = 1, int rr = n, int ind = 1) {
    //cout << ll << " " << rr << "\n";
    if(ll == rr) {
        len[ind] = 1;
        t[ind] = news[ll];
        return;
    }
    build(ll, (ll + rr) >> 1, ind << 1);
    build(((ll + rr) >> 1) + 1, rr, ind << 1 | 1);
    len[ind] = len[ind << 1] + len[ind << 1 | 1];
    t[ind] = t[ind << 1] + t[ind << 1 | 1];
}

void tupdate(int l, int r, int ll = 1, int rr = n, int ind = 1) {
    if(l <= ll && r >= rr) {
        t[ind] = len[ind];
        lazy[ind] = true;
        return;
    }
    if(rr < l || ll > r) return;
    tupdate(l, r, ll, (ll + rr) >> 1, ind << 1);
    tupdate(l, r, ((ll + rr) >> 1) + 1, ind << 1 | 1);
    t[ind] = t[ind << 1] + t[ind << 1 | 1];
}

int tquery(int l, int r, int ll = 1, int rr = n, int ind = 1) {
    //cout << l << " " << r << " " << ll << " " << rr << "\n";
    if(lazy[ind]) {
        t[ind] = len[ind];
        lazy[ind] = false;
        if(ll != rr) lazy[ind << 1] = lazy[ind << 1 | 1] = true;
    }
    if(l <= ll && r >= rr) return t[ind];
    if(ll > r || rr < l) return 0;
    return tquery(l, r, ll, (ll + rr) >> 1, ind << 1) + tquery(l, r, ((ll + rr) >> 1) + 1, rr, ind << 1 | 1);
}

void dfs(int u, int v) {
    tin[u] = ++timer; re[timer] = u;
    d[u] = d[v] + 1;
    for(int adj : g[u]) if(adj != v)
        dfs(adj, u);
    tout[u] = timer;
}
void update(int u, int k) {
    k += d[u];
    tupdate(tin[u], tout[u]);
}
int query(int u, int k) {
    k += d[u];
    return tquery(tin[u], tout[u]);
}

int main()
{
    ios_base :: sync_with_stdio(false); cin.tie(nullptr);
    int q, t, x, y;
    cin >> n;
    for(int i = 1; i < n; i++)
        cin >> x >> y,
        g[x].push_back(y),
        g[y].push_back(x);
    dfs(1, 0);
    for(int i = 1; i <= n; i++)
        cin >> news[tin[i]];
    //cout << ".";
    build();
    //cout << ".";
    cin >> q;
    for(int i = 1; i <= q; i++) {
        cin >> t >> x >> y;
        assert(y == n);
        if(t == 1) update(x, y);
        else cout << query(x, y) << "\n";
        //cout << "#";
    }
    return 0;
}
