#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <bits/stdc++.h>
#include <ext/rope>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace __gnu_cxx;
using namespace std;

using ll = long long;

template <typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int dfs(int v, int p, vector<vector<pair<int, int>>> &adj, vector<int> &dp)
{
    int maxim = 0;
    for (auto [u, w] : adj[v]) if (u != p) maxim = max(maxim, dfs(u, v, adj, dp) + (w < 0 ? 0 : w));
    return dp[v] = maxim;
}

signed main()
{
    cin.tie(0)->sync_with_stdio(0);
    cout << "what";
    int n;
    cin >> n;

    vector<pair<int, int>> es(n);
    for (auto &[e, s] : es) cin >> e;
    for (auto &[e, s] : es) cin >> s;
    vector<vector<pair<int, int>>> adj(n + 1);
    for (int i = 2; i <= n; ++i)
    {
        int p, w;
        cin >> p >> w;
        adj[p].emplace_back(i, w);
    }
    vector<int> dp(n + 1);
    cout << dfs(1, 0, adj, dp);
    return 0;
}