#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

#include <iostream>
#include <vector>

using namespace std;

using ll = long long;

int get(int v, int d, int k, vector<vector<int>>& adj, vector<int>& b)
{
    if (d > k) return 0;
    int sum = b[v];
    for (int u : adj[v]) sum += get(u, d + 1, k, adj, b);
    return sum;
}

void update(int v, int d, int k, vector<vector<int>>& adj, vector<int>& b)
{
    if (d > k) return;
    b[v] = 1;
    for (int u : adj[v]) update(u, d + 1, k, adj, b);
}

signed main()
{
    //cin.tie(0)->sync_with_stdio(0);
    int n;
    cin >> n;
    vector<vector<int>> adj(n + 1);
    for (int i = 0; i < n - 1; ++i)
    {
        int x, y;
        cin >> x >> y;
        adj[x].push_back(y);
    }
    //vector<int> shoo(13);
   // cout << "whyy";
    vector<int> b(n + 1);
    for (int i = 1; i <= n; ++i) cin >> b[i];
    int q;
    cin >> q;
    while (q--)
    {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 1) update(x, 0, k, adj, b);
        else cout << get(x, 0, k, adj, b) << '\n';
    }
    return 0;
}/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

 */
