#include <bits/stdc++.h>
#define pb push_back
#define F first
#define S second
#define el "\n"
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
//#pragma GCC optimize("unroll-loops")
//#pragma GCC optimize("-O3")
//#pragma GCC optimize("-Ofast")
using namespace std;
typedef long double ld;

const int N = 4e5 + 500;
const int SQ = 100;

int tin[N], tout[N], tim, d[N], mn[N], tp[N], x[N], k[N], f[N];
vector <int> g[N], qr[N];
int root[N];
vector <pair <int, int> > vc[N];
vector <pair <int, int> > vvc[N];
vector <pair <pair <int, int>, int> > p[N];

struct tree {
    vector <int> t = {};
    vector <int> le = {}, ri = {};

    tree() {
        t.pb(0);
        le.pb(0);
        ri.pb(0);
    }

    void upd(int v) {
        t[v] = 0;
        if (le[v]) {
            t[v] += t[le[v]];
        }
        if (ri[v]) {
            t[v] += t[ri[v]];
        }
    }
    int add() {
        int v = sz(t);
        t.pb(0);
        le.pb(0);
        ri.pb(0);
        return v;
    }

    void upd(int v, int l, int r, int ps, int val) {
        if (l == r) {
            t[v] += val;
        } else {
            int md = (l + r) >> 1;
            if (ps <= md) {
                if (!le[v]) {
                    int u = add();
                    le[v] = u;
                }
                upd(le[v], l, md, ps, val);
            } else {
                if (!ri[v]) {
                    int u = add();
                    ri[v] = u;
                }
                upd(ri[v], md + 1, r, ps, val);
            }
            upd(v);
        }
    }
    int get(int v, int l, int r, int tl, int tr) {
        if (l > r || tl > tr || tl > r || l > tr) {
            return 0;
        }
        if (l >= tl && r <= tr) {
            return t[v];
        }
        int md = (l + r) >> 1;
        int ret = 0;
        if (le[v]) {
            ret += get(le[v], l, md, tl, tr);
        }
        if (ri[v]) {
            ret += get(ri[v], md + 1, r, tl, tr);
        }
        return ret;
    }
};
tree st[N];

vector <int> t, le, ri;
int clone(int v) {
    int ret = sz(t);
    t.pb(t[v]);
    le.pb(le[v]);
    ri.pb(ri[v]);
    return ret;
}

int add() {
    int v = sz(t);
    t.pb(1e9);
    le.pb(0);
    ri.pb(0);
    return v;
}

void upd(int v, int l, int r, int ps, int val) {
    if (l == r) {
        t[v] = min(t[v], val);
    } else {
        int md = (l + r) >> 1;
        if (ps <= md) {
            if (le[v]) {
                int u = clone(le[v]);
                le[v] = u;
            } else {
                int u = add();
//                cerr << u << el;
                le[v] = u;
            }
            upd(le[v], l, md, ps, val);
        } else {
            if (ri[v]) {
                int u = clone(ri[v]);
                ri[v] = u;
            } else {
                int u = add();
//                cerr << u << el;
                ri[v] = u;
            }
            upd(ri[v], md + 1, r, ps, val);
        }
        t[v] = 1e9;
        if (le[v]) {
            t[v] = t[le[v]];
        }
        if (ri[v]) {
            t[v] = min(t[v], t[ri[v]]);
        }
    }
}

void upd(int v, int x, int val) {
    for(; v < N; v = (v | (v + 1))) {
        st[v].upd(0, 0, N - 1, x, val);
    }
}

int get(int v, int x) {
    int ret = 0;
    for (; v >= 0; v = (v & (v + 1)) - 1) {
        ret += st[v].get(0, 0, N - 1, 0, x);
    }
    return ret;
}

void upd(int v) {for (; v < N; v = (v | (v + 1))) f[v]++;}
int get(int v) {int ret = 0; for (; v >= 0; v = (v & (v + 1)) - 1) ret += f[v]; return ret;}

int get(int v, int l, int r, int tl, int tr) {
    if (l > r || tl > tr || tl > r || l > tr) {
        return 1e9;
    }
    if (l >= tl && r <= tr) {
        return t[v];
    }
    int md = (l + r) >> 1;
    int ret = 1e9;
    if (le[v]) {
        ret = min(ret, get(le[v], l, md, tl, tr));
    }
    if (ri[v]) {
        ret = min(ret, get(ri[v], md + 1, r, tl, tr));
    }
    return ret;
}

void dfs(int v, int pr) {
    tin[v] = tim++;
    if (pr != -1) {
        int u = clone(root[pr]);
        root[v] = u;
    }
    for (auto x : vvc[v]) {
        int k = x.F, ind = x.S;
        upd(root[v], 0, N - 1, d[v] + k, ind);
    }
    vc[d[v]].pb({tin[v], v});
    mn[v] = min(mn[v], get(root[v], 0, N - 1, d[v], N - 1));
    for (auto u : g[v]) {
        d[u] = d[v] + 1;
        dfs(u, v);
    }
    tout[v] = tim++;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    int n, u, v;
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> u >> v;
        g[u].pb(v);
    }
    int q;
    for (int i = 1; i <= n; i++) {
        int b;
        cin >> b;
        if (b == 1) {
            mn[i] = 0;
        } else {
            mn[i] = 1e9;
        }
    }
    cin >> q;
    for (int it = 1; it <= q; it++) {
        cin >> tp[it] >> x[it] >> k[it];
        if (tp[it] == 1) {
            vvc[x[it]].pb({k[it], it});
        }
    }
    t.pb(1e9);
    le.pb(0);
    ri.pb(0);
    root[1] = 0;
    dfs(1, -1);
    for (int i = 1; i <= n; i++) {
        sort(all(vc[i]));
        if (mn[i] > q) {
            continue;
        }
        qr[mn[i]].pb(i);
    }
    vector <int> ans(q + 1);
    for (int it = 0; it <= q; it++) {
        if (tp[it] == 2) {
            int v = x[it];
            int nd = d[v] + k[it] + 1;
            ans[it] = get(tout[v]) - get(tin[v] - 1);
            if (nd <= n) {
                p[nd].pb({{tin[v], tout[v]}, it});
            }
//            for (; l <= r; l++) {
//                int u = vc[nd][l].S;
//                ans -= (get(tout[u]) - get(tin[u] - 1));
//            }
//            cout << ans << el;
        }
        for (auto v : qr[it]) {
            upd(tin[v]);
        }
    }
    for (int i = 1; i <= n; i++) {
        upd(tin[i], mn[i], 1);
    }

    for (int i = 0; i <= n; i++) {
        for (auto x : p[i]) {
            int l = x.F.F, r = x.F.S;
            int it = x.S;

            ans[it] -= (get(r, it) - get(l - 1, it));
        }
        for (auto x : vc[i]) {
            int v = x.S;
            upd(tin[v], mn[v], -1);
        }
    }
    for (int i = 1; i <= q; i++) {
        if (tp[i] == 2) {
            cout << ans[i] << el;
        }
    }
}

