#include <bits/stdc++.h>
#define DIM 4010
#define INF 2000000000
using namespace std;

int capacitate[DIM][DIM],flux[DIM][DIM],cst[DIM][DIM],sp[DIM],dist[DIM],t[DIM],viz[DIM];
int s[DIM],maxi[DIM];
pair <int,int> poz[DIM];
vector <pair<int,int> > edg[DIM];
vector <int> L[DIM];
deque <int> c;

int n,i,j,x,sursa,dest,costt,k;

void dfs (int nod, int tata){
    //E[++k] = nod;
    poz[nod].first = ++k;
    for (auto it : edg[nod]){
        int vecin = it.first;
        sp[vecin] = sp[nod] + it.second;
        dfs (vecin,nod);
    }
    poz[nod].second = k;
}

int bellmanFord (){

    for (int i=sursa;i<=dest;i++){
        dist[i] = INF;
        t[i] = -1;
        viz[i] = 0;
    }
    c.clear();
    c.push_back(sursa);
    viz[sursa] = 1;
    dist[sursa] = 0;

    while (!c.empty()){
        int nod = c.front();
        c.pop_front();
        viz[nod] = 0;
        for (auto vecin : L[nod]){
            if (flux[nod][vecin] >= capacitate[nod][vecin])
                continue;
            if (dist[nod] + cst[nod][vecin] < dist[vecin]){
                dist[vecin] = dist[nod] + cst[nod][vecin];
                t[vecin] = nod;
                if (!viz[vecin]){
                    viz[vecin] = 1;
                    c.push_back(vecin);
                }
            }
        }
    }

    return (dist[dest] != INF);

}

int main (){

    //ifstream cin ("date.in");
    //ofstream cout ("date.out");

    cin>>n;
    for (i=1;i<=n;i++)
        cin>>s[i];
    for (i=1;i<=n;i++)
        cin>>maxi[i];

    for (i=2;i<=n;i++){
        cin>>x>>costt;
        edg[x].push_back(make_pair(i,costt));
        //cst[i] = cost;
    }

    dfs (1,0);

    sursa = 0, dest = 2*n + 1;
    for (i=1;i<=n;i++){
        L[sursa].push_back(i);
        L[i].push_back(sursa);
        capacitate[sursa][i] = s[i];


        L[i+n].push_back(dest);
        L[dest].push_back(i+n);
        capacitate[i+n][dest] = maxi[i];
    }

    for (i=1;i<=n;i++){
        for (j=1;j<=n;j++){
            if (i == j)
                continue;
            if ( !(poz[j].first >= poz[i].first && poz[j].second <= poz[i].second) )
                continue;

            if (sp[j] - sp[i] > 0){
                L[i].push_back(j+n);
                L[j+n].push_back(i);
                capacitate[i][j+n] = INF;
                cst[i][j+n] = -(sp[j] - sp[i]);
                cst[j+n][i] = sp[j] - sp[i];

                //cout<<i<<" "<<j+n<<" "<<cst[i][j+n]<<"\n";
            }
        }
    }

    long long sol = 0, f = 0;
    while (bellmanFord()){

        int x = dest, dif = INF;
        while (x != -1){
            dif = min (dif,capacitate[t[x]][x] - flux[t[x]][x]);
            x = t[x];
        }

        f += dif;
        x = dest;
        while (x != -1){


            sol += dif * cst[t[x]][x];

            flux[t[x]][x] += dif;
            flux[x][t[x]] -= dif;
            x = t[x];
        }

    }

    cout<<-sol;


    return 0;
}
