#include <bits/stdc++.h>
using namespace std;
int n, i, a, b, timer, k, q, quer;
int c[200005];
vector<int> adj[200005];
int en[200005];
int qu[200005];
int par[200005];
int seg[800020];
bool lazy[800020];

void dfs(int x, int p=-1) {
  en[x] = ++timer;
  for (auto y : adj[x]) {
    if (y != p) {
      dfs(y, x);
    }
  }
  qu[x] = timer;
}

void Build(int start=1, int ende=n, int indx=1) {
  if (start==ende) {
    seg[indx] = c[start];
    lazy[indx] = false;
    return;
  }

  int mid = (start+ende)/2;

  Build(start, mid, 2*indx);
  Build(mid+1, ende, 2*indx+1);
  seg[indx] = seg[2*indx]+seg[2*indx+1];
}

void Update(int from, int to, int start=1, int ende=n, int indx=1) {
  if (from == start && to == ende) {
    seg[indx] = to-from+1;
    lazy[indx] = true;
    return;
  }

  int mid = (start+ende)/2;

  if (to <= mid) Update(from, to, start, mid, 2*indx);
  else if (from > mid) Update(from, to, mid+1, ende, 2*indx+1);
  else {
    Update(from, mid, start, mid, 2*indx);
    Update(mid+1, to, mid+1, ende, 2*indx+1);
  }
  seg[indx]=seg[2*indx]+seg[2*indx+1];
}

int Query(int from, int to, int start=1, int ende=n, int indx=1) {
  if (from == start && to == ende) {
    return seg[indx];
  }

  int mid = (start+ende)/2;

  if (lazy[indx]) {
    lazy[indx] = false;
    Update(start, mid, start, mid, 2*indx);
    Update(mid+1, ende, mid+1, ende, 2*indx+1);
  }

  if (to <= mid) return Query(from, to, start, mid, 2*indx);
  else if (from > mid) return Query(from, to, mid+1, ende, 2*indx+1);
  else return Query(from, mid, start, mid, 2*indx) + Query(mid+1, to, mid+1, ende, 2*indx+1);
}

int main() {
  scanf("%d", &n);

  for (i=0; i < n-1; ++i) {
    scanf("%d%d", &a, &b);
    adj[a].push_back(b);
    adj[b].push_back(a);
    par[b] = a;
  }

  timer = 0;
  dfs(1);

  for (i=1; i <= n; ++i)
    scanf("%d", &c[en[i]]);

  Build();

  scanf("%d", &q);

  while (q--) {
    scanf("%d%d%d", &quer, &a, &k);

    if (quer == 1) {
      Update(en[a], qu[a]);
    }

    else {
      printf("%d\n", Query(en[a], qu[a]));
    }
  }

  return 0;
}
