#include <bits/stdc++.h>
using namespace std;
const int N = 5e5 + 10;
int n;
int in[N], out[N], d[N], mark[N], ans[N], fen[N];
vector<int> children[N], updates[N];
vector<pair<int, int>> queries[N];
void add(int x, int y) {
	for (; x <= n; x += x & -x) {
		fen[x] += y;
	}
}
int sum(int x) {
	int answer = 0;
	for (; x > 0; x -= x & -x) {
		answer += fen[x];
	}
	return answer;
}
int sum(int l, int r) {
	return sum(r) - sum(l - 1);
}
void dfs(int x) {
	static int timer = 0, depth = 0;
	in[x] = ++timer;
	d[x] = ++depth;
	for (int to : children[x]) {
		dfs(to);
	}
	--depth;
	out[x] = timer;
}
int main() {
	ios::sync_with_stdio(0); cin.tie(0);
	cin >> n;
	for (int i = 0; i < n - 1; ++i) {
		int x, y; cin >> x >> y;
		children[x].push_back(y);
	}
	for (int i = 1; i <= n; ++i) {
		cin >> mark[i];
	}
	dfs(1);
	for (int i = 1; i <= n; ++i) {
		if (mark[i]) {
			updates[d[i]].push_back(i);
		}
	}
	int q; cin >> q;
	for (int i = 1; i <= q; ++i) {
		int t, x, k;
		cin >> t >> x >> k;
		assert(t == 2);
		queries[min(n, d[x] + k)].emplace_back(x, i);
	}
	for (int i = 1; i <= n; ++i) {
		// cout << "update " << i << ": ";
		for (int u : updates[i]) {
			// cout << u << ' ';
			add(in[u], 1);
		}
		// for (int x = 1; x <= n; ++x) {
		// 	cout << sum(x, x) << ' ';
		// }
		for (auto [u, i] : queries[i]) {
			// cout << u << ' ' << i << '\n';
			ans[i] = sum(in[u], out[u]);
		}
	}
	for (int i = 1; i <= q; ++i) {
		cout << ans[i] << ' ';
	}
}