#include <bits/stdc++.h>
#define ll long long
using namespace std;
const int N = 5e5 + 10, oo = 1e9 + 10;
int n;
int mark[N], in[N], out[N], h[N];
int depth = 0;
vector<int> children[N], who[N];
bool isAnc(int x, int y) {
    return !x || (in[x] <= in[y] && out[x] >= out[y]);
}
void dfs(int x) {
    static int timer = 0;
    in[x] = ++timer;
    for (int to : children[x]) {
        h[to] = min(h[to], h[x]);
        dfs(to);
    }
    out[x] = timer;
}
int tree[N];
void add(int x, int y) {
    for (; x <= n; x += x & -x) {
        tree[x] += y;
    }
}
int sum(int x) {
    int ans = 0;
    for (; x > 0; x -= x & -x) {
        ans += tree[x];
    }
    return ans;
}
int sum(int l, int r) {
    return sum(r) - sum(l - 1);
}
const int UPDATE = 1, SUM = 2;
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        children[x].push_back(y);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> mark[i];
        h[i] = oo;
    }
    int q; cin >> q;
    vector<array<int, 3>> queries(q);
    for (int i = 0; i < q; ++i) {
        auto &[t, x, k] = queries[i];
        cin >> t >> x >> k;
        if (t == UPDATE && h[x] == oo) {
            h[x] = i;
        }
    }
    dfs(1);
    for (int i = 1; i <= n; ++i) {
        if (mark[i]) {
            add(in[i], 1);
        } else if (h[i] < q) {
            who[h[i]].push_back(i);
        }
    }
    for (int i = 0; i < q; ++i) {
        auto [t, x, k] = queries[i];
        if (t == SUM) {
            cout << sum(in[x], out[x]) << '\n';
        }
        for (int v : who[i]) {
            add(in[v], 1);
        }
    }
}