#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define pb push_back
#define f first
#define s second
#define int ll

using namespace std;


const int N = 1e5 * 5;

vector < int > g[N];
int tin[N];
int tout[N];
int tim = 0;
void dfs(int v, int pr = -1)
{
    tim++;
    tin[v] = tim;
    tout[v] = tim;
    for (auto to: g[v])
    {
        if (to == pr)
            continue;
        dfs(to, v);
        tout[v] = max(tout[v], tout[to]);
    }
    return;
}


int t[N * 6], f[N * 6];

void push(int v, int tl, int tr)
{
    if (f[v] == 0)
        return;
    int mid = (tl + tr) >> 1;
    int len = mid - tl + 1;
    t[v * 2 + 1] = len;
    f[v * 2 + 1] = 1;
    t[v * 2] = len;
    f[v * 2] = 1;
    f[v] = 0;
    return;
}

int get(int v, int tl, int tr, int l, int r)
{
    if (l <= tl && tr <= r)
        return t[v];
    if (l > tr || tl > r)
        return 0;
    int mid = (tl + tr) >> 1;
    push(v, tl, tr);

    return get(v * 2, tl, mid, l, r) + get(v * 2 + 1, mid + 1, tr, l, r);
}


void upd(int v, int tl, int tr, int l, int r)
{
    if (l <= tl && tr <= r)
    {
        f[v] = 1;
        t[v] = (tr - tl + 1);
        return;
    }

    if (l > tr || tl > r)
        return;
    int mid = (tl + tr) >> 1;
    upd(v * 2, tl, mid, l, r);
    upd(v * 2 + 1, mid + 1, tr, l, r);
    t[v] = t[v * 2] + t[v * 2 + 1];
    return;
}

int32_t main()
{

#ifdef LOCAL
    freopen("input.txt","r", stdin);
    freopen("output.txt","w",stdout);
#endif LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n;
    cin >> n;

    for (int i = 0; i < n - 1; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }


    dfs(0);

    int k = 1;
    while (k <= tim)
        k *= 2;


    for (int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        if (x == 1)
        {
            t[tin[i] + k - 1] = 1;
        }
    }

    for (int i = k - 1; i >= 1; i--)
    {
        t[i] = t[i * 2] + t[i * 2 + 1];
    }


    int q;
    cin >> q;

    while (q--)
    {
        int typ, v, kk;
        cin >> typ >> v >> kk;
        v--;

        if (typ == 1)
        {
            upd(1, 1, k, tin[v], tout[v]);
        }
        else
        {
            cout << get(1, 1, k, tin[v], tout[v]) << "\n";
        }

    }







    return 0;
}
