#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")
#include <bits/stdc++.h>

#define ll long long
#define pii pair<int, int>
#define pb push_back
#define f first
#define s second
#define int ll

using namespace std;


const int N = 1e5 * 5;

vector < int > g[N];
int a[N], pred[N];

void dfss(int v, int k)
{
    a[v] = 1;
    if (k == 0) return;
    for (auto to: g[v])
    {
       if (to == pred[v]) continue;
       dfss(to, k - 1);
    }

    return;
}

int dfs(int v, int k)
{
    int ans = a[v];
    if (k == 0) return ans;
    for (auto to: g[v])
    {
        if (to != pred[v])
        {
            ans += dfs(to, k - 1);
        }
    }

    return ans;
}

void calc(int v)
{
    for (auto to: g[v])
    {
        if (to != pred[v])
        {
            pred[to] = v;
            calc(to);
        }
    }

    return;
}
int32_t main()
{

#ifdef LOCAL
    freopen("input.txt","r", stdin);
    freopen("output.txt","w",stdout);
#endif LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int n;
    cin >> n;

    for (int i = 0; i < n - 1; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        g[x].pb(y);
        g[y].pb(x);
    }


    calc(0);

    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }



    int q;
    cin >> q;

    while (q--)
    {
        int typ, x, k;
        cin >> typ >> x >> k;
        x--;
        if (typ == 1)
        {
            dfss(x, k);
        }
        else
        {
            cout << dfs(x, k) << "\n";
        }
    }


    return 0;
}
