#include <bits/stdc++.h>

using namespace std;
using pi = pair<int, int>;
using ll = long long;

// (n) => (n-1), (n-2), ..., (0)
// a_1 => (0), (1), ..., (n), ... = N
// a_2 => N + a_1
// a_3 =>

const int S = 40;

int main() {
    ios::sync_with_stdio(0); cin.tie(0);

    int k, q; cin >> k >> q;

    const int b = 3000;
    const int maxs = b;
    vector g(b+1, vector<ll>(maxs+1, -1));
    vector<int> maxg(b+1);
    vector counter(b+1, vector<int>(maxs+1, 0));

    set<ll> sss;

    for (int i = 0; i <= b; ++i) {
        vector<int> mn_d(i);

        if (i != 0) {
            for (int j = 0; j <= maxs; ++j) {
                int high = g[i-1][j] >> S;
                int low = g[i-1][j] & ((1LL << S) - 1);

                if (counter[low][high] == 0) {
                    sss.erase(g[i-1][j]);
                }
                counter[low][high]++;
            }

            for (int t = 0; t < i; ++t) {
                int j = i - t - 1;
                int high = g[t][j] >> S;
                int low = g[t][j] & ((1LL << S) - 1);

                if (--counter[low][high] == 0) {
                    sss.insert(g[t][j]);
                    // cout << "i=" << i << ", insert " << g[t][j] << endl;
                }
            }
        }

        auto it = sss.begin();
        ll high;
        ll val = -1;

        sss.insert((ll)i << S);

        for (int j = 0; j <= maxs; ++j) {
            val = it != sss.end() ? *(it++) : val + 1;

            g[i][j] = val;
            if ((val >> S) != i) maxg[i] = j;
        }

        sss.erase((ll)i << S);

        assert(maxg[i] <= maxs);

        // cout << maxg[i] << endl;
    }

/*
    for (int i = 0; i <= 5; ++i) {
        for (int j = 0; j <= 7; ++j) {
            cout << (g[i][j] >> S) << ":" << (g[i][j] & (1LL<<S)-1) << ' ';
        }
        cout << endl;
    }
*/

    while (q--) {
        int n; cin >> n;
        ll x = 0;
        for (int i = 0; i < n; ++i) {
            ll b, s; cin >> b >> s;
            ll game = maxg[b] >= s/k ? g[b][s/k]+s%k : (b<<S)+s-(maxg[b]+1)*k;
            if (b == 0) {
                game = s;
            } else if (k == 0) {
                game = (b << S) + s;
            } else {
                if (s/k <= maxg[b]) {
                    ll high = g[b][s/k] >> S;
                    ll low  = g[b][s/k] & ((1LL << S) - 1);
                    game = (high << S) + s%k + k * low;
                } else {
                    game = (b << S) + s - (maxg[b]+1)*k;
                }
            }
            x ^= game;
        }

        bool win = x != 0;
        cout << (win ? "Win" : "Loss") << endl;
    }
}