#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast", "-O3", "O3", "fast-math")

#define int long long
#define pii pair<int, int>

const int inf = 1e9;
int ans = 0;
map<int, int> leftMiners;

vector<int> capacity;
vector<vector<pii>> gr;


pii maxCost(int v, int curCost = 0) {
    pii res = {curCost, v};
    for (auto to: gr[v]) {
        auto resTo = maxCost(to.first, curCost + to.second);
        if (resTo.second != -1 && capacity[resTo.second]) {
            if (res.first < resTo.first || !capacity[res.second])
                res = {resTo.first, resTo.second};
        }
    }
    if (!capacity[res.second])
        res.second = -1;
    return res;
}

void proceed() {
    pair<int, pii > update = {-inf, {-1, -1}};
    for (auto entry: leftMiners) {
        int miner = entry.first;
        auto minerRes = maxCost(miner);
        if (minerRes.first > update.first && minerRes.first > 0)
            update = {minerRes.first, {miner, minerRes.second}};
    }
    if (update.second.first < 0)
        leftMiners.clear();
    else {
        ans += update.first;
        capacity[update.second.second]--;
        int removeMiner = update.second.first;
        if (leftMiners[removeMiner] == 1)
            leftMiners.erase(removeMiner);
        else
            leftMiners[removeMiner]--;
    }
}

signed main() {
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int s;
        cin >> s;
        if (s > 0)
            leftMiners[i] += s;
    }
    for (int i = 0; i < n; ++i) {
        int e;
        cin >> e;
        capacity.push_back(e);
    }
    for (int i = 0; i < n; ++i) {
        vector<pii > buf;
        gr.push_back(buf);
    }
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        gr[p - 1].push_back({i, w});
    }
    while (!leftMiners.empty()) {
        proceed();
    }
    cout << ans;
}