#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("Ofast", "-O3", "O3", "fast-math")

#define int long long
#define pii pair<int, int>
#define endl "\n"

vector<vector<int>> gr;
vector<bool> know;


int operator2(int x, int k) {
    int res = know[x];
    if (k == 0) return res;
    for (int u: gr[x])
        res += operator2(u, k - 1);
    return res;
}

void operator1(int x, int k) {
    know[x] = true;
    if (k == 0) return;
    for (int u: gr[x])
        operator1(u, k - 1);
}

signed main() {
    ios_base::sync_with_stdio();
    cin.tie();
    cout.tie();

    int n, q;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        vector<int> buf;
        gr.push_back(buf);
        know.push_back(false);
    }
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        gr[x].push_back(y);
    }

    for (int i = 0; i < n; ++i) {
        int kn;
        cin >> kn;
        know[i] = kn == 1;
    }

    cin >> q;
    for (int i = 0; i < q; ++i) {
        int op, x, k;
        cin >> op >> x >> k;
        x--;
        if (op == 1)
            operator1(x, k);
        else {
            int res = operator2(x, k);
            cout << res << endl;
        }
    }
}