#include <bits/stdc++.h>
using namespace std;

struct nod{
	int val;
	int sz=1;
	int s, e;
	set<pair<int, int>, greater<pair<int, int>>> ven;
	vector<int> out;
};

vector<nod> g;

void predfs(int x){
	for(auto it:g[x].out){
		g[it].val+=g[x].val;
		predfs(it);
		g[x].sz+=g[it].sz;
	}
}

void merge(int a, int b){
	if(g[a].ven.size()<g[b].ven.size()) swap(g[a].ven, g[b].ven);
	for(auto it:g[b].ven){
		g[a].ven.insert(it);
	}
	while(!g[b].ven.empty()) g[b].ven.erase(g[b].ven.begin());
}

int sol=0;
void solve(int x){
	for(auto it:g[x].out){
		solve(it);
		merge(x, it);
	}
	while(g[x].s){
		auto val=*(g[x].ven.begin());
		if(val.first<=g[x].val) g[x].s=0;
		else if(val.second>g[x].s){
			sol+=g[x].s*(val.first-g[x].val);
			val.second-=g[x].s;
			g[x].s=0;
			g[x].ven.erase(g[x].ven.begin());
			g[x].ven.insert(val);
		}
		else{
			sol+=val.second*(val.first-g[x].val);
			g[x].s-=val.second;
			val.second=0;
			g[x].ven.erase(g[x].ven.begin());
		}
	}
	g[x].ven.insert({g[x].val, g[x].e});
}

int main(){
	int n;
	cin>>n;
	g.resize(n+1);
	for(int i=1;i<=n;++i){
		cin>>g[i].s;
	}
	for(int i=1;i<=n;++i){
		cin>>g[i].e;
	}
	for(int i=2;i<=n;++i){
		int x, w;
		cin>>x>>w;
		g[x].out.push_back(i);
		g[i].val=w;
	}
	predfs(1);
	solve(1);
	cout<<sol<<"\n";
	return 0;
}




