#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;

struct nod{
	int sz=1, maxd=0;
	bool on=0;
	int nr=0;
	int tin, tout;
	vector<int> out;
};

vector<nod> g;

int n, q;

void predfs(int x){
	if(g[x].on) g[x].nr=1;
	for(auto it:g[x].out){
		predfs(it);
		g[x].sz+=g[it].sz;
		g[x].nr+=g[it].nr;
		g[x].maxd=max(g[it].maxd+1, g[x].maxd);
	}
}

void update(int x, int k){
	if(k<0) return;
	if(g[x].nr==g[x].sz) return;
	g[x].on=1;
	g[x].nr=1;
	for(auto it:g[x].out){
		update(it, k-1);
		g[x].nr+=g[it].nr;
	}
}

int query(int x, int k){
	if(k>g[x].maxd+3) return g[x].nr;
	if(k<0) return 0;
	int sol=0;
	if(g[x].on) sol++;
	for(auto it:g[x].out){
		sol+=query(it, k-1);
	}
	return sol;
}

int main(){
	cin>>n;
	g.resize(n+1);
	for(int i=1;i<n;++i){
		int x, y;
		cin>>x>>y;
		g[x].out.push_back(y);
	}
	for(int i=1;i<=n;++i) cin>>g[i].on;
	predfs(1);
	cin>>q;
	while(q--){
		int t, x, k;
		cin>>t>>x>>k;
		if(t==2) cout<<query(x, k)<<"\n";
		else update(x, k);
	}
	return 0;
}
