#pragma GCC optimize("O3")
#include <bits/stdc++.h>
using namespace std;

int timp=0;
struct nod{
	int sz=1, maxd=0;
	bool on=0;
	int tin, tout;
	vector<int> out;
};

vector<nod> g;

int n, q;

void predfs(int x){
	g[x].tin=++timp;
	for(auto it:g[x].out){
		predfs(it);
		g[x].sz+=g[it].sz;
		g[x].maxd=max(g[it].maxd+1, g[x].maxd);
	}
	g[x].tout=timp;
}

int aint[4*200005];
bool lazy[4*200005];

#define mid ((l+r)/2)


void update(int ul, int ur, int l, int r, int cr){
	if(lazy[cr]) return;
	if(ul==l&&ur==r){
		lazy[cr]=1;
		aint[cr]=ur-ul+1;
		return;
	}
	if(ul<=mid){
		update(ul, min(ur, mid), l, mid, 2*cr);
	}
	if(mid<ur){
		update(max(ul, mid+1), ur, mid+1, r, 2*cr+1);
	}
	aint[cr]=aint[2*cr]+aint[2*cr+1];
}

int query(int ql, int qr, int l, int r, int cr){
	if(ql==l&&qr==r) return aint[cr];
	if(lazy[cr]) return qr-ql+1;
	if(qr<=mid) return query(ql, qr, l, mid, 2*cr);
	if(mid<ql) return query(ql, qr, mid+1, r, 2*cr+1);
	return query(ql, mid, l, mid, 2*cr)+query(mid+1, qr, mid+1, r, 2*cr+1);
}
#undef mid



int main(){
	cin>>n;
	g.resize(n+1);
	for(int i=1;i<n;++i){
		int x, y;
		cin>>x>>y;
		g[x].out.push_back(y);
	}
	predfs(1);
	for(int i=1;i<=n;++i){
		cin>>g[i].on;
		if(g[i].on) update(g[i].tin, g[i].tin, 1, timp, 1);
	}
	cin>>q;
	while(q--){
		int t, x, k;
		cin>>t>>x>>k;
		if(t==2){
			int val=query(g[x].tin, g[x].tout, 1, timp, 1);
			cout<<val<<"\n";
		}
		else{
			update(g[x].tin, g[x].tout, 1, timp, 1);
		}
	}
	return 0;
}
