#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int N_MAX = 100;
const int M_MAX = N_MAX * 2000;

const ll INF = LLONG_MAX / 2;

int N;

int init[N_MAX + 2];
int maxEnd[N_MAX + 2];

int parent[N_MAX + 2];
int score[N_MAX + 2];

vector <int> sons[N_MAX + 2];

int sub[N_MAX + 2];
ll maxScore[N_MAX + 2][M_MAX + 2];

void dfs (int u) {
    for (int v : sons[u]) {
        score[v] += score[u];
        dfs(v);
    }

    sub[u] = maxEnd[u];
    for (int add = 0; add <= sub[u]; add++) {
        maxScore[u][add] = (ll) score[u] * add;
    }
    for (int v : sons[u]) {
        sub[u] += sub[v];
        for (int cntu = sub[u] - sub[v] + 1; cntu <= sub[u]; cntu++) {
            maxScore[u][cntu] = -INF;
        }
        for (int cntu = sub[u] - sub[v]; cntu >= 0; cntu--) {
            for (int cntv = sub[v]; cntv >= 0; cntv--) {
                maxScore[u][cntu + cntv] = max(maxScore[u][cntu + cntv],
                                               maxScore[u][cntu] + maxScore[v][cntv]);
            }
        }
    }
    for (int cntu = 0; cntu <= sub[u]; cntu++) {
        for (int del = 0; del <= init[u] && cntu + del <= sub[u]; del++) {
            maxScore[u][cntu] = max(maxScore[u][cntu],
                                    maxScore[u][cntu + del] - (ll) score[u] * del);
        }
    }
}

int main () {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> N;
    for (int u = 1; u <= N; u++) {
        cin >> init[u];
    }
    for (int u = 1; u <= N; u++) {
        cin >> maxEnd[u];
    }
    for (int u = 2; u <= N; u++) {
        cin >> parent[u] >> score[u];
        sons[parent[u]].push_back(u);
    }

    dfs(1);

    cout << maxScore[1][0] << "\n";

    return 0;
}
