#include <bits/stdc++.h>

#define endl "\n"
#define see(x) cout<<#x<<"="<<x<<endl;

using namespace std;

const int N = 5*1e5+5;

struct str {
    int from, to, cost;
};

bool cmp(str a, str b) {
    return a.cost > b.cost;
}

int n, s[N], e[N], cntFrom[N], cntTo[N];
vector <pair <int, int>> g[N];
vector <str> path;

void dfs(int start, int v, int cost = 0) {
    for (auto i: g[v]) {
        path.push_back({start, i.first, cost + i.second});
        dfs(start, i.first, cost + i.second);
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
/*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
*/

    cin >> n;
    for (int i = 1; i <= n; i ++) cin >> s[i];
    for (int i = 1; i <= n; i ++) cin >> e[i];
    for (int i = 1; i < n; i ++) {
        int p, w;
        cin >> p >> w;
        g[p].push_back({i + 1, w});
    }

    for (int i = 1; i <= n; i ++) {
        dfs(i, i, 0);
    }
    sort(path.begin(), path.end(), cmp);

    int ans = 0;
    for (auto i: path) {
        if (i.cost <= 0) break;
        while (cntFrom[i.from] < s[i.from] and cntTo[i.to] < e[i.to]) {
            cntFrom[i.from] ++;
            cntTo[i.to] ++;
            ans += i.cost; /*
            cout << i.from << " " << i.to << " " << i.cost << endl;
            cout << cntFrom[i.from] << " " << cntTo[i.to] << endl;
            cout << s[i.from] << " " << e[i.to] << endl;
            cout << endl; */
        }
    }

    cout << ans << endl;

    return 0;
}