#include <bits/stdc++.h>

#define endl "\n"
#define see(x) cout<<#x<<"="<<x<<endl;

using namespace std;

const int N = 2*1e5+5;

int n, q, b[N], used[N], cnt[N], nodes[N];
vector <int> g[N];

void pre(int v) {
    nodes[v] = 1;
    cnt[v] = b[v];
    for (auto i: g[v]) {
        pre(i);
        nodes[v] += nodes[i];
        cnt[v] += cnt[i];
    }
}

void dfs(int v) {
    used[v] = 1;
    cnt[v] = nodes[v];
    for (auto i: g[v]) {
        if (!used[i]) dfs(i);
    }
}

int main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
/*
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
*/

    cin >> n;

    for (int i = 1; i < n; i ++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }

    for (int i = 1; i <= n; i ++) {
        cin >> b[i];
    }

    pre(1);

    cin >> q;

    while (q --) {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 1) {
            if (!used[x]) dfs(x);
        }
        else {
            cout << cnt[x] << endl;
        }
    }

    return 0;
}