#include <bits/stdc++.h>

using namespace std;

const int N = 1e5 + 5;

int n;
int s[N], e[N];
int p[N], w[N];

vector<int> g[N];


int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		cin >> s[i];
	}
	for (int i = 1; i <= n; ++i) {
		cin >> e[i];
	}
	for (int i = 2; i <= n; ++i) {
		cin >> p[i] >> w[i];
	}

	for (int i = 2; i <= n; ++i) {
		g[p[i]].push_back(i);
		w[i] += w[p[i]];
	}

	long long ans = 0;
	priority_queue<pair<int, int>, vector<pair<int, int>>> q;
	for (int i = n; i >= 1; --i) {
		if (e[i] > 0) {
			q.push({w[i], e[i]});
		}
		while (s[i] > 0 && !q.empty() && w[i] < q.top().first) {
			int val = q.top().first;
			int cnt = q.top().second;
			q.pop();
			int t = min(s[i], cnt);
			ans += t * 1ll * (val - w[i]);
			cnt -= t;
			s[i] -= t;
			q.push({w[i], t});
			if (cnt > 0) {
				q.push({val, cnt});
			}
		}
	}

	cout << ans << endl;
	return 0;
}
