#include <cmath>
#include <iostream>
#include <vector>
#include <utility>
#include <stack>

using namespace std;

typedef long long ll;

int main(){
    
    int n;
    cin >> n;
    
    vector <vector <ll>  > adjl(n);
    
    for (int i = 0; i < n - 1; i++){
        
        int u, v;
        cin >> u >> v;
        u--, v--;
        adjl[u].push_back(v);
        
    }
    
    vector <ll> b(n);
    for (int i = 0; i < n; i++)
        cin >> b[i];
    
    int q;
    cin >> q;
    
    stack <pair <ll,ll> > dfs;
    for (int i = 0; i < q; i++){
        
        int t, x, k;
        cin >> t >> x >> k;
        x--;
        
        if (t == 1){
            
            dfs.push(make_pair(x, 0));
            while (dfs.size()){
                
                ll u = dfs.top().first, de = dfs.top().second;
                dfs.pop();
                
                b[u] = 1;
                
                for (int i = 0; i < adjl[u].size(); i++){
                    
                    ll v = adjl[u][i];
                    if (de + 1 <= k)
                        dfs.push(make_pair(v,de+1));
                    
                }
                
            }
            
        } else if (t == 2){
            
            dfs.push(make_pair(x, 0));
            ll broj = 0;
            while (dfs.size()){
                
                ll u = dfs.top().first, de = dfs.top().second;
                dfs.pop();
                
                if (b[u] == 1)
                    broj++;
                
                for (int i = 0; i < adjl[u].size(); i++){
                    
                    ll v = adjl[u][i];
                    if (de + 1 <= k)
                        dfs.push(make_pair(v,de+1));
                    
                }
                
            }
            
            cout << broj << endl;

            
        }
        
        
    }
    
}
