#include <bits/stdc++.h>
#define ff(i,a,b) for(int (i) = (a); (i) <= (b); ++(i))
#define pb push_back

using namespace std;

int n;
vector<int> graf[200005];
int niz[200005];
int val[200005];
int disc[200005];
int out[200005];
int dep[200005];
int t;
void dfs(int x, int y){
    dep[x] = y;
    disc[x] = t;
    for(auto c:graf[x]){
        t++;
        dfs(c,y+1);
    }
    out[x] = t;
}
int q;
struct kveri{
    int idx;
    int x;
    int k;
};
kveri kv[200005];

bool fl1,fl2,fl3;

int lejzi[4*200005];
int seg[4*200005];
void propagate(int node, int l, int r){
    if(!lejzi[node])return;
    seg[node] = r-l+1;
    if(l < r){
        lejzi[node * 2] = lejzi[node * 2 + 1] = 1;
    }
    lejzi[node] = 0;
}
void update(int node, int l, int r, int levo, int desno){
    propagate(node, l, r);
    if(r < levo || desno < l)return;
    if(l >= levo && r <= desno){
        lejzi[node] = 1;
        propagate(node, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(node * 2, l, mid, levo, desno);
    update(node * 2 + 1, mid + 1, r, levo, desno);
    seg[node] = seg[node * 2] + seg[node * 2 + 1];
}
int kveri(int node, int l, int r, int levo, int desno){
    propagate(node, l, r);
    if(r < levo || desno < l)return 0;
    if(l >= levo && r <= desno){
        return seg[node];
    }
    int mid = (l+r)/2;
    return kveri(node * 2, l, mid, levo, desno) + kveri(node * 2 + 1, mid + 1, r, levo, desno);
}


vector<int> mgs[4 * 200005];
vector<int> pref[4 * 200005];

void spoji(int x, int y, int z){
    int br1 = 0;
    int br2 = 0;
    int br = 0;
    int n1 = mgs[y].size();
    int n2 = mgs[z].size();
    int posl = 0;
    while(br1 < n1 || br2 < n2){
        if(br1 == n1){
            int sta = val[mgs[z][br2]];
            mgs[x].pb(mgs[z][br2]);
            pref[x].pb(posl + sta);
            posl += sta;
            br2++;
            continue;
        }
        if(br2 == n2){
            int sta = val[mgs[y][br1]];
            mgs[x].pb(mgs[y][br1]);
            pref[x].pb(posl + sta);
            posl += sta;
            br1++;
            continue;
        }
        if(dep[mgs[y][br1]] < dep[mgs[z][br2]]){
            int sta = val[mgs[y][br1]];
            mgs[x].pb(mgs[y][br1]);
            pref[x].pb(posl + sta);
            posl += sta;
            br1++;
            continue;
        }
        else{
            int sta = val[mgs[z][br2]];
            mgs[x].pb(mgs[z][br2]);
            pref[x].pb(posl + sta);
            posl += sta;
            br2++;
            continue;
        }
    }
}

void init(int node, int l, int r){
    if(l == r){
        mgs[node].pb(niz[l]);
        pref[node].pb(val[niz[l]]);
        return;
    }
    int mid = (l+r)/2;
    init(node * 2, l, mid);
    init(node * 2 + 1, mid + 1, r);
    spoji(node, node*2, node*2+1);
}

int resi(int node, int mnj){
    int l = 0;
    int r = mgs[node].size();
    if(r == 0)return 0;
    if(dep[mgs[node][0]] > mnj)return 0;
    r--;
    while(l < r){
        int mid = (l+r+1)/2;
        if(dep[mgs[node][mid]] > mnj)r = mid-1;
        else{
            l = mid;
        }
    }
    return pref[node][l];
}


int kverimgs(int node, int l, int r, int levo, int desno, int mnj){
    if(r < levo || desno < l)return 0;
    if(l >= levo && r <= desno){
        return resi(node, mnj);
    }
    int mid = (l+r)/2;
    return kverimgs(node*2,l,mid,levo,desno,mnj)+kverimgs(node*2+1,mid+1,r,levo,desno,mnj);
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    ff(i,1,n-1){
        int x,y;
        cin >> x >> y;
        graf[x].pb(y);
    }
    ff(i,1,n)cin >> val[i];
    t = 1;
    dfs(1,0);

    cin >> q;
    ff(i,1,q){
        cin >> kv[i].idx >> kv[i].x >> kv[i].k;
    }
    if(n <= 10000 && q <= 10000 ){
        ff(i,1,n){
            niz[disc[i]] = i;
        }
        ff(i,1,q){
            if(kv[i].idx == 2){
                int ans = 0;
                ff(j,disc[kv[i].x], out[kv[i].x]){
                    if(dep[niz[j]] <= dep[kv[i].x]+kv[i].k)ans+=val[niz[j]];
                }
                cout << ans << "\n";
            }
            else{
                ff(j,disc[kv[i].x], out[kv[i].x]){
                    if(dep[niz[j]] <= dep[kv[i].x]+kv[i].k)val[niz[j]] = 1;
                }
            }
        }
        return 0;
    }
    int najm = n;
    ff(i,1,q){
        najm = min(najm, kv[i].k);
    }
    if(najm == n ){
        ff(i,1,n){
            if(val[i]){
                update(1,1,n,disc[i],disc[i]);
            }
        }
        ff(i,1,q){
            if(kv[i].idx == 2){
                cout << kveri(1,1,n,disc[kv[i].x], out[kv[i].x]) << "\n";
            }
            else{
                update(1,1,n,disc[kv[i].x], out[kv[i].x]);
            }
        }
        return 0;
    }
    int kol = 0;
    ff(i,1,q){
        if(kv[i].idx == 1)kol = 1;
    }
    if(!kol){
        ff(i,1,n){
            niz[disc[i]] = i;
        }
        init(1,1,n);
        ff(i,1,q){
            cout << kverimgs(1,1,n,disc[kv[i].x],out[kv[i].x],dep[kv[i].x]+kv[i].k) << "\n";
        }
    }


    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
3
2 1 1
2 4 4
2 3 0
*/
