#include <bits/stdc++.h>
#define ff(i,a,b) for(int (i) = (a); (i) <= (b); ++(i))
#define pb push_back
#define pii pair<int,int>
#define xx first
#define yy second

using namespace std;

int n;
vector<int> graf[200005];
int niz[200005];
int val[200005];
int disc[200005];
int out[200005];
int dep[200005];
int t;
void dfs(int x, int y){
    dep[x] = y;
    disc[x] = t;
    for(auto c:graf[x]){
        t++;
        dfs(c,y+1);
    }
    out[x] = t;
}
int q;
struct kveri{
    int idx;
    int x;
    int k;
};
kveri kv[200005];

bool fl1,fl2,fl3;

int lejzi[4*200005];
int seg[4*200005];
void propagate(int node, int l, int r){
    if(!lejzi[node])return;
    seg[node] = r-l+1;
    if(l < r){
        lejzi[node * 2] = lejzi[node * 2 + 1] = 1;
    }
    lejzi[node] = 0;
}
void update(int node, int l, int r, int levo, int desno){
    propagate(node, l, r);
    if(r < levo || desno < l)return;
    if(l >= levo && r <= desno){
        lejzi[node] = 1;
        propagate(node, l, r);
        return;
    }
    int mid = (l + r) / 2;
    update(node * 2, l, mid, levo, desno);
    update(node * 2 + 1, mid + 1, r, levo, desno);
    seg[node] = seg[node * 2] + seg[node * 2 + 1];
}
int kveri(int node, int l, int r, int levo, int desno){
    propagate(node, l, r);
    if(r < levo || desno < l)return 0;
    if(l >= levo && r <= desno){
        return seg[node];
    }
    int mid = (l+r)/2;
    return kveri(node * 2, l, mid, levo, desno) + kveri(node * 2 + 1, mid + 1, r, levo, desno);
}


vector<int> mgs[4 * 200005];
vector<int> pref[4 * 200005];

void spoji(int x, int y, int z){
    int br1 = 0;
    int br2 = 0;
    int br = 0;
    int n1 = mgs[y].size();
    int n2 = mgs[z].size();
    int posl = 0;
    while(br1 < n1 || br2 < n2){
        if(br1 == n1){
            int sta = val[mgs[z][br2]];
            mgs[x].pb(mgs[z][br2]);
            pref[x].pb(posl + sta);
            posl += sta;
            br2++;
            continue;
        }
        if(br2 == n2){
            int sta = val[mgs[y][br1]];
            mgs[x].pb(mgs[y][br1]);
            pref[x].pb(posl + sta);
            posl += sta;
            br1++;
            continue;
        }
        if(dep[mgs[y][br1]] < dep[mgs[z][br2]]){
            int sta = val[mgs[y][br1]];
            mgs[x].pb(mgs[y][br1]);
            pref[x].pb(posl + sta);
            posl += sta;
            br1++;
            continue;
        }
        else{
            int sta = val[mgs[z][br2]];
            mgs[x].pb(mgs[z][br2]);
            pref[x].pb(posl + sta);
            posl += sta;
            br2++;
            continue;
        }
    }
}

void init(int node, int l, int r){
    if(l == r){
        mgs[node].pb(niz[l]);
        pref[node].pb(val[niz[l]]);
        return;
    }
    int mid = (l+r)/2;
    init(node * 2, l, mid);
    init(node * 2 + 1, mid + 1, r);
    spoji(node, node*2, node*2+1);
}

int resi(int node, int mnj){
    int l = 0;
    int r = mgs[node].size();
    if(r == 0)return 0;
    if(dep[mgs[node][0]] > mnj)return 0;
    r--;
    while(l < r){
        int mid = (l+r+1)/2;
        if(dep[mgs[node][mid]] > mnj)r = mid-1;
        else{
            l = mid;
        }
    }
    return pref[node][l];
}


int kverimgs(int node, int l, int r, int levo, int desno, int mnj){
    if(r < levo || desno < l)return 0;
    if(l >= levo && r <= desno){
        return resi(node, mnj);
    }
    int mid = (l+r)/2;
    return kverimgs(node*2,l,mid,levo,desno,mnj)+kverimgs(node*2+1,mid+1,r,levo,desno,mnj);
}




int blok = 200;
int gde[50005];
vector<int> blk[50000/200 + 1];
vector<int> obcn[50000/200 + 1];
int lejzib[50000/200 + 1][4* 201];
int segb[50000/200 + 1][4* 201];
void bpropagate(int node, int l, int r, int idx){
    if(!lejzib[idx][node])return;
    segb[idx][node] = r-l+1;
    if(l < r){
        lejzib[idx][node * 2] = lejzib[idx][node * 2 + 1] = 1;
    }
    lejzib[idx][node] = 0;
}
bool check(int l, int r){
    if(l < 0 || r < 0 || l > r)return 1;
    return 0;
}
void bupdate(int node, int l, int r, int levo, int desno, int idx){
    if(check(levo,desno))return;
    bpropagate(node, l, r, idx);
    if(r < levo || desno < l)return;
    if(l >= levo && r <= desno){
        lejzib[idx][node] = 1;
        bpropagate(node, l, r, idx);
        return;
    }
    int mid = (l + r) / 2;
    bupdate(node * 2, l, mid, levo, desno, idx);
    bupdate(node * 2 + 1, mid + 1, r, levo, desno, idx);
    segb[idx][node] = segb[idx][node * 2] + segb[idx][node * 2 + 1];
}
int bkveri(int node, int l, int r, int levo, int desno, int idx){
    if(check(levo,desno))return 0;
    bpropagate(node, l, r, idx);
    if(r < levo || desno < l)return 0;
    if(l >= levo && r <= desno){
        return segb[idx][node];
    }
    int mid = (l+r)/2;
    return bkveri(node * 2, l, mid, levo, desno, idx) + bkveri(node * 2 + 1, mid + 1, r, levo, desno, idx);
}
pii pom[50005];

int manji(int x, int y){
    int sta = blk[y].size();
    if(sta == 0)return -1;
    if(blk[y][sta-1]<x)return -1;
    int l=0;
    int r=sta-1;
    while(l < r){
        int mid = (l+r)/2;
        if(blk[y][mid]<x)l=mid+1;
        else r=mid;
    }
    return l;
}
int veci(int x, int y){
    int sta = blk[y].size();
    if(sta == 0)return -1;
    if(blk[y][0]>x)return -1;
    int l=0;
    int r=sta-1;
    while(l < r){
        int mid = (l+r+1)/2;
        if(blk[y][mid]>x)r=mid-1;
        else l=mid;
    }
    return l;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    ff(i,1,n-1){
        int x,y;
        cin >> x >> y;
        graf[x].pb(y);
    }
    ff(i,1,n)cin >> val[i];
    t = 1;
    dfs(1,0);

    cin >> q;
    ff(i,1,q){
        cin >> kv[i].idx >> kv[i].x >> kv[i].k;
    }
    if(n <= 10000 && q <= 10000){
        ff(i,1,n){
            niz[disc[i]] = i;
        }
        ff(i,1,q){
            if(kv[i].idx == 2){
                int ans = 0;
                ff(j,disc[kv[i].x], out[kv[i].x]){
                    if(dep[niz[j]] <= dep[kv[i].x]+kv[i].k)ans+=val[niz[j]];
                }
                cout << ans << "\n";
            }
            else{
                ff(j,disc[kv[i].x], out[kv[i].x]){
                    if(dep[niz[j]] <= dep[kv[i].x]+kv[i].k)val[niz[j]] = 1;
                }
            }
        }
        return 0;
    }
    int najm = n;
    ff(i,1,q){
        najm = min(najm, kv[i].k);
    }
    if(najm == n){
        ff(i,1,n){
            if(val[i]){
                update(1,1,n,disc[i],disc[i]);
            }
        }
        ff(i,1,q){
            if(kv[i].idx == 2){
                cout << kveri(1,1,n,disc[kv[i].x], out[kv[i].x]) << "\n";
            }
            else{
                update(1,1,n,disc[kv[i].x], out[kv[i].x]);
            }
        }
        return 0;
    }
    int kol = 0;
    ff(i,1,q){
        if(kv[i].idx == 1)kol = 1;
    }
    if(!kol){
        ff(i,1,n){
            niz[disc[i]] = i;
        }
        init(1,1,n);
        ff(i,1,q){
            cout << kverimgs(1,1,n,disc[kv[i].x],out[kv[i].x],dep[kv[i].x]+kv[i].k) << "\n";
        }
        return 0;
    }
    ff(i,1,n){
        niz[disc[i]] = i;
    }
    ff(i,0,n-1)pom[i] = {dep[i+1], disc[i+1]};
    sort(pom , pom + n);
    ff(i,0,n-1){
        blk[i/blok].pb(pom[i].yy);
        obcn[i/blok].pb(pom[i].yy);
    }
    ff(i,0,(n-1)/blok)sort(blk[i].begin(), blk[i].end());
    ff(i,0,(n-1)/blok){
        int sta =blk[i].size();
        ff(j,0,sta - 1){
            gde[blk[i][j]] = j;
            if(val[niz[blk[i][j]]]){
                //cout << "aaa\n";
                bupdate(1,0,blok-1,j,j,i);
            }
        }
    }
    //cout << bkveri(1,0,blok-1,0,blok-1,0);
    //return 0;
    ff(i,1,q){
        if(kv[i].idx == 1){
            for(int j=0; j<=(n-1)/blok; j++){
                if(pom[min(n-1, j*blok+blok-1)].xx > dep[kv[i].x]+kv[i].k){
                    for(int r=0; r<obcn[j].size(); r++){
                        if(pom[r+j*blok].xx > dep[kv[i].x]+kv[i].k)break;
                        if(obcn[j][r] >= disc[kv[i].x] && obcn[j][r] <= out[kv[i].x]){
                            bupdate(1,0,blok-1,gde[obcn[j][r]],gde[obcn[j][r]], j);
                        }
                    }
                    break;
                }
                else{

                    bupdate(1,0,blok-1,manji(disc[kv[i].x],j), veci(out[kv[i].x],j),j);
                }
            }
        }
        else{
            int ans = 0;
            for(int j=0; j<=(n-1)/blok; j++){
                if(pom[min(n-1, j*blok+blok-1)].xx > dep[kv[i].x]+kv[i].k){
                    for(int r=0; r<obcn[j].size(); r++){
                        if(pom[r+j*blok].xx > dep[kv[i].x]+kv[i].k)break;
                        if(obcn[j][r] >= disc[kv[i].x] && obcn[j][r] <= out[kv[i].x]){
                            //bupdate(1,1,n,gde[obcn[j][r]],gde[obcn[j][r]], j);
                            ans += bkveri(1,0,blok-1,gde[obcn[j][r]], gde[obcn[j][r]], j);
                        }
                    }
                    break;
                }
                else{
                    ans += bkveri(1,0,blok-1,manji(disc[kv[i].x],j), veci(out[kv[i].x],j),j);
                   // bupdate(1,1,blok,manji(disc[kv[i].x],j), veci(out[kv[i].x],j),j);
                }
            }
            cout << ans << "\n";
        }
    }

    return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
3
2 1 1
2 4 4
2 3 0
*/
