#include <bits/stdc++.h>

using namespace std;
#define pii pair<int, int>
#define pb(x) push_back(x)
#define ll long long
#define all(x) x.begin(), x.end()

const int max_n = 2e5 + 1;

vector<pii> gr[max_n];
int dist[max_n];
int w[max_n];
int tin[max_n], tout[max_n];
int cntt = 0;


bool is_par(int par, int son) {
	return tin[par] <= tin[son] && tout[son] <= tout[par];
}

void dfs(int v) {
	tin[v] = cntt++;
	for (auto to : gr[v])
		dist[to.first] = dist[v] + to.second, dfs(to.first);
	tout[v] = cntt++;
}

void print(auto st) {
	for (auto k : st)
		cout << k.first << " " << k.second << '\n';
	cout << '\n';
}

signed main() {
	cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	vector<int> s(n), e(n);
	for (int i = 0; i < n; i++)
		cin >> s[i];
	for (int i = 0; i < n; i++)
		cin >> e[i];
	for (int i = 1; i < n; i++) {
		int p, ww;
		cin >> p >> ww;
		gr[p - 1].emplace_back(i, ww);
	}
	dfs(0);
	struct prek {
		int d, v, u;
		prek(){}
		prek(int d, int v, int u) : d(d), v(v), u(u) {}
	};
	vector<prek> loc;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (is_par(i, j))
				loc.emplace_back(dist[j] - dist[i], i, j);
		}
	}
	ll ans = 0;
	sort(all(loc), [](prek A, prek B) {return A.d > B.d;});
	for (auto o : loc) {
		//cout << o.d << " " << o.v << " " << o.u << '\n';
		if (o.d < 0) break; 
		int k = min(s[o.v], e[o.u]);
		s[o.v] -= k;
		e[o.u] -= k;
		ans += 1LL * k * o.d;
	}
	cout << ans << '\n';
}