#include <bits/stdc++.h>

using namespace std;
#define pii pair<int, int>
#define pb(x) push_back(x)
#define ll long long
#define all(x) x.begin(), x.end()

const int max_n = 2e5 + 100;
vector<int> gr[max_n];
bool col[max_n];
int tin[max_n], tout[max_n];
int euler[max_n];
int h[max_n];
int cntt = 0;

struct prek{
	int t, l, r;
	prek(){}
	prek(int t, int l, int r) : t(t), l(l), r(r){}
};

void dfs(int v) {
	euler[cntt] = v;
	tin[v] = cntt++;
	for (int to : gr[v])
		h[to] = h[v] + 1, dfs(to);
	tout[v] = cntt;
}

// solve1

int seg[max_n * 4];
bool mod_val[max_n * 4];
bool moded[4 * max_n];

void push(int v, int tl, int tr) {
	if (!moded[v]) return;
	moded[v] = false;
	int tm = (tl + tr) >> 1;
	seg[v << 1] = (tm - tl) * mod_val[v];
	seg[v << 1 | 1] = (tr - tm) * mod_val[v];
	mod_val[v << 1] = mod_val[v << 1 | 1] = mod_val[v];
	moded[v << 1] = moded[v << 1 | 1] = true;
}

void sett(int l, int r, int val, int v = 1, int tl = 0, int tr = max_n) {
	if (tr <= l || r <= tl) return;
	if (l <= tl && tr <= r) {
		moded[v] = true;
		mod_val[v] = val;
		seg[v] = val * (tr - tl);
		return;
	}
	push(v, tl, tr);
	int tm = (tl + tr) >> 1;
	sett(l, r, val, v << 1, tl, tm);
	sett(l, r, val, v << 1 | 1, tm, tr);
	seg[v] = seg[v << 1] + seg[v << 1 | 1];
}

int get(int l, int r, int v = 1, int tl = 0, int tr = max_n) {
	if (tr <= l || r <= tl) return 0;
	if (l <= tl && tr <= r) {
		return seg[v];
	}
	push(v, tl, tr);
	int tm = (tl + tr) >> 1;
	int sum = get(l, r, v << 1, tl, tm) + get(l, r, v << 1 | 1, tm, tr);
	seg[v] = seg[v << 1] + seg[v << 1 | 1];
	return sum;
}

void solve1(vector<prek> & vec, int n) {
	for (int i = 0; i < n; i++) {
		sett(tin[i], tin[i] + 1, col[i]);
		//cout << get(tin[i], tin[i] + 1) << '\n';
		//cout << i << " " << tin[i] << " " << tout[i] << '\n';
	}
	for (auto o : vec) {
		if (o.t == 1) {
			sett(tin[o.l], tout[o.l], 1);
		} else {
			cout << get(tin[o.l], tout[o.l]) << '\n';
		}
	}
}


signed main() {
	cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		int x, y;
		cin >> x >> y;
		gr[x - 1].pb(y - 1);
	}
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		col[i] = x;
	}

	dfs(0);
	int q;
	cin >> q;
	bool da = true;
	vector<prek> mem(q);
	for  (int i = 0; i < q; i++)
		cin >> mem[i].t >> mem[i].l >> mem[i].r, mem[i].l--, mem[i].r--, da &= mem[i].r == n -1;
	if (da)
		solve1(mem, n);
}