#include <bits/stdc++.h>

using namespace std;
#define pii pair<int, int>
#define pb(x) push_back(x)
#define ll long long
#define all(x) x.begin(), x.end()

const int max_n = 2e5 + 100;
vector<int> gr[max_n];
bool col[max_n];
int h[max_n];
int tin[max_n];
int tout[max_n];
int cntt = 0;

struct prek{
    int t, l, r;
    prek(){}
    prek(int t, int l, int r) : t(t), l(l), r(r){}
};

void dfs(int v) {
	tin[v] = cntt++;
    for (int to : gr[v])
        h[to] = h[v] + 1, dfs(to);
    tout[v] = cntt++;
}

bool is_par(int par, int son) {
	return tin[par] <= tin[son] && tout[son] <= tout[par];
}

int bfs(int v, int d, bool f) {
	deque<int> deq;
	deq.pb(v);
	int cnt = 0;
	while (deq.size()) {
		int x = deq.front();
		//cout << x << '\n';
		deq.pop_front();
		if (f) col[x] = true;
		else cnt += col[x];
		if (h[x] - h[v] == d) continue;
		for (int to : gr[x])
			deq.pb(to);
	}
	return cnt;
}


signed main() {
    cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        gr[x - 1].pb(y - 1);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        col[i] = x;
    }

    dfs(0);
    int q;
    cin >> q;
    set<int> st;
    for (int i = 0; i < n; i++)
    	if (!col[i])
    		st.insert(i);
    for (int i = 0; i < q; i++) {
    	int t, v, x;
    	cin >> t >> v >> x;
    	v--;
    	if (t == 1) {
    		vector<int> del;
    		for (int k : st) {
    			if (is_par(v, k) && h[k] - h[v] <= x)
    				del.pb(k);
    		}
    		for (int k : del)
    			col[k] = true, st.erase(k);
    	} else {
    		cout << bfs(v, x, false) << '\n';
    	}
    }
}