#include <bits/stdc++.h>

using namespace std;
#define pii pair<int, int>
#define pb(x) push_back(x)
#define ll long long
#define all(x) x.begin(), x.end()

const int max_n = 2e5 + 100;
vector<int> gr[max_n];
bool col[max_n];
int h[max_n];
int pdsu[max_n];
int sz[max_n];

struct prek{
    int t, l, r;
    prek(){}
    prek(int t, int l, int r) : t(t), l(l), r(r){}
};

void dfs(int v) {
    for (int to : gr[v])
        h[to] = h[v] + 1, dfs(to);
}


void dfs2(int v, int &x, int &d, int &cnt) {
	if (h[v] - h[x] > d) return;
	cnt += col[v];
	for (int to : gr[v])
		dfs2(to, x, d, cnt);
}

void dfs3(int v, int &x, int &d) {
	if (h[v] - h[x] > d) return;
	col[v] = true;
	for (int to : gr[v])
		dfs3(to, x, d);
}


signed main() {
    cin.tie(), cout.tie(), ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        gr[x - 1].pb(y - 1);
    }
    for (int i = 0; i < n; i++) {
        int x;
        cin >> x;
        col[i] = x;
    }

    dfs(0);
    int q;
    cin >> q;
    bool da = true;
    vector<prek> mem(q);
    for  (int i = 0; i < q; i++)
        cin >> mem[i].t >> mem[i].l >> mem[i].r, mem[i].l--, mem[i].r--, da &= mem[i].r == n - 1;
    if (n <= 5e4) {
        for (int i = 0; i < q; i++) {
        	mem[i].r++;
            if (mem[i].t == 1) {
                dfs3(mem[i].l, mem[i].l, mem[i].r);
            } else {
            	int cnt = 0;
                dfs2(mem[i].l, mem[i].l, mem[i].r, cnt);
        		cout << cnt << '\n';
            }
        }
        return 0;
    }
}