#include "bits/stdc++.h"

using namespace std;
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int MAXN = 5e5 + 1;
vector<vector<pair<int, int>>> g(MAXN);
vector<int> s(MAXN), e(MAXN), d(MAXN), depth(MAXN);
vector<pair<int, pair<int, int>>> t;
vector<int> cur;

void dfs(int v, int D) {
    depth[v] = D++;
    for (auto x:cur)
        t.push_back({d[v] - d[x], {x, v}});
    cur.push_back(v);
    for (auto[w, val]:g[v]) {
        d[w] = d[v] + val;
        dfs(w, D);
    }
    cur.pop_back();
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i)
        cin >> s[i];
    for (int i = 0; i < n; ++i)
        cin >> e[i];
    for (int i = 1; i < n; ++i) {
        int u, w;
        cin >> u >> w;
        g[u-1].emplace_back(i, w);
    }
    dfs(0, 0);
    sort(all(t), [&](pair<int, pair<int, int>> a, pair<int, pair<int, int>> b) {
        if (a.first != b.first)
            return a.first > b.first;
        return depth[a.second.first] > depth[b.second.first];
    });
    int ans = 0;
    for (auto[w, pii]:t) {
        auto[u, v]=pii;
//        cout << w << " " << u << " " << v << endl;
        if (w <= 0)
            break;
        int mn = min(e[v], s[u]);
        e[v] -= mn;
        s[u] -= mn;
        ans += mn * w;
    }
    cout << ans;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}