#include "bits/stdc++.h"

using namespace std;
//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

#define sz(a)(int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int MAXN = 5e5 + 1;
const int inf = 1e18;
int T = 0, n, R = 1 << 18;
vector<vector<int>> g(MAXN);
vector<int> fu(2 * R), d(2 * R, inf), tin(2 * R, inf), tout(2 * R, inf), posin(2 * R, inf), posout(2 * R, inf);
vector<pair<int, int>> a(2 * R);
vector<vector<int>> sum(2 * R), ps(2 * R), t(2 * R);

void dfs(int v, int D) {
    d[v] = D++;
    tin[v] = T++;
    for (auto w:g[v])
        dfs(w, D);
    tout[v] = T++;
}

void init(int x, int xl, int xr) {
    int len = xr - xl;
    if (xl + 1 == xr) {
        t[x].push_back(a[x - R].second);
        sum[x].resize(len * 2);
        sum[x][1] = fu[a[x - R].second];
        ps[x].resize(len * 2);
        return;
    }
    int mid = (xl + xr) >> 1;
    init(x * 2, xl, mid);
    init(x * 2 + 1, mid, xr);
    int l = 0;
    int r = 0;
    len /= 2;
    while (l < len && r < len)
        if (d[t[x * 2][l]] < d[t[x * 2 + 1][r]]) t[x].push_back(t[x * 2][l++]);
        else t[x].push_back(t[x * 2 + 1][r++]);
    while (l < len) t[x].push_back(t[x * 2][l++]);
    while (r < len) t[x].push_back(t[x * 2 + 1][r++]);
//    cout << sz(t[x * 2]) << " " << sz(t[x * 2 + 1]) << " " << sz(t[x]) << endl;
    len = (xr - xl);
    sum[x].resize(len * 2);
    ps[x].resize(len * 2);
    for (int i = 0; i < sz(t[x]); ++i)
        sum[x][i + len] = fu[t[x][i]];
    for (int i = len - 1; i > 0; --i)
        sum[x][i] = sum[x][i * 2] + sum[x][i * 2 + 1];
}

void init() {
    dfs(0, 0);
    for (int i = 0; i < sz(a); ++i)
        a[i] = {tin[i], i};
    sort(all(a));
    for (int i = 0; i < sz(a); ++i) {
        posin[a[i].second] = i;
        pair<int, int> pii = {tout[a[i].second], -1};
        posout[a[i].second] = lower_bound(all(a), pii) - a.begin();
    }
    init(1, 0, R);
}
//
//void upd(int x, int MAXD, int xl, int xr, int ql, int qr) {
//    if (xr <= ql || qr <= xl)
//        return;
//    if (ql <= xl && xr <= qr) {
//        sum[x] = (xr - xl);
//        ps[x] = 1;
//        return;
//    }
//    int mid = (xl + xr) >> 1;
//    upd(x * 2, xl, mid, ql, qr);
//    upd(x * 2 + 1, mid, xr, ql, qr);
//    sum[x] = sum[x * 2] + sum[x * 2 + 1];
//}
//
//void upd(int x) {
//    int l = posin[x];
//    int r = posout[x];
//    upd(1, 0, R, l, r);
//}
//
//void push(int x, int xl, int xr) {
//    int mid = (xl + xr) >> 1;
//    if (ps[x] == 1) {
//        sum[x * 2] = mid - xl;
//        sum[x * 2 + 1] = xr - mid;
//        ps[x * 2] = 1;
//        ps[x * 2 + 1] = 1;
//        ps[x] = 0;
//    }
//}

int get_X(int XXX, int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return sum[XXX][x];
    int mid = (xl + xr) >> 1;
    return get_X(XXX, x * 2, xl, mid, ql, qr) + get_X(XXX, x * 2 + 1, mid, xr, ql, qr);
}

int fnd_ind(int x, int MAXD) {
    int l = -1;
    int r = sz(t[x]);
    while (l + 1 < r) {
        int mid = (l + r) >> 1;
        if (d[t[x][mid]] > MAXD)
            r = mid;
        else
            l = mid;
    }
    return r;
}

int get(int x, int MAXD, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return get_X(x, 1, 0, xr - xl, 0, fnd_ind(x, MAXD));
//    push(x, xl, xr);
    int mid = (xl + xr) >> 1;
    return get(x * 2, MAXD, xl, mid, ql, qr) + get(x * 2 + 1, MAXD, mid, xr, ql, qr);
}

int get(int x, int MAXD) {
    int l = posin[x];
    int r = posout[x];
    return get(1, MAXD, 0, R, l, r);
}

void solve() {
    cin >> n;
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
    }
    for (int i = 0; i < n; ++i)
        cin >> fu[i];
    init();
    int q;
    cin >> q;
    while (q--) {
        int ty, x, k;
        cin >> ty >> x >> k;
        --x;
        if (ty == 1) {
//            upd(x);
        } else
            cout << get(x, d[x] + k) << "\n";
    }
//    for (int i = 0; i < sz(sum[2]); ++i)
//        cout << sum[2][i] << " ";


}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}