#include <bits/stdc++.h>

#define fr(i, a, b) for(int i = (a); i <= (b); ++i)
#define rf(i, a, b) for(int i = (a); i >= (b); --i)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))

using namespace std;

mt19937_64 rng(chrono::system_clock::now().time_since_epoch().count());

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template<typename T>
bool umn(T& a, T b) { return (a > b ? (a = b, 1) : 0); }
template<typename T>
bool umx(T& a, T b) { return (a < b ? (a = b, 1) : 0); }

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template<typename T>
using ve = vector<T>;

const int N = 5e5 + 5;

int n;
int s[N], e[N];
ve<pii> g[N];
int d[N];
int timer;
int tin[N], tout[N];
int D[N];

void dfs(int v = 0, int p = 0, int dep = 0) {
    d[v] = dep;
    tin[v] = timer++;
    fe(to, g[v]) {
        if(to.fi == p) continue;
        D[to.fi] = D[v] + 1;
        dfs(to.fi, v, dep + to.se);
    }
    tout[v] = timer++;
}

bool is_upper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

ve<array<int, 3>> paths;

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#else
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;

    fr(i, 0, n - 1) {
        cin >> s[i];
    }
    fr(i, 0, n - 1) {
        cin >> e[i];
    }

    fr(i, 1, n - 1) {
        int p, w;
        cin >> p >> w;
        p--;

        g[p].pb({i, w});
        g[i].pb({p, w});

//        cout << i + 1 << " " << p + 1 << " " << w << "\n";
    }

    dfs();

    fr(i, 0, n - 1) {
        fr(j, 0, n - 1) {
            if(i == j) continue;
            if(!is_upper(i, j)) continue;
            paths.pb(array<int, 3>{d[j] - d[i], i, j});
        }
    }
    sort(all(paths), [&](array<int, 3> a, array<int, 3> b) {
        if(a[0] != b[0]) return a[0] > b[0];
        return D[a[1]] > D[b[1]];
    });
//    reverse(all(paths));

//    fe(cur, paths) {
//        cout << cur[0] << " " << cur[1] + 1 << " " << cur[2] + 1 << "\n";
//    }
//    cout << "\n";

    ll ans = 0;
    fr(i, 0, sz(paths) - 1) {
        if(paths[i][0] <= 0) break;

        int take = min(s[paths[i][1]], e[paths[i][2]]);
        s[paths[i][1]] -= take;
        e[paths[i][2]] -= take;
        ans += 1LL * paths[i][0] * take;

//        cout << paths[i][1] + 1 << " " << paths[i][2] + 1 << " " << take << "\n";
    }

    cout << ans << "\n";

    return 0;
}
