#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int N = 2020;

vector<pair<int, int>> g[N];
int tin[N], tout[N], timer;
int D[N], e[N], s[N];

void dfs(int v){
      tin[v] = ++ timer;
      for(auto [w, to] : g[v]){
            D[to] = D[v] + w;
            dfs(to);
      }
      tout[v] = ++ timer;
}

bool upper(int a, int b){
      return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int main(){
      ios_base :: sync_with_stdio(0);
      cin.tie(0); cout.tie(0);
      int n; cin >> n;
      for(int i = 0; i < n; i ++)
            cin >> s[i];
      for(int i = 0; i < n; i ++)
            cin >> e[i];
      for(int i = 0; i < n - 1; i ++){
            int p, w;
            cin >> p >> w;
            g[p - 1].emplace_back(w, i + 1);
      }
      dfs(0);
      ll result = 0;
      while(true){
            tuple<int, int, int> best = make_tuple(INT_MIN, -1, -1);
            for(int i = 0; i < n; i ++){
                  if(!s[i])
                        continue;
                  for(int j = 0; j < n; j ++){
                        if(!e[j])
                              continue;
                        if(!upper(i, j))
                              continue;
                        best = max(best, make_tuple(D[j] - D[i], i, j));
                  }
            }
            if(get<0>(best) <= 0)
                  break;
            auto [w, i, j] = best;
            int v = min(s[i], e[j]);
            s[i] -= v;
            e[j] -= v;
//            cout << v << " : " << i + 1 << " " << j + 1 << " - " << w << endl;
            result += w * v;
      }
      cout << result;
}
