#include <bits/stdc++.h>
using namespace std;

#define ll long long

int const N = 2005;
int const inf = 1e9 + 7;

ll s[N], e[N];
ll p[N], w[N];
vector<ll> g[N];
ll tin[N], tout[N];
ll timer;
vector<pair<ll, pair<ll, ll>>> ara;

void dfs(int v) {
    tin[v] += timer;
    timer++;
    for (auto& to: g[v])
        dfs(to);
    tout[v] += timer;
}

int main() {
    ll n;
    cin >> n;
    for (int i = 1; i <= n; i++) 
        cin >> s[i];
    for (int i = 1; i <= n; i++)
        cin >> e[i];
    for (int i = 1; i <= n - 1; i++) {
        cin >> p[i + 1] >> w[i + 1];
        g[p[i + 1]].push_back(i + 1);
    }

    dfs(1);

    for (int i = 1; i <= n; i++) {
        if (s[i] == 0)
            continue;
        for (int j = 1; j <= n; j++) {
            if (!(tin[i] <= tin[j] && tout[i] >= tout[j])) {
                continue;
            }

            int v = j;
            int dis = 0;
            while(v != i) {
                dis += w[v];
                v = p[v];
            }

            ara.push_back(make_pair(dis, make_pair(i, j)));
        }
    }

    sort(ara.begin(), ara.end());

    ll answ = 0;
    for (int i = ara.size() - 1; i >= 0; i--) {
        if (ara[i].first <= 0)
            break;
        if (s[ara[i].second.first] != 0 && e[ara[i].second.second] != 0) {
            answ += ara[i].first;
            s[ara[i].second.first]--;
            e[ara[i].second.second]--;
            i++;
        }
    }

    cout << answ << "\n";
    
    return 0;
}
