#include <bits/stdc++.h>

using namespace std;

#define ll long long

int const N = 2e5 + 5;
int const inf = 1e9 + 7;

vector<int> g[N];
int b[N];

void dfs1(int v, int dist, int k) {
    if (dist > k)
        return;
    
    b[v] = 1;
    for (auto& to: g[v]) {
        dfs1(to, dist + 1, k);
    }
}

int dfs2(int v, int dist, int k) {
    int ret = 0;
    if (dist > k)
        return 0;
    
    ret += b[v];
    for (auto& to: g[v]) {
        ret += dfs2(to, dist + 1, k);
    }

    return ret;
}

int main() {
    int n;
    cin >> n;

    for (int i = 0; i < n - 1; i++) {
        int x, y;
        cin >> x >> y;
        g[x].push_back(y);
    }

    for (int i = 1; i <= n; i++)
        cin >> b[i];

    int q;
    cin >> q;
    while(q--) {
        int ara, x, k;
        cin >> ara >> x >> k;
        if (ara == 1) {
            dfs1(x, 0, k);
        } else {
            cout << dfs2(x, 0, k) << "\n";
        }
    }


    return 0;
}