#include <bits/stdc++.h>
#define fr(i, n, m) for(int i = (n); i < (m); i++)
#define pb push_back
#define st first
#define nd second
#define pq priority_queue
#define all(x) begin(x), end(x)

using namespace std;
typedef long long ll;
typedef pair<int,int> pii;

const int mxn = 2e5+5;

int n, q;
vector<int> g[mxn];
int sub[mxn];
int depth[mxn];
int pos[mxn];
int node[mxn];

int state[mxn];

int p;
void dfs(int u){
	node[p] = u;
	
	pos[u] = p++;
	sub[u] = 1;
	for(auto e : g[u]){
		depth[e] = depth[u] + 1;
		dfs(e);
		sub[u] += sub[e];
	}
}

vector<int> seg[4*mxn];
vector<int> all[4*mxn];
int maxd[4*mxn];



int BIT[30][mxn];
void add(int i, int j, int v){
	while(j < mxn){
		BIT[i][j] += v;
		j += j&-j;
	}
}
int sum(int i, int j){
	int su = 0;
	while(j > 0){
		su += BIT[i][j];
		j -= j&-j;
	}
	return su;
}
void remove(int k, int l, int r, int x, int dep){
	if(x < l || x > r) return;
	int N = all[k].size();
	int K = 0;
	while(all[k][K] != node[x]) ++K;
	
	/*for(int B = (N+1)/2; B >= 1; B /= 2){
		while(K + B < N && depth[all[k][K+B]] >= depth[node[x]]) K += B;
	}*/
	//x found here
	int relative_pos = l + K;
	add(dep, relative_pos + 1, +1);
	
	
	if(l == r) return;
	int mid = (l+r)/2;
	remove(k*2, l, mid, x, dep + 1);
	remove(k*2+1, mid+1, r, x, dep + 1);
}
void UPDATE(int x){
	
	state[x] = 1;
	remove(1, 0, n-1, pos[x], 0);
}




void build(int k, int l, int r){
	
	if(l == r){
		if(state[node[l]] == 0) seg[k] = {node[l]};
		all[k] = {node[l]};
		return;
	}
	int mid = (l+r)/2;
	build(k*2, l, mid);
	build(k*2+1, mid+1, r);
	
	
	int N = (int)seg[k*2].size();
	int M = (int)seg[k*2+1].size();
	fr(i, 0, N) seg[k].pb(seg[k*2][i]);
	fr(i, 0, M) seg[k].pb(seg[k*2+1][i]);
	sort(all(seg[k]), [](const int &i, const int &j){
		return depth[i] > depth[j];
	});
	
	N = (int)all[k*2].size();
	M = (int)all[k*2+1].size();
	fr(i, 0, N) all[k].pb(all[k*2][i]);
	fr(i, 0, M) all[k].pb(all[k*2+1][i]);
	sort(all(all[k]), [](const int &i, const int &j){
		return depth[i] > depth[j];
	});
	
	/*seg[k].resize(N+M);
	
	int p1 = 0, p2 = 0, p3 = 0;
	
	while(p1 < N && p2 < M){
		if(depth[seg[k*2][p1]] > depth[seg[k*2+1][p2]]){
			seg[k][p3++] = seg[k*2][p1++];
		}
		else{
			seg[k][p3++] = seg[k*2+1][p2++];
		}
	}
	while(p1 < N){
		seg[k][p3++] = seg[k*2][p1++];
	}
	while(p2 < M){
		seg[k][p3++] = seg[k*2+1][p2++];
	}*/
	
	
	
	
}

int query(int k, int l, int r, int x, int y, int D, int dep){
	if(r < x || y < l){
		return 0;
	}
	if(x <= l && r <= y){
		int N = all[k].size();
		int K = -1;
		for(int B = (N+1)/2; B >= 1; B /= 2){
			while(K + B < N && depth[all[k][K+B]] > D) K += B;
		}
		K++;		
		int REMOVED = sum(dep, r+1) - sum(dep, l+K);		
		
		
		
		return REMOVED;
	}
	int mid = (l+r)/2;
	return query(k*2, l, mid, x, y, D, dep+1) + query(k*2+1, mid+1, r, x, y, D, dep+1);
}


void update(int k, int l, int r, int x, int y, int carry, int D){
	if(r < x || y < l) return;
	
	
	if(x <= l && r <= y){
		while(!seg[k].empty() && depth[seg[k].back()] <= D){
			int u = seg[k].back();
			seg[k].pop_back();
			if(state[u] == 1) continue;
			state[u] = 1;
			UPDATE(u);
		}
		
		maxd[k] = max(maxd[k], D);	
		return;
	}
	int mid = (l+r)/2;
	update(k*2, l, mid, x, y, maxd[k], D);
	update(k*2+1, mid+1, r, x, y, maxd[k], D);
}

int main(){
	memset(maxd, -1, sizeof(maxd));
	
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	
	cin >> n;
	fr(i, 0, n-1){
		int x, y;
		cin >> x >> y;
		--x, --y;
		g[x].pb(y);
	}
	
	
	fr(i, 0, n){
		cin >> state[i];
	}
	dfs(0);
	
	build(1, 0, n-1);
	fr(i, 0, n){
		if(state[i] == 1) UPDATE(i);
	}
	
	
	
	
	
	
	cin >> q;
	
	fr(i, 0, q){
		int t, x, k;
		cin >> t >> x >> k;
		--x;
		int L = pos[x];
		int R = pos[x] + sub[x] - 1;
		int D = depth[x] + k;
		
		
		if(t == 1){
			update(1, 0, n-1, L, R, -1, D);
		}
		else{
			cout<<query(1, 0, n-1, L, R, D, 0)<<endl;
		
		}
	}
	return 0;
}
