#include <iostream>
#include <vector>

using namespace std;
vector<vector<int> /**/> tree;
vector<bool> marked;

void tell(int x, int k)
{
    if (k == 0)
    {
        marked[x] = 1;
    }
    else
    {
        marked[x] = 1;
        for (int i = 0; i < tree[x].size(); i++)
        {
            int a = k - 1;
            tell(tree[x][i], a);
        }
    }
}
int count(int x, int k)
{
    if (k == 0)
    {
        return marked[x];
    }
    else
    {
        int r = 0;
        for (int i = 0; i < tree[x].size(); i++)
        {
            int a = k - 1;
            r += count(tree[x][i], a);
        }
        r += marked[x];
        return r;
    }
}
int main()
{
    int n;
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        vector<int> a;
        tree.push_back(a);
    }
    for (int i = 0; i < n - 1; i++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        tree[x].push_back(y);
    }
    //cout << "here" << endl;
    for (int i = 0; i < n; i++)
    {
        bool a;
        cin >> a;
        marked.push_back(a);
    }
    //cout << "here" << endl;
    int q;
    cin >> q;
    //cout << "here" << endl;
    for (int i = 0; i < q; i++)
    {
        int t;
        int x;
        int k;
        cin >> t >> x >> k;
        x--;
        if (t == 1)
        {
            tell(x, k);
        }
        if (t == 2)
        {
            cout << count(x, k) << endl;
        }
    }
}