#include <iostream>
#include <vector>

using namespace std;

const int N = 5e5 + 5;

vector<int> fii[N];
int m[N], av[N], w[N];
long long sp[N], best, ans;
int a, b;

void getBestPath(int nod, long long min_sum, int idx) {
  if (idx != -1 && nod != 1 && av[nod]) {
    long long ww = sp[nod] - min_sum;
    if (ww > best) {
      best = ww;
      a = idx, b = nod;
    }
  }
  if (nod != 1 && sp[nod] < min_sum && m[nod]) {
    min_sum = sp[nod];
    idx = nod;
  }
  for (auto f : fii[nod]) {
    sp[f] = sp[nod] + w[f];
    getBestPath(f, min_sum, idx);
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 1; i <= n; ++i)
    cin >> m[i];
  for (int i = 1; i <= n; ++i)
    cin >> av[i];
  for (int i = 2; i <= n; ++i) {
    int tata;
    cin >> tata >> w[i];
    fii[tata].push_back(i);
  }
  while (true) {
    best = 0;
    if (m[1] > 0)
      getBestPath(1, 0, 1);
    else
      getBestPath(1, 1 << 30, -1);
    if (best == 0)
      break;
    int cati = min(m[a], av[b]);
    ans += best * cati;
    m[a] -= cati, av[b] -= cati;
  }
  cout << ans << "\n";
  return 0;
}
