#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int N = 5e5 + 5;

struct path {
  int a, b;
  int w;
  bool operator<(const path& P) const {
    return w > P.w;
  }
};

vector<int> fii[N], v;
vector<path> p;
int m[N], av[N], w[N];


void dfs(int nod) {
  int s = w[nod];
  if (av[nod])
    for (int i = v.size() - 1; i >= 0; --i) {
      if (m[v[i]] && s > 0)
        p.push_back({v[i], nod, s});
      s += w[v[i]];
    }
  v.push_back(nod);
  for (auto f : fii[nod])
    dfs(f);
  v.pop_back();
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 1; i <= n; ++i)
    cin >> m[i];
  for (int i = 1; i <= n; ++i)
    cin >> av[i];
  for (int i = 2; i <= n; ++i) {
    int tata;
    cin >> tata >> w[i];
    fii[tata].push_back(i);
  }
  dfs(1);
  sort(p.begin(), p.end());
  long long ans = 0;
  for (auto i : p) {
    int cati = min(m[i.a], av[i.b]);
    if (cati == 0)
      continue;
    ans += i.w * cati;
    m[i.a] -= cati;
    av[i.b] -= cati;
  }
  cout << ans << "\n";
  return 0;
}
