#include <iostream>
#include <vector>

using namespace std;

const int N = 2e5 + 5;

vector<int> fii[N];
bool marcat[N];
int ans;

void update(int nod, int k) {
  marcat[nod] = true;
  if (k == 0) return;
  for (auto f : fii[nod])
    update(f, k - 1);
}

void query(int nod, int k) {
  ans += marcat[nod];
  if (k == 0) return;
  for (auto f : fii[nod])
    query(f, k - 1);
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr), cout.tie(nullptr);
  int n;
  cin >> n;
  for (int i = 0; i < n - 1; ++i) {
    int x, y;
    cin >> x >> y;
    fii[x].push_back(y);
  }
  for (int i = 1; i <= n; ++i)
    cin >> marcat[i];
  int q;
  cin >> q;
  while (q--) {
    int cer, nod, k;
    cin >> cer >> nod >> k;
    if (cer == 1)
      update(nod, k);
    else {
      ans = 0;
      query(nod, k);
      cout << ans << "\n";
    }
  }
  return 0;
}