// miners.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> vvp;
typedef vector<int> vi;
typedef vector<vi> vvi;

vector<set<pii>> paths;
vvp tu;
vi ans;

int dp(int v, vvp& g, vi& s, vi& e, int p)
{
    int end = 0;
    int umax = 0;
    for (pii u : g[v])
    {
        if (u.first == p) continue;
        int eu;
        eu = dp(u.first, g, s, e, v);
        end += eu;
        ans[v] += ans[u.first];
        for (pii t : paths[u.first]) paths[v].insert({ t.first + u.second, t.second });
        if (u.second > 0) tu[v].push_back({u.second, eu});
        umax = max(u.second, umax);
    }
    //sort(paths[v].begin(), paths[v].end());
    int miners = s[v];
    int count = 0;
    if (!paths[v].empty())
    {
        auto i = paths[v].end();
        vector<pii> temp;
        for (i--; i != paths[v].begin() && miners > 0; i--)
        {
            pii path = *i;
            if (e[path.second] > 0 && path.first >= umax)
            {
                int c = min(e[path.second], miners);
                ans[v] += c * path.first;
                e[path.second] -= c;
                miners -= c;
                count += c;
            }
            if (e[path.second] == 0) temp.push_back(path);
        }
        for (pii t : temp) paths[v].erase(t);
    }
    if (miners >= 0)
    {
        sort(tu[v].begin(), tu[v].end(), greater<pii>());
        for (pii u : tu[v])
        {
            int c = min(u.second, miners);
            ans[v] += c * u.first;
            miners -= c;
            if (miners == 0) break;
        }
    }
    for(pii u : g[v]) if(u.first != p) paths[v].insert({ u.second, u.first });
    if (!paths[v].empty())
    {
        auto i = paths[v].end();
        vector<pii> temp;
        for (i--; i != paths[v].begin() && miners > 0; i--)
        {
            pii path = *i;
            if (e[path.second] > 0 && path.first > 0)
            {
                int c = min(e[path.second], miners);
                ans[v] += c * path.first;
                e[path.second] -= c;
                miners -= c;
                count += c;
            }
            if (e[path.second] == 0) temp.push_back(path);
        }
        for (pii t : temp) paths[v].erase(t);
    }
    end += count;
    return end;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    vi s(n); vi e(n);
    for (int i = 0; i < n; i++) cin >> s[i];
    for (int i = 0; i < n; i++) cin >> e[i];
    vvp g(n);
    for (int i = 0; i < n-1; i++)
    {
        int u, w; cin >> u >> w;
        u--;
        g[i+1].push_back({ u, w });
        g[u].push_back({ i+1, w });
    }
    paths.resize(n);
    ans.resize(n, 0);
    tu.resize(n);
    dp(0, g, s, e, -1);
    cout << ans[0] << endl;
}
