#include "bits/stdc++.h"

using namespace std;

#define len(a) (int)((a).size())

using ll = int_fast64_t;

const int INF = 1 << 29;

void solve(){
    int n;
    cin >> n;
    vector<int> s(n), e(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i] >> e[i];
    }
    int p1 = 0, p2 = n - 1;
    ll ans = 0;
    while(p1 < p2){
        int c = min(s[p1], e[p2]);
        ans += c * (p2 - p1);
        s[p1] -= c, e[p2] -= c;
        if(s[p1] == 0)
            ++p1;
        if(e[p2] == 0)
            --p2;
    }
    cout << ans;
}

signed main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
