#include <bits/stdc++.h>

#define f first
#define s second
#define m_p make_pair
#define vec vector
#define pb push_back
#define all(x) (x).begin(),(x).end()
#define rall(x) (x).rbegin(),(x).rend()
#define pw(x) (1LL<<(x))
#define sz(x) (int)(x).size()
#define fast_iati ios_base::sync_with_stdio(false);cin.tie(0);cout.tie(0);

using namespace std;

typedef long long ll;
typedef pair<int,int> pii;
template<class T> bool umin(T &a,const T &b){return (a>b?a=b,1:0);}
template<class T> bool umax(T &a,const T &b){return (a<b?a=b,1:0);}
const int N=2e5+1;
vec<int> g[N];
int in[N],out[N],tt=0,h[N];
struct segtree{
    pii t[4*N];
    segtree(){
        fill(t,t+4*N,m_p(2e9,-1));
    }
    void upd(int id,pii x,int v,int tl,int tr){
        if(tl==tr){
            t[v]=x;
            return;
        }
        int tm=(tl+tr)>>1;
        if(tm>=id)
            upd(id,x,2*v,tl,tm);
        else
            upd(id,x,2*v+1,tm+1,tr);
        t[v]=min(t[2*v],t[2*v+1]);
    }
    pii get(int l,int r,int v,int tl,int tr){
        if(tl>=l&&tr<=r){
            return t[v];
        }
        if(tl>r||tr<l)
            return {2e9,1};
        int tm=(tl+tr)>>1;
        return min(get(l,r,2*v,tl,tm),get(l,r,2*v+1,tm+1,tr));
    }
}sega;
struct _2d_fenw{
    struct fenwick{
        vec<int> a;
        vec<int> f;
        void build(){
            a.erase(unique(all(a)),a.end());
            f.assign(sz(a)+1,0);
        }
        void upd(int i,int x){
            i=lower_bound(all(a),i)-a.begin();
            ++i;
            while(i<=sz(a)){
                f[i]+=x;
                i+=i&-i;
            }
        }
        int get(int i){
            ++i;
            int ans=0;
            while(i>0){
                ans+=f[i];
                i-=i&-i;
            }
            return ans;
        }
        int get(int l,int r){
            l=lower_bound(all(a),l)-a.begin();
            r=upper_bound(all(a),r)-a.begin()-1;
            return get(r)-get(l-1);
        }
    };
    fenwick t[4*N];
    void build(int v,int tl,int tr){
        t[v].build();
        if(tl==tr) return;
        int tm=(tl+tr)>>1;
        build(2*v,tl,tm);
        build(2*v+1,tm+1,tr);
    }
    void add(int id,int h,int v,int tl,int tr){
        t[v].a.pb(h);
        if(tl==tr){
            return;
        }
        int tm=(tl+tr)>>1;
        if(tm>=id)
            add(id,h,2*v,tl,tm);
        else
            add(id,h,2*v+1,tm+1,tr);
    }
    void _add(int id,pii x,int v,int tl,int tr){
        t[v].upd(x.f,x.s);
        if(tl==tr){
            return;
        }
        int tm=(tl+tr)>>1;
        if(tm>=id)
            _add(id,x,2*v,tl,tm);
        else
            _add(id,x,2*v+1,tm+1,tr);
    }
    int get(int l,int r,int l1,int r1,int v,int tl,int tr){
        if(tl>=l&&tr<=r){
            return t[v].get(l1,r1);
        }
        if(tl>r||tr<l)
            return 0;
        int tm=(tl+tr)>>1;
        return get(l,r,l1,r1,2*v,tl,tm)+get(l,r,l1,r1,2*v+1,tm+1,tr);
    }
}seg1;
void dfs(int v){
    in[v]=tt++;
    for(auto &z : g[v]){
        h[z]=h[v]+1;
        dfs(z);
    }
    out[v]=tt-1;
}
signed main(){
    fast_iati;
    int n;
    cin>>n;
    for(int i=1;i<n;i++){
        int v,u;
        cin>>v>>u;--v;--u;
        g[v].pb(u);
    }
    dfs(0);
    vec<int>a(n);
    for(int i=0;i<n;i++)
        cin>>a[i];
    vec<int>p(n);iota(all(p),0);
    sort(all(p),[&](int i,int j){return h[i]<h[j];});
    for(auto &v : p){
        seg1.add(in[v],h[v],1,0,n-1);
    }
    seg1.build(1,0,n-1);
    for(int i=0;i<n;i++){
        if(!a[i]){
            sega.upd(in[i],{h[i],i},1,0,n-1);
        }
        else{
            seg1._add(in[i],{h[i],1},1,0,n-1);
        }
    }
    int q;
    cin>>q;
    while(q--){
        int t,v,k;
        cin>>t>>v>>k;
        --v;
        if(t==1){
            while(1){
                pii w=sega.get(in[v],out[v],1,0,n-1);
                if(w.f-h[v]>k) break;
                int u=w.s;
                sega.upd(in[u],{2e9,-1},1,0,n-1);
                seg1._add(in[u],{h[u],1},1,0,n-1);
            }
        }
        else{
            cout<<seg1.get(in[v],out[v],h[v],h[v]+k,1,0,n-1)<<'\n';
        }
    }
    return 0;
}
