#include<bits/stdc++.h>
using namespace std;

#define pb push_back
#define ll long long
#define sz(a) (int)a.size()
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()

#define int long long
const int N = 105;
ll path[N][N], s[N], e[N];
const ll inf = 1e12;
ll depth[N];
vector<pair<int,int>> adj[N];
void dfs(int u, int par, int node){
    for(auto x: adj[u]){
        int v = x.first, w = x.second;
        if(v == par)continue;
        path[node][v] = path[node][u] + w;
        if(node == 0)depth[v] = depth[u] + 1;
        dfs(v, u, node);
    }
}

void solve(){
    int n;
    cin >> n;
    for(int i = 0;i < n; ++i){
        cin >> s[i];
    }
    for(int i = 0;i < n; ++i){
        cin >> e[i];
    }

    for(int i = 0;i < n; ++i)for(int j = 0;j < n; ++j)path[i][j] = -inf;

    for(int i = 1;i < n; ++i){
        int u, w;
        cin >> u >> w;
        --u;
        adj[u].pb({i, w});
    }
    for(int i = 0;i < n; ++i){
        path[i][i] = 0;
        dfs(i, i, i);
    }
    ll ans = 0;
    vector<pair<int,int>> a;
    for(int i = 0;i < n; ++i){
        a.pb({depth[i], i});
    }
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    for(auto x: a){
        int i = x.second;
        vector<pair<int,int>> v;
        for(int j = 0;j < n; ++j){
            if(s[j] && path[j][i] > 0){
                v.pb({path[j][i], j});
            }
        }
        sort(v.begin(),v.end());
        reverse(v.begin(), v.end());
        for(auto x: v){
            int j = x.second;
            ll f = min(s[j], e[i]);
            s[j] -= f;
            e[i] -= f;
            ans += f * path[j][i];
        }
    }
    cout << ans << "\n";
}

int32_t main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);
    int t = 1;
    //cin >> t;

    while(t--){
        solve();
    }
}
