#include <bits/stdc++.h>
#define ll long long
#define all(x) (x).begin(),(x).end()

#pragma GCC optimize("-O3")
#pragma GCC target("avx,avx2,fma")
#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = 2e5 + 5;
vector <int> gr[N];
vector <int> eu;

int in[N], out[N], h[N];

inline void dfs(int v, int p = -1) {
    eu.push_back(v);
    in[v] = eu.size() - 1;
    for (auto to : gr[v]) if (to != p) {
        h[to] = h[v] + 1; dfs(to, v);
    }
    out[v] = eu.size() - 1;
}

int t[4 * N], fl[4 * N];
inline void build(int v, int vl, int vr, vector<int> &a) {
    if (vl == vr) { t[v] = a[vl]; return; }
    int m = vl + vr >> 1;
    build(2 * v + 1, vl, m, a);
    build(2 * v + 2, m + 1, vr, a);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}
inline void push(int v, int vl, int vr) {
    if (!fl[v]) return;
    if (vl != vr) {
        for (auto u : {2 * v + 1, 2 * v + 2}) {
            fl[u] |= fl[v];
        }
    }
    t[v] = vr - vl + 1;
    fl[v] = 0;
}
inline void upd(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (l > r) return;
    else if (vl == l && vr == r) {
        fl[v] = 1;
        push(v, vl, vr);
        return;
    }
    int m = vl + vr >> 1;
    upd(2 * v + 1, vl, m, l, min(r, m));
    upd(2 * v + 2, m + 1, vr, max(l, m + 1), r);
    t[v] = t[2 * v + 1] + t[2 * v + 2];
}
inline int get(int v, int vl, int vr, int l, int r) {
    push(v, vl, vr);
    if (l > r) return 0;
    else if (vl == l && vr == r) return t[v];
    int m = vl + vr >> 1;
    int a = get(2 * v + 1, vl, m, l, min(r, m));
    int b = get(2 * v + 2, m + 1, vr, max(l, m + 1), r);
    return a + b;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int v, u;
        cin >> v >> u, --v, --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    }

    dfs(0);
    vector <int> p(n);
    for (int i = 0; i < n; ++i) cin >> p[i];

    int q;
    cin >> q;

    if (n <= (int)5e4 && q <= (int)5e4) {
        while (q--) {
            int t;
            cin >> t;
            if (t == 2) {
                int v, k;
                cin >> v >> k, --v;

                int ans = 0;
                for (int i = in[v]; i <= out[v]; ++i) {
                    if (h[eu[i]] <= h[v] + k)
                        ans += p[eu[i]];
                }
                cout << ans << '\n';
            }
            else {
                int v, k;
                cin >> v >> k, --v;

                int ans = 0;
                for (int i = in[v]; i <= out[v]; ++i) {
                    if (h[eu[i]] <= h[v] + k)
                        p[eu[i]] = 1;
                }
            }
        }
    }
    else {
        vector <int> a(n);
        for (int i = 0; i < n; ++i) a[i] = p[eu[i]];

        build(0, 0, n - 1, a);

        while (q--) {
            int t, v, k;
            cin >> t >> v >> k, --v;

            if (t == 1) upd(0, 0, n - 1, in[v], out[v]);
            else cout << get(0, 0, n - 1, in[v], out[v]) << '\n';
        }
    }
}
