#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define all(x) (x).begin(),(x).end()

//#pragma GCC optimize("-O3")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;
using namespace __gnu_pbds;
using oset = tree <int, null_type, less_equal<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int N = 2e5 + 5;
vector <int> gr[N];
vector <int> eu;

int in[N], out[N], h[N];

inline void dfs(int v, int p = -1) {
    eu.push_back(v);
    in[v] = eu.size() - 1;
    for (auto to : gr[v]) if (to != p) {
        h[to] = h[v] + 1; dfs(to, v);
    }
    out[v] = eu.size() - 1;
}

#define pii pair<int,int>
#define fi first
#define se second

set <pii> t[4 * N];

inline void upd(int v, int vl, int vr, int pos, pii cur) {
    t[v].insert(cur);
    if (vl == vr) return;
    int m = vl + vr >> 1;
    if (pos <= m) upd(2 * v + 1, vl, m, pos, cur);
    else upd(2 * v + 2, m + 1, vr, pos, cur);
}

void to_del(int v, int vl, int vr, int l, int r, int to, vector <pii> &res) {
    if (t[v].empty() || t[v].begin()->fi > to) return;

    if (l > r) return;
    else if (vl == l && vr == r) {
        auto it = t[v].begin();
        while (it != t[v].end() && it->fi <= to) {
            res.push_back(*it); ++it;
        }
        return;
    }

    int m = vl + vr >> 1;
    to_del(2 * v + 1, vl, m, l, min(r, m), to, res);
    to_del(2 * v + 2, m + 1, vr, max(l, m + 1), r, to, res);
}

inline void er(int v, int vl, int vr, int pos, pii cur) {
    t[v].erase(cur);
    if (vl == vr) return;
    int m = vl + vr >> 1;
    if (pos <= m) er(2 * v + 1, vl, m, pos, cur);
    else er(2 * v + 2, m + 1, vr, pos, cur);
}

oset tt[4 * N];

inline void upd(int v, int vl, int vr, int pos, int x) {
    tt[v].insert(x);
    if (vl == vr) return;
    int m = vl + vr >> 1;
    if (pos <= m) upd(2 * v + 1, vl, m, pos, x);
    else upd(2 * v + 2, m + 1, vr, pos, x);
}

inline int answer(int v, int vl, int vr, int l, int r, int x) {
    if (l > r) return 0;
    else if (vl == l && vr == r) return tt[v].order_of_key(x + 1);
    int m = vl + vr >> 1;
    int a = answer(2 * v + 1, vl, m, l, min(r, m), x);
    int b = answer(2 * v + 2, m + 1, vr, max(l, m + 1), r, x);
    return a + b;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int v, u;
        cin >> v >> u, --v, --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    } dfs(0);

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x) upd(0, 0, n - 1, in[i], h[i]);
        else {
            pii cur = {h[i], i};
            upd(0, 0, n - 1, in[i], cur);
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t, v, k;
        cin >> t >> v >> k, --v;

        if (t == 2) cout << answer(0, 0, n - 1, in[v], out[v], h[v] + k) << '\n';
        else {
            vector <pii> kek;
            to_del(0, 0, n - 1, in[v], out[v], h[v] + k, kek);

            for (auto lel : kek) {
                er(0, 0, n - 1, in[lel.se], lel);
                upd(0, 0, n - 1, in[lel.se], lel.fi);
            }
        }
    }
}
