#include <bits/stdc++.h>
#define ll long long
#define all(x) (x).begin(),(x).end()

//#pragma GCC optimize("-O3")
//#pragma GCC target("avx,avx2,fma")
//#pragma GCC optimize("unroll-loops")

using namespace std;

const int N = 2e5 + 5;
vector <int> gr[N];
vector <int> eu;

int in[N], out[N], h[N];

inline void dfs(int v, int p = -1) {
    eu.push_back(v);
    in[v] = eu.size() - 1;
    for (auto to : gr[v]) if (to != p) {
        h[to] = h[v] + 1; dfs(to, v);
    }
    out[v] = eu.size() - 1;
}

#define pii pair<int,int>
#define fi first
#define se second

constexpr int K = 987;

struct oset {
    int f[N];
    inline void upd(int i, int x) { i += 2;
        for (; i < N; i += i & -i) f[i] += x;
    }
    inline int order_of_key(int i) {
        int ans = 0; i += 2;
        for (; i; i -= i & -i) ans += f[i];
        return ans;
    }
} f[N / K + 5];

int a[N];

int del[N];

pii b[N];
set <pii> t[N / K + 5];

inline void upd(int pos, pii cur) {
    b[pos] = cur; del[pos] = 0;
    t[pos / K].insert(cur);
}

void to_del(int l, int r, int to, vector <pii> &kek) {

    int lb = l / K, rb = r / K;

    if (lb == rb) {
        for (int i = l; i <= r; ++i) {
            if (del[i] || b[i].fi > to) continue;
            kek.push_back(b[i]);
        }
        return;
    }
    for (int i = lb + 1; i <= rb - 1; ++i) {
        auto it = t[i].begin();
        if (it != t[i].end() && it->fi <= to) {
            kek.push_back(*it);
            ++it;
        }
    }
    for (int i = l; i < (lb + 1) * K; ++i) {
        if (del[i] || b[i].fi > to) continue;
        kek.push_back(b[i]);
    }
    for (int i = r; i >= rb * K; --i) {
        if (del[i] || b[i].fi > to) continue;
        kek.push_back(b[i]);
    }
}

inline void er(int pos, pii cur) {
    del[pos] = 1; b[pos] = {1e9, 1e9};
    t[pos / K].erase(cur);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int v, u;
        cin >> v >> u, --v, --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    } dfs(0);

    for (int i = 0; i < n; ++i) a[i] = 1e9;

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x) {
            a[in[i]] = h[i];
            f[in[i] / K].upd(h[i], 1); del[in[i]] = 1;
        }
        else {
            pii cur = {h[i], i};
            upd(in[i], cur);
        }
    }

    int q;
    cin >> q;
    while (q--) {
        int t, v, k;
        cin >> t >> v >> k, --v;

        if (t == 2) {
            int l = in[v], r = out[v];
            int lb = l / K, rb = r / K;

            if (lb == rb) {
                int ans = 0;
                for (int i = l; i <= r; ++i) {
                    ans += a[i] <= h[v] + k;
                }
                cout << ans << '\n';
                continue;
            }

            int ans = 0;
            for (int i = lb + 1; i <= rb - 1; ++i) ans += f[i].order_of_key(h[v] + k);
            for (int i = l; i < (lb + 1) * K; ++i) ans += (a[i] <= h[v] + k);
            for (int i = r; i >= rb * K; --i) ans += (a[i] <= h[v] + k);

            cout << ans << '\n';
        }
        else {
            vector <pii> kek;
            to_del(in[v], out[v], h[v] + k, kek);

            for (auto lel : kek) {
                er(in[lel.se], lel);
                a[in[lel.se]] = lel.fi;
                f[in[lel.se] / K].upd(lel.fi, 1);
            }
        }
    }
}
