#include <bits/stdc++.h>
#define ll long long
#define all(x) (x).begin(),(x).end()

using namespace std;

const int inf = INT_MAX;

const int N = 2e5 + 5;
constexpr int K = 1201;

vector <int> gr[N];
vector <int> eu;

int in[N], out[N], h[N];

inline void dfs(int v, int p = -1) {
    eu.push_back(v);
    in[v] = eu.size() - 1;
    for (auto to : gr[v]) if (to != p) {
        h[to] = h[v] + 1; dfs(to, v);
    }
    out[v] = eu.size() - 1;
}

#define pii pair<int,int>
#define fi first
#define se second

struct oset {
    int f[N];
    oset() { memset(f, 0, sizeof(f)); }
    inline void upd(int i, int x) { i += 2;
        for (; i < N; i += i & -i) f[i] += x;
    }
    inline int order_of_key(int i) {
        int ans = 0; i += 2;
        for (; i; i -= i & -i) ans += f[i];
        return ans;
    }
} f[N / K + 5];

int a[N];

int del[N];

pii b[N];
multiset <pii> t[N / K + 5];

inline void add(int v) {
    b[in[v]] = {h[v], v};
    del[in[v]] = 0;

    a[in[v]] = inf; t[in[v] / K].insert(b[in[v]]);
}

inline void remov(int v) {

    assert(!del[in[v]]);

    int be = in[v] / K;
    t[be].erase(t[be].find(b[in[v]]));
    b[in[v]] = {inf, inf};
    del[in[v]] = 1;

    a[in[v]] = h[v];
    f[in[v] / K].upd(h[v], 1);
}

void to_del(int l, int r, int to, vector <int> &kek) {
    int lb = l / K, rb = r / K;
    if (lb == rb) {
        for (int i = l; i <= r; ++i) {
            if (del[i]) continue;
            int v = eu[i];

            if (h[v] > to) continue;
            kek.push_back(v);
        }
        return;
    }

    for (int i = l; i < (lb + 1) * K; ++i) {
        if (del[i]) continue;

        int v = eu[i];
        if (h[v] > to) continue;
        kek.push_back(v);
    }
    for (int i = r; i >= rb * K; --i) {
        if (del[i]) continue;

        int v = eu[i];
        if (h[v] > to) continue;
        kek.push_back(v);
    }
    for (int i = lb + 1; i <= rb - 1; ++i) {
        if (t[i].empty()) continue;

        auto it = t[i].begin();
        while (it != t[i].end() && it->fi <= to) {
            assert(!del[in[it->se]]);
            kek.push_back(it->se);
            ++it;
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int v, u;
        cin >> v >> u, --v, --u;
        gr[v].push_back(u);
        gr[u].push_back(v);
    } dfs(0);

    for (int i = 0; i < n; ++i) add(i);

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        if (x) remov(i);
    }

    int q;
    cin >> q;
    while (q--) {
        int t, v, k;
        cin >> t >> v >> k, --v;

        if (t == 2) {
            int l = in[v], r = out[v];
            int lb = l / K, rb = r / K;

            if (lb == rb) {
                int ans = 0;
                for (int i = l; i <= r; ++i) {
                    if (!del[i]) continue;
                    ans += a[i] <= h[v] + k;
                }
                cout << ans << '\n';
                continue;
            }

            int ans = 0;
            for (int i = lb + 1; i <= rb - 1; ++i) ans += f[i].order_of_key(h[v] + k);
            for (int i = l; i < (lb + 1) * K; ++i) if (!del[i]) ans += (a[i] <= h[v] + k);
            for (int i = r; i >= rb * K; --i) if (!del[i]) ans += (a[i] <= h[v] + k);

            cout << ans << '\n';
        }
        else {
            vector <int> kek;
            to_del(in[v], out[v], h[v] + k, kek);
            for (auto v : kek) remov(v);
        }
    }
}
