#include<bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define ckmin(a, b) a = min(a, b)
#define ckmax(a, b) a = max(a, b)
#define int long long

int n, timer = 0;
vector<int> s, e, d, tin, tout, par;
vector<vector<pair<int, int>>> g;

void dfs1(int v, int p = -1) {
    par[v] = p;
    tin[v] = timer++;
    for (auto &U : g[v]) {
        int u = U.first, w = U.second;
        if (u != p) {
            d[u] = d[v] + w;
            dfs1(u, v);
        }
    }
    tout[v] = timer++;
}

bool parent(int i, int j) {
    return tin[i] <= tin[j] && tout[i] >= tout[j];
}

int get_dist(int v, int u) {
    if (v > u)
        swap(v, u);
    return d[u] - d[v];
}

multiset<pair<int, int>> pairing;

//multiset<pair<int, int>> dfs(int v, int p = -1) {
//    multiset<pair<int, int>> cur;
//    for (auto &U : g[v]) {
//        int u = U.first, w = U.second;
//        if (u != p) {
//            auto t = dfs(u, v);
//            for (auto val : t) {
//                cur.insert({val.first + w, val.second});
//            }
//        }
//    }
//
//    for (int i = 0; i < e[v]; ++i)cur.insert({0, v});
//
//    while (!cur.empty() && s[v] > 0) {
//        auto val = *(--cur.end());
//        pairing.insert({v, val.second});
//        cur.erase(cur.find(val));
//        s[v]--;
//    }
//
//    vector<pair<int, int>> er, ins;
//    for (auto &t : pairing) {
//        if (s[v] > 0 && get_dist(v, t.second) > get_dist(t.first, t.second)) {
//            er.emplace_back(t.first, t.second);
//            ins.emplace_back(v, t.second);
//            s[v]--;
//        }
//    }
//
//    for (auto &t : ins) {
//        pairing.insert(t);
//    }
//    for (auto &t : er) {
//        pairing.erase(pairing.find(t));
//    }
//
//    return cur;
//}

const int inf = 1e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    s.resize(n);
    e.resize(n);
    g.resize(n);
    d.resize(n);
    tin.resize(n);
    tout.resize(n);
    par.resize(n);

    for (int i = 0; i < n; ++i)cin >> s[i];
    for (int i = 0; i < n; ++i) cin >> e[i];
    for (int i = 1; i < n; ++i) {
        int p, w;
        cin >> p >> w;
        g[--p].push_back({i, w});
        g[i].push_back({p, w});
    }

    dfs1(0);

    int res = 0;
    while (true) {
        vector<pair<int, pair<int, int>>> best;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                if (parent(i, j) && s[i] > 0 && e[j] > 0) {
                    vector<int> path;
                    int jj = j;
                    while (jj != i) {
                        path.push_back(jj);
                        jj = par[jj];
                    }
                    path.push_back(i);
                    reverse(all(path));

                    int sz = path.size();
                    vector<int> suf(sz, -inf);
                    if (s[path[sz - 1]] > 0)suf[sz - 1] = get_dist(path[sz - 1], j);

                    for (int id = sz - 2; id >= 0; --id) {
                        suf[id] = suf[id + 1];
                        if (s[path[id]] > 0)ckmax(suf[id], get_dist(path[id], j));
                    }

                    int best_left = -inf;
                    int bestt = -inf;

                    for (int id = 0; id < sz - 1; ++id) {
                        if (e[id] > 0)ckmax(best_left, get_dist(i, path[id]));
                        if (best_left != -inf && suf[id + 1] != -inf)ckmax(bestt, best_left + suf[id + 1]);
                    }
                    if(best_left <= get_dist(i, j)){
                        best.push_back({get_dist(i, j), {i, j}});
                    }
                }
            }
        }
        sort(rall(best));
        if(best.empty())break;
        res += max(0ll, best[0].first);
        s[best[0].second.first]--;
        e[best[0].second.second]--;
    }
    cout << res;
}
