#include <bits/stdc++.h>
#define pii pair <int, int>
#define pii64 pair <int64, int64>
using namespace std;
const int maxn = 200200;
vector <int> ad [maxn];
bitset <maxn> know;
#define long long int64

int get (int x, int k) {
    queue <pii> q;
    q.push({x, 0});
    int rs = 0;
    while (!q.empty()) {
        pii u = q.front();
        q.pop();
        if (know[u.first]) rs++;
        if (u.second == k) continue;
        for (auto v: ad[u.first]) {
            q.push({v, u.second + 1});
        }
    }
    return rs;
}

void update (int x, int k) {
    queue <pii> q;
    q.push({x, 0});
    int rs = 0;
    while (!q.empty()) {
        pii u = q.front();
        q.pop();
        know[u.first] = 1;
        if (u.second == k) continue;
        for (auto v: ad[u.first]) {
            q.push({v, u.second + 1});
        }
    }
}

int main() {
    cin.tie(0); ios::sync_with_stdio(false);
    int n,q;
    cin >> n;
    for (int i = 0; i < n - 1; i++){
        int x,y;
        cin >> x >> y;
        ad[x].push_back(y);
    }
    for (int i = 1; i <= n; i++){
        int t;
        cin >> t;
        know[i] = !!t;
    }
    cin >> q;
    while (q--) {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 2) {
            cout << get(x, k) << "\n";
        }
        else {
            update(x, k);
        }
    }
    return 0;
}
