#include <bits/stdc++.h>
#define pii pair <int, int>
#define pii64 pair <int64, int64>
#define long long int64
using namespace std;
const int maxn = 200200;
vector <int> ad [maxn];
bitset <maxn> know;
bitset <maxn> full;
vector <int> good (maxn);
int dad[maxn];
vector <int> ch (maxn);

int dfs2 (int u) {
    for (auto v: ad[u]) {
        good[u]+= dfs2(v);
    }
    good[u]+=know[u];
    return good[u];
}

int dfs (int u) {
    for (auto v: ad[u]) {
        ch[u]+=dfs(v);
    }
    ch[u]++;
    return ch[u];
}

int get (int x) {
    queue <int> q;
    q.push(x);
    int rs = 0;
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        if (full[u]) {
            rs+=ch[u];
            continue;
        }
        if (know[u]) rs++;
        for (auto v: ad[u]) {
            q.push(v);
        }
    }
    return rs;
}
void update (int x) {
    int dif = ch[x] - good[x];
    if (!dif) return;
    queue <int> q;
    q.push(x);
    while (!q.empty()) {
        int u = q.front();
        q.pop();
        int udif = ch[u] - good[u];
        if (!udif) continue;
        good[u] = ch[u];
        for (auto v: ad[u]) {
            q.push(v);
        }
    }
    while (1) {
        if (x == 1) break;
        x = dad[x];
        good[x]+=dif;
    }
}


int main() {
    cin.tie(0); ios::sync_with_stdio(false);
    int n,q;
    cin >> n;
    for (int i = 0; i < n - 1; i++){
        int x,y;
        cin >> x >> y;
        ad[x].push_back(y);
        dad[y] = x;
    }
    for (int i = 1; i <= n; i++){
        int t;
        cin >> t;
        know[i] = !!t;
    }
    dfs(1);
    dfs2(1);
    cin >> q;
    while (q--) {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 2) {
            cout << good[x] << "\n";
        }
        else {
            update(x);
        }
    }
    return 0;
}
