#include <bits/stdc++.h>
#define pii pair <int, int>
#define pii64 pair <int64, int64>
#define long long int64
using namespace std;
const int maxn = 200200;
vector <int> ad [maxn];
bitset <maxn> know;
bitset <maxn> full;
vector <int> good (maxn);
int dad[maxn];
vector <int> ch (maxn);
vector <int> mxdp (maxn, -1);

int dfs2 (int u) {
    for (auto v: ad[u]) {
        good[u]+= dfs2(v);
    }
    good[u]+=know[u];
    return good[u];
}

int dfs (int u) {
    for (auto v: ad[u]) {
        ch[u]+=dfs(v);
    }
    ch[u]++;
    return ch[u];
}

int get (int x, int k) {
    queue <pii> q;
    q.push({x, k});
    int rs = 0;
    while (!q.empty()) {
        int u = q.front().first, nk = q.front().second;
        q.pop();
        if (full[u] && mxdp[u] <= nk) {
            rs+=good[u];
            continue;
        }
        if (know[u]) rs++;
        if (!nk) continue;
        for (auto v: ad[u]) {
            q.push({v, nk - 1});
        }
    }
    return rs;
}
void update (int x, int k) {
    int dif = 0;
    queue <pii> q;
    q.push({x, k});
    while (!q.empty()) {
        int u = q.front().first, nk = q.front().second;
        q.pop();
        int udif = ch[u] - good[u];
        if (!udif) continue;
        if (mxdp[u] <= nk) {
            know[u] = 1;
            dif+=ch[u] - good[u];
            good[u] = ch[u];
            continue;
        }
        if (!know[u]) {
            know[u] = 1;
            dif++;
        }
        if (!nk) continue;
        for (auto v: ad[u]) {
            q.push({v, nk - 1});
        }
    }
    while (1) {
        if (x == 1) break;
        x = dad[x];
        good[x]+=dif;
    }
}


int main() {
    cin.tie(0); ios::sync_with_stdio(false);
    int n,q;
    cin >> n;
    for (int i = 0; i < n - 1; i++){
        int x,y;
        cin >> x >> y;
        ad[x].push_back(y);
        dad[y] = x;
    }
    queue <int> qq;
    for (int i = 1; i <= n; i++){
        int t;
        cin >> t;
        know[i] = !!t;
        if (ad[i].empty()) {
            qq.push(i);
            mxdp[i] = 0;
        }
    }
    while (!qq.empty()) {
        int u = qq.front();
        qq.pop();
        if (u == 0) continue;
        if (mxdp[dad[u]] < mxdp[u] + 1) {
            mxdp[dad[u]] = mxdp[u] + 1;
            qq.push(dad[u]);
        }
    }
    dfs(1);
    dfs2(1);
    cin >> q;
    while (q--) {
        int t, x, k;
        cin >> t >> x >> k;
        if (t == 2) {
            cout << get(x,k) << "\n";
        }
        else {
            update(x, k);
        }
    }
    return 0;
}
