#include <bits/stdc++.h>

using namespace std;


int N, Q, p, state[200004], loc[200004];
vector<int> G[200004];
unordered_map<int, pair<int, int>> interval;
vector<pair<int, int>> br;

void cleanup() {
    for(auto i = br.begin(); i != br.end(); i++) {
        if(i + 1 != br.end() && (i + 1)->first <= i->second)
        {
            i->second = max(i->second, (i + 1)->second);
            br.erase(i + 1);
            i--;
        }
    }
}

int intersection(pair<int, int> a, pair<int, int> b) {
    if(a.first > b.first)
        swap(a, b);

    if(b.first > a.second) return 0;

    return min(a.second, b.second) - max(a.first, b.first) + 1;
}


void broadcast(int nod, int k) {
    int st = interval[nod].first;
    int dr = interval[nod].second;

    pair<int, int> p = {st, dr};
    br.insert(lower_bound(br.begin(), br.end(), p), p);
    cleanup();
}


int check(int nod, int k) {
    int st = interval[nod].first;
    int dr = interval[nod].second;

    int sum = 0;

    for(auto p : br) {
        sum += intersection({st, dr}, p);
    }

    return sum;
}

void euler(int nod = 1) {
    p++;
    if(state[nod])
        br.push_back({p, p});
    interval[nod].first = p;
    for(auto it : G[nod])
        euler(it);
    interval[nod].second = p;
}

int main()
{
    cin >> N;
    for(int i = 1; i < N; i++) {
        static int x, y;
        cin >> x >> y;
        G[x].push_back(y);
    }
    for(int i = 1; i <= N; i++) {
        cin >> state[i];
    }
    euler();
    cin >> Q;
    for(int i = 1; i <= Q; i++) {
        int tip, x, k;
        cin >> tip >> x >> k;
        if(tip == 1) {
            broadcast(x, k);
        } else if(tip == 2) {
            cout << check(x, k) << "\n";
        }
    }
    return 0;
}
