#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <set>
#include <map>
#include <vector>
#include <stack>
#include <queue>
#include <unordered_map>
#include <iomanip>
#include <bitset>

using namespace std;

#define ll long long
#define ull unsigned long long
#define ft first
#define sc second
#define mpr make_pair()
#define all(v) v.begin(), v.end()
#define sz(a) (ll)a.size()
#define add push_back
#define vi vector<int>
#define pii pair<int,int>
#define FOR(i,a,b) for(ll i = (a); i < (b); i++)
#define FORD(i,a,b) for(ll i = (a); i >= (b); i--)
#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

const ll MOD = 1e9+7;
const ll INF = 1e9;
const int N = 200005;

int par[N];
vi g[N];
bool marked[N];
int ansnow = 0;
int dis[N];
int know;

void bfs(int u, bool isup)
{
    queue<int> q;
    dis[u] = 0;
    q.push(u);
    if(!isup)
    {
        ansnow+=marked[u];
    }
    if(isup)
    {
        marked[u] = 1;
    }
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        for(auto f : g[v])
        {
            if(f != par[v])
            {
                dis[f] = dis[v]+1;
                if(dis[f] > know)
                {
                    return;
                }
                if(isup)
                {
                    marked[f] = 1;
                }
                else
                {
                    ansnow+=marked[f];
                }
                q.push(f);
            }
        }
    }
}

int main()
{

    fastio;

    int n;
    cin>>n;
    FOR(i,1,n)
    {
        int a,b;
        cin>>a>>b;
        par[b] = a;
        g[a].add(b);
        g[b].add(a);
    }
    FOR(i,1,n+1)
    {
        int a;
        cin>>a;
        marked[i] = a;
    }
    int qq;
    cin>>qq;
    while(qq--)
    {
        int gg;
        cin>>gg;
        if(gg == 1)
        {
            int pp;
            cin>>pp>>know;
            bfs(pp,1);
        }
        else
        {
            int pp;
            cin>>pp>>know;
            ansnow = 0;
            bfs(pp,0);
            cout<<ansnow<<endl;
        }
    }

    return 0;
}