#include <bits/stdc++.h>

using namespace std;

#define int long long

vector < vector < pair <int, int> > > a;
vector < pair <int, pair <int, int> > > dist;
int cur = 0;

void dfs(int v, int d){
    if(cur != v){
        dist.push_back({d, {cur, v}});
    }
    for(auto to : a[v]){
        dfs(to.first, d + to.second);
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <int> k(n), e(n);
    a.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> k[i];
    }
    for(int i = 0; i < n; ++i){
        cin >> e[i];
    }

    for(int i = 0; i < n - 1; ++i){
        int x, y;
        cin >> x >> y;
        a[x - 1].push_back({i + 1, y});
    }

    for(int i = 0; i < n; ++i){
        cur = i;
        dfs(i, 0);
    }

    sort(dist.rbegin(), dist.rend());

    int otv = 0;
    for(auto i : dist){
        int d = i.first;
        int x = i.second.first;
        int y = i.second.second;

        if(d <= 0){
            break;
        }

        int z = min(k[x], e[y]);
        otv += z * d;
        k[x] -= z;
        e[y] -= z;
    }

    cout << otv;
}