#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;

void solvek0(int q) {
    rep(_, q) {
        int n;
        cin >> n;
        int b = 0, s = 0;
        rep(i, n) {
            int x, y;
            cin >> x >> y;
            b ^= x;
            s ^= y;
        }
        if (b == 0 && s == 0) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    }
}

void solve() {
    int k, q;
    cin >> k >> q;
    if (k == 0) {
        solvek0(q);
        return;
    }
    const int N = 32;
    vector<vector<int>> grandy(N, vector<int>(N));
    rep(i, N) {
        rep(j, N) {
            if (j == 0) continue;
            vector<int> have(N * N);
            for (int x = 0; x <= i; ++x) {
                for(int y = (i - x) * k; y < N; ++y) {
                    if (x == i && y >= j) break;
                    have[grandy[x][y]] = 1;
                }
            }
            rep(e, N * N) {
                if (!have[e]) {
                    grandy[i][j] = e;
                    break;
                }
            }
        }
    }
    rep(_, q) {
        int n;
        cin >> n;
        int g = 0;
        rep(i, n) {
            int b, s;
            cin >> b >> s;
            g ^= grandy[b][s];
        }
        if (g == 0) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}