#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;

void solvek0(int q) {
    rep(_, q) {
        int n;
        cin >> n;
        int b = 0, s = 0;
        rep(i, n) {
            int x, y;
            cin >> x >> y;
            b ^= x;
            s ^= y;
        }
        if (b == 0 && s == 0) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    }
}

void solve() {
    int k, q;
    cin >> k >> q;
    const int B = 310;
    vector<vector<int>> g1(B);
    vector<vector<int>> g2(B);
    for (int i = 1; i < B; ++i) {
        vector<vector<int>> have(i);
        rep(j, i) {
            have[j].resize(max(0, (i - j) * k - (int) g1[j].size()));
        }
        rep(j, i) {
            for (int e = (i - j) * k; e < (int) g1[j].size(); ++e) {
                if (g2[j][e] < (int) have[g1[j][e]].size()) {
                    have[g1[j][e]][g2[j][e]] = 1;
                }
            }
            int start = max(0, (i - j) * k - (int) g1[j].size());
            while (start < (int) have[j].size()) {
                have[j][start++] = 1;
            }
        }
        int a = 0;
        int b = 0;
        while (a != i) {
            g1[i].push_back(a);
            g2[i].push_back(b);
            have[a][b] = 1;
            while (b < have[a].size() && have[a][b] == 1) b++;
            while (a < i && b == have[a].size()) {
                a++;
                if (a == i) break;
                b = 0;
                while (b < have[a].size() && have[a][b] == 1) b++;
            }
        }
    }
    rep(_, q) {
        int n;
        cin >> n;
        int b = 0, s = 0;
        rep(i, n) {
            int x, y;
            cin >> x >> y;
            if (y >= g1[x].size()) {
                b ^= x;
                s ^= (y - (int) g1[x].size());
            } else {
                b ^= g1[x][y];
                s ^= g2[x][y];
            }
        }
        if (b == 0 && s == 0) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}