#include <bits/stdc++.h>

#define rep(i, n) for(int i = 0; i < (n); ++i)
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define ar array

using namespace std;

typedef long long ll;

using vi = vector<int>;

void solvek0(int q) {
    rep(_, q) {
        int n;
        cin >> n;
        int b = 0, s = 0;
        rep(i, n) {
            int x, y;
            cin >> x >> y;
            b ^= x;
            s ^= y;
        }
        if (b == 0 && s == 0) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    }
}

void solve() {
    int k, q;
    cin >> k >> q;
    if (k == 0) {
        solvek0(q);
        return;
    }
    const int B = 310;
    vector<vector<ar<int, 4>>> g(B);
    // 300 * 300 * 300
    const int INFi = 2e9;
    g[0].push_back({0, 0, 0, INFi});
    for (int i = 1; i < B; ++i) {
        vector<vector<pair<int, int>>> have(i);
        rep(j, i) {
            int start = (i - j) * k;
            for (int e = (int) g[j].size() - 1; e >= 0; --e) {
                auto[pos, a, b, c] = g[j][e];
                have[a].emplace_back(max(start - pos, b), c);
                if (pos <= start) break;
            }
        }
        int cur = 0;
        rep(j, i) {
            have[j].push_back({-1, -1});
            sort(all(have[j]));
            for (int e = 1; e < (int) have[j].size(); ++e) {
                if (have[j][e - 1].second + 1 == have[j][e].first) continue;
                assert(have[j][e - 1].second + 1 < have[j][e].first);
                g[i].push_back({cur, j, have[j][e - 1].second + 1, have[j][e].first - 1});
                cur += have[j][e].first - have[j][e - 1].second - 1;
            }
        }
        g[i].push_back({cur, i, 0, INFi});
    }
    rep(_, q) {
        int n;
        cin >> n;
        int b = 0, s = 0;
        rep(i, n) {
            int x, y;
            cin >> x >> y;
            ar<int, 4> cur = {y + 1, -1, -1, -1};
            int j = lower_bound(all(g[x]), cur) - g[x].begin();
            j--;
            b ^= g[x][j][1];
            s ^= (y - g[x][j][0] + g[x][j][2]);
        }
        if (b == 0 && s == 0) {
            cout << "Loss\n";
        } else {
            cout << "Win\n";
        }
    }
}

int main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);
    int tests = 1;
    rep(_, tests) {
        solve();
    }
    return 0;
}