#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second
#define ll long long
const int N = 2005;
ll dist[N][N];
ll s[N];
ll e[N];
vector <pair<int, ll>> g[N];
void dfs(int nod, int start)
{
    for (auto son : g[nod])
    {
        dist[start][son.x] = dist[start][nod] + son.y;
        dfs(son.x, start);
    }
}
struct ura{
    int x, y; ll z;
} v[N * N];
bool cmp(ura a, ura b)
{
    if (a.z != b.z)
    return a.z > b.z;
    return e[a.y] > e[b.y];
}
int main()
{
    int n; ll ans = 0;
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> s[i];
    for (int i = 1; i <= n; i++)
        cin >> e[i];
    for (int i = 2; i <= n; i++)
    {
        int x; ll y;
        cin >> x >> y;
        g[x].push_back({i, y}); ///son and cost
    }
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            dist[i][j] = -2e9;
    for (int i = 1; i <= n; i++)
        dist[i][i] = 0;
    for (int i = 1; i <= n; i++)
        dfs(i, i);
    int m = 0;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
        {
            v[++m] = {i, j, dist[i][j]};
        }
    sort(v + 1, v + m + 1, cmp);
    for (int i = 1; i <= m; i++)
    {
        int x = v[i].x;
        int y = v[i].y;
        ll d = v[i].z;
        if (d < 0)
            break;
        if (e[y] >= s[x])
        {
            ans += s[x] * d;
            e[y] -= s[x];
            s[x] = 0;
        }
        else
        {
            ans += e[y] * d;
            s[x] -= e[y];
            e[y] = 0;
        }
        s[y] += s[x];
    }
    cout << ans;
    return 0;
}
