#include <bits/stdc++.h>

#define INF 1.1e9
#define pb push_back
#define pause system("pause")
#define exit exit(0)
#define endl '\n'

using namespace std;
using ull = unsigned long long;
using ll = long long;

typedef pair<int, int> pii;
const int N = 200005;

int n, q, par[N];
char b[N];
vector<int> g[N];

void dfs_pre(int u) {
	for (auto v : g[u]) {
		if (v != par[u]) {
			par[v] = u;
			dfs_pre(v);
		}
	}
}

void dfs_upd(int u, int k) {
	b[u] = 1;
	if (k == 0) return;
	for (auto v : g[u]) {
		if (v != par[u]) {
			dfs_upd(v, k - 1);
		}
	}
}

int dfs_ans(int u, int k) {
	int ans = b[u];
	if (k == 0) return ans;
	for (auto v : g[u]) {
		if (v != par[u]) {
			ans += dfs_ans(v, k - 1);
		}
	}

	return ans;
}

void naive() {
	dfs_pre(1);
	for (int i = 0, t, p, x; i < q; ++i) {
		cin >> t >> p >> x;
		if (t == 1) {
			dfs_upd(p, x);
		} else {
			cout << dfs_ans(p, x) << endl;
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	cin >> n;
	for (int i = 0, u, v; i < n - 1; ++i) {
		cin >> u >> v;
		g[u].pb(v), g[v].pb(u);
	}

	for (int i = 1; i <= n; ++i) {
		cin >> b[i];
		b[i] -= '0';
	}

	cin >> q;
	if (n <= 10000) {
		naive();
		return 0;
	}
return 0;

	//dfs(1);

	for (int i = 0, t, x, k, cnt = 0; i < n; ++i) {
		cin >> t >> x >> k;
	}
	pause;
	return 0;
}