#include<bits/stdc++.h>
#define p pair<int, int>
#define endl '\n'
const int INF = 1000000001;

using namespace std;

vector<int> is;

struct MST{
    vector<vector<int>> do_arr;
    int len;

    MST(vector<p> &a) {
        len = 1;
        while (len < a.size()) {
            len *= 2;
        }
        do_arr.assign(2*len, {});
        for (int q = len; q < len+a.size(); q++) {
            if (is[a[q-len].first] == 1) {
                do_arr[q] = {a[q-len].second};
            }
        }
        for (int q = len-1; q > 0; q--) {
            merge(do_arr[2*q].begin(), do_arr[2*q].end(), do_arr[2*q+1].begin(), do_arr[2*q+1].end(), back_inserter(do_arr[q]));
        }
    }

    int ans(int l, int r, int l1, int r1, int q, int h) {
        if (l >= r1 || l1 >= r) {
            return 0;
        }
        if (l1 <= l && r <= r1) {
            auto w = upper_bound(do_arr[q].begin(), do_arr[q].end(), h);
            return w-do_arr[q].begin();
        }
        int m = (l+r)/2;
        return ans(l, m, l1, r1, 2*q, h)+ans(m, r, l1, r1, 2*q+1, h);
    }
};

vector<vector<int>> d;
vector<int> tin, tout, height;
vector<p> order;
int time1 = 0;

void make(int vertex, int h) {
    tin[vertex] = time1++, height[vertex] = h;
    order.push_back({vertex, h});
    for (int q : d[vertex]) {
        make(q, h+1);
    }
    tout[vertex] = time1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n;
    d.assign(n, {}), is.assign(n, -1), tin.assign(n, -1), tout.assign(n, -1), height.assign(n, -1);
    for (int q = 0; q < n-1; q++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        d[x].push_back(y);
    }
    for (int q = 0; q < n; q++) {
        cin >> is[q];
    }
    make(0, 0);
    MST mst = MST(order);
    cin >> m;
    for (int q = 0; q < m; q++) {
        int type, x, k;
        cin >> type >> x >> k;
        x--;
        if (type == 1) {
            exit(179);
        } else {
            cout << mst.ans(0, mst.len, tin[x], tout[x], 1, height[x]+k) << endl;
        }
    }
    return 0;
}
