#include <bits/stdc++.h>

using namespace std;


vector<vector<int>> dp;
vector<int> s, e;
vector<vector<pair<int, int>>> adj;


pair<int, vector<int>> dfs(int u) {
	vector<int> diff;
	int sum = 0;

	for(auto [v, w]: adj[u]) {
		auto [child_sum, child_diff] = dfs(v);
		sum += child_sum;
		for(int d1: child_diff) {
			diff.emplace_back(d1 + w);
		}
	}

	sort(diff.begin(), diff.end());

	int c = 0;
	for(int i = 0; i < s[u]; i++) {
		if(!diff.empty() && diff.back() > 0) {
			sum += diff.back();
			diff.pop_back();
			c++;
		}
	}

	for(int i = 0; i < c + e[u]; i++) {
		diff.push_back(0);
	}

	sort(diff.begin(), diff.end());

	// cerr << "dp[" << u + 1 << "] = {" << sum << ", { ";
	// for(int x: diff) {
	// 	cerr << x << " ";
	// }
	// cerr << "}} (" << c << ")" << endl;

	return {sum, diff};
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;

	dp.resize(n);

	s.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> s[i];
	}
	e.resize(n);
	for(int i = 0; i < n; i++) {
		cin >> e[i];
	}

	adj.resize(n);
	for(int v = 1; v < n; v++) {
		int p, w;
		cin >> p >> w;
		p--;
		adj[p].emplace_back(v, w);
	}

	auto res = dfs(0);

	cout << res.first << endl;

	return 0;
}
