#include <bits/stdc++.h>
using namespace std;

int n;
vector<int> num(10001,0);
vector<int> vis(10001,0);
int dfs(int r, vector<int> &p, vector<vector<int>> &adj) {

	
	int res=vis[r];

	for (int i:adj[r]) {
		res+=dfs(i,p,adj);
	}


	return num[r]=res;





}

int update1(int r,int k, vector<int> &p, vector<vector<int>> &adj) {


	vis[r]=1;
	
	int res=vis[r];

	for (int i:adj[r]) {
		if (k-1>=0) res+=update1(i,k-1,p,adj);
		else res+=num[i];
	}


	return num[r]=res;





}

void update2(int r,int k, vector<int> &p, vector<vector<int>> &adj) {

	if (p[r]==-1) return;

	num[p[r]]+=k;

	update2(p[r],k,p,adj);
	





}

int bfs(int r,int k,vector<int> &p, vector<vector<int>> &adj) {

	vector<int> dist(10001,0);

	queue<int> q;
	q.push(r);
	int res=0;

	while (!q.empty()) {
		int s=q.front();

		q.pop();

		//vis[s]=1;
		res+=(vis[s]==1);
		if (r==2) {
			//cout<<s<<' '<<vis[s]<<'\n';

		}
		

		for (int i:adj[s]) {
			//cout<<s<<':'<<i<<'\n';
			if (dist[s]+1<=k) {
				dist[i]=dist[s]+1;
				q.push(i);
			}

		}




	}

	return res;


}

int main() {
	cin.tie(nullptr);
	cin.sync_with_stdio(false);

	
	cin>>n;

	vector<int> p(n+1,-1);
	vector<vector<int>> adj(n+1);

	//cout<<"sdfasdf";

	//return 0;

	int x,y;
	for (int i=0;i<n-1;i++) {

		cin>>x>>y;

		p[y-1]=x-1;

		adj[x-1].push_back(y-1);
	}


	

	for (int i=0;i<n;i++) {
		cin>>vis[i];		
	}

	dfs(0,p,adj);

	int q;
	cin>>q;

	

	int typ;

	for (int i=0;i<q;i++) {
		int k;
		cin>>typ;
		cin>>x>>k;
		x--;

		//cout<<typ<<' '<<x<<' '<<k<<'\n';

		if (typ==1) {
			int diff=num[x];

			update1(x,k,p,adj);

			//update2(x,num[x]-diff,p,adj);

		}
		else {
			//cout<<x<<k;
			cout<<bfs(x,k,p,adj)<<'\n';

		}
	}


	return 0;

}