#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#define int long long
#define pb push_back
#define ft first
#define sc second

using namespace std;
using namespace __gnu_pbds;

const int N = 2e5 + 55;
const int INF = 1e5;

int ans = 0;
vector <pair <int, int> > g[N];
int a[N];
int b[N];

pair <int, int> dfs1(int v) {
    int mx = -INF, id = v;
    for (auto it : g[v]) {
        int to = it.ft;
        int cost = it.sc;
        pair <int, int> p = dfs1(to);
        if (mx < p.ft + cost) {
            mx = p.ft + cost;
            id = p.sc;
        }
    }
    if (a[v] != b[v] && mx < 0) mx = 0, id = v;
    return {mx, id};
}

void dfs(int v) {
    for (auto it : g[v]) {
        int to = it.ft;
        int cost = it.sc;
        dfs(to);
    }
    while(a[v]) {
        pair <int, int> p = dfs1(v);
        a[v] --;
        if (p.sc == v || p.ft < 0) continue;
        else {
//            cout << v << ' ' << p.ft << ' ' << p.sc << '\n';
            a[p.sc] ++;
            ans += p.ft;
        }
    }
}

main() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; i ++) {
        cin >> b[i];
    }
    for (int i = 2; i <= n; i ++) {
        int x, y;
        cin >> x >> y;
        g[x].pb({i, y});
    }
    multiset <int, greater <int> > s;
    s.insert(0);
    int cur = 0;
    int ans = 0;
    for (int i = n - 1; i >= 1; i --) {
        cur += g[i][0].sc;
        if (*s.begin() + cur > 0) {
            ans += *s.begin() + cur;
//            cout << i << ' ' << cur << ' ' << *s.begin() + cur << '\n';
            s.erase(s.begin());
        }
        s.insert(-cur);
    }
    cout << ans;
}
