#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
//#define int long long
#define pb push_back
#define ft first
#define sc second

using namespace std;
using namespace __gnu_pbds;

const int N = 2e5 + 55;

typedef tree <pair <int, int>, null_type, less<pair <int, int> >, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

int a[N];
int ht[N];
pair <int, int> hh[N];
int h1[N];
int tin[N];
int tout[N];
vector <int> g[N];
ordered_set t[4 * N];
vector <int> t1[4 * N];
vector <pair <int, int> > prom[4 * N];
vector <pair <int, int> > tmp1;
int timer = 0;
int n;
int cnn = 0;
int cnn1 = 0;

inline ordered_set Merge(ordered_set x, ordered_set y) {
    for (auto it : y) x.insert(it);
    return x;
}

inline vector <int> Merge1(vector <int> & v1, vector <int> & v2) {
    int l1 = 0, l2 = 0;
    vector <int> vec;
    while (l1 < v1.size() && l2 < v2.size()) {
        if (v1[l1] < v2[l2]) vec.pb(v1[l1 ++]);
        else vec.pb(v2[l2 ++]);
    }
    while (l1 < v1.size()) {
        vec.pb(v1[l1 ++]);
    }
    while (l2 < v2.size()) {
        vec.pb(v2[l2 ++]);
    }
    return vec;
}

void build(int v, int tl, int tr) {
    if (tl == tr) {
        if (hh[tl].ft) {
            t[v].insert(hh[tl]);
        }
        t1[v].pb(h1[tl]);
        return;
    }
    int m = (tl + tr) / 2;
    build(v * 2, tl, m);
    build(v * 2 + 1, m + 1, tr);
    t[v] = Merge(t[v * 2], t[v * 2 + 1]);
    t1[v] = Merge1(t1[v * 2], t1[v * 2 + 1]);
}

void push(int v, int tl, int tr) {
    if (!prom[v].empty()) {
        int m = (tl + tr) / 2;
        for (auto it : prom[v]) {
            t[v].erase(it);
            if (tl != tr) {
                if (it.sc <= m) prom[v * 2].pb(it);
                else prom[v * 2 + 1].pb(it);
            }
        }
        prom[v].clear();
    }
}

void get2(int v, int tl, int tr, int l, int r, int ch) {
    push(v, tl, tr);
    if (tl == l && tr == r) {
        auto it = t[v].upper_bound({ch, n + 1});
        auto rr = upper_bound(t1[v].begin(), t1[v].end(), ch);
        cnn1 += (rr - t1[v].begin());
        if (it == t[v].end()) cnn += t[v].size();
        else {
            cnn += t[v].order_of_key(*it);
        }
        return;
    }
    int m = (tl + tr) / 2;
    if (l <= min(r, m)) get2(v * 2, tl, m, l, min(r, m), ch);
    if (max(m + 1, l) <= r) get2(v * 2 + 1, m + 1, tr, max(m + 1, l), r, ch);
}

//void update(int v, int tl, int tr, int pos, int cur1, int cur2) {
//    t[v].erase(make_pair(cur1, cur2));
//    if (tl == tr) return;
//    int m = (tl + tr) / 2;
//    if (pos <= m) update(v * 2, tl, m, pos, cur1, cur2);
//    else update(v * 2 + 1, m + 1, tr, pos, cur1, cur2);
//}

void get3(int v, int tl, int tr, int l, int r, int ch) {
    push(v, tl, tr);
    if (tl == l && tr == r) {
        for (auto it : t[v]) {
            if (it.ft > ch) break;
            prom[1].pb(it);
        }
        return;
    }
    int m = (tl + tr) / 2;
    if (l <= min(r, m)) get3(v * 2, tl, m, l, min(r, m), ch);
    if (max(m + 1, l) <= r) get3(v * 2 + 1, m + 1, tr, max(m + 1, l), r, ch);
}

void dfs(int v, int h = 1) {
    ht[v] = h;
    tin[v] = ++timer;
    h1[tin[v]] = h;
    if (!a[v]) hh[tin[v]] = {h, tin[v]};
    for (auto to : g[v]) {
        dfs(to, h + 1);
    }
    tout[v] = timer;
}

main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 1; i < n; i ++) {
        int x, y;
        cin >> x >> y;
        g[x].pb(y);
    }
    for (int i = 1; i <= n; i ++) {
        cin >> a[i];
    }
    dfs(1);
    build(1, 1, n);
    int q;
    cin >> q;
    while (q --) {
        int c, v, h;
        cin >> c >> v >> h;
        if (c == 1) {
            get3(1, 1, n, tin[v], tout[v], ht[v] + h);
        }
        else {
            cnn = 0;
            cnn1 = 0;
            get2(1, 1, n, tin[v], tout[v], ht[v] + h);
            cout << cnn1 - cnn << '\n';
        }
    }
}
