#include <iostream>
#include "vector"
#include "algorithm"
#include "cmath"
#define all(a) (a).begin(), (a).end()
using namespace std;
int K;
int findxor(vector<int> a) {
    int res = 0;
    for (auto i : a)
        res ^= i;
    return res;
}
vector<vector<pair<int, int>>> nim;
void solve() {
    int n;
    cin >> n;
    int r1 = 0, r2 = 0;
    vector<int> b(n), s(n);
    for (int i = 0; i < n; ++i) {
        cin >> b[i] >> s[i];
        r1 ^= nim[b[i]][s[i]].first;
        r2 ^= nim[b[i]][s[i]].second;
    }
    if (K == 0) {
        if (findxor(b) != 0 or findxor(s) != 0) {
            cout << "Win\n";
        } else {
            cout << "Loss\n";
        }
    } else {
        if (r1 != 0 or r2 != 0) {
            cout << "Win\n";
        } else {
            cout << "Loss\n";
        }
    }
}
vector<int> lenka, lepos;
bool notinf(int i, int j) {
    if (i == 0)
        return 0;
    return (lenka[i] * K <= j);
}
int findnim(int i, int j) {
    if (i == 0)
        return j;
    //TODO
}
int mex(vector<int> a) {
    int ind = 0;
    int k = 0;
    while (1) {
        while (ind != a.size() and a[ind] < k)
            ind++;
        if (ind == a.size() or a[ind] > k) {
            break;
        }
        k++;
    }
    return k;
}
void chch() {
    int n = 21, m = 300;
    lenka.assign(n, 0), lepos.assign(m, 0);
    int t = 1;
    int nxtup = 1;
    int val = 0;
    for (int i = 1; i < n; i++) {
        if (nxtup == i) {
            val++;
            lepos[val] = i;
            nxtup += t;
            t++;
        }
        lenka[i] = val;
    }
    nim.assign(n, vector<pair<int, int>>(m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            vector<vector<int>> a(n);
            for (int k = 0; k < j; ++k) {
                a[nim[i][k].first].push_back(nim[i][k].second);
            }
            for (int k = 1; k <= i; ++k) {
                for (int l = k * K; l < m; ++l) {
                    a[nim[i-k][l].first].push_back(nim[i-k][l].second);
                }
            }
            for (int q = 0; q < n; ++q) {
                sort(all(a[q]));
                int x = mex(a[q]);
                if (x + i < m) {
                    //cerr << q << endl;
                    nim[i][j] = {q, x};
                    break;
                }
            }
            //cout << "{" << nim[i][j].first << ", " << nim[i][j].second << "}\t";
        }
        //cout << '\n';
    }
    //exit(0);
}
int main() {
    cin >> K;
    chch();
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        solve();
    }
}
