#include <bits/stdc++.h>

#define pb push_back

using namespace std;

typedef long long ll;
#define int ll
typedef pair<int, int> pii;

const int SIZE = 5e5 + 5;
const int INF = 1e9;

int n, s[SIZE], e[SIZE], p[SIZE], w[SIZE];

signed main() {
    ifstream cin("input.txt");

    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> e[i];
    }

    for(int i = 1; i < n; i++) {
        cin >> p[i] >> w[i];
        p[i]--;
    }

    vector<pair<int, pii>> paths;

    for(int i = 0; i < n; i++) {
        int x = i, sum = 0;
        while(1) {
            if(x == p[x]) break;
            sum += w[x];
            x = p[x];
            paths.push_back({sum, {i, x}});
        }
    }

    sort(paths.rbegin(), paths.rend());
    int ans = 0;
    for(auto i : paths) {
        while(i.first > 0 && e[i.second.first] > 0 && s[i.second.second] > 0) {
            e[i.second.first]--;
            s[i.second.second]--;
            ans += i.first;
        }
    }

    cout << ans;

    return 0;
}
