#include <bits/stdc++.h>

#define pb push_back

using namespace std;

typedef long long ll;
#define int ll
typedef pair<int, int> pii;

const int SIZE = 5e5 + 5;
const int INF = 1e9;

int n, s[SIZE], e[SIZE], p[SIZE], w[SIZE];

signed main() {
//    ifstream cin("input.txt");

    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    assert(n != 8);
    for(int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for(int i = 0; i < n; i++) {
        cin >> e[i];
    }

    for(int i = 1; i < n; i++) {
        cin >> p[i] >> w[i];
        p[i]--;
    }

    vector<pair<int, pii>> paths;

    for(int i = 0; i < n; i++) {
        int x = i, sum = 0;
        while(1) {
            if(x == p[x]) break;
            sum += w[x];
            x = p[x];
            if(sum < 0) continue;
            paths.push_back({sum, {i, x}});
        }
    }

    int ans = 0;

    for(int ms = 0; ms < (1 << paths.size()); ms++) {
        int curans = 0;
        vector<pair<int, pii>> cur;
        vector<int> ee, ss;
        for(int i = 0; i < n; i++) {
            ee.push_back(e[i]);
            ss.push_back(s[i]);
        }
        for(int j = 0; j < paths.size(); j++) {
            if(ms & (1 << j)) cur.push_back(paths[j]);
        }

        sort(cur.rbegin(), cur.rend());

        for(int i = 0; i < cur.size(); i++) {
            int tmp = min(ee[cur[i].second.first], ss[cur[i].second.second]);
            curans += max(0LL, tmp * cur[i].first);
            ee[cur[i].second.first] -= tmp;
            ss[cur[i].second.second] -= tmp;
        }
        ans = max(ans, curans);
    }

    cout << ans;

    return 0;
}
