#include <bits/stdc++.h>
using namespace std;
typedef vector<int> vi;
typedef vector<vi> vvi;
#define pb push_back
const int sz = 2e5 + 1;

void dfs1(int src, vvi &ni, vi &dist, int father, vector<bitset<sz>> &vbit)
{
    vbit[src][src] = 1;
    for (int u : ni[src])
    {
        if (father == u)
            continue;
        dist[u] = dist[src] + 1;
        dfs1(u, ni, dist, src, vbit);
        vbit[src] |= vbit[u];
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    int n, a, b;
    cin >> n;
    vvi ni(n + 1);
    for (int i = 0; i < n - 1; i++)
    {
        cin >> a >> b;
        ni[a].pb(b);
        ni[b].pb(a);
    }
    vi dist(n + 1);
    vector<bitset<sz>> vbit2(n + 1);
    dfs1(1, ni, dist, -1, vbit2);
    bitset<sz> bit;
    bool tmp;
    for (int i = 1; i <= n; i++)
        cin >> tmp, bit[i] = tmp;
    int q;
    cin >> q;
    while (q--)
    {
        int a, b, c;
        cin >> a >> b >> c;
        if (a == 1)
        {
            bit |= (vbit2[b]);
        }
        else
        {
            cout << (bit & vbit2[b]).count() << "\n";
        }
    }
}