#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <cstdio>
using namespace std;
#define pb push_back
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

const int N = 2005, inf = 1e9;
int n, p[N];
vector< pair<int,int> > adj[N];
vector< pair<int, pair<int, int> > > dists;
int dist[N][N];

int main () {
  cin >> n;
  vector<int> a(n + 1), b(n + 1);

  for(int i = 1; i <= n; i++) {
    cin >> a[i];
  }

  for(int i = 1; i <= n; i++) {
    cin >> b[i];
  }

  for(int i = 1; i <= n - 1; i++) {
    int x, y; cin >> x >> y;
    adj[x].pb({i + 1, y});
  }

  for(int i = 1; i <= n; i++) {

    queue<pair<int, int>> q;
    dist[i][i] = 0;
    q.push({i, 0});

    while (!q.empty()) {
      auto u = q.front();
      q.pop();

      for (auto j: adj[u.first]) {
        dist[i][j.first] = dist[i][u.first] + j.second;
        q.push({j.first, j.second});
      }
    }
  }

  for(int i = 1; i <= n; i++) {
    for(int j = 1; j <= n; j++) {
      if(dist[i][j]) {
        dists.pb({dist[i][j], {i, j}});
      }
    }
  }

  sort(rall(dists));

  int sz = sz(dists), ans = 0;
  for(int i = 0; i < sz; i++) {
//    cout << dists[i].first << " " << dists[i].second.first << " " << dists[i].second.second << endl;
    if(dists[i].first < 0) break;
    int to = dists[i].second.first, go = dists[i].second.second, dst = dists[i].first;
    ans += min(a[to], b[go]) * dst;

    int mn = min(a[to], b[go]);
    a[to] -= mn;
    b[go] -= mn;
  }

  cout << ans << endl;

  return 0;
}