#define _CRT_SECURE_NO_WARNINGS
#include <bits/stdc++.h>
#include <cstdio>
using namespace std;

#define pb push_back
#define rall(a) a.rbegin(), a.rend()
#define sz(a) (int)a.size()

const int N = 2005, inf = 1e9;
long long n;
vector< pair<long long,long long> > adj[N];
vector< pair<long long, pair<long long, long long> > > dists;
long long dist[N][N];

int main () {
  cin >> n;
  vector<long long> a(n + 1), b(n + 1);

  for(int i = 1; i <= n; i++) {
    cin >> a[i];
  }

  for(int i = 1; i <= n; i++) {
    cin >> b[i];
  }

  for(int i = 1; i <= n - 1; i++) {
    int x, y; cin >> x >> y;
    adj[x].pb({i + 1, y});
  }

  int sz = 0;

  for(int i = 1; i <= n; i++) {

    queue<pair<long long, long long>> q;
    dist[i][i] = 0;
    q.push({i, 0});

    while (!q.empty()) {
      auto u = q.front();
      q.pop();

      for (auto j: adj[u.first]) {
        dist[i][j.first] = dist[i][u.first] + j.second;


        if(dist[i][j.first] > 0) {
          dists.pb({dist[i][j.first], {i, j.first}});
          sz++;
        }

        q.push({j.first, j.second});
      }
    }
  }

  sort(rall(dists));

  long long ans = 0;
  for(int i = 0; i < sz; i++) {
//    cout << dists[i].first << " " << dists[i].second.first << " " << dists[i].second.second << endl;
    if(dists[i].first <= 0) break;
    long long to = dists[i].second.first, go = dists[i].second.second, dst = dists[i].first;
    ans += min(a[to], b[go]) * dst;

    long long mn = min(a[to], b[go]);
    a[to] -= mn;
    b[go] -= mn;
  }

  cout << ans << endl;

  return 0;
}