#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAX_N = 2e5+2;
const int MAX_LN = 20;
vector<int> a;
int tmp=0, t=1;
int tree[MAX_N*4], lazy[MAX_N*4], s_pos[MAX_N], f_pos[MAX_N];
void update2(int node, int tl, int tr, int l, int r)
{
    if(tl > r || tr < l) return;
    if(tl == tr && tl >= l && tl <= r)
    {
        tree[node] = 1;
        return;
    }
    int mid = (tl+tr)>>1;
    update2(node*2, tl, mid, l, r);
    update2(node*2+1, mid+1, tr, l, r);
    tree[node] = tree[node*2] + tree[node*2+1];
}
void update(int node, int tl, int tr, int l, int r)
{
    if(lazy[node])
    {
        tree[node] = (tr-tl+1);
        if(tl != tr)
        {
            lazy[node*2] = 1;
            lazy[node*2+1] = 1;
        }
        lazy[node] = 0;
        return;
    }
    if(tl > r || tr < l) return;
    if(tl >= l && tr <= r)
    {
        tree[node] = (tr-tl+1);
        if(tl != tr)
        {
            lazy[node*2] = 1;
            lazy[node*2+1] = 1;
        }
        return;
    }
    int mid = (tl+tr)>>1;
    update(node*2, tl, mid, l, r);
    update(node*2+1, mid+1, tr, l, r);
    tree[node] = tree[node*2]+tree[node*2+1];
}
int query(int node,int tl, int tr, int l, int r)
{
    if(lazy[node])
    {
        tree[node] = (tr-tl+1);
        if(tl != tr)
        {
            lazy[node*2] = 1;
            lazy[node*2+1] = 1;
        }
        lazy[node] = 0;
    }
    if(tl > r || tr < l) return 0;
    if(tl >= l && tr <= r) return tree[node];
    int mid = (tl+tr)>>1;
    return query(node*2, tl, mid, l, r) + query(node*2+1, mid+1, tr, l, r);
}
int val[MAX_N],par[MAX_N];
vector<int> on_depth[MAX_N], adj[MAX_N];
void dfs(int cur, int par)
{
    a.push_back(val[cur]);
    s_pos[cur] = t; t++;
    for(auto x: adj[cur])
    {
        if(x == par) continue;
        dfs(x,cur);
    }
    a.push_back(val[cur]);
    f_pos[cur] = t; t++;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    int u0,v0;
    cin>>n;
    a.push_back(0);
    for(int i=0; i<n-1; i++)
    {
        cin>>u0>>v0;
        adj[u0].push_back(v0);
        par[v0] = u0;
    }
    for(int i=1; i<=n; i++) cin>>val[i];
    dfs(1,-1);
    for(int i=1; i<=n; i++)
    {
        if(val[i] == 1)
        {
            update2(1,1,t-1,s_pos[i],s_pos[i]);
            update2(1,1,t-1,f_pos[i],f_pos[i]);
        }
    }
    int q;
    cin>>q;
    int type0, x0, k0;
    for(int i=0; i<q; i++)
    {
        cin>>type0>>x0>>k0;
        if(type0 == 1)
        {
            update(1,1,t-1,s_pos[x0], f_pos[x0]);
        }
        else
        {
            cout<<query(1,1,t-1,s_pos[x0],f_pos[x0])/2<<endl;
        }
    }
}
/**
12
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
5 11
11 12
0 1 0 1 0 1 0 1 0 1 0 0

9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2
*/

