#include <bits/stdc++.h>
using namespace std;

const int maxn = 5e5+5;
int n;
int s [maxn], e [maxn];
vector <pair <int, int> > adj [maxn];
pair <int, int> par [maxn];
long long ans;
/*
void dfs (int a){

    for (auto p : adj [a]){
        dfs (p.second);
    }
    sort (adj [a].begin (), adj [a].end ());
    reverse (adj [a].begin (), adj [a].end ());
    for (auto p : adj [a]){
        if (p.first > 0){
            int x = min (e [p.second], s [a]);
            ans += x * p.first;
            s [a] -= x;
            e [p.second] -= x;
            e [a] += x;
        }
        if (a != 1 && e [p.second] > 0) adj [par [a].second].push_back ({par [a].first + p.first, p.second});
    }

}
*/

struct path{
    long long w;
    int start, end;
    bool operator < (path oth) const{
        return w < oth.w;
    }
};
vector <path> paths;
void dfs (int a, int start, int curr_w){
    paths.push_back ({curr_w, start, a});
    for (auto p : adj [a]){
        dfs (p.second, start, curr_w + p.first);
    }
}

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n;

    for (int i = 1; i <= n; i ++) cin >> s [i];
    for (int i = 1; i <= n; i ++) cin >> e [i];
    for (int i = 2; i <= n; i ++){
        int p, w;
        cin >> p >> w;
        adj [p].push_back ({w, i});
        par [i] = {w, p};
    }
    for (int i = 1; i <= n; i ++){
        dfs (i, i, 0);
    }
    sort (paths.begin (), paths.end ());
    reverse (paths.begin (), paths.end ());
    for (auto p : paths){
        if (p.w < 0) break;
        int x = min (s [p.start], e [p.end]);
        ans += x * p.w;
        s [p.start] -= x;
        e [p.end] -= x;
    }
    cout << ans << '\n';

}