#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const int MAX_N = 200, MAX_K = 1e7 + 10;
int win[MAX_N][MAX_N];
int k, q, n;

int calc(int a, int b) {
    if(b > MAX_N) {
        return mod;
    }
    if(win[a][b] != -1) {
        return win[a][b];
    }
    win[a][b] = 0;
    set<int> st;
    for(int i = 0; i <= a; i += max(1, a)) {
    //for(int i = 0; i <= a; i += 1) {
        for(int j = 0; j <= b; j ++) {
            if(i + j == 0) {continue;}
            for(int add = k * i; add < MAX_N; add ++) {
                st.insert(calc(a - i, b - j + add));
            }
        }
    }
    while(st.find(win[a][b]) != st.end()) {
        win[a][b] ++;
    }
    return win[a][b];
}

int b[MAX_N], s[MAX_N];

bool check() {
    int cnt = 0;
    int xr = 0;
    for(int i = 0; i < n; i ++) {
        cnt ^= b[i];
        xr  ^= s[i];
    }
    return cnt != 0 || xr != 0;
}

void solve() {
    int xr = 0;
    cin >> n;
    int sum = 0;
    for(int i = 0; i < n; i ++) {
        cin >> b[i] >> s[i];
        xr ^= s[i];
        sum += b[i];
    }
    if(sum == 0) {
        if(xr == 0) {
            cout << "Loss" << endl;
        } else {
            cout << "Win" << endl;
        }
        return;
    }
    for(int i = 0; i < n; i ++) {
        pair<int, int> cpy = {b[i], s[i]};
        for(int j = 1; j <= b[i]; j ++) {
            for(int x = j * k; x <= xr; x ++) {
                b[i] -= j;
                s[i] = x;
                if(!check()) {
                    cout << "Win" << endl;
                    return;
                }
                b[i] = cpy.first;
                s[i] = cpy.second;
            }
        }
    }
    cout << "Loss" << endl;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif
    cin >> k;
    cin >> q;
    while(q --) {
        solve();
    }

    return 0;
}
