#include <bits/stdc++.h>
using namespace std;
#ifndef LOCAL
#define cerr if(false) cerr
#endif
#define endl "\n"
typedef long long ll;
template<class T, class T2> inline ostream &operator <<(ostream &out, const pair<T, T2> &x) { out << x.first << " " << x.second; return out;}
template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return x < y ? x = y, 1 : 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return x > y ? x = y, 1 : 0; }
const ll mod = 1e9 + 7;

const ll MAX_N = 110;
const ll MAX_K = 2e3 + 10;
ll dp[MAX_N][MAX_K * MAX_N];
ll sz[MAX_N];
ll s[MAX_N], e[MAX_N];
ll d[MAX_N];
ll n;
vector<pair<ll, ll> > g[MAX_N];

void dfs(ll x, ll p, ll w) {
    d[x] = d[p] + w;
    for(auto it : g[x]) {
        if(it.first == p) {continue;}
        dfs(it.first, x, it.second);
    }
    fill_n(dp[x], MAX_K, -mod);
    for(ll i = 0; i <= e[x]; i ++) {
        dp[x][i] = d[x] * i;
    }
    sz[x] = e[x];
    for(auto it : g[x]) {
        if(it.first == p) {continue;}
        for(ll i = sz[x]; i >= 0; i --) {
            for(ll j = sz[it.first]; j >= 0; j --) {
                if(!chkmax(dp[x][i + j], dp[x][i] + dp[it.first][j])) {
                    break;
                }
            }
        }
        sz[x] += sz[it.first];
    }
    for(ll j = 0; j <= sz[x]; j ++) {
        for(ll i = 0; i <= min(j, s[x]); i ++) {
            chkmax(dp[x][j - i], dp[x][j] - d[x] * i);
        }
    }
    return;
    cerr << "~~~~~~~~~~" << endl;
    cerr << x << ": " << sz[x] << " " << d[x] << endl;
    cerr << s[x] << " " << e[x] << endl;
    cerr << dp[x][0] << "! ";
    for(ll i = 1; i <= sz[x]; i ++) {
        cerr << dp[x][i] - dp[x][i - 1] << " ";
    }
    cerr << endl;
}



signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif

    cin >> n;
    for(ll i = 1; i <= n; i ++) {
        cin >> s[i];
    }
    for(ll i = 1; i <= n; i ++) {
        cin >> e[i];
    }
    for(ll i = 2; i <= n; i ++) {
        ll p, w;
        cin >> p >> w;
        g[p].push_back({i, w});
    }
    dfs(1, 0, 0);
    cout << dp[1][0] << endl;
    return 0;
}