#include<cstdio>
#include<set>
#include<queue>
using namespace std;
#define MAXN 500000
struct reb
{ int child,weight; };
int count[MAXN];
bool operator<(reb r1,reb r2)
{
	if(r1.weight>r2.weight)return true;
	if(r1.weight<r2.weight)return false;
	if(count[r1.child]<count[r2.child]) return true;
	return false;
}

set<reb> T[MAXN];
int maxCount[MAXN];
int N;
int i;
int sort[MAXN];

void init()
{
	int child,weight;
	scanf("%d",&N);
	for(i=0;i<N;i++)
		scanf("%d",count+i);
	for(i=0;i<N;i++)
		scanf("%d",maxCount+i);
	for(i=1;i<N;i++)
	{
		scanf("%d %d",&child,&weight);
		T[child-1].insert(reb{i,weight});
	}
}
void bfs(int s)
{
	static queue<int> q;
	static int l;
	static int i;
	q.push(s);
	l=0;
	while(q.size()!=0)
	{
		sort[l++]=q.front();
		for(auto el:T[q.front()])
			if(el.child!=q.front())
				q.push(el.child);
		q.pop();
	}
}

void solve()
{
	long res=0;
	int j;
	bfs(0);
	for(i=N-1;i>=0;i--)
	{
		multiset<reb> tmp;
		multiset<reb>::iterator it;
		for(auto &el:T[sort[i]])
		{
			for(auto &el1:T[el.child])
				if(maxCount[el1.child]>0)
					tmp.insert({el1.child,el1.weight+el.weight});
		}
		T[sort[i]].insert(tmp.begin(),tmp.end());
		if(count[sort[i]]>0)
		{
			for(auto el:T[sort[i]])
				if(el.weight>0&&maxCount[el.child]>0)
					if(count[sort[i]]>=maxCount[el.child])
					{
						count[sort[i]]-=maxCount[el.child];
						res+=maxCount[el.child]*el.weight;
						maxCount[el.child]=0;
					}
					else
					{
						maxCount[el.child]-=count[sort[i]];
						res+=count[sort[i]]*el.weight;
						count[sort[i]]=0;
						break;
					}
		}
	}
	printf("%ld",res);
}
int main()
{
	init();
	solve();
	return 0;
}
/*
5
5 1 0 0 0
100 1 1 2 4
1 -1
1 3
2 6
2 2

*/