#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 200003
using namespace std;
int n, q;
vector <int> adj[MAXN];
bool b[MAXN];

void input()
{
    cin >> n;
    for (int i = 1; i < n; ++i)
    {
        int x, y;
        cin >> x >> y;
        adj[x].push_back(y);
    }

    for (int i = 1; i <= n; ++i)
    {
        cin >> b[i];
    }
}

void update(int tmp, int k, int par = -1)
{
    if (k < 0)
        return;

    b[tmp] = 1;
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (nb == par)
            continue;
        update(nb, k - 1, tmp);
    }
}

int get(int tmp, int k, int par = -1)
{
    if (k < 0)
        return 0;

    int cnt = b[tmp] ? 1 : 0;
    for (int i = 0; i < adj[tmp].size(); ++i)
    {
        int nb = adj[tmp][i];
        if (nb != par)
            cnt += get(nb, k - 1, tmp);
    }

    return cnt;
}

void solve()
{
    cin >> q;
    for (int i = 0; i < q; ++i)
    {
        int type, x, k;
        cin >> type >> x >> k;

        if (type == 1)
        {
            update(x, k, x);
        }
        else
        {
            cout << get(x, k, x) << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    input();
    solve();

    return 0;
}

/**

10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

*/
