#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 5e5 + 3; 

int n;
int s[maxn], e[maxn];
pair <int, int> par[maxn];
vector <pair <int, int> > adj[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	cin >> s[i];
	
	for (int i = 1; i <= n; i++)
	cin >> e[i];
	
	for (int i = 2; i <= n; i++)
	{
		cin >> par[i].first >> par[i].second;
	    adj[par[i].first].push_back({i, par[i].second});
	}
}

int depth[maxn];
void dfs(int ver)
{
	for (auto i: adj[ver])
	{
		depth[i.first] = depth[ver] + 1;
		dfs(i.first);
	}
}

void solve()
{
	dfs(1);
	
	long long ans = 0;
	for (;;)
	{
		int max_score = -1, a, b = -1; 
		for (int i = 2; i <= n; i++)
		if (e[i])
		{
			int ver = i, curr = 0;
			while (ver != 1)
			{
				curr += par[ver].second;
				ver = par[ver].first;
				
				if (curr >= max_score && s[ver])
				max_score = curr, a = i, b = ver; 
			}
		}
		
		if (max_score <= 0)
		break;
		
		int times = min(e[a], s[b]);
		ans += 1ll * times * max_score;
		
		e[a] -= times;
		s[b] -= times;
	}
	
	cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
