#include <bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3")

using namespace std;

const int maxn = 103; 
const long long inf = 1e12;

int n;
int s[maxn], e[maxn];
pair <int, int> par[maxn];
vector <pair <int, int> > adj[maxn];
void read()
{
	cin >> n;
	for (int i = 1; i <= n; i++)
	cin >> s[i];
	
	for (int i = 1; i <= n; i++)
	cin >> e[i];
	
	for (int i = 2; i <= n; i++)
	{
		cin >> par[i].first >> par[i].second;
	    adj[par[i].first].push_back({i, par[i].second});
	}
}

vector <long long> merge(vector <long long> a, vector <long long> b)
{
	vector <long long> ans;
	ans.resize(max(10000, (int)a.size() + (int)b.size() - 1), -inf);
	for (int i = 0; i < (int)a.size(); i++)
	for (int j = 0; j < (int)b.size(); j++)
	ans[i+j] = max(ans[i+j], a[i] + b[j]);
	
	return ans;
}

int pr[maxn];
void pre_dfs(int ver)
{
	for (auto i: adj[ver])
	{
		pr[i.first] = pr[ver] + i.second;
		pre_dfs(i.first);
	}	
}

vector <long long> dp[maxn];
void dfs(int ver)
{
	dp[ver].resize(e[ver] + 1);
	for (int i = 0; i <= e[ver]; i++)
	dp[ver][i] = 1ll * i * pr[ver];
	
	for (auto i: adj[ver])
	{
		dfs(i.first);
	    dp[ver] = merge(dp[ver], dp[i.first]);
	}
	
	for (int i = 0; i < (int)dp[ver].size(); i++)
	for (int j = 1; j <= s[ver] && i+j < (int)dp[ver].size(); j++)
	dp[ver][i] = max(dp[ver][i], dp[ver][i+j] - 1ll * j * pr[ver]);
}

void solve()
{
	pre_dfs(1);
	dfs(1);
	cout << dp[1][0] << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	read();
	solve();
}
