#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

#define ll long long
#define fr first
#define sc second
#define pb push_back

using namespace std;
using namespace __gnu_pbds;

template<class T> using matrix = vector<vector<T>>;
template<class T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

int n, q, T;
matrix<int> G, lvl, prefix;
vector<int> ans, tin, tout, dep;

void init(){
	G = lvl = prefix = matrix<int>(n + 1);
	ans = tin = tout = dep = vector<int>(n + 1);
}

void dfs(int u = 1, int d = 0){
	tin[u] = ++ T;
	dep[u] = d;
	lvl[d].pb(u);
	for(auto v : G[u]){
		dfs(v, d + 1);
		ans[u] += ans[v];
	}
	tout[u] = T;
}

int main(){
	cin >> n;
	init();
	for(int i = 0; i < n - 1; i ++){
		int u, v; cin >> u >> v;
		G[u].pb(v);
	}
	for(int i = 1; i <= n; i ++) cin >> ans[i];
	dfs();
	for(int i = 0; i < n; i ++){
		prefix[i] = lvl[i];
		for(int j = 0; j < lvl[i].size(); j ++){
			prefix[i][j] = (j ? prefix[i][j - 1] : 0) + ans[prefix[i][j]];
		}
	}
	cin >> q;
	for(int i = 0; i < q; i ++){
		int t, x, k; cin >> t >> x >> k;
		k += dep[x] + 1;
		if(k >= n || lvl[k].empty()){
			cout << ans[x] << endl;
		}
		else{
			int lb = 0, rb = 0;
			int l, r;
			l = 0; r = lvl[k].size() - 1;
			while(l <= r){
				int m = (l + r) / 2;
				if(tin[x] <= tin[lvl[k][m]]){
					r = m - 1;
					lb = m;
				}
				else{
					l = m + 1;
				}
			}
			l = 0; r = lvl[k].size() - 1;
			while(l <= r){
				int m = (l + r) / 2;
				if(tout[lvl[k][m]] <= tout[x]){
					l = m + 1;
					rb = m;
				}
				else{
					r = m - 1;
				}
			}
			cout << ans[x] - (prefix[k][rb] - (lb ? prefix[k][lb - 1] : 0)) << endl;
		}
	}
}
/**
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
9
2 1 1
2 4 4
2 3 0
1 1 2
2 3 4
1 4 1
2 1 1
2 4 4
2 3 2

1
3
0
6
3
4
6


7
1 2
1 3
2 4
2 5
3 6
3 7
0 0 1 0 1 0 0

4
2 3 1
2 3 0
2 1 1
2 1 2

10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1 0 1
7
2 1 1
2 4 4
2 3 0
2 3 4
2 1 1
2 4 4
2 3 2

1
3
0
4
1
3
3
*/