#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 500000;

int s0[MAXN + 5], e[MAXN + 5], p0[MAXN + 5], w[MAXN + 5], idx[MAXN + 5];
long long p[MAXN + 5], p1[MAXN + 5], s[MAXN + 5], s1[MAXN + 5], dp[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s0[i];
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> e[i];
    }

    bool flag = false;
    for (int i = 1; i < n; ++ i)
    {
        cin >> p0[i] >> w[i];
        if (w[i] < 0) flag = true;
        p[i] = p[i - 1] + w[i];
        p1[i] = p1[i - 1] + 1ll * i * w[i];
    }

    if (flag)
    {
        cout << 1 / 0 << endl;
    }

    for (int i = n - 1; i >= 1; -- i)
    {
        s[i] = s[i + 1] + w[i];
        s1[i] = s1[i + 1] + 1ll * (n - i) * w[i];
    }

    dp[1] = w[1];
    idx[1] = 0;
    for (int i = 2; i < n; ++ i)
    {
        dp[i] = -1;
        idx[i] = idx[i - 1];
        for (int j = idx[i - 1]; j < i; ++ j)
        {
            int len = i - j;
            int mid = (j + 1 + i) / 2;
            long long sum = p1[mid] - p1[j] - 1ll * j * (p[mid] - p[j]);
            if (mid + 1 <= i)
            {
                sum += s1[mid + 1] - s1[i + 1] - 1ll * (n - 1 - i) * (s[mid + 1] - s[i + 1]);
            }
            if (dp[i] == -1) dp[i] = sum;
            else if (sum > dp[i])
            {
                dp[i] = sum;
                idx[i] = j;
            }
        }
    }

    cout << dp[n - 1] << endl;

    return 0;
}
