#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;
const int LOG = 20;

int b[MAXN + 5];
int s[MAXN + 5][LOG + 5];
vector<int> G[MAXN + 5][LOG + 5];

void DFS(int u)
{
    for (int i = 0; i < G[u][0].size(); ++ i)
    {
        int v = G[u][0][i];
        s[u][0] += b[v];
        DFS(v);
        for (int j = 1; j <= LOG; ++ j)
        {
            for (int k = 0; k < G[v][j - 1].size(); ++ k)
            {
                G[u][j].push_back(G[v][j - 1][k]);
            }
        }
    }

    for (int j = 0; j < LOG; ++ j)
    {
        s[u][j + 1] += s[u][j];
        for (int i = 0; i < G[u][j].size(); ++ i)
        {
            s[u][j + 1] += s[G[u][j][i]][j];
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        int x, y;
        cin >> x >> y;
        G[x][0].push_back(y);
    }

    for (int i = 1; i <= n; ++ i)
    {
        cin >> b[i];
    }

    DFS(1);

    return 0;
}
