#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;
int nodes;
int parent[200000];
bool know[200000];
vector<int> path[200000];
void Input()
{
    cin>>nodes;
    for(int i = 1; i < nodes; ++i)
    {
        int a, b, temp;
        cin>>a>>b;
        parent[b] = a;
        temp = b;
        while(parent[temp])
        {
            path[b].push_back(parent[temp]);
            temp = parent[temp];
        }
    }
    for(int i = 1; i <= nodes; ++i)
    {
        cin>>know[i];
    }

}
void PrintData()
{
    cout<<"Know: "<<endl;
    for(int i = 1; i <= nodes; ++i)
    {
        cout<<know[i]<<" ";
    }
    cout<<endl;
    cout<<"Paths: "<<endl;
    for(int i = 1; i <= nodes; ++i)
    {
        cout<<i<<": ";
        for(int j = 0; j < path[i].size(); ++j)
        {
            cout<<path[i][j]<<" ";
        }
        cout<<endl;
    }
}
void Edit(int root, int depth)
{
    for(int i = 1; i <= nodes; ++i)
    {
        if(i == root)
        {
            know[i] = true;
        }
        else
        {
            for(int j = 0; j < depth; ++j)
            {
                if(path[i].size() > 0 && path[i][j] == root)
                {
                    know[i] = true;
                    break;
                }
            }
        }
    }
}
void Print(int root, int depth)
{
    int result = 0;
    if(know[root]) result++;
    for(int i = 1; i <= nodes; ++i)
    {
        for(int j = 0; j < depth; ++j)
        {
            if(path[i].size() > 0 && know[i] && path[i][j] == root)
            {
                result++;
                break;
            }
        }

    }
    cout<<result<<endl;
}
int main()
{
    Input();
    int queries;
    cin>>queries;
    for(int i = 0; i < queries; ++i)
    {
        int c, x, k;
        cin>>c>>x>>k;
        if(c == 1)
            Edit(x, k);
        else
            Print(x, k);
    }
    return 0;
}
