#include<bits/stdc++.h>
using namespace std;

const int nmax=2e5+42,M=512;

struct quer
{
    int type,node,depth;
};
quer que[nmax];

int C;

int n,q;

int inp[nmax];

int outp[nmax];

vector<int> adj[nmax];

int in[nmax],out[nmax],t=0,SZ[nmax];

int height[nmax];

void dfs(int node,int par,int h)
{
    t++;

    height[node]=h;
    in[node]=t;

    SZ[node]=1;

    for(auto w:adj[node])
        if(w!=par)
        {
            dfs(w,node,h+1);
            SZ[node]+=SZ[w];
        }
    out[node]=t;
}

vector<int> seen[2][nmax];

vector<pair<int/*depth*/,int/*id*/> > queries[2][nmax];

void dfs_add(int node,int par,int h)
{
    seen[inp[node]][h].push_back(node);

    for(auto w:adj[node])
        if(w!=par)dfs_add(w,node,h+1);
}

void rebuild()
{
    for(int i=0;i<=n;i++)
    {
        seen[0][i]={};
        seen[1][i]={};
    }

    dfs_add(1,0,1);
}

int group[nmax],hand[nmax];

int BIT=9;
int ALL=(1<<BIT)-1;

void update(int pos,int coeff)
{
    //cout<<"update "<<pos<<" "<<coeff<<endl;

    hand[pos]+=coeff;
    group[pos>>BIT]+=coeff;
}

int sum(int l,int r)
{
    //cout<<"l= "<<l<<" r= "<<r<<endl;

    //for(int i=1;i<=n;i++)cout<<i<<" -> hand= "<<hand[i]<<endl;

    int ret=0;

    while(l<=r&&(l&ALL))
    {
        ret+=hand[l];
        l++;
    }

    while(l<=r&&(r&ALL)!=ALL)
    {
        ret+=hand[r];
        r--;
    }

    if(l>r)return ret;

    l=(l>>BIT);
    r=(r>>BIT);

    for(int i=l;i<=r;i++)
        ret+=group[i];

    //cout<<"sum l= "<<l<<" r= "<<r<<" -> "<<ret<<endl;

    return ret;
}

int ALL_ACTIVE[nmax],pointer=0;

void solve_queries(int node,int par)
{
    //cout<<"solve queries "<<node<<" "<<par<<endl;

    int biggest=-1;

    for(auto w:adj[node])
        if(w!=par)
        {
            if(biggest==-1)biggest=w;
            else if(SZ[biggest]<SZ[w])biggest=w;
        }

    vector<int> to_add={};

    for(auto w:adj[node])
        if(w!=par&&w!=biggest)
        {
            solve_queries(w,node);

            while(pointer)
            {
                to_add.push_back(ALL_ACTIVE[pointer]);
                update(height[ALL_ACTIVE[pointer]],-1);
                pointer--;
            }
        }

    //solve big

    if(biggest!=-1)
    {
        solve_queries(biggest,node);
    }

    for(auto w:to_add)
    {
        update(height[w],1);

        pointer++;
        ALL_ACTIVE[pointer]=w;
    }

    if(inp[node])
    {
        update(height[node],1);

        pointer++;
        ALL_ACTIVE[pointer]=node;
    }

    for(auto w:queries[1][node])
    {
        outp[w.second]=sum(height[node],height[node]+w.first);

        //cout<<"solved query!!! "<<w.second<<" -> "<<outp[w.second]<<endl;
    }

    /*
    cout<<"queries solved "<<node<<endl;
    cout<<"all_active= ";for(auto w:ALL_ACTIVE)cout<<w<<" ";cout<<endl;
    cout<<"---"<<endl;
    system("pause");
    */
}





unordered_map<int,int> to_colour;

int TIME_NOW;

void note(int node,int t)
{
    //cout<<"note "<<node<<" "<<t<<endl;
    if(to_colour.count(node))to_colour[node]=min(to_colour[node],t);
    else to_colour[node]=t;
}

void add_hand(int node,int h)
{
        int ok=-1,not_ok=seen[0][h].size();

        while(not_ok-ok>1)
        {
            int av=(ok+not_ok)/2;

            if(in[seen[0][h][av]]<in[node])ok=av;
            else not_ok=av;
        }

        /*
        cout<<"seen[0][h]= ";for(auto w:seen[0][h_low])cout<<w<<" ";cout<<endl;
        cout<<"ok= "<<ok<<endl;
        */

        for(int i=ok+1;i<seen[0][h].size();i++)
        {
            int cur_now=seen[0][h][i];

            if(out[cur_now]<=out[node])
            {
                note(cur_now,TIME_NOW);
            }
        }
}

void take_all(int node,int l,int r)
{
    //cout<<"take all "<<node<<" "<<h_low<<" "<<h_high<<endl;

    //cout<<"l= "<<l<<" r= "<<r<<endl;

    //for(int i=1;i<=n;i++)cout<<i<<" -> hand= "<<hand[i]<<endl;

    while(l<=r&&(l&ALL))
    {
        if(hand[l])add_hand(node,l);
        l++;
    }

    while(l<=r&&(r&ALL)!=ALL)
    {
        if(hand[r])add_hand(node,r);
        r--;
    }

    if(l>r)return;

    while(l<=r)
        if(group[l>>BIT])
        {
            int stop=l+(1<<BIT);

            for(;l<stop;l++)
            {
                if(hand[l])add_hand(node,l);
            }
        }
        else l+=(1<<BIT);
}

void all_zeros(int node,int par)
{
    //cout<<"all zeros "<<node<<" "<<par<<endl;

    int biggest=-1;

    for(auto w:adj[node])
        if(w!=par)
        {
            if(biggest==-1)biggest=w;
            else if(SZ[biggest]<SZ[w])biggest=w;
        }

    vector<int> to_add={};

    for(auto w:adj[node])
        if(w!=par&&w!=biggest)
        {
            all_zeros(w,node);

            while(pointer)
            {
                to_add.push_back(ALL_ACTIVE[pointer]);
                update(height[ALL_ACTIVE[pointer]],-1);
                pointer--;
            }
        }

    //solve big

    if(biggest!=-1)
    {
        all_zeros(biggest,node);
    }

    //cout<<"solved biggest= "<<biggest<<endl;

    for(auto w:to_add)
    {
        update(height[w],1);

        pointer++;
        ALL_ACTIVE[pointer]=w;
    }

    if(inp[node]==0)
    {
        update(height[node],1);

        pointer++;
        ALL_ACTIVE[pointer]=node;
    }

    for(auto w:queries[0][node])
    {
        TIME_NOW=w.second;

        take_all(node,height[node],min(n,height[node]+w.first));
    }

    /*
    cout<<"node= "<<node<<endl;
    cout<<"all_active= ";for(auto w:ALL_ACTIVE)cout<<w<<" ";cout<<endl;
    */
}


int main()
{
    scanf("%i",&n);

    for(int i=1;i<n;i++)
    {
        int u,v;
        scanf("%i%i",&u,&v);

        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    dfs(1,0,1);

    for(int i=1;i<=n;i++)scanf("%i",&inp[i]);

    scanf("%i",&q);

    for(int i=1;i<=q;i++)scanf("%i%i%i",&que[i].type,&que[i].node,&que[i].depth);

    C=3*sqrt(n*log2(n)*log2(n))+1;

    //cout<<"C= "<<C<<endl;

    for(int i=1;i<=q;i+=C)
    {
        //cout<<"inp ";for(int j=1;j<=n;j++)printf("%i ",inp[j]);printf("\n");

        rebuild();

        int low=i,high=min(i+C-1,q);

        for(int i=1;i<=n;i++)queries[0][i]={},queries[1][i]={};

        for(int j=low;j<=high;j++)
            queries[que[j].type-1][que[j].node].push_back({que[j].depth,j});

        memset(group,0,sizeof(group));
        memset(hand,0,sizeof(hand));

        pointer=0;
        solve_queries(1,0);

        memset(group,0,sizeof(group));
        memset(hand,0,sizeof(hand));

        pointer=0;
        to_colour={};
        all_zeros(1,0);

        //for(auto w:to_colour)cout<<"colour "<<w.first<<" "<<w.second<<endl;

        for(auto w:to_colour)
        {
            int node=w.first;
            int t=w.second;

            inp[node]=1;

            for(int j=t;j<=high;j++)
                if(que[j].type==2)
                {
                    int ROOT=que[j].node;
                    int H=que[j].depth;

                    if(in[ROOT]<=in[node]&&out[node]<=out[ROOT]&&height[ROOT]+H>=height[node])outp[j]++;
                }
        }
    }

    for(int i=1;i<=q;i++)
        if(que[i].type==2)printf("%i\n",outp[i]);

    return 0;
}
