#include<bits/stdc++.h>
#pragma GCC optimize ("Ofast")
#pragma GCC target ("avx2")
#define endl "\n"

using namespace std;

struct edge
{
    int child, c;
    edge() { }
    edge(int child, int c) :child(child), c(c) { }
};

struct road
{
    int x, y, p;
    road() { }
    road(int x, int y, int p) :x(x), y(y), p(p) { }
    bool operator< (const road &o) const
    {
        return p > o.p;
    }
};

const int N = 2010;
vector<edge> ver[N];
vector<road> a;
int s[N], e[N];
int st;

void travel(int v, int cost)
{
    a.push_back({st, v, cost});
    for(edge i : ver[v])
    {
        travel(i.child, cost + i.c);
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int n, p, w, ans = 0;
	cin >> n;
	for(int i = 1; i <= n; ++i) cin >> s[i];
	for(int i = 1; i <= n; ++i) cin >> e[i];
	for(int i = 1; i < n; ++i)
    {
        cin >> p >> w;
        ver[p].push_back({i + 1, w});
    }
    for(int i = 1; i <= n; ++i)
    {
        if(s[i])
        {
            st = i;
            travel(i, 0);
        }
    }
    sort(a.begin(), a.end());
    //for(int i = 0; i < a.size(); ++i) cout << a[i].x << " " << a[i].y << " " << a[i].p << endl;
    for(int i = 0; i < (int)a.size(); ++i)
    {
        while(s[a[i].x] && e[a[i].y] && a[i].p > 0)
        {
            //cout << a[i].x << " " << a[i].y << endl;
            ans += a[i].p, s[a[i].x]--, e[a[i].y]--;
        }
    }
    cout << ans << endl;
	return 0;
}
