#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int MAXN=200001;
const int MAXQ=200001;

int n,q;
bool kn[MAXN];
vector<int> a[MAXN];
pair<int,pair<int,int> > qu[MAXQ];

void init()
{
	scanf("%d",&n);
	
	int u,v,t;
	for(int i=1;i<n;i++)
	{
		scanf("%d%d",&u,&v);
		a[u].push_back(v);
	}
	
	for(int i=1;i<=n;i++)
	{
		scanf("%d",&u);
		kn[i]=u;
	}
	
	scanf("%d",&q);
	cout<<q<<endl;
	for(int i=1;i<=q;i++)
	{
		scanf("%d%d%d",&u,&v,&t);
		qu[i]=make_pair(u,make_pair(v,t));
	}
	cout<<"done\n";
}

void printGr()
{
	for(int i=1;i<=n;i++)
	{
		cout<<i<<": ";
		for(int j=0;j<a[i].size();j++)
		{
			cout<<"("<<a[i][j]<<", "<<kn[a[i][j]]<<") ";
		}
		cout<<endl;
	}
}

void one(int x,int k)
{
	int len[MAXN];
	for(int i=1;i<=n;i++)
		len[i]=-1;
	
	queue<int> qq;
	qq.push(x);
	len[x]=0;
	kn[x]=1;
	
	while(!qq.empty())
	{
		int d=qq.front();
		qq.pop();
		
		for(int i=0;i<a[d].size();i++)
		{
			len[a[d][i]]=len[d]+1;
			kn[a[d][i]]=1;
			if(len[a[d][i]]<k)
				qq.push(a[d][i]);
		}
	}
}

void two(int x,int k)
{
	int len[MAXN];
	for(int i=1;i<=n;i++)
		len[i]=-1;
	
	queue<int> qq;
	qq.push(x);
	len[x]=0;
	
	int ans=0;
	while(!qq.empty())
	{
		int d=qq.front();
		qq.pop();
		
		if(kn[d]) ans++;
		for(int i=0;i<a[d].size();i++)
		{
			if(len[a[d][i]]==-1)
			{
				len[a[d][i]]=len[d]+1;
				if(len[a[d][i]]<=k)
					qq.push(a[d][i]);
			}
		}
	}
	
	printf("%d\n",ans);
}

int main()
{
	init();
	
	for(int i=1;i<=q;i++)
	{
		if(qu[i].first==1)
		{
			one(qu[i].second.first,qu[i].second.second);
			//printGr();
		}
		else
			two(qu[i].second.first,qu[i].second.second);
	}
}