# include <bits/stdc++.h>
using namespace std;
const int maxn = 5e4+5;
const int groups= 300;
const int V = 305;
vector <int> g[maxn];
int in[maxn],out[maxn],levels[maxn],ids=-1, h[maxn];
int gr[V][maxn], num[V][maxn], get[V][maxn], pref[V][maxn], all_get[V];
bool vis[maxn];
int n;
void dfs(int v, int level = 1)
{
    ids++;
    in[v] = ids;
    h[v] = level;
    levels[ids] = level;
    for(auto u:g[v])
    {
        dfs(u,level+1);
    }
    out[v] = ids;
}
void update_fenwick(int k, int id, int delta)
{
  //  cout<<"**********"<<k<<" "<<id<<" "<<delta<<endl;
    for(;id<maxn; id+=(id&(-id)))
    {

        pref[k][id]+=delta;
        //  cout<<id<<endl;
    }
}
int query_fenwick(int k, int id)
{
    int ans = 0;
    for(;id>0;id-=(id&(-id)))
    {
        ans+=pref[k][id];
    }
    return ans;
}
void update(int l, int r, int p)
{ // cout<<l<<" &  "<<r<<" & "<<p<<endl;
    int f = l/groups;
    int i;
    for(i = l; i< (f+1)*groups&&i<=r; i++)
    {
        if(levels[i]>p||vis[i])continue;
        vis[i] = 1;
       // cout<<"^^"<<i<<endl;
        update_fenwick(f,levels[i],1);
    }
    int s = r/groups;
    if(f==s)return ;
    for(i=f+1; i<s;i++)
    {
        all_get[i]=max(all_get[i],p);

    }
    for(i=(s*groups);i<=r;i++)
    {
         if(levels[i]>p||vis[i])continue;
        vis[i] = 1;
        update_fenwick(s,levels[i],1);
    }
}
int query(int l, int r, int p)
{
   // cout<<"QUery"<<" "<<l<<" "<<r<<" "<<p<<endl;
    int ans = 0;
     int f = l/groups;
    int i;
    //i< (f+1)*groups&&
    for(i = l; i<=r; i++)
    {
        if(levels[i]>p)continue;
      //  cout<<i<<" is get "<<all_get[i]<<endl;
        if(vis[i]||all_get[i]>=levels[i]){//cout<<" && "<<i<<endl;
        ans++;}
    }
    return ans;
    int s = r/groups;
    if(f==s)return ans;
    for(i=f+1; i<s;i++)
    {
        if(all_get[i]>=p)ans+=num[i][p];
        else
        {
            int W = query_fenwick(i,p) - query_fenwick(i,all_get[i]) + num[i][all_get[i]];
            ans+=W;
        }
    }
   // cout<<"!!!!!!!!!!!!!!   "<<ans<<endl;
    for(i=(s*groups);i<=r;i++)
    {
         if(levels[i]>p)continue;
        if(vis[i]||all_get[i]>=levels[i])ans++;
    }
    return ans;
}
void groupit()
{
    int i,j;
    for(i=0;i*groups<n;i++)
    {
        for(j=0;j<groups&&((i*groups+j)<n);j++)
        {
            //cout<<i<<"**"<<j<<endl;
            num[i][levels[i*groups+j]]++;
            if(vis[i*groups+j])update_fenwick(i,levels[i*groups+j],1);
        }
        for(j = 1; j<=n;j++)
        {
            num[i][j] = num[i][j]+num[i][j-1];
        }
    }
}
int main()
{
        int x,y,i,j;
        cin>>n;
        if(n>50000)
        {
            while(1)n++;
        }
        for(i = 1;i<n;i++)
        {
            cin>>x>>y;
            g[x].push_back(y);
        }
        dfs(1);
        for(i=1;i<=n;i++)
            cin>>vis[in[i]];
        groupit();
        int q;
        cin>>q;
        int t,k;
        for(i=1;i<=q;i++)
        {
            cin>>t>>x>>k;
            if(t==1)
            {
                update(in[x],out[x],k+h[x]);
            }
            if(t==2)
               {
                   int ans=  query(in[x],out[x],k+h[x]);
                   cout<<ans<<endl;
               }
        }
}
