#include<bits/stdc++.h>
#pragma GCC optimize("Ofast")
using namespace std;
const int maxn=(1<<18);
int n,Q,SZ[maxn],lvl[maxn];
int parent[maxn];
vector<int>v[maxn];
bool know[maxn];
struct seg_tree
{
    int sz,t[maxn*2];
    seg_tree(){sz=0;}
    seg_tree(int _sz){sz=_sz;}
    void update(int root,int l,int r,int pos,int val)
    {
        if(l==r)
        {
            t[root]=val;
            return;
        }
        int mid=(l+r)/2;
        if(pos>mid)update(root*2+1,mid+1,r,pos,val);
        else update(root*2,l,mid,pos,val);
        t[root]=t[root*2+1]+t[root*2];
    }
    void Update(int pos,int val)
    {
        update(1,1,sz,pos,val);
    }
    int query(int root,int l,int r,int ql,int qr)
    {
        if(l==ql&&r==ql)return t[root];
        int mid=(l+r)/2;
        if(qr<=mid)return query(root*2,l,mid,ql,qr);
        if(ql>mid)return query(root*2+1,mid+1,r,ql,qr);
        return query(root*2,l,mid,ql,mid)+
               query(root*2+1,mid+1,r,mid+1,qr);
    }
    int Query(int ql,int qr)
    {
        return query(1,1,sz,ql,qr);
    }
};
void read()
{
    scanf("%d",&n);
    int x,y;
    for(int i=1;i<n;i++)
    {
        scanf("%d%d",&x,&y);
        v[x].push_back(y);
        //v[y].push_back(x);
        parent[y]=x;
        //v[y].push_back(x);
    }
    for(int i=1;i<=n;i++)
    {
        scanf("%d",&x);
        know[i]=x;
    }
}
int chain[maxn],pos[maxn],head[maxn],heavy[maxn],sub[maxn];
vector<seg_tree>T;
void init_heavy(int ver)
{
    int i,sz=v[ver].size(),nb;
    int ms=0;
    for(i=0;i<sz;++i)
    {
        nb=v[ver][i];
        init_heavy(nb);
        sub[ver]+=sub[nb];
        if(ms<sub[nb])
        {
            ms=sub[nb];
            heavy[ver]=nb;
        }
    }
    sub[ver]++;
}
int HLD(int ver,int par,int sz)
{
    /*cout<<"Entered in HLD\n";
    pos[ver]=sz+1;
    cout<<"place 1\n";
    if(sz)head[ver]=head[par];
    else head[ver]=ver;
    cout<<"place 2\n";
    int i=0,szv=v[ver].size(),nb;
    cout<<"place 3\n";
    for(i=0;i<szv;i++)
    {
        nb=v[ver][i];
        if(nb!=heavy[ver])
            chain[nb]=HLD(nb,ver,0);
    }
    cout<<"for have passed\n";
    if(heavy[ver]==-1)
    {
        chain[ver]=T.size();
        T.push_back(seg_tree(sz));
    }
    else chain[ver]=HLD(heavy[ver],ver,sz+1);
    cout<<"chain[ver] is with value\n";
    T[chain[ver]].Update(pos[ver],(int)know[ver]);
    cout<<"doesn't crash at Updating Tree with chain=="<<chain[ver]<<endl;
    return chain[ver];*/
    pos[ver]=sz+1;
    if(sz==0)head[ver]=ver;
    else head[ver]=head[par];
    int i,szv=v[ver].size(),nb;
    for(i=0;i<szv;i++)
    {
        nb=v[ver][i];
        if(nb!=heavy[ver])
            chain[nb]=HLD(nb,ver,0);
    }
    if(heavy[ver]==-1)
    {
        chain[ver]=T.size();
        T.push_back(seg_tree(sz));
    }
    else chain[ver]=HLD(heavy[ver],ver,sz+1);
    T[chain[ver]].Update(pos[ver],1);
    return chain[ver];
}
/*void update_chains(int ver,int k)
{
    int i,sz=v[ver].size(),;
    for(i=0;i<sz;++i)
    {
        nb
    }
}*/
int query(int ver,int kth)
{
    int ans=0;
    int i,nb,sz=v[ver].size();
    for(int i=0;i<sz;i++)
    {
        nb=v[ver][i];
        if(nb==heavy[ver])
            ans+=T[chain[ver]].Query(pos[ver],min(pos[ver]+kth,T[chain[ver]].sz));
        else
        {
            ans+=query(nb,kth-1);
        }
    }
    return ans;
}
void fast_queries()
{
    scanf("%d",&Q);
    int st,x,k;
    for(int i=0;i<Q;++i)
    {
        scanf("%d%d%d",&st,&x,&k);
        if(st==2)printf("%d\n",query(x,k));
    }
}
int main()
{
	/*ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);*/
	read();
	memset(heavy,-1,sizeof(heavy));
	init_heavy(1);
	int sth=HLD(1,1,0);
	fast_queries();
return 0;
}
/*
10
1 2
1 3
3 4
3 5
3 6
4 7
4 8
8 9
8 10
0 1 0 1 0 1 0 1
0 1
7
2 1 1
2 4 4
2 3 0
2 3 4
2 1 1
2 4 4
2 3 2
*/
